/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/base/common/extpath","vs/platform/windows/electron-main/windows","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/base/common/process","vs/base/common/labels","vs/platform/userDataProfile/common/userDataProfile","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/map","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/objects","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ne=function(V){for(var e=[],S=0,t=V.length;S<t;S++)e[S]=te[V[S]];return e};define(te[120],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function S(M){return M?M.replace(/\$\((.*?)\)/g,(A,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=S;class t{constructor(A,I,w){this.id=A,this.definition=I,this.description=w,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var k;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function I(p){if(p instanceof t)return["codicon","codicon-"+p.id];const y=A.exec(p.id);if(!y)return I(t.error);const[,v,h]=y,d=["codicon","codicon-"+v];return h&&d.push("codicon-modifier-"+h.substring(1)),d}M.asClassNameArray=I;function w(p){return I(p).join(" ")}M.asClassName=w;function g(p){return"."+I(p).join(".")}M.asCSSSelector=g})(k=e.CSSIcon||(e.CSSIcon={}))}),define(te[121],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function S(I,w){const g=Math.pow(10,w);return Math.round(I*g)/g}class t{constructor(w,g,p,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,w))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=S(Math.max(Math.min(1,y),0),3)}static equals(w,g){return w.r===g.r&&w.g===g.g&&w.b===g.b&&w.a===g.a}}e.RGBA=t;class k{constructor(w,g,p,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,w),0)|0,this.s=S(Math.max(Math.min(1,g),0),3),this.l=S(Math.max(Math.min(1,p),0),3),this.a=S(Math.max(Math.min(1,y),0),3)}static equals(w,g){return w.h===g.h&&w.s===g.s&&w.l===g.l&&w.a===g.a}static fromRGBA(w){const g=w.r/255,p=w.g/255,y=w.b/255,v=w.a,h=Math.max(g,p,y),d=Math.min(g,p,y);let b=0,l=0;const u=(d+h)/2,m=h-d;if(m>0){switch(l=Math.min(u<=.5?m/(2*u):m/(2-2*u),1),h){case g:b=(p-y)/m+(p<y?6:0);break;case p:b=(y-g)/m+2;break;case y:b=(g-p)/m+4;break}b*=60,b=Math.round(b)}return new k(b,l,u,v)}static i(w,g,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?w+(g-w)*6*p:p<1/2?g:p<2/3?w+(g-w)*(2/3-p)*6:w}static toRGBA(w){const g=w.h/360,{s:p,l:y,a:v}=w;let h,d,b;if(p===0)h=d=b=y;else{const l=y<.5?y*(1+p):y+p-y*p,u=2*y-l;h=k.i(u,l,g+1/3),d=k.i(u,l,g),b=k.i(u,l,g-1/3)}return new t(Math.round(h*255),Math.round(d*255),Math.round(b*255),v)}}e.HSLA=k;class M{constructor(w,g,p,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,w),0)|0,this.s=S(Math.max(Math.min(1,g),0),3),this.v=S(Math.max(Math.min(1,p),0),3),this.a=S(Math.max(Math.min(1,y),0),3)}static equals(w,g){return w.h===g.h&&w.s===g.s&&w.v===g.v&&w.a===g.a}static fromRGBA(w){const g=w.r/255,p=w.g/255,y=w.b/255,v=Math.max(g,p,y),h=Math.min(g,p,y),d=v-h,b=v===0?0:d/v;let l;return d===0?l=0:v===g?l=((p-y)/d%6+6)%6:v===p?l=(y-g)/d+2:l=(g-p)/d+4,new M(Math.round(l*60),b,v,w.a)}static toRGBA(w){const{h:g,s:p,v:y,a:v}=w,h=y*p,d=h*(1-Math.abs(g/60%2-1)),b=y-h;let[l,u,m]=[0,0,0];return g<60?(l=h,u=d):g<120?(l=d,u=h):g<180?(u=h,m=d):g<240?(u=d,m=h):g<300?(l=d,m=h):g<=360&&(l=h,m=d),l=Math.round((l+b)*255),u=Math.round((u+b)*255),m=Math.round((m+b)*255),new t(l,u,m,v)}}e.HSVA=M;class A{static fromHex(w){return A.Format.CSS.parseHex(w)||A.red}static equals(w,g){return!w&&!g?!0:!w||!g?!1:w.equals(g)}get hsla(){return this.i?this.i:k.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(w){if(w)if(w instanceof t)this.rgba=w;else if(w instanceof k)this.i=w,this.rgba=k.toRGBA(w);else if(w instanceof M)this.j=w,this.rgba=M.toRGBA(w);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(w){return!!w&&t.equals(this.rgba,w.rgba)&&k.equals(this.hsla,w.hsla)&&M.equals(this.hsva,w.hsva)}getRelativeLuminance(){const w=A.k(this.rgba.r),g=A.k(this.rgba.g),p=A.k(this.rgba.b),y=.2126*w+.7152*g+.0722*p;return S(y,4)}static k(w){const g=w/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(w){const g=this.getRelativeLuminance(),p=w.getRelativeLuminance();return g>p?(g+.05)/(p+.05):(p+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(w){const g=this.getRelativeLuminance(),p=w.getRelativeLuminance();return g>p}isDarkerThan(w){const g=this.getRelativeLuminance(),p=w.getRelativeLuminance();return g<p}lighten(w){return new A(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*w,this.hsla.a))}darken(w){return new A(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*w,this.hsla.a))}transparent(w){const{r:g,g:p,b:y,a:v}=this.rgba;return new A(new t(g,p,y,v*w))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(w){const g=w.rgba,p=this.rgba.a,y=g.a,v=p+y*(1-p);if(v<1e-6)return A.transparent;const h=this.rgba.r*p/v+g.r*y*(1-p)/v,d=this.rgba.g*p/v+g.g*y*(1-p)/v,b=this.rgba.b*p/v+g.b*y*(1-p)/v;return new A(new t(h,d,b,v))}makeOpaque(w){if(this.isOpaque()||w.rgba.a!==1)return this;const{r:g,g:p,b:y,a:v}=this.rgba;return new A(new t(w.rgba.r-v*(w.rgba.r-g),w.rgba.g-v*(w.rgba.g-p),w.rgba.b-v*(w.rgba.b-y),1))}flatten(...w){const g=w.reduceRight((p,y)=>A.o(y,p));return A.o(this,g)}static o(w,g){const p=1-w.rgba.a;return new A(new t(p*g.rgba.r+w.rgba.a*w.rgba.r,p*g.rgba.g+w.rgba.a*w.rgba.g,p*g.rgba.b+w.rgba.a*w.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(w,g,p){if(w.isLighterThan(g))return w;p=p||.5;const y=w.getRelativeLuminance(),v=g.getRelativeLuminance();return p=p*(v-y)/v,w.lighten(p)}static getDarkerColor(w,g,p){if(w.isDarkerThan(g))return w;p=p||.5;const y=w.getRelativeLuminance(),v=g.getRelativeLuminance();return p=p*(y-v)/y,w.darken(p)}}e.Color=A,A.white=new A(new t(255,255,255,1)),A.black=new A(new t(0,0,0,1)),A.red=new A(new t(255,0,0,1)),A.blue=new A(new t(0,0,255,1)),A.green=new A(new t(0,255,0,1)),A.cyan=new A(new t(0,255,255,1)),A.lightgrey=new A(new t(211,211,211,1)),A.transparent=new A(new t(0,0,0,0)),function(I){let w;(function(g){let p;(function(y){function v(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:I.Format.CSS.formatRGBA(i)}y.formatRGB=v;function h(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}y.formatRGBA=h;function d(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:I.Format.CSS.formatHSLA(i)}y.formatHSL=d;function b(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}y.formatHSLA=b;function l(i){const r=i.toString(16);return r.length!==2?"0"+r:r}function u(i){return`#${l(i.rgba.r)}${l(i.rgba.g)}${l(i.rgba.b)}`}y.formatHex=u;function m(i,r=!1){return r&&i.rgba.a===1?I.Format.CSS.formatHex(i):`#${l(i.rgba.r)}${l(i.rgba.g)}${l(i.rgba.b)}${l(Math.round(i.rgba.a*255))}`}y.formatHexA=m;function C(i){return i.isOpaque()?I.Format.CSS.formatHex(i):I.Format.CSS.formatRGBA(i)}y.format=C;function E(i){const r=i.length;if(r===0||i.charCodeAt(0)!==35)return null;if(r===7){const n=16*R(i.charCodeAt(1))+R(i.charCodeAt(2)),o=16*R(i.charCodeAt(3))+R(i.charCodeAt(4)),a=16*R(i.charCodeAt(5))+R(i.charCodeAt(6));return new I(new t(n,o,a,1))}if(r===9){const n=16*R(i.charCodeAt(1))+R(i.charCodeAt(2)),o=16*R(i.charCodeAt(3))+R(i.charCodeAt(4)),a=16*R(i.charCodeAt(5))+R(i.charCodeAt(6)),c=16*R(i.charCodeAt(7))+R(i.charCodeAt(8));return new I(new t(n,o,a,c/255))}if(r===4){const n=R(i.charCodeAt(1)),o=R(i.charCodeAt(2)),a=R(i.charCodeAt(3));return new I(new t(16*n+n,16*o+o,16*a+a))}if(r===5){const n=R(i.charCodeAt(1)),o=R(i.charCodeAt(2)),a=R(i.charCodeAt(3)),c=R(i.charCodeAt(4));return new I(new t(16*n+n,16*o+o,16*a+a,(16*c+c)/255))}return null}y.parseHex=E;function R(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=g.CSS||(g.CSS={}))})(w=I.Format||(I.Format={}))}(A=e.Color||(e.Color={}))}),define(te[54],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function S(A){return(I,w,g)=>{let p=null,y=null;if(typeof g.value=="function"?(p="value",y=g.value):typeof g.get=="function"&&(p="get",y=g.get),!y)throw new Error("not supported");g[p]=A(y,w)}}function t(A,I,w){let g=null,p=null;if(typeof w.value=="function"?(g="value",p=w.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(g="get",p=w.get),!p)throw new Error("not supported");const y=`$memoize$${I}`;w[g]=function(...v){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,v)}),this[y]}}e.memoize=t;function k(A,I,w){return S((g,p)=>{const y=`$debounce$${p}`,v=`$debounce$result$${p}`;return function(...h){this[v]||(this[v]=w?w():void 0),clearTimeout(this[y]),I&&(this[v]=I(this[v],...h),h=[this[v]]),this[y]=setTimeout(()=>{g.apply(this,h),this[v]=w?w():void 0},A)}})}e.debounce=k;function M(A,I,w){return S((g,p)=>{const y=`$throttle$timer$${p}`,v=`$throttle$result$${p}`,h=`$throttle$lastRun$${p}`,d=`$throttle$pending$${p}`;return function(...b){if(this[v]||(this[v]=w?w():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),I&&(this[v]=I(this[v],...b)),this[d])return;const l=this[h]+A;l<=Date.now()?(this[h]=Date.now(),g.apply(this,[this[v]]),this[v]=w?w():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[h]=Date.now(),g.apply(this,[this[v]]),this[v]=w?w():void 0},l-Date.now()))}})}e.throttle=M}),define(te[13],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?C.isErrorNoTelemetry(i)?new C(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(r=>{r(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=S,e.errorHandler=new S;function t(R){e.errorHandler.setUnexpectedErrorHandler(R)}e.setUnexpectedErrorHandler=t;function k(R){w(R)||e.errorHandler.onUnexpectedError(R)}e.onUnexpectedError=k;function M(R){w(R)||e.errorHandler.onUnexpectedExternalError(R)}e.onUnexpectedExternalError=M;function A(R){if(R instanceof Error){const{name:i,message:r}=R,n=R.stacktrace||R.stack;return{$isError:!0,name:i,message:r,stack:n,noTelemetry:C.isErrorNoTelemetry(R)}}return R}e.transformErrorForSerialization=A;const I="Canceled";function w(R){return R instanceof g?!0:R instanceof Error&&R.name===I&&R.message===I}e.isCancellationError=w;class g extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=g;function p(){const R=new Error(I);return R.name=R.message,R}e.canceled=p;function y(R){return R?new Error(`Illegal argument: ${R}`):new Error("Illegal argument")}e.illegalArgument=y;function v(R){return R?new Error(`Illegal state: ${R}`):new Error("Illegal state")}e.illegalState=v;function h(R){return R?new Error(`readonly property '${R} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function d(R){const i=new Error(`${R} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function b(R){return R?R.message?R.message:R.stack?R.stack.split(`
`)[0]:String(R):"Error"}e.getErrorMessage=b;class l extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=l;class u extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=u;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=m;class C extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof C)return i;const r=new C;return r.message=i.message,r.stack=i.stack,r}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=C;class E extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype);debugger}}e.BugIndicatingError=E}),define(te[24],ne([0,1,13]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(B,Q=0){return B[B.length-(1+Q)]}e.tail=t;function k(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=k;function M(B,Q,ie=(ae,de)=>ae===de){if(B===Q)return!0;if(!B||!Q||B.length!==Q.length)return!1;for(let ae=0,de=B.length;ae<de;ae++)if(!ie(B[ae],Q[ae]))return!1;return!0}e.equals=M;function A(B,Q){const ie=B.length-1;Q<ie&&(B[Q]=B[ie]),B.pop()}e.removeFastWithoutKeepingOrder=A;function I(B,Q,ie){return w(B.length,ae=>ie(B[ae],Q))}e.binarySearch=I;function w(B,Q){let ie=0,ae=B-1;for(;ie<=ae;){const de=(ie+ae)/2|0,ke=Q(de);if(ke<0)ie=de+1;else if(ke>0)ae=de-1;else return de}return-(ie+1)}e.binarySearch2=w;function g(B,Q){let ie=0,ae=B.length;if(ae===0)return 0;for(;ie<ae;){const de=Math.floor((ie+ae)/2);Q(B[de])?ae=de:ie=de+1}return ie}e.findFirstInSorted=g;function p(B,Q,ie){if(B=B|0,B>=Q.length)throw new TypeError("invalid index");const ae=Q[Math.floor(Q.length*Math.random())],de=[],ke=[],Oe=[];for(const De of Q){const Me=ie(De,ae);Me<0?de.push(De):Me>0?ke.push(De):Oe.push(De)}return B<de.length?p(B,de,ie):B<de.length+Oe.length?Oe[0]:p(B-(de.length+Oe.length),ke,ie)}e.quickSelect=p;function y(B,Q){const ie=[];let ae;for(const de of B.slice(0).sort(Q))!ae||Q(ae[0],de)!==0?(ae=[de],ie.push(ae)):ae.push(de);return ie}e.groupBy=y;function v(B,Q,ie){const ae=[];function de(De,Me,ve){if(Me===0&&ve.length===0)return;const we=ae[ae.length-1];we&&we.start+we.deleteCount===De?(we.deleteCount+=Me,we.toInsert.push(...ve)):ae.push({start:De,deleteCount:Me,toInsert:ve})}let ke=0,Oe=0;for(;;){if(ke===B.length){de(ke,0,Q.slice(Oe));break}if(Oe===Q.length){de(ke,B.length-ke,[]);break}const De=B[ke],Me=Q[Oe],ve=ie(De,Me);ve===0?(ke+=1,Oe+=1):ve<0?(de(ke,1,[]),ke+=1):ve>0&&(de(ke,0,[Me]),Oe+=1)}return ae}e.sortedDiff=v;function h(B,Q,ie){const ae=v(B,Q,ie),de=[],ke=[];for(const Oe of ae)de.push(...B.slice(Oe.start,Oe.start+Oe.deleteCount)),ke.push(...Oe.toInsert);return{removed:de,added:ke}}e.delta=h;function d(B,Q,ie){if(ie===0)return[];const ae=B.slice(0,ie).sort(Q);return l(B,Q,ae,ie,B.length),ae}e.top=d;function b(B,Q,ie,ae,de){return ie===0?Promise.resolve([]):new Promise((ke,Oe)=>{(async()=>{const De=B.length,Me=B.slice(0,ie).sort(Q);for(let ve=ie,we=Math.min(ie+ae,De);ve<De;ve=we,we=Math.min(we+ae,De)){if(ve>ie&&await new Promise(ye=>setTimeout(ye)),de&&de.isCancellationRequested)throw new S.CancellationError;l(B,Q,Me,ve,we)}return Me})().then(ke,Oe)})}e.topAsync=b;function l(B,Q,ie,ae,de){for(const ke=ie.length;ae<de;ae++){const Oe=B[ae];if(Q(Oe,ie[ke-1])<0){ie.pop();const De=g(ie,Me=>Q(Oe,Me)<0);ie.splice(De,0,Oe)}}}function u(B){return B.filter(Q=>!!Q)}e.coalesce=u;function m(B){let Q=0;for(let ie=0;ie<B.length;ie++)B[ie]&&(B[Q]=B[ie],Q+=1);B.length=Q}e.coalesceInPlace=m;function C(B,Q,ie){B.splice(ie,0,B.splice(Q,1)[0])}e.move=C;function E(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=E;function R(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=R;function i(B,Q=ie=>ie){const ie=new Set;return B.filter(ae=>{const de=Q(ae);return ie.has(de)?!1:(ie.add(de),!0)})}e.distinct=i;function r(B){const Q=new Set;return ie=>{const ae=B(ie);return Q.has(ae)?!1:(Q.add(ae),!0)}}e.uniqueFilter=r;function n(B,Q){const ie=o(B,Q);if(ie!==-1)return B[ie]}e.findLast=n;function o(B,Q){for(let ie=B.length-1;ie>=0;ie--){const ae=B[ie];if(Q(ae))return ie}return-1}e.lastIndex=o;function a(B,Q){return B.length>0?B[0]:Q}e.firstOrDefault=a;function c(B,Q){return B.length>0?B[B.length-1]:Q}e.lastOrDefault=c;function s(B,Q,ie=(ae,de)=>ae===de){let ae=0;for(let de=0,ke=Math.min(B.length,Q.length);de<ke&&ie(B[de],Q[de]);de++)ae++;return ae}e.commonPrefixLength=s;function f(B){return[].concat(...B)}e.flatten=f;function P(B,Q){let ie=typeof Q=="number"?B:0;typeof Q=="number"?ie=B:(ie=0,Q=B);const ae=[];if(ie<=Q)for(let de=ie;de<Q;de++)ae.push(de);else for(let de=ie;de>Q;de--)ae.push(de);return ae}e.range=P;function L(B,Q,ie){return B.reduce((ae,de)=>(ae[Q(de)]=ie?ie(de):de,ae),Object.create(null))}e.index=L;function T(B,Q){return B.push(Q),()=>U(B,Q)}e.insert=T;function U(B,Q){const ie=B.indexOf(Q);if(ie>-1)return B.splice(ie,1),Q}e.remove=U;function G(B,Q,ie){const ae=B.slice(0,Q),de=B.slice(Q);return ae.concat(ie,de)}e.arrayInsert=G;function H(B,Q){let ie;if(typeof Q=="number"){let ae=Q;ie=()=>{const de=Math.sin(ae++)*179426549;return de-Math.floor(de)}}else ie=Math.random;for(let ae=B.length-1;ae>0;ae-=1){const de=Math.floor(ie()*(ae+1)),ke=B[ae];B[ae]=B[de],B[de]=ke}}e.shuffle=H;function K(B,Q){const ie=B.indexOf(Q);ie>-1&&(B.splice(ie,1),B.unshift(Q))}e.pushToStart=K;function se(B,Q){const ie=B.indexOf(Q);ie>-1&&(B.splice(ie,1),B.push(Q))}e.pushToEnd=se;function Z(B,Q){for(const ie of Q)B.push(ie)}e.pushMany=Z;function ce(B,Q){return Array.isArray(B)?B.map(Q):Q(B)}e.mapArrayOrNot=ce;function ge(B){return Array.isArray(B)?B:[B]}e.asArray=ge;function _(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=_;function $(B,Q){for(const ie of B){const ae=Q(ie);if(ae!==void 0)return ae}}e.mapFind=$;function N(B,Q,ie){const ae=z(B,Q),de=B.length,ke=ie.length;B.length=de+ke;for(let Oe=de-1;Oe>=ae;Oe--)B[Oe+ke]=B[Oe];for(let Oe=0;Oe<ke;Oe++)B[Oe+ae]=ie[Oe]}e.insertInto=N;function W(B,Q,ie,ae){const de=z(B,Q),ke=B.splice(de,ie);return N(B,de,ae),ke}e.splice=W;function z(B,Q){return Q<0?Math.max(Q+B.length,0):Math.min(Q,B.length)}var Y;(function(B){function Q(de){return de<0}B.isLessThan=Q;function ie(de){return de>0}B.isGreaterThan=ie;function ae(de){return de===0}B.isNeitherLessOrGreaterThan=ae,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(Y=e.CompareResult||(e.CompareResult={}));function oe(B,Q){return(ie,ae)=>Q(B(ie),B(ae))}e.compareBy=oe;function ee(...B){return(Q,ie)=>{for(const ae of B){const de=ae(Q,ie);if(!Y.isNeitherLessOrGreaterThan(de))return de}return Y.neitherLessOrGreaterThan}}e.tieBreakComparators=ee;const D=(B,Q)=>B-Q;e.numberComparator=D;function O(B,Q){if(B.length===0)return;let ie=B[0];for(let ae=1;ae<B.length;ae++){const de=B[ae];Q(de,ie)>0&&(ie=de)}return ie}e.findMaxBy=O;function F(B,Q){if(B.length===0)return;let ie=B[0];for(let ae=1;ae<B.length;ae++){const de=B[ae];Q(de,ie)>=0&&(ie=de)}return ie}e.findLastMaxBy=F;function j(B,Q){return O(B,(ie,ae)=>-Q(ie,ae))}e.findMinBy=j;class q{constructor(Q){this.f=Q,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Q){let ie=this.c;for(;ie<this.f.length&&Q(this.f[ie]);)ie++;const ae=ie===this.c?null:this.f.slice(this.c,ie);return this.c=ie,ae}takeFromEndWhile(Q){let ie=this.d;for(;ie>=0&&Q(this.f[ie]);)ie--;const ae=ie===this.d?null:this.f.slice(ie+1,this.d+1);return this.d=ie,ae}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Q=this.f[this.c];return this.c++,Q}removeLast(){const Q=this.f[this.d];return this.d--,Q}takeCount(Q){const ie=this.f.slice(this.c,this.c+Q);return this.c+=Q,ie}}e.ArrayQueue=q;class X{constructor(Q){this.iterate=Q}forEach(Q){this.iterate(ie=>(Q(ie),!0))}toArray(){const Q=[];return this.iterate(ie=>(Q.push(ie),!0)),Q}filter(Q){return new X(ie=>this.iterate(ae=>Q(ae)?ie(ae):!0))}map(Q){return new X(ie=>this.iterate(ae=>ie(Q(ae))))}some(Q){let ie=!1;return this.iterate(ae=>(ie=Q(ae),!ie)),ie}findFirst(Q){let ie;return this.iterate(ae=>Q(ae)?(ie=ae,!1):!0),ie}findLast(Q){let ie;return this.iterate(ae=>(Q(ae)&&(ie=ae),!0)),ie}findLastMaxBy(Q){let ie,ae=!0;return this.iterate(de=>((ae||Y.isGreaterThan(Q(de,ie)))&&(ae=!1,ie=de),!0)),ie}}e.CallbackIterable=X,X.empty=new X(B=>{})}),define(te[122],ne([0,1,13]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(w,g){if(!w)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=t;function k(w,g="Unreachable"){throw new Error(g)}e.assertNever=k;function M(w){if(!w)throw new S.BugIndicatingError("Assertion Failed")}e.assert=M;function A(w){if(!w()){debugger;w(),(0,S.onUnexpectedError)(new S.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function I(w,g){let p=0;for(;p<w.length-1;){const y=w[p],v=w[p+1];if(!g(y,v))return!1;p++}return!0}e.checkAdjacentItems=I}),define(te[50],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(t){const k=this;let M=!1,A;return function(){return M||(M=!0,A=t.apply(k,arguments)),A}}e.once=S}),define(te[67],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(t){function k(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}t.is=k;const M=Object.freeze([]);function A(){return M}t.empty=A;function*I(E){yield E}t.single=I;function w(E){return k(E)?E:I(E)}t.wrap=w;function g(E){return E||M}t.from=g;function p(E){return!E||E[Symbol.iterator]().next().done===!0}t.isEmpty=p;function y(E){return E[Symbol.iterator]().next().value}t.first=y;function v(E,R){for(const i of E)if(R(i))return!0;return!1}t.some=v;function h(E,R){for(const i of E)if(R(i))return i}t.find=h;function*d(E,R){for(const i of E)R(i)&&(yield i)}t.filter=d;function*b(E,R){let i=0;for(const r of E)yield R(r,i++)}t.map=b;function*l(...E){for(const R of E)for(const i of R)yield i}t.concat=l;function u(E,R,i){let r=i;for(const n of E)r=R(r,n);return r}t.reduce=u;function*m(E,R,i=E.length){for(R<0&&(R+=E.length),i<0?i+=E.length:i>E.length&&(i=E.length);R<i;R++)yield E[R]}t.slice=m;function C(E,R=Number.POSITIVE_INFINITY){const i=[];if(R===0)return[i,E];const r=E[Symbol.iterator]();for(let n=0;n<R;n++){const o=r.next();if(o.done)return[i,t.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return r}}]}t.consume=C})(S=e.Iterable||(e.Iterable={}))}),define(te[43],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function A(i,r=!1){let n=0;const o=i.length;let a="",c=0,s=16,f=0;function P(se){let Z=0,ce=0;for(;Z<se;){const ge=i.charCodeAt(n);if(ge>=48&&ge<=57)ce=ce*16+ge-48;else if(ge>=65&&ge<=70)ce=ce*16+ge-65+10;else if(ge>=97&&ge<=102)ce=ce*16+ge-97+10;else break;n++,Z++}return Z<se&&(ce=-1),ce}function L(se){n=se,a="",c=0,s=16,f=0}function T(){const se=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&g(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&g(i.charCodeAt(n)))for(n++;n<i.length&&g(i.charCodeAt(n));)n++;else return f=3,i.substring(se,n);let Z=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&g(i.charCodeAt(n))){for(n++;n<i.length&&g(i.charCodeAt(n));)n++;Z=n}else f=3;return i.substring(se,Z)}function U(){let se="",Z=n;for(;;){if(n>=o){se+=i.substring(Z,n),f=2;break}const ce=i.charCodeAt(n);if(ce===34){se+=i.substring(Z,n),n++;break}if(ce===92){if(se+=i.substring(Z,n),n++,n>=o){f=2;break}switch(i.charCodeAt(n++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const _=P(4);_>=0?se+=String.fromCharCode(_):f=4;break}default:f=5}Z=n;continue}if(ce>=0&&ce<=31)if(w(ce)){se+=i.substring(Z,n),f=2;break}else f=6;n++}return se}function G(){if(a="",f=0,c=n,n>=o)return c=o,s=17;let se=i.charCodeAt(n);if(I(se)){do n++,a+=String.fromCharCode(se),se=i.charCodeAt(n);while(I(se));return s=15}if(w(se))return n++,a+=String.fromCharCode(se),se===13&&i.charCodeAt(n)===10&&(n++,a+=`
`),s=14;switch(se){case 123:return n++,s=1;case 125:return n++,s=2;case 91:return n++,s=3;case 93:return n++,s=4;case 58:return n++,s=6;case 44:return n++,s=5;case 34:return n++,a=U(),s=10;case 47:{const Z=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<o&&!w(i.charCodeAt(n));)n++;return a=i.substring(Z,n),s=12}if(i.charCodeAt(n+1)===42){n+=2;const ce=o-1;let ge=!1;for(;n<ce;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,ge=!0;break}n++}return ge||(n++,f=1),a=i.substring(Z,n),s=13}return a+=String.fromCharCode(se),n++,s=16}case 45:if(a+=String.fromCharCode(se),n++,n===o||!g(i.charCodeAt(n)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=T(),s=11;default:for(;n<o&&H(se);)n++,se=i.charCodeAt(n);if(c!==n){switch(a=i.substring(c,n),a){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return a+=String.fromCharCode(se),n++,s=16}}function H(se){if(I(se)||w(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let se;do se=G();while(se>=12&&se<=15);return se}return{setPosition:L,getPosition:()=>n,scan:r?K:G,getToken:()=>s,getTokenValue:()=>a,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>f}}e.createScanner=A;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function w(i){return i===10||i===13||i===8232||i===8233}function g(i){return i>=48&&i<=57}var p;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(p||(p={}));function y(i,r){const n=[],o=new Object;let a;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function f(P,L,T,U){c.value=P,c.offset=L,c.length=T,c.type=U,c.colonOffset=void 0,a=c}try{C(i,{onObjectBegin:(P,L)=>{if(r<=P)throw o;a=void 0,s=r>P,n.push("")},onObjectProperty:(P,L,T)=>{if(r<L||(f(P,L,T,"property"),n[n.length-1]=P,r<=L+T))throw o},onObjectEnd:(P,L)=>{if(r<=P)throw o;a=void 0,n.pop()},onArrayBegin:(P,L)=>{if(r<=P)throw o;a=void 0,n.push(0)},onArrayEnd:(P,L)=>{if(r<=P)throw o;a=void 0,n.pop()},onLiteralValue:(P,L,T)=>{if(r<L||(f(P,L,T,R(P)),r<=L+T))throw o},onSeparator:(P,L,T)=>{if(r<=L)throw o;if(P===":"&&a&&a.type==="property")a.colonOffset=L,s=!1,a=void 0;else if(P===","){const U=n[n.length-1];typeof U=="number"?n[n.length-1]=U+1:(s=!0,n[n.length-1]=""),a=void 0}}})}catch(P){if(P!==o)throw P}return{path:n,previousNode:a,isAtPropertyKey:s,matches:P=>{let L=0;for(let T=0;L<P.length&&T<n.length;T++)if(P[L]===n[T]||P[L]==="*")L++;else if(P[L]!=="**")return!1;return L===P.length}}}e.getLocation=y;function v(i,r=[],n=M.DEFAULT){let o=null,a=[];const c=[];function s(P){Array.isArray(a)?a.push(P):o!==null&&(a[o]=P)}return C(i,{onObjectBegin:()=>{const P={};s(P),c.push(a),a=P,o=null},onObjectProperty:P=>{o=P},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const P=[];s(P),c.push(a),a=P,o=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:s,onError:(P,L,T)=>{r.push({error:P,offset:L,length:T})}},n),a[0]}e.parse=v;function h(i,r=[],n=M.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(P){o.type==="property"&&(o.length=P-o.offset,o=o.parent)}function c(P){return o.children.push(P),P}C(i,{onObjectBegin:P=>{o=c({type:"object",offset:P,length:-1,parent:o,children:[]})},onObjectProperty:(P,L,T)=>{o=c({type:"property",offset:L,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:P,offset:L,length:T,parent:o})},onObjectEnd:(P,L)=>{o.length=P+L-o.offset,o=o.parent,a(P+L)},onArrayBegin:(P,L)=>{o=c({type:"array",offset:P,length:-1,parent:o,children:[]})},onArrayEnd:(P,L)=>{o.length=P+L-o.offset,o=o.parent,a(P+L)},onLiteralValue:(P,L,T)=>{c({type:R(P),offset:L,length:T,parent:o,value:P}),a(L+T)},onSeparator:(P,L,T)=>{o.type==="property"&&(P===":"?o.colonOffset=L:P===","&&a(L))},onError:(P,L,T)=>{r.push({error:P,offset:L,length:T})}},n);const f=o.children[0];return f&&delete f.parent,f}e.parseTree=h;function d(i,r){if(!i)return;let n=i;for(const o of r)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===o){n=c.children[1],a=!0;break}if(!a)return}else{const a=o;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}e.findNodeAtLocation=d;function b(i){if(!i.parent||!i.parent.children)return[];const r=b(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;r.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&r.push(n)}return r}e.getNodePath=b;function l(i){switch(i.type){case"array":return i.children.map(l);case"object":{const r=Object.create(null);for(const n of i.children){const o=n.children[1];o&&(r[n.children[0].value]=l(o))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=l;function u(i,r,n=!1){return r>=i.offset&&r<i.offset+i.length||n&&r===i.offset+i.length}e.contains=u;function m(i,r,n=!1){if(u(i,r,n)){const o=i.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=r;a++){const c=m(o[a],r,n);if(c)return c}return i}}e.findNodeAtOffset=m;function C(i,r,n=M.DEFAULT){const o=A(i,!1);function a(oe){return oe?()=>oe(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(oe){return oe?ee=>oe(ee,o.getTokenOffset(),o.getTokenLength()):()=>!0}const s=a(r.onObjectBegin),f=c(r.onObjectProperty),P=a(r.onObjectEnd),L=a(r.onArrayBegin),T=a(r.onArrayEnd),U=c(r.onLiteralValue),G=c(r.onSeparator),H=a(r.onComment),K=c(r.onError),se=n&&n.disallowComments,Z=n&&n.allowTrailingComma;function ce(){for(;;){const oe=o.scan();switch(o.getTokenError()){case 4:ge(14);break;case 5:ge(15);break;case 3:ge(13);break;case 1:se||ge(11);break;case 2:ge(12);break;case 6:ge(16);break}switch(oe){case 12:case 13:se?ge(10):H();break;case 16:ge(1);break;case 15:case 14:break;default:return oe}}}function ge(oe,ee=[],D=[]){if(K(oe),ee.length+D.length>0){let O=o.getToken();for(;O!==17;){if(ee.indexOf(O)!==-1){ce();break}else if(D.indexOf(O)!==-1)break;O=ce()}}}function _(oe){const ee=o.getTokenValue();return oe?U(ee):f(ee),ce(),!0}function $(){switch(o.getToken()){case 11:{let oe=0;try{oe=JSON.parse(o.getTokenValue()),typeof oe!="number"&&(ge(2),oe=0)}catch{ge(2)}U(oe);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return ce(),!0}function N(){return o.getToken()!==10?(ge(3,[],[2,5]),!1):(_(!1),o.getToken()===6?(G(":"),ce(),Y()||ge(4,[],[2,5])):ge(5,[],[2,5]),!0)}function W(){s(),ce();let oe=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(oe||ge(4,[],[]),G(","),ce(),o.getToken()===2&&Z)break}else oe&&ge(6,[],[]);N()||ge(4,[],[2,5]),oe=!0}return P(),o.getToken()!==2?ge(7,[2],[]):ce(),!0}function z(){L(),ce();let oe=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(oe||ge(4,[],[]),G(","),ce(),o.getToken()===4&&Z)break}else oe&&ge(6,[],[]);Y()||ge(4,[],[4,5]),oe=!0}return T(),o.getToken()!==4?ge(8,[4],[]):ce(),!0}function Y(){switch(o.getToken()){case 3:return z();case 1:return W();case 10:return _(!0);default:return $()}}return ce(),o.getToken()===17?n.allowEmptyContent?!0:(ge(4,[],[]),!1):Y()?(o.getToken()!==17&&ge(9,[],[]),!0):(ge(4,[],[]),!1)}e.visit=C;function E(i,r){const n=A(i),o=[];let a,c=0,s;do switch(s=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:c!==s&&o.push(i.substring(c,s)),r!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,r)),c=n.getPosition();break}while(a!==17);return o.join("")}e.stripComments=E;function R(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=R}),define(te[123],ne([0,1,43]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(g,p,y){let v,h,d,b,l;if(p){for(b=p.offset,l=b+p.length,d=b;d>0&&!w(g,d-1);)d--;let s=l;for(;s<g.length&&!w(g,s);)s++;h=g.substring(d,s),v=A(h,y)}else h=g,v=0,d=0,b=0,l=g.length;const u=I(y,g);let m=!1,C=0,E;y.insertSpaces?E=M(" ",y.tabSize||4):E="	";const R=(0,S.createScanner)(h,!1);let i=!1;function r(){return u+M(E,v+C)}function n(){let s=R.scan();for(m=!1;s===15||s===14;)m=m||s===14,s=R.scan();return i=s===16||R.getTokenError()!==0,s}const o=[];function a(s,f,P){!i&&f<l&&P>b&&g.substring(f,P)!==s&&o.push({offset:f,length:P-f,content:s})}let c=n();if(c!==17){const s=R.getTokenOffset()+d,f=M(E,v);a(f,d,s)}for(;c!==17;){let s=R.getTokenOffset()+R.getTokenLength()+d,f=n(),P="";for(;!m&&(f===12||f===13);){const T=R.getTokenOffset()+d;a(" ",s,T),s=R.getTokenOffset()+R.getTokenLength()+d,P=f===12?r():"",f=n()}if(f===2)c!==1&&(C--,P=r());else if(f===4)c!==3&&(C--,P=r());else{switch(c){case 3:case 1:C++,P=r();break;case 5:case 12:P=r();break;case 13:m?P=r():P=" ";break;case 6:P=" ";break;case 10:if(f===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?P=" ":f!==5&&f!==17&&(i=!0);break;case 16:i=!0;break}m&&(f===12||f===13)&&(P=r())}const L=R.getTokenOffset()+d;a(P,s,L),c=f}return o}e.format=t;function k(g,p){const y=JSON.stringify(g,void 0,p.insertSpaces?p.tabSize||4:"	");return p.eol!==void 0?y.replace(/\r\n|\r|\n/g,p.eol):y}e.toFormattedString=k;function M(g,p){let y="";for(let v=0;v<p;v++)y+=g;return y}function A(g,p){let y=0,v=0;const h=p.tabSize||4;for(;y<g.length;){const d=g.charAt(y);if(d===" ")v++;else if(d==="	")v+=h;else break;y++}return Math.floor(v/h)}function I(g,p){for(let y=0;y<p.length;y++){const v=p.charAt(y);if(v==="\r")return y+1<p.length&&p.charAt(y+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return g&&g.eol||`
`}e.getEOL=I;function w(g,p){return`\r
`.indexOf(g.charAt(p))!==-1}e.isEOL=w}),define(te[124],ne([0,1,43,123]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(g,p,y){return M(g,p,void 0,y)}e.removeProperty=k;function M(g,p,y,v,h){const d=p.slice(),b=[],l=(0,S.parseTree)(g,b);let u,m;for(;d.length>0&&(m=d.pop(),u=(0,S.findNodeAtLocation)(l,d),u===void 0&&y!==void 0);)typeof m=="string"?y={[m]:y}:y=[y];if(u)if(u.type==="object"&&typeof m=="string"&&Array.isArray(u.children)){const C=(0,S.findNodeAtLocation)(u,[m]);if(C!==void 0)if(y===void 0){if(!C.parent)throw new Error("Malformed AST");const E=u.children.indexOf(C.parent);let R,i=C.parent.offset+C.parent.length;if(E>0){const r=u.children[E-1];R=r.offset+r.length}else R=u.offset+1,u.children.length>1&&(i=u.children[1].offset);return A(g,{offset:R,length:i-R,content:""},v)}else return A(g,{offset:C.offset,length:C.length,content:JSON.stringify(y)},v);else{if(y===void 0)return[];const E=`${JSON.stringify(m)}: ${JSON.stringify(y)}`,R=h?h(u.children.map(r=>r.children[0].value)):u.children.length;let i;if(R>0){const r=u.children[R-1];i={offset:r.offset+r.length,length:0,content:","+E}}else u.children.length===0?i={offset:u.offset+1,length:0,content:E}:i={offset:u.offset+1,length:0,content:E+","};return A(g,i,v)}}else if(u.type==="array"&&typeof m=="number"&&Array.isArray(u.children))if(y!==void 0){const C=`${JSON.stringify(y)}`;let E;if(u.children.length===0||m===0)E={offset:u.offset+1,length:0,content:u.children.length===0?C:C+","};else{const R=m===-1||m>u.children.length?u.children.length:m,i=u.children[R-1];E={offset:i.offset+i.length,length:0,content:","+C}}return A(g,E,v)}else{const C=m,E=u.children[C];let R;if(u.children.length===1)R={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===C){const i=u.children[C-1],r=i.offset+i.length,n=u.offset+u.length;R={offset:r,length:n-2-r,content:""}}else R={offset:E.offset,length:u.children[C+1].offset-E.offset,content:""};return A(g,R,v)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${u.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return A(g,{offset:l?l.offset:0,length:l?l.length:0,content:JSON.stringify(y)},v)}}e.setProperty=M;function A(g,p,y){let v=I(g,p),h=p.offset,d=p.offset+p.content.length;if(p.length===0||p.content.length===0){for(;h>0&&!(0,t.isEOL)(v,h-1);)h--;for(;d<v.length&&!(0,t.isEOL)(v,d);)d++}const b=(0,t.format)(v,{offset:h,length:d-h},y);for(let u=b.length-1;u>=0;u--){const m=b[u];v=I(v,m),h=Math.min(h,m.offset),d=Math.max(d,m.offset+m.length),d+=m.content.length-m.length}const l=g.length-(v.length-d)-h;return[{offset:h,length:l,content:v.substring(h,d)}]}e.withFormatting=A;function I(g,p){return g.substring(0,p.offset)+p.content+g.substring(p.offset+p.length)}e.applyEdit=I;function w(g,p){const y=p.slice(0).sort((h,d)=>{const b=h.offset-d.offset;return b===0?h.length-d.length:b});let v=g.length;for(let h=y.length-1;h>=0;h--){const d=y[h];if(d.offset+d.length<=v)g=I(g,d);else throw new Error("Overlapping edit");v=d.offset}return g}e.applyEdits=w}),define(te[125],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class S{constructor(k){this.d=k,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(k){return new S(()=>k(this.getValue()))}}e.Lazy=S}),define(te[2],ne([0,1,50,67]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let M=null;function A(c){M=c}if(e.setDisposableTracker=A,k){const c="__is_disposable_tracked__";A(new class{trackDisposable(s){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[c]||console.log(f)},3e3)}setParent(s,f){if(s&&s!==m.None)try{s[c]=!0}catch{}}markAsDisposed(s){if(s&&s!==m.None)try{s[c]=!0}catch{}}markAsSingleton(s){}})}function I(c){return M?.trackDisposable(c),c}function w(c){M?.markAsDisposed(c)}function g(c,s){M?.setParent(c,s)}function p(c,s){if(!!M)for(const f of c)M.setParent(f,s)}function y(c){return M?.markAsSingleton(c),c}e.markAsSingleton=y;function v(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=v;function h(c){if(t.Iterable.is(c)){const s=[];for(const f of c)if(f)try{f.dispose()}catch(P){s.push(P)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=h;function d(c){for(const s of c)v(s)&&s.dispose();return[]}e.disposeIfDisposable=d;function b(...c){const s=l(()=>h(c));return p(c,s),s}e.combinedDisposable=b;function l(c){const s=I({dispose:(0,S.once)(()=>{w(s),c()})});return s}e.toDisposable=l;class u{constructor(){this.c=new Set,this.f=!1,I(this)}dispose(){this.f||(w(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{h(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return g(s,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this.q=new u,I(this),g(this.q,this)}dispose(){w(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class C{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&g(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&g(s,null),s}}e.MutableDisposable=C;class E{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=E;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(s){let f=s;return this.unset=()=>f=void 0,this.isset=()=>f!==void 0,this.dispose=()=>{f&&(f(),f=void 0,w(this))},this}}e.SafeDisposable=R;class i{constructor(){this.a=new Map}acquire(s,...f){let P=this.a.get(s);P||(P={counter:0,object:this.b(s,...f)},this.a.set(s,P));const{object:L}=P,T=(0,S.once)(()=>{--P.counter===0&&(this.c(s,P.object),this.a.delete(s))});return P.counter++,{object:L,dispose:T}}}e.ReferenceCollection=i;class r{constructor(s){this.a=s}async acquire(s,...f){const P=this.a.acquire(s,...f);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(L){throw P.dispose(),L}}}e.AsyncReferenceCollection=r;class n{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=n;function o(c){const s=new u;try{c(s)}finally{s.dispose()}}e.disposeOnReturn=o;class a{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,f,P=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),P||this.a.get(s)?.dispose(),this.a.set(s,f)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=a}),define(te[96],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(M){this.element=M,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class t{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let M=this.a;for(;M!==S.Undefined;){const A=M.next;M.prev=S.Undefined,M.next=S.Undefined,M=A}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,A){const I=new S(M);if(this.a===S.Undefined)this.a=I,this.b=I;else if(A){const g=this.b;this.b=I,I.prev=g,g.next=I}else{const g=this.a;this.a=I,I.next=g,g.prev=I}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(I))}}shift(){if(this.a!==S.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==S.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==S.Undefined&&M.next!==S.Undefined){const A=M.prev;A.next=M.next,M.next.prev=A}else M.prev===S.Undefined&&M.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):M.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):M.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==S.Undefined;)yield M.element,M=M.next}}e.LinkedList=t}),define(te[40],ne([0,1]),function(V,e){"use strict";var S,t,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(d,b,l){let u=d.get(b);return u===void 0&&(u=l,d.set(b,u)),u}e.getOrSet=M;function A(d){const b=[];return d.forEach((l,u)=>{b.push(`${u} => ${l}`)}),`Map(${d.size}) {${b.join(", ")}}`}e.mapToString=A;function I(d){const b=[];return d.forEach(l=>{b.push(l)}),`Set(${d.size}) {${b.join(", ")}}`}e.setToString=I;class w{constructor(b,l){this.uri=b,this.value=l}}class g{constructor(b,l){this[S]="ResourceMap",b instanceof g?(this.b=new Map(b.b),this.c=l??g.a):(this.b=new Map,this.c=b??g.a)}set(b,l){return this.b.set(this.c(b),new w(b,l)),this}get(b){return this.b.get(this.c(b))?.value}has(b){return this.b.has(this.c(b))}get size(){return this.b.size}clear(){this.b.clear()}delete(b){return this.b.delete(this.c(b))}forEach(b,l){typeof l<"u"&&(b=b.bind(l));for(const[u,m]of this.b)b(m.value,m.uri,this)}*values(){for(const b of this.b.values())yield b.value}*keys(){for(const b of this.b.values())yield b.uri}*entries(){for(const b of this.b.values())yield[b.uri,b.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,b]of this.b)yield[b.uri,b.value]}}e.ResourceMap=g,g.a=d=>d.toString();class p{constructor(b,l){this[t]="ResourceSet",!b||typeof b=="function"?this.a=new g(b):(this.a=new g(l),b.forEach(this.add,this))}get size(){return this.a.size}add(b){return this.a.set(b,b),this}clear(){this.a.clear()}delete(b){return this.a.delete(b)}forEach(b,l){this.a.forEach((u,m)=>b.call(l,m,m,this))}has(b){return this.a.has(b)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=p;var y;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class v{constructor(){this[k]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(b){return this.a.has(b)}get(b,l=0){const u=this.a.get(b);if(!!u)return l!==0&&this.j(u,l),u.value}set(b,l,u=0){let m=this.a.get(b);if(m)m.value=l,u!==0&&this.j(m,u);else{switch(m={key:b,value:l,next:void 0,previous:void 0},u){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(b,m),this.d++}return this}delete(b){return!!this.remove(b)}remove(b){const l=this.a.get(b);if(!!l)return this.a.delete(b),this.i(l),this.d--,l.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const b=this.b;return this.a.delete(b.key),this.i(b),this.d--,b.value}forEach(b,l){const u=this.e;let m=this.b;for(;m;){if(l?b.bind(l)(m.value,m.key,this):b(m.value,m.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const b=this,l=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(b.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const C={value:u.key,done:!1};return u=u.next,C}else return{value:void 0,done:!0}}};return m}values(){const b=this,l=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(b.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const C={value:u.value,done:!1};return u=u.next,C}else return{value:void 0,done:!0}}};return m}entries(){const b=this,l=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(b.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const C={value:[u.key,u.value],done:!1};return u=u.next,C}else return{value:void 0,done:!0}}};return m}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(b){if(b>=this.size)return;if(b===0){this.clear();return}let l=this.b,u=this.size;for(;l&&u>b;)this.a.delete(l.key),l=l.next,u--;this.b=l,this.d=u,l&&(l.previous=void 0),this.e++}g(b){if(!this.b&&!this.c)this.c=b;else if(this.b)b.next=this.b,this.b.previous=b;else throw new Error("Invalid list");this.b=b,this.e++}h(b){if(!this.b&&!this.c)this.b=b;else if(this.c)b.previous=this.c,this.c.next=b;else throw new Error("Invalid list");this.c=b,this.e++}i(b){if(b===this.b&&b===this.c)this.b=void 0,this.c=void 0;else if(b===this.b){if(!b.next)throw new Error("Invalid list");b.next.previous=void 0,this.b=b.next}else if(b===this.c){if(!b.previous)throw new Error("Invalid list");b.previous.next=void 0,this.c=b.previous}else{const l=b.next,u=b.previous;if(!l||!u)throw new Error("Invalid list");l.previous=u,u.next=l}b.next=void 0,b.previous=void 0,this.e++}j(b,l){if(!this.b||!this.c)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(b===this.b)return;const u=b.next,m=b.previous;b===this.c?(m.next=void 0,this.c=m):(u.previous=m,m.next=u),b.previous=void 0,b.next=this.b,this.b.previous=b,this.b=b,this.e++}else if(l===2){if(b===this.c)return;const u=b.next,m=b.previous;b===this.b?(u.previous=void 0,this.b=u):(u.previous=m,m.next=u),b.next=void 0,b.previous=this.c,this.c.next=b,this.c=b,this.e++}}}toJSON(){const b=[];return this.forEach((l,u)=>{b.push([u,l])}),b}fromJSON(b){this.clear();for(const[l,u]of b)this.set(l,u)}}e.LinkedMap=v;class h extends v{constructor(b,l=1){super(),this.k=b,this.l=Math.min(Math.max(0,l),1)}get limit(){return this.k}set limit(b){this.k=b,this.m()}get ratio(){return this.l}set ratio(b){this.l=Math.min(Math.max(0,b),1),this.m()}get(b,l=2){return super.get(b,l)}peek(b){return super.get(b,0)}set(b,l){return super.set(b,l,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=h}),define(te[77],ne([0,1,40]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new S.LRUCache(1e4);function k(g){return w(g,"NFC",t)}e.normalizeNFC=k;const M=new S.LRUCache(1e4);function A(g){return w(g,"NFD",M)}e.normalizeNFD=A;const I=/[^\u0000-\u0080]/;function w(g,p,y){if(!g)return g;const v=y.get(g);if(v)return v;let h;return I.test(g)?h=g.normalize(p):h=g,y.set(g,h),h}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(p){return A(p).replace(g,"")}}()}),define(te[126],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function S(I,w,g){return Math.min(Math.max(I,w),g)}e.clamp=S;function t(I,w){return(w+I%w)%w}e.rot=t;class k{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=k;class M{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=M;class A{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const g=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=A}),function(){function V(k){const M=[];typeof k=="number"&&M.push("code/timeOrigin",k);function A(w){M.push(w,Date.now())}function I(){const w=[];for(let g=0;g<M.length;g+=2)w.push({name:M[g],startTime:M[g+1]});return w}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(k+A.startTime)});return M}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function S(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=S(t))}(),function(V,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var t in S)(typeof exports=="object"?exports:V)[t]=S[t]}}(typeof self<"u"?self:this,function(){return function(V){var e={};function S(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return V[t].call(k.exports,k,k.exports,S),k.l=!0,k.exports}return S.m=V,S.c=e,S.d=function(t,k,M){S.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:M})},S.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},S.t=function(t,k){if(1&k&&(t=S(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var M=Object.create(null);if(S.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var A in t)S.d(M,A,function(I){return t[I]}.bind(null,A));return M},S.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return S.d(k,"a",k),k},S.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},S.p="",S(S.s=0)}([function(V,e,S){(function(t){var k;e=V.exports=D,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],w=e.src=[],g=0,p=g++;w[p]="0|[1-9]\\d*";var y=g++;w[y]="[0-9]+";var v=g++;w[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=g++;w[h]="("+w[p]+")\\.("+w[p]+")\\.("+w[p]+")";var d=g++;w[d]="("+w[y]+")\\.("+w[y]+")\\.("+w[y]+")";var b=g++;w[b]="(?:"+w[p]+"|"+w[v]+")";var l=g++;w[l]="(?:"+w[y]+"|"+w[v]+")";var u=g++;w[u]="(?:-("+w[b]+"(?:\\."+w[b]+")*))";var m=g++;w[m]="(?:-?("+w[l]+"(?:\\."+w[l]+")*))";var C=g++;w[C]="[0-9A-Za-z-]+";var E=g++;w[E]="(?:\\+("+w[C]+"(?:\\."+w[C]+")*))";var R=g++,i="v?"+w[h]+w[u]+"?"+w[E]+"?";w[R]="^"+i+"$";var r="[v=\\s]*"+w[d]+w[m]+"?"+w[E]+"?",n=g++;w[n]="^"+r+"$";var o=g++;w[o]="((?:<|>)?=?)";var a=g++;w[a]=w[y]+"|x|X|\\*";var c=g++;w[c]=w[p]+"|x|X|\\*";var s=g++;w[s]="[v=\\s]*("+w[c]+")(?:\\.("+w[c]+")(?:\\.("+w[c]+")(?:"+w[u]+")?"+w[E]+"?)?)?";var f=g++;w[f]="[v=\\s]*("+w[a]+")(?:\\.("+w[a]+")(?:\\.("+w[a]+")(?:"+w[m]+")?"+w[E]+"?)?)?";var P=g++;w[P]="^"+w[o]+"\\s*"+w[s]+"$";var L=g++;w[L]="^"+w[o]+"\\s*"+w[f]+"$";var T=g++;w[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=g++;w[U]="(?:~>?)";var G=g++;w[G]="(\\s*)"+w[U]+"\\s+",I[G]=new RegExp(w[G],"g");var H=g++;w[H]="^"+w[U]+w[s]+"$";var K=g++;w[K]="^"+w[U]+w[f]+"$";var se=g++;w[se]="(?:\\^)";var Z=g++;w[Z]="(\\s*)"+w[se]+"\\s+",I[Z]=new RegExp(w[Z],"g");var ce=g++;w[ce]="^"+w[se]+w[s]+"$";var ge=g++;w[ge]="^"+w[se]+w[f]+"$";var _=g++;w[_]="^"+w[o]+"\\s*("+r+")$|^$";var $=g++;w[$]="^"+w[o]+"\\s*("+i+")$|^$";var N=g++;w[N]="(\\s*)"+w[o]+"\\s*("+r+"|"+w[s]+")",I[N]=new RegExp(w[N],"g");var W=g++;w[W]="^\\s*("+w[s]+")\\s+-\\s+("+w[s]+")\\s*$";var z=g++;w[z]="^\\s*("+w[f]+")\\s+-\\s+("+w[f]+")\\s*$";var Y=g++;w[Y]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)k(oe,w[oe]),I[oe]||(I[oe]=new RegExp(w[oe]));function ee(re,he){if(re instanceof D)return re;if(typeof re!="string"||re.length>M||!(he?I[n]:I[R]).test(re))return null;try{return new D(re,he)}catch{return null}}function D(re,he){if(re instanceof D){if(re.loose===he)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof D))return new D(re,he);k("SemVer",re,he),this.loose=he;var fe=re.trim().match(he?I[n]:I[R]);if(!fe)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Pe=+be;if(Pe>=0&&Pe<A)return Pe}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=ee,e.valid=function(re,he){var fe=ee(re,he);return fe?fe.version:null},e.clean=function(re,he){var fe=ee(re.trim().replace(/^[=v]+/,""),he);return fe?fe.version:null},e.SemVer=D,D.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},D.prototype.toString=function(){return this.version},D.prototype.compare=function(re){return k("SemVer.compare",this.version,this.loose,re),re instanceof D||(re=new D(re,this.loose)),this.compareMain(re)||this.comparePre(re)},D.prototype.compareMain=function(re){return re instanceof D||(re=new D(re,this.loose)),F(this.major,re.major)||F(this.minor,re.minor)||F(this.patch,re.patch)},D.prototype.comparePre=function(re){if(re instanceof D||(re=new D(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var he=0;do{var fe=this.prerelease[he],be=re.prerelease[he];if(k("prerelease compare",he,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return F(fe,be)}while(++he)},D.prototype.inc=function(re,he){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,he,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new D(re,fe).inc(he,be).version}catch{return null}},e.diff=function(re,he){if(B(re,he))return null;var fe=ee(re),be=ee(he);if(fe.prerelease.length||be.prerelease.length){for(var Pe in fe)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&fe[Pe]!==be[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in fe)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&fe[Pe]!==be[Pe])return Pe},e.compareIdentifiers=F;var O=/^[0-9]+$/;function F(re,he){var fe=O.test(re),be=O.test(he);return fe&&be&&(re=+re,he=+he),fe&&!be?-1:be&&!fe?1:re<he?-1:re>he?1:0}function j(re,he,fe){return new D(re,fe).compare(new D(he,fe))}function q(re,he,fe){return j(re,he,fe)>0}function X(re,he,fe){return j(re,he,fe)<0}function B(re,he,fe){return j(re,he,fe)===0}function Q(re,he,fe){return j(re,he,fe)!==0}function ie(re,he,fe){return j(re,he,fe)>=0}function ae(re,he,fe){return j(re,he,fe)<=0}function de(re,he,fe,be){var Pe;switch(he){case"===":typeof re=="object"&&(re=re.version),typeof fe=="object"&&(fe=fe.version),Pe=re===fe;break;case"!==":typeof re=="object"&&(re=re.version),typeof fe=="object"&&(fe=fe.version),Pe=re!==fe;break;case"":case"=":case"==":Pe=B(re,fe,be);break;case"!=":Pe=Q(re,fe,be);break;case">":Pe=q(re,fe,be);break;case">=":Pe=ie(re,fe,be);break;case"<":Pe=X(re,fe,be);break;case"<=":Pe=ae(re,fe,be);break;default:throw new TypeError("Invalid operator: "+he)}return Pe}function ke(re,he){if(re instanceof ke){if(re.loose===he)return re;re=re.value}if(!(this instanceof ke))return new ke(re,he);k("comparator",re,he),this.loose=he,this.parse(re),this.semver===Oe?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(re,he){return F(he,re)},e.major=function(re,he){return new D(re,he).major},e.minor=function(re,he){return new D(re,he).minor},e.patch=function(re,he){return new D(re,he).patch},e.compare=j,e.compareLoose=function(re,he){return j(re,he,!0)},e.rcompare=function(re,he,fe){return j(he,re,fe)},e.sort=function(re,he){return re.sort(function(fe,be){return e.compare(fe,be,he)})},e.rsort=function(re,he){return re.sort(function(fe,be){return e.rcompare(fe,be,he)})},e.gt=q,e.lt=X,e.eq=B,e.neq=Q,e.gte=ie,e.lte=ae,e.cmp=de,e.Comparator=ke;var Oe={};function De(re,he){if(re instanceof De)return re.loose===he?re:new De(re.raw,he);if(re instanceof ke)return new De(re.value,he);if(!(this instanceof De))return new De(re,he);if(this.loose=he,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function Me(re){return!re||re.toLowerCase()==="x"||re==="*"}function ve(re,he,fe,be,Pe,We,Te,qe,Ue,je,Xe,$e,Ke){return((he=Me(fe)?"":Me(be)?">="+fe+".0.0":Me(Pe)?">="+fe+"."+be+".0":">="+he)+" "+(qe=Me(Ue)?"":Me(je)?"<"+(+Ue+1)+".0.0":Me(Xe)?"<"+Ue+"."+(+je+1)+".0":$e?"<="+Ue+"."+je+"."+Xe+"-"+$e:"<="+qe)).trim()}function we(re,he){for(var fe=0;fe<re.length;fe++)if(!re[fe].test(he))return!1;if(he.prerelease.length){for(fe=0;fe<re.length;fe++)if(k(re[fe].semver),re[fe].semver!==Oe&&re[fe].semver.prerelease.length>0){var be=re[fe].semver;if(be.major===he.major&&be.minor===he.minor&&be.patch===he.patch)return!0}return!1}return!0}function ye(re,he,fe){try{he=new De(he,fe)}catch{return!1}return he.test(re)}function Re(re,he,fe,be){var Pe,We,Te,qe,Ue;switch(re=new D(re,be),he=new De(he,be),fe){case">":Pe=q,We=ae,Te=X,qe=">",Ue=">=";break;case"<":Pe=X,We=ie,Te=q,qe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye(re,he,be))return!1;for(var je=0;je<he.set.length;++je){var Xe=he.set[je],$e=null,Ke=null;if(Xe.forEach(function(J){J.semver===Oe&&(J=new ke(">=0.0.0")),$e=$e||J,Ke=Ke||J,Pe(J.semver,$e.semver,be)?$e=J:Te(J.semver,Ke.semver,be)&&(Ke=J)}),$e.operator===qe||$e.operator===Ue||(!Ke.operator||Ke.operator===qe)&&We(re,Ke.semver)||Ke.operator===Ue&&Te(re,Ke.semver))return!1}return!0}ke.prototype.parse=function(re){var he=this.loose?I[_]:I[$],fe=re.match(he);if(!fe)throw new TypeError("Invalid comparator: "+re);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new D(fe[2],this.loose):this.semver=Oe},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(re){return k("Comparator.test",re,this.loose),this.semver===Oe||(typeof re=="string"&&(re=new D(re,this.loose)),de(re,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(re,he){if(!(re instanceof ke))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new De(re.value,he),ye(this.value,fe,he);if(re.operator==="")return fe=new De(this.value,he),ye(re.semver,fe,he);var be=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),We=this.semver.version===re.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),qe=de(this.semver,"<",re.semver,he)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),Ue=de(this.semver,">",re.semver,he)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return be||Pe||We&&Te||qe||Ue},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(re){var he=this.loose;re=re.trim(),k("range",re,he);var fe=he?I[z]:I[W];re=re.replace(fe,ve),k("hyphen replace",re),re=re.replace(I[N],"$1$2$3"),k("comparator trim",re,I[N]),re=(re=(re=re.replace(I[G],"$1~")).replace(I[Z],"$1^")).split(/\s+/).join(" ");var be=he?I[_]:I[$],Pe=re.split(" ").map(function(We){return function(Te,qe){return k("comp",Te),Te=function(Ue,je){return Ue.trim().split(/\s+/).map(function(Xe){return function($e,Ke){k("caret",$e,Ke);var J=Ke?I[ge]:I[ce];return $e.replace(J,function(le,ue,me,Se,Le){var Be;return k("caret",$e,le,ue,me,Se,Le),Me(ue)?Be="":Me(me)?Be=">="+ue+".0.0 <"+(+ue+1)+".0.0":Me(Se)?Be=ue==="0"?">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+".0 <"+(+ue+1)+".0.0":Le?(k("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Be=ue==="0"?me==="0"?">="+ue+"."+me+"."+Se+Le+" <"+ue+"."+me+"."+(+Se+1):">="+ue+"."+me+"."+Se+Le+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+Se+Le+" <"+(+ue+1)+".0.0"):(k("no pr"),Be=ue==="0"?me==="0"?">="+ue+"."+me+"."+Se+" <"+ue+"."+me+"."+(+Se+1):">="+ue+"."+me+"."+Se+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+Se+" <"+(+ue+1)+".0.0"),k("caret return",Be),Be})}(Xe,je)}).join(" ")}(Te,qe),k("caret",Te),Te=function(Ue,je){return Ue.trim().split(/\s+/).map(function(Xe){return function($e,Ke){var J=Ke?I[K]:I[H];return $e.replace(J,function(le,ue,me,Se,Le){var Be;return k("tilde",$e,le,ue,me,Se,Le),Me(ue)?Be="":Me(me)?Be=">="+ue+".0.0 <"+(+ue+1)+".0.0":Me(Se)?Be=">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":Le?(k("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Be=">="+ue+"."+me+"."+Se+Le+" <"+ue+"."+(+me+1)+".0"):Be=">="+ue+"."+me+"."+Se+" <"+ue+"."+(+me+1)+".0",k("tilde return",Be),Be})}(Xe,je)}).join(" ")}(Te,qe),k("tildes",Te),Te=function(Ue,je){return k("replaceXRanges",Ue,je),Ue.split(/\s+/).map(function(Xe){return function($e,Ke){$e=$e.trim();var J=Ke?I[L]:I[P];return $e.replace(J,function(le,ue,me,Se,Le,Be){k("xRange",$e,le,ue,me,Se,Le,Be);var it=Me(me),xe=it||Me(Se),He=xe||Me(Le);return ue==="="&&He&&(ue=""),it?le=ue===">"||ue==="<"?"<0.0.0":"*":ue&&He?(xe&&(Se=0),He&&(Le=0),ue===">"?(ue=">=",xe?(me=+me+1,Se=0,Le=0):He&&(Se=+Se+1,Le=0)):ue==="<="&&(ue="<",xe?me=+me+1:Se=+Se+1),le=ue+me+"."+Se+"."+Le):xe?le=">="+me+".0.0 <"+(+me+1)+".0.0":He&&(le=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),k("xRange return",le),le})}(Xe,je)}).join(" ")}(Te,qe),k("xrange",Te),Te=function(Ue,je){return k("replaceStars",Ue,je),Ue.trim().replace(I[Y],"")}(Te,qe),k("stars",Te),Te}(We,he)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(We){return!!We.match(be)})),Pe=Pe.map(function(We){return new ke(We,he)})},De.prototype.intersects=function(re,he){if(!(re instanceof De))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return re.set.some(function(Pe){return Pe.every(function(We){return be.intersects(We,he)})})})})},e.toComparators=function(re,he){return new De(re,he).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},De.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new D(re,this.loose));for(var he=0;he<this.set.length;he++)if(we(this.set[he],re))return!0;return!1},e.satisfies=ye,e.maxSatisfying=function(re,he,fe){var be=null,Pe=null;try{var We=new De(he,fe)}catch{return null}return re.forEach(function(Te){We.test(Te)&&(be&&Pe.compare(Te)!==-1||(Pe=new D(be=Te,fe)))}),be},e.minSatisfying=function(re,he,fe){var be=null,Pe=null;try{var We=new De(he,fe)}catch{return null}return re.forEach(function(Te){We.test(Te)&&(be&&Pe.compare(Te)!==1||(Pe=new D(be=Te,fe)))}),be},e.validRange=function(re,he){try{return new De(re,he).range||"*"}catch{return null}},e.ltr=function(re,he,fe){return Re(re,he,"<",fe)},e.gtr=function(re,he,fe){return Re(re,he,">",fe)},e.outside=Re,e.prerelease=function(re,he){var fe=ee(re,he);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(re,he,fe){return re=new De(re,fe),he=new De(he,fe),re.intersects(he)},e.coerce=function(re){if(re instanceof D)return re;if(typeof re!="string")return null;var he=re.match(I[T]);return he==null?null:ee((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,S(1))},function(V,e){var S,t,k=V.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(l){if(S===setTimeout)return setTimeout(l,0);if((S===M||!S)&&setTimeout)return S=setTimeout,setTimeout(l,0);try{return S(l,0)}catch{try{return S.call(null,l,0)}catch{return S.call(this,l,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:M}catch{S=M}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var w,g=[],p=!1,y=-1;function v(){p&&w&&(p=!1,w.length?g=w.concat(g):y=-1,g.length&&h())}function h(){if(!p){var l=I(v);p=!0;for(var u=g.length;u;){for(w=g,g=[];++y<u;)w&&w[y].run();y=-1,u=g.length}w=null,p=!1,function(m){if(t===clearTimeout)return clearTimeout(m);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(m);try{t(m)}catch{try{return t.call(null,m)}catch{return t.call(this,m)}}}(l)}}function d(l,u){this.fun=l,this.array=u}function b(){}k.nextTick=function(l){var u=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)u[m-1]=arguments[m];g.push(new d(l,u)),g.length!==1||p||I(h)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=b,k.addListener=b,k.once=b,k.off=b,k.removeListener=b,k.removeAllListeners=b,k.emit=b,k.prependListener=b,k.prependOnceListener=b,k.listeners=function(l){return[]},k.binding=function(l){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(l){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(te[127],ne([0,1]),function(V,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(I,w,g){this.level=I,this.key=w,this.value=g,this.forward=[]}}const k=void 0;class M{constructor(I,w=2**16){this.comparator=I,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new t(this.c,k,k)}get size(){return this.f}clear(){this.e=new t(this.c,k,k)}has(I){return Boolean(M.g(this,I,this.comparator))}get(I){return M.g(this,I,this.comparator)?.value}set(I,w){return M.h(this,I,w,this.comparator)&&(this.f+=1),this}delete(I){const w=M.k(this,I,this.comparator);return w&&(this.f-=1),w}forEach(I,w){let g=this.e.forward[0];for(;g;)I.call(w,g.value,g.key,this),g=g.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",w=this.e.forward[0];for(;w;)I+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return I}static g(I,w,g){let p=I.e;for(let y=I.d-1;y>=0;y--)for(;p.forward[y]&&g(p.forward[y].key,w)<0;)p=p.forward[y];if(p=p.forward[0],p&&g(p.key,w)===0)return p}static h(I,w,g,p){const y=[];let v=I.e;for(let h=I.d-1;h>=0;h--){for(;v.forward[h]&&p(v.forward[h].key,w)<0;)v=v.forward[h];y[h]=v}if(v=v.forward[0],v&&p(v.key,w)===0)return v.value=g,!1;{const h=M.j(I);if(h>I.d){for(let d=I.d;d<h;d++)y[d]=I.e;I.d=h}v=new t(h,w,g);for(let d=0;d<h;d++)v.forward[d]=y[d].forward[d],y[d].forward[d]=v;return!0}}static j(I,w=.5){let g=1;for(;Math.random()<w&&g<I.c;)g+=1;return g}static k(I,w,g){const p=[];let y=I.e;for(let v=I.d-1;v>=0;v--){for(;y.forward[v]&&g(y.forward[v].key,w)<0;)y=y.forward[v];p[v]=y}if(y=y.forward[0],!y||g(y.key,w)!==0)return!1;for(let v=0;v<I.d&&p[v].forward[v]===y;v++)p[v].forward[v]=y.forward[v];for(;I.d>0&&I.e.forward[I.d-1]===k;)I.d-=1;return!0}}e.SkipList=M}),define(te[59],ne([0,1,13,2]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(E){const R=E;return R?typeof R.read=="function":!1}e.isReadable=k;function M(E){const R=E;return R?[R.on,R.pause,R.resume,R.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=M;function A(E){const R=E;return R?M(R.stream)&&Array.isArray(R.buffer)&&typeof R.ended=="boolean":!1}e.isReadableBufferedStream=A;function I(E,R){return new w(E,R)}e.newWriteableStream=I;class w{constructor(R,i){this.e=R,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(R){if(!this.a.destroyed){if(this.a.flowing)this.g(R);else if(this.b.data.push(R),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(R){this.a.destroyed||(this.a.flowing?this.h(R):this.b.error.push(R))}end(R){this.a.destroyed||(typeof R<"u"&&this.write(R),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(R){this.c.data.slice(0).forEach(i=>i(R))}h(R){this.c.error.length===0?(0,S.onUnexpectedError)(R):this.c.error.slice(0).forEach(i=>i(R))}i(){this.c.end.slice(0).forEach(R=>R())}on(R,i){if(!this.a.destroyed)switch(R){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(R,i){if(this.a.destroyed)return;let r;switch(R){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const n=r.indexOf(i);n>=0&&r.splice(n,1)}}j(){if(this.b.data.length>0){const R=this.e(this.b.data);this.g(R),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const R of this.b.error)this.h(R);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(E,R){const i=[];let r;for(;(r=E.read())!==null;)i.push(r);return R(i)}e.consumeReadable=g;function p(E,R,i){const r=[];let n;for(;(n=E.read())!==null&&r.length<i;)r.push(n);return n===null&&r.length>0?R(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const o=n;return n=void 0,o}return E.read()}}}e.peekReadable=p;function y(E,R){return new Promise((i,r)=>{const n=[];v(E,{onData:o=>{R&&n.push(o)},onError:o=>{R?r(o):i(void 0)},onEnd:()=>{i(R?R(n):void 0)}})})}e.consumeStream=y;function v(E,R){let i=!1;return E.on("error",r=>{i||R.onError(r)}),E.on("end",()=>{i||R.onEnd()}),E.on("data",r=>{i||R.onData(r)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=v;function h(E,R){return new Promise((i,r)=>{const n=new t.DisposableStore,o=[],a=f=>{if(o.push(f),o.length>R)return n.dispose(),E.pause(),i({stream:E,buffer:o,ended:!1})},c=f=>r(f),s=()=>i({stream:E,buffer:o,ended:!0});n.add((0,t.toDisposable)(()=>E.removeListener("error",c))),E.on("error",c),n.add((0,t.toDisposable)(()=>E.removeListener("end",s))),E.on("end",s),n.add((0,t.toDisposable)(()=>E.removeListener("data",a))),E.on("data",a)})}e.peekStream=h;function d(E,R){const i=I(R);return i.end(E),i}e.toStream=d;function b(){const E=I(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=b;function l(E){let R=!1;return{read:()=>R?null:(R=!0,E)}}e.toReadable=l;function u(E,R,i){const r=I(i);return v(E,{onData:n=>r.write(R.data(n)),onError:n=>r.error(R.error?R.error(n):n),onEnd:()=>r.end()}),r}e.transform=u;function m(E,R,i){let r=!1;return{read:()=>{const n=R.read();return r?n:(r=!0,n!==null?i([E,n]):E)}}}e.prefixedReadable=m;function C(E,R,i){let r=!1;const n=I(i);return v(R,{onData:o=>r?n.write(o):(r=!0,n.write(i([E,o]))),onError:o=>n.error(o),onEnd:()=>{r||(r=!0,n.write(E)),n.end()}}),n}e.prefixedStream=C}),define(te[17],ne([0,1,59]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,M;class A{static alloc(f){return t?new A(Buffer.allocUnsafe(f)):new A(new Uint8Array(f))}static wrap(f){return t&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new A(f)}static fromString(f,P){return!(P?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(f)):(k||(k=new TextEncoder),new A(k.encode(f)))}static fromByteArray(f){const P=A.alloc(f.length);for(let L=0,T=f.length;L<T;L++)P.buffer[L]=f[L];return P}static concat(f,P){if(typeof P>"u"){P=0;for(let U=0,G=f.length;U<G;U++)P+=f[U].byteLength}const L=A.alloc(P);let T=0;for(let U=0,G=f.length;U<G;U++){const H=f[U];L.set(H,T),T+=H.byteLength}return L}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=A.alloc(this.byteLength);return f.set(this),f}toString(){return t?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(f,P){return new A(this.buffer.subarray(f,P))}set(f,P){if(f instanceof A)this.buffer.set(f.buffer,P);else if(f instanceof Uint8Array)this.buffer.set(f,P);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),P);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return g(this.buffer,f)}writeUInt32BE(f,P){p(this.buffer,f,P)}readUInt32LE(f){return y(this.buffer,f)}writeUInt32LE(f,P){v(this.buffer,f,P)}readUInt8(f){return h(this.buffer,f)}writeUInt8(f,P){d(this.buffer,f,P)}}e.VSBuffer=A;function I(s,f){return s[f+0]<<0>>>0|s[f+1]<<8>>>0}e.readUInt16LE=I;function w(s,f,P){s[P+0]=f&255,f=f>>>8,s[P+1]=f&255}e.writeUInt16LE=w;function g(s,f){return s[f]*2**24+s[f+1]*2**16+s[f+2]*2**8+s[f+3]}e.readUInt32BE=g;function p(s,f,P){s[P+3]=f,f=f>>>8,s[P+2]=f,f=f>>>8,s[P+1]=f,f=f>>>8,s[P]=f}e.writeUInt32BE=p;function y(s,f){return s[f+0]<<0>>>0|s[f+1]<<8>>>0|s[f+2]<<16>>>0|s[f+3]<<24>>>0}e.readUInt32LE=y;function v(s,f,P){s[P+0]=f&255,f=f>>>8,s[P+1]=f&255,f=f>>>8,s[P+2]=f&255,f=f>>>8,s[P+3]=f&255}e.writeUInt32LE=v;function h(s,f){return s[f]}e.readUInt8=h;function d(s,f,P){s[P]=f}e.writeUInt8=d;function b(s){return S.consumeReadable(s,f=>A.concat(f))}e.readableToBuffer=b;function l(s){return S.toReadable(s)}e.bufferToReadable=l;function u(s){return S.consumeStream(s,f=>A.concat(f))}e.streamToBuffer=u;async function m(s){return s.ended?A.concat(s.buffer):A.concat([...s.buffer,await u(s.stream)])}e.bufferedStreamToBuffer=m;function C(s){return S.toStream(s,f=>A.concat(f))}e.bufferToStream=C;function E(s){return S.transform(s,{data:f=>typeof f=="string"?A.fromString(f):A.wrap(f)},f=>A.concat(f))}e.streamToBufferReadableStream=E;function R(s){return S.newWriteableStream(f=>A.concat(f),s)}e.newWriteableBufferStream=R;function i(s,f){return S.prefixedReadable(s,f,P=>A.concat(P))}e.prefixedBufferReadable=i;function r(s,f){return S.prefixedStream(s,f,P=>A.concat(P))}e.prefixedBufferStream=r;function n(s){let f=0,P=0,L=0;const T=new Uint8Array(Math.floor(s.length/4*3)),U=H=>{switch(P){case 3:T[L++]=f|H,P=0;break;case 2:T[L++]=f|H>>>2,f=H<<6,P=3;break;case 1:T[L++]=f|H>>>4,f=H<<4,P=2;break;default:f=H<<2,P=1}};for(let H=0;H<s.length;H++){const K=s.charCodeAt(H);if(K>=65&&K<=90)U(K-65);else if(K>=97&&K<=122)U(K-97+26);else if(K>=48&&K<=57)U(K-48+52);else if(K===43||K===45)U(62);else if(K===47||K===95)U(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${s[H]}`)}}const G=L;for(;P>0;)U(0);return A.wrap(T).slice(0,G)}e.decodeBase64=n;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:s},f=!0,P=!1){const L=P?a:o;let T="";const U=s.byteLength%3;let G=0;for(;G<s.byteLength-U;G+=3){const H=s[G+0],K=s[G+1],se=s[G+2];T+=L[H>>>2],T+=L[(H<<4|K>>>4)&63],T+=L[(K<<2|se>>>6)&63],T+=L[se&63]}if(U===1){const H=s[G+0];T+=L[H>>>2],T+=L[H<<4&63],f&&(T+="==")}else if(U===2){const H=s[G+0],K=s[G+1];T+=L[H>>>2],T+=L[(H<<4|K>>>4)&63],T+=L[K<<2&63],f&&(T+="=")}return T}e.encodeBase64=c}),define(te[11],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function S(r){return typeof r=="string"}e.isString=S;function t(r){return Array.isArray(r)&&r.every(n=>S(n))}e.isStringArray=t;function k(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=k;function M(r){const n=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof n}e.isTypedArray=M;function A(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=A;function I(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=I;function w(r){return r===!0||r===!1}e.isBoolean=w;function g(r){return typeof r>"u"}e.isUndefined=g;function p(r){return!y(r)}e.isDefined=p;function y(r){return g(r)||r===null}e.isUndefinedOrNull=y;function v(r,n){if(!r)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=v;function h(r){if(y(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=h;function d(...r){const n=[];for(let o=0;o<r.length;o++){const a=r[o];if(y(a))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);n.push(a)}return n}e.assertAllDefined=d;const b=Object.prototype.hasOwnProperty;function l(r){if(!k(r))return!1;for(const n in r)if(b.call(r,n))return!1;return!0}e.isEmptyObject=l;function u(r){return typeof r=="function"}e.isFunction=u;function m(...r){return r.length>0&&r.every(u)}e.areFunctions=m;function C(r,n){const o=Math.min(r.length,n.length);for(let a=0;a<o;a++)E(r[a],n[a])}e.validateConstraints=C;function E(r,n){if(S(n)){if(typeof r!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(u(n)){try{if(r instanceof n)return}catch{}if(!y(r)&&r.constructor===n||n.length===1&&n.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function R(r){return r===null?void 0:r}e.withNullAsUndefined=R;function i(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=i}),define(te[44],ne([0,1,11]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([C,E])=>{m[C]=E&&typeof E=="object"?t(E):E}),m}e.deepClone=t;function k(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const C=m.shift();Object.freeze(C);for(const E in C)if(M.call(C,E)){const R=C[E];typeof R=="object"&&!Object.isFrozen(R)&&!(0,S.isTypedArray)(R)&&m.push(R)}}return u}e.deepFreeze=k;const M=Object.prototype.hasOwnProperty;function A(u,m){return I(u,m,new Set)}e.cloneAndChange=A;function I(u,m,C){if((0,S.isUndefinedOrNull)(u))return u;const E=m(u);if(typeof E<"u")return E;if(Array.isArray(u)){const R=[];for(const i of u)R.push(I(i,m,C));return R}if((0,S.isObject)(u)){if(C.has(u))throw new Error("Cannot clone recursive data-structure");C.add(u);const R={};for(const i in u)M.call(u,i)&&(R[i]=I(u[i],m,C));return C.delete(u),R}return u}function w(u,m,C=!0){return(0,S.isObject)(u)?((0,S.isObject)(m)&&Object.keys(m).forEach(E=>{E in u?C&&((0,S.isObject)(u[E])&&(0,S.isObject)(m[E])?w(u[E],m[E],C):u[E]=m[E]):u[E]=m[E]}),u):m}e.mixin=w;function g(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let C,E;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(C=0;C<u.length;C++)if(!g(u[C],m[C]))return!1}else{const R=[];for(E in u)R.push(E);R.sort();const i=[];for(E in m)i.push(E);if(i.sort(),!g(R,i))return!1;for(C=0;C<R.length;C++)if(!g(u[R[C]],m[R[C]]))return!1}return!0}e.equals=g;function p(u){const m=new Set;return JSON.stringify(u,(C,E)=>{if((0,S.isObject)(E)||Array.isArray(E)){if(m.has(E))return"[Circular]";m.add(E)}return E})}e.safeStringify=p;function y(u,m){const C=Object.create(null);return!u||!m||Object.keys(m).forEach(R=>{const i=u[R],r=m[R];g(i,r)||(C[R]=r)}),C}e.distinct=y;function v(u,m){const C=m.toLowerCase(),E=Object.keys(u).find(R=>R.toLowerCase()===C);return E?u[E]:u[m]}e.getCaseInsensitive=v;function h(u,m){const C=Object.create(null);for(const[E,R]of Object.entries(u))m(E,R)&&(C[E]=R);return C}e.filter=h;function d(u){let m=[],C=Object.getPrototypeOf(u);for(;Object.prototype!==C;)m=m.concat(Object.getOwnPropertyNames(C)),C=Object.getPrototypeOf(C);return m}e.getAllPropertyNames=d;function b(u){const m=[];for(const C of d(u))typeof u[C]=="function"&&m.push(C);return m}e.getAllMethodNames=b;function l(u,m){const C=R=>function(){const i=Array.prototype.slice.call(arguments,0);return m(R,i)},E={};for(const R of u)E[R]=C(R);return E}e.createProxyObject=l}),define(te[30],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return S.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(I){for(let w=0;w<I.length;w++)I[w]=Math.floor(Math.random()*256);return I};const M=new Uint8Array(16),A=[];for(let I=0;I<256;I++)A.push(I.toString(16).padStart(2,"0"));return function(){k(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let w=0,g="";return g+=A[M[w++]],g+=A[M[w++]],g+=A[M[w++]],g+=A[M[w++]],g+="-",g+=A[M[w++]],g+=A[M[w++]],g+="-",g+=A[M[w++]],g+=A[M[w++]],g+="-",g+=A[M[w++]],g+=A[M[w++]],g+="-",g+=A[M[w++]],g+=A[M[w++]],g+=A[M[w++]],g+=A[M[w++]],g+=A[M[w++]],g+=A[M[w++]],g}}()}),define(te[128],ne([0,1,78,41,50]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(A,I){if(await new Promise((p,y)=>{const v=t.createReadStream(A),h=S.createHash("sha1");v.pipe(h);const d=(0,k.once)((b,l)=>{v.removeAllListeners(),h.removeAllListeners(),b?y(b):p(l)});v.once("error",d),v.once("end",d),h.once("error",d),h.once("data",b=>d(void 0,b.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=M}),define(te[129],ne([0,1,25]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(A){const I=A.replace(/\-/g,":").toLowerCase();return!t.has(I)}function M(){const A=(0,S.networkInterfaces)();for(const I in A){const w=A[I];if(w){for(const{mac:g}of w)if(k(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=M}),define(te[97],ne([0,1,79]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(I,w,g,p=1){let y=!1;return new Promise(v=>{const h=setTimeout(()=>{if(!y)return y=!0,v(0)},g);k(I,w,p,d=>{if(!y)return y=!0,clearTimeout(h),v(d)})})}e.findFreePort=t;function k(I,w,g,p){if(w===0)return p(0);const y=new S.Socket;y.once("connect",()=>(A(y),k(I+g,w-1,g,p))),y.once("data",()=>{}),y.once("error",v=>(A(y),v.code!=="ECONNREFUSED"?k(I+g,w-1,g,p):p(I))),y.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(I,w,g,p="127.0.0.1"){let y=!1,v,h=1;const d=S.createServer({pauseOnConnect:!0});function b(l,u){y||(y=!0,d.removeAllListeners(),d.close(),v&&clearTimeout(v),u(l))}return new Promise(l=>{v=setTimeout(()=>{b(0,l)},g),d.on("listening",()=>{b(I,l)}),d.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&h<w?(I++,h++,d.listen(I,p)):b(0,l)}),d.on("close",()=>{b(0,l)}),d.listen(I,p)})}e.findFreePortFaster=M;function A(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(w){console.error(w)}}}),define(te[130],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(te[131],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class S{constructor(k,M){this.a=k,this.onMessage=M}send(k){try{this.a.send("vscode:message",k.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=S}),define(te[42],ne([0,1,14,13]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.a=new WeakMap}on(A,I){const w=(g,...p)=>{this.b(A,g)&&I(g,...p)};return this.a.set(I,w),S.ipcMain.on(A,w),this}once(A,I){return S.ipcMain.once(A,(w,...g)=>{this.b(A,w)&&I(w,...g)}),this}handle(A,I){return S.ipcMain.handle(A,(w,...g)=>this.b(A,w)?I(w,...g):Promise.reject(`Invalid channel '${A}' or sender for ipcMain.handle() usage.`)),this}removeHandler(A){return S.ipcMain.removeHandler(A),this}removeListener(A,I){const w=this.a.get(I);return w&&(S.ipcMain.removeListener(A,w),this.a.delete(I)),this}b(A,I){if(!A||!A.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because the channel is unknown.`),!1;const w=I.senderFrame,g=w.url;if(!g)return!0;let p="unknown";try{p=new URL(g).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a malformed URL '${g}'.`),!1}return p!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a bad origin of '${p}'.`),!1):w.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because sender of origin '${p}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(te[132],ne([0,1,14,42,11,130]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function A(){t.validatedIpcMain.on(M.CONTEXT_MENU_CHANNEL,(w,g,p,y,v)=>{const h=I(w,y,p);h.popup({window:(0,k.withNullAsUndefined)(S.BrowserWindow.fromWebContents(w.sender)),x:v?v.x:void 0,y:v?v.y:void 0,positioningItem:v?v.positioningItem:void 0,callback:()=>{h&&w.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,g)}})})}e.registerContextMenuListener=A;function I(w,g,p){const y=new S.Menu;return p.forEach(v=>{let h;v.type==="separator"?h=new S.MenuItem({type:v.type}):Array.isArray(v.submenu)?h=new S.MenuItem({submenu:I(w,g,v.submenu),label:v.label}):h=new S.MenuItem({label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:v.enabled,visible:v.visible,click:(d,b,l)=>w.sender.send(g,v.id,l)}),y.append(h)}),y}}),define(te[133],ne([12,10]),function(V,e){return V.create("vs/base/common/date",e)}),define(te[134],ne([0,1,133]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,M=k*24,A=M*7,I=M*30,w=M*365;function g(y,v,h,d){typeof y!="number"&&(y=y.getTime());const b=Math.round((new Date().getTime()-y)/1e3);if(b<-30)return(0,S.localize)(0,null,g(new Date().getTime()+b*1e3,!1));if(!d&&b<30)return(0,S.localize)(1,null);let l;return b<t?(l=b,v?l===1?h?(0,S.localize)(2,null,l):(0,S.localize)(3,null,l):h?(0,S.localize)(4,null,l):(0,S.localize)(5,null,l):l===1?h?(0,S.localize)(6,null,l):(0,S.localize)(7,null,l):h?(0,S.localize)(8,null,l):(0,S.localize)(9,null,l)):b<k?(l=Math.floor(b/t),v?l===1?h?(0,S.localize)(10,null,l):(0,S.localize)(11,null,l):h?(0,S.localize)(12,null,l):(0,S.localize)(13,null,l):l===1?h?(0,S.localize)(14,null,l):(0,S.localize)(15,null,l):h?(0,S.localize)(16,null,l):(0,S.localize)(17,null,l)):b<M?(l=Math.floor(b/k),v?l===1?h?(0,S.localize)(18,null,l):(0,S.localize)(19,null,l):h?(0,S.localize)(20,null,l):(0,S.localize)(21,null,l):l===1?h?(0,S.localize)(22,null,l):(0,S.localize)(23,null,l):h?(0,S.localize)(24,null,l):(0,S.localize)(25,null,l)):b<A?(l=Math.floor(b/M),v?l===1?(0,S.localize)(26,null,l):(0,S.localize)(27,null,l):l===1?(0,S.localize)(28,null,l):(0,S.localize)(29,null,l)):b<I?(l=Math.floor(b/A),v?l===1?h?(0,S.localize)(30,null,l):(0,S.localize)(31,null,l):h?(0,S.localize)(32,null,l):(0,S.localize)(33,null,l):l===1?h?(0,S.localize)(34,null,l):(0,S.localize)(35,null,l):h?(0,S.localize)(36,null,l):(0,S.localize)(37,null,l)):b<w?(l=Math.floor(b/I),v?l===1?h?(0,S.localize)(38,null,l):(0,S.localize)(39,null,l):h?(0,S.localize)(40,null,l):(0,S.localize)(41,null,l):l===1?h?(0,S.localize)(42,null,l):(0,S.localize)(43,null,l):h?(0,S.localize)(44,null,l):(0,S.localize)(45,null,l)):(l=Math.floor(b/w),v?l===1?h?(0,S.localize)(46,null,l):(0,S.localize)(47,null,l):h?(0,S.localize)(48,null,l):(0,S.localize)(49,null,l):l===1?h?(0,S.localize)(50,null,l):(0,S.localize)(51,null,l):h?(0,S.localize)(52,null,l):(0,S.localize)(53,null,l))}e.fromNow=g;function p(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=p}),define(te[135],ne([12,10]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(te[45],ne([0,1,24,11,135]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(y,v){return v&&(y.stack||y.stacktrace)?k.localize(0,null,I(y),A(y.stack)||A(y.stacktrace)):I(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function I(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?k.localize(1,null,y.message):y.message||k.localize(2,null)}function w(y=null,v=!1){if(!y)return k.localize(3,null);if(Array.isArray(y)){const h=S.coalesce(y),d=w(h[0],v);return h.length>1?k.localize(4,null,d,h.length):d}if(t.isString(y))return y;if(y.detail){const h=y.detail;if(h.error)return M(h.error,v);if(h.exception)return M(h.exception,v)}return y.stack?M(y,v):y.message?y.message:k.localize(5,null)}e.toErrorMessage=w;function g(y){const v=y;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=g;function p(y,v){let h;return typeof y=="string"?h=new Error(y):h=y,h.actions=v,h}e.createErrorWithActions=p}),define(te[136],ne([12,10]),function(V,e){return V.create("vs/base/common/jsonErrorMessages",e)}),define(te[137],ne([0,1,136]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(te[138],ne([12,10]),function(V,e){return V.create("vs/base/common/platform",e)}),define(te[4],ne([0,1,138]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,M=!1,A=!1,I=!1,w=!1,g=!1,p=!1,y=!1,v=!1,h,d=e.LANGUAGE_DEFAULT,b,l;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const m=typeof u?.versions?.electron=="string",C=m&&u?.type==="renderer";if(typeof navigator=="object"&&!C)l=navigator.userAgent,t=l.indexOf("Windows")>=0,k=l.indexOf("Macintosh")>=0,p=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=l.indexOf("Linux")>=0,v=l?.indexOf("Mobi")>=0,w=!0,h=S.getConfiguredDefaultLocale(S.localize(0,null))||e.LANGUAGE_DEFAULT,d=h;else if(typeof u=="object"){t=u.platform==="win32",k=u.platform==="darwin",M=u.platform==="linux",A=M&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,g=m,y=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const s=u.env.VSCODE_NLS_CONFIG;if(s)try{const f=JSON.parse(s),P=f.availableLanguages["*"];h=f.locale,d=P||e.LANGUAGE_DEFAULT,b=f._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var E;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function R(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=R;let i=0;k?i=1:t?i=3:M&&(i=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=M,e.isLinuxSnap=A,e.isNative=I,e.isElectron=g,e.isWeb=w,e.isWebWorker=w&&typeof e.globals.importScripts=="function",e.isIOS=p,e.isMobile=v,e.isCI=y,e.platform=i,e.userAgent=l,e.language=d;var r;(function(s){function f(){return e.language}s.value=f;function P(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=P;function L(){return e.language==="en"}s.isDefault=L})(r=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=b,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let L=0,T=s.length;L<T;L++){const U=s[L];if(U.id===P.data.vscodeScheduleAsyncWork){s.splice(L,1),U.callback();return}}});let f=0;return P=>{const L=++f;s.push({id:L,callback:P}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return s=>setTimeout(s)})();var n;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||p?2:t?1:3;let o=!0,a=!1;function c(){if(!a){a=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,o=new Uint16Array(s.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[35],ne([0,1,4]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof S.globals.vscode<"u"&&typeof S.globals.vscode.process<"u"){const k=S.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(te[9],ne([0,1,35]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,M=90,A=122,I=46,w=47,g=92,p=58,y=63;class v extends Error{constructor(r,n,o){let a;typeof n=="string"&&n.indexOf("not ")===0?(a="must not be",n=n.replace(/^not /,"")):a="must be";const c=r.indexOf(".")!==-1?"property":"argument";let s=`The "${r}" ${c} ${a} of type ${n}`;s+=`. Received type ${typeof o}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function h(i,r){if(i===null||typeof i!="object")throw new v(r,"Object",i)}function d(i,r){if(typeof i!="string")throw new v(r,"string",i)}const b=S.platform==="win32";function l(i){return i===w||i===g}function u(i){return i===w}function m(i){return i>=t&&i<=M||i>=k&&i<=A}function C(i,r,n,o){let a="",c=0,s=-1,f=0,P=0;for(let L=0;L<=i.length;++L){if(L<i.length)P=i.charCodeAt(L);else{if(o(P))break;P=w}if(o(P)){if(!(s===L-1||f===1))if(f===2){if(a.length<2||c!==2||a.charCodeAt(a.length-1)!==I||a.charCodeAt(a.length-2)!==I){if(a.length>2){const T=a.lastIndexOf(n);T===-1?(a="",c=0):(a=a.slice(0,T),c=a.length-1-a.lastIndexOf(n)),s=L,f=0;continue}else if(a.length!==0){a="",c=0,s=L,f=0;continue}}r&&(a+=a.length>0?`${n}..`:"..",c=2)}else a.length>0?a+=`${n}${i.slice(s+1,L)}`:a=i.slice(s+1,L),c=L-s-1;s=L,f=0}else P===I&&f!==-1?++f:f=-1}return a}function E(i,r){h(r,"pathObject");const n=r.dir||r.root,o=r.base||`${r.name||""}${r.ext||""}`;return n?n===r.root?`${n}${o}`:`${n}${i}${o}`:o}e.win32={resolve(...i){let r="",n="",o=!1;for(let a=i.length-1;a>=-1;a--){let c;if(a>=0){if(c=i[a],d(c,"path"),c.length===0)continue}else r.length===0?c=S.cwd():(c=S.env[`=${r}`]||S.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==r.toLowerCase()&&c.charCodeAt(2)===g)&&(c=`${r}\\`));const s=c.length;let f=0,P="",L=!1;const T=c.charCodeAt(0);if(s===1)l(T)&&(f=1,L=!0);else if(l(T))if(L=!0,l(c.charCodeAt(1))){let U=2,G=U;for(;U<s&&!l(c.charCodeAt(U));)U++;if(U<s&&U!==G){const H=c.slice(G,U);for(G=U;U<s&&l(c.charCodeAt(U));)U++;if(U<s&&U!==G){for(G=U;U<s&&!l(c.charCodeAt(U));)U++;(U===s||U!==G)&&(P=`\\\\${H}\\${c.slice(G,U)}`,f=U)}}}else f=1;else m(T)&&c.charCodeAt(1)===p&&(P=c.slice(0,2),f=2,s>2&&l(c.charCodeAt(2))&&(L=!0,f=3));if(P.length>0)if(r.length>0){if(P.toLowerCase()!==r.toLowerCase())continue}else r=P;if(o){if(r.length>0)break}else if(n=`${c.slice(f)}\\${n}`,o=L,L&&r.length>0)break}return n=C(n,!o,"\\",l),o?`${r}\\${n}`:`${r}${n}`||"."},normalize(i){d(i,"path");const r=i.length;if(r===0)return".";let n=0,o,a=!1;const c=i.charCodeAt(0);if(r===1)return u(c)?"\\":i;if(l(c))if(a=!0,l(i.charCodeAt(1))){let f=2,P=f;for(;f<r&&!l(i.charCodeAt(f));)f++;if(f<r&&f!==P){const L=i.slice(P,f);for(P=f;f<r&&l(i.charCodeAt(f));)f++;if(f<r&&f!==P){for(P=f;f<r&&!l(i.charCodeAt(f));)f++;if(f===r)return`\\\\${L}\\${i.slice(P)}\\`;f!==P&&(o=`\\\\${L}\\${i.slice(P,f)}`,n=f)}}}else n=1;else m(c)&&i.charCodeAt(1)===p&&(o=i.slice(0,2),n=2,r>2&&l(i.charCodeAt(2))&&(a=!0,n=3));let s=n<r?C(i.slice(n),!a,"\\",l):"";return s.length===0&&!a&&(s="."),s.length>0&&l(i.charCodeAt(r-1))&&(s+="\\"),o===void 0?a?`\\${s}`:s:a?`${o}\\${s}`:`${o}${s}`},isAbsolute(i){d(i,"path");const r=i.length;if(r===0)return!1;const n=i.charCodeAt(0);return l(n)||r>2&&m(n)&&i.charCodeAt(1)===p&&l(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,n;for(let c=0;c<i.length;++c){const s=i[c];d(s,"path"),s.length>0&&(r===void 0?r=n=s:r+=`\\${s}`)}if(r===void 0)return".";let o=!0,a=0;if(typeof n=="string"&&l(n.charCodeAt(0))){++a;const c=n.length;c>1&&l(n.charCodeAt(1))&&(++a,c>2&&(l(n.charCodeAt(2))?++a:o=!1))}if(o){for(;a<r.length&&l(r.charCodeAt(a));)a++;a>=2&&(r=`\\${r.slice(a)}`)}return e.win32.normalize(r)},relative(i,r){if(d(i,"from"),d(r,"to"),i===r)return"";const n=e.win32.resolve(i),o=e.win32.resolve(r);if(n===o||(i=n.toLowerCase(),r=o.toLowerCase(),i===r))return"";let a=0;for(;a<i.length&&i.charCodeAt(a)===g;)a++;let c=i.length;for(;c-1>a&&i.charCodeAt(c-1)===g;)c--;const s=c-a;let f=0;for(;f<r.length&&r.charCodeAt(f)===g;)f++;let P=r.length;for(;P-1>f&&r.charCodeAt(P-1)===g;)P--;const L=P-f,T=s<L?s:L;let U=-1,G=0;for(;G<T;G++){const K=i.charCodeAt(a+G);if(K!==r.charCodeAt(f+G))break;K===g&&(U=G)}if(G!==T){if(U===-1)return o}else{if(L>T){if(r.charCodeAt(f+G)===g)return o.slice(f+G+1);if(G===2)return o.slice(f+G)}s>T&&(i.charCodeAt(a+G)===g?U=G:G===2&&(U=3)),U===-1&&(U=0)}let H="";for(G=a+U+1;G<=c;++G)(G===c||i.charCodeAt(G)===g)&&(H+=H.length===0?"..":"\\..");return f+=U,H.length>0?`${H}${o.slice(f,P)}`:(o.charCodeAt(f)===g&&++f,o.slice(f,P))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const r=e.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===g){if(r.charCodeAt(1)===g){const n=r.charCodeAt(2);if(n!==y&&n!==I)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(m(r.charCodeAt(0))&&r.charCodeAt(1)===p&&r.charCodeAt(2)===g)return`\\\\?\\${r}`;return i},dirname(i){d(i,"path");const r=i.length;if(r===0)return".";let n=-1,o=0;const a=i.charCodeAt(0);if(r===1)return l(a)?i:".";if(l(a)){if(n=o=1,l(i.charCodeAt(1))){let f=2,P=f;for(;f<r&&!l(i.charCodeAt(f));)f++;if(f<r&&f!==P){for(P=f;f<r&&l(i.charCodeAt(f));)f++;if(f<r&&f!==P){for(P=f;f<r&&!l(i.charCodeAt(f));)f++;if(f===r)return i;f!==P&&(n=o=f+1)}}}}else m(a)&&i.charCodeAt(1)===p&&(n=r>2&&l(i.charCodeAt(2))?3:2,o=n);let c=-1,s=!0;for(let f=r-1;f>=o;--f)if(l(i.charCodeAt(f))){if(!s){c=f;break}}else s=!1;if(c===-1){if(n===-1)return".";c=n}return i.slice(0,c)},basename(i,r){r!==void 0&&d(r,"ext"),d(i,"path");let n=0,o=-1,a=!0,c;if(i.length>=2&&m(i.charCodeAt(0))&&i.charCodeAt(1)===p&&(n=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let s=r.length-1,f=-1;for(c=i.length-1;c>=n;--c){const P=i.charCodeAt(c);if(l(P)){if(!a){n=c+1;break}}else f===-1&&(a=!1,f=c+1),s>=0&&(P===r.charCodeAt(s)?--s===-1&&(o=c):(s=-1,o=f))}return n===o?o=f:o===-1&&(o=i.length),i.slice(n,o)}for(c=i.length-1;c>=n;--c)if(l(i.charCodeAt(c))){if(!a){n=c+1;break}}else o===-1&&(a=!1,o=c+1);return o===-1?"":i.slice(n,o)},extname(i){d(i,"path");let r=0,n=-1,o=0,a=-1,c=!0,s=0;i.length>=2&&i.charCodeAt(1)===p&&m(i.charCodeAt(0))&&(r=o=2);for(let f=i.length-1;f>=r;--f){const P=i.charCodeAt(f);if(l(P)){if(!c){o=f+1;break}continue}a===-1&&(c=!1,a=f+1),P===I?n===-1?n=f:s!==1&&(s=1):n!==-1&&(s=-1)}return n===-1||a===-1||s===0||s===1&&n===a-1&&n===o+1?"":i.slice(n,a)},format:E.bind(null,"\\"),parse(i){d(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const n=i.length;let o=0,a=i.charCodeAt(0);if(n===1)return l(a)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(l(a)){if(o=1,l(i.charCodeAt(1))){let U=2,G=U;for(;U<n&&!l(i.charCodeAt(U));)U++;if(U<n&&U!==G){for(G=U;U<n&&l(i.charCodeAt(U));)U++;if(U<n&&U!==G){for(G=U;U<n&&!l(i.charCodeAt(U));)U++;U===n?o=U:U!==G&&(o=U+1)}}}}else if(m(a)&&i.charCodeAt(1)===p){if(n<=2)return r.root=r.dir=i,r;if(o=2,l(i.charCodeAt(2))){if(n===3)return r.root=r.dir=i,r;o=3}}o>0&&(r.root=i.slice(0,o));let c=-1,s=o,f=-1,P=!0,L=i.length-1,T=0;for(;L>=o;--L){if(a=i.charCodeAt(L),l(a)){if(!P){s=L+1;break}continue}f===-1&&(P=!1,f=L+1),a===I?c===-1?c=L:T!==1&&(T=1):c!==-1&&(T=-1)}return f!==-1&&(c===-1||T===0||T===1&&c===f-1&&c===s+1?r.base=r.name=i.slice(s,f):(r.name=i.slice(s,c),r.base=i.slice(s,f),r.ext=i.slice(c,f))),s>0&&s!==o?r.dir=i.slice(0,s-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const R=(()=>{if(b){const i=/\\/g;return()=>{const r=S.cwd().replace(i,"/");return r.slice(r.indexOf("/"))}}return()=>S.cwd()})();e.posix={resolve(...i){let r="",n=!1;for(let o=i.length-1;o>=-1&&!n;o--){const a=o>=0?i[o]:R();d(a,"path"),a.length!==0&&(r=`${a}/${r}`,n=a.charCodeAt(0)===w)}return r=C(r,!n,"/",u),n?`/${r}`:r.length>0?r:"."},normalize(i){if(d(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===w,n=i.charCodeAt(i.length-1)===w;return i=C(i,!r,"/",u),i.length===0?r?"/":n?"./":".":(n&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return d(i,"path"),i.length>0&&i.charCodeAt(0)===w},join(...i){if(i.length===0)return".";let r;for(let n=0;n<i.length;++n){const o=i[n];d(o,"path"),o.length>0&&(r===void 0?r=o:r+=`/${o}`)}return r===void 0?".":e.posix.normalize(r)},relative(i,r){if(d(i,"from"),d(r,"to"),i===r||(i=e.posix.resolve(i),r=e.posix.resolve(r),i===r))return"";const n=1,o=i.length,a=o-n,c=1,s=r.length-c,f=a<s?a:s;let P=-1,L=0;for(;L<f;L++){const U=i.charCodeAt(n+L);if(U!==r.charCodeAt(c+L))break;U===w&&(P=L)}if(L===f)if(s>f){if(r.charCodeAt(c+L)===w)return r.slice(c+L+1);if(L===0)return r.slice(c+L)}else a>f&&(i.charCodeAt(n+L)===w?P=L:L===0&&(P=0));let T="";for(L=n+P+1;L<=o;++L)(L===o||i.charCodeAt(L)===w)&&(T+=T.length===0?"..":"/..");return`${T}${r.slice(c+P)}`},toNamespacedPath(i){return i},dirname(i){if(d(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===w;let n=-1,o=!0;for(let a=i.length-1;a>=1;--a)if(i.charCodeAt(a)===w){if(!o){n=a;break}}else o=!1;return n===-1?r?"/":".":r&&n===1?"//":i.slice(0,n)},basename(i,r){r!==void 0&&d(r,"ext"),d(i,"path");let n=0,o=-1,a=!0,c;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let s=r.length-1,f=-1;for(c=i.length-1;c>=0;--c){const P=i.charCodeAt(c);if(P===w){if(!a){n=c+1;break}}else f===-1&&(a=!1,f=c+1),s>=0&&(P===r.charCodeAt(s)?--s===-1&&(o=c):(s=-1,o=f))}return n===o?o=f:o===-1&&(o=i.length),i.slice(n,o)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===w){if(!a){n=c+1;break}}else o===-1&&(a=!1,o=c+1);return o===-1?"":i.slice(n,o)},extname(i){d(i,"path");let r=-1,n=0,o=-1,a=!0,c=0;for(let s=i.length-1;s>=0;--s){const f=i.charCodeAt(s);if(f===w){if(!a){n=s+1;break}continue}o===-1&&(a=!1,o=s+1),f===I?r===-1?r=s:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||o===-1||c===0||c===1&&r===o-1&&r===n+1?"":i.slice(r,o)},format:E.bind(null,"/"),parse(i){d(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const n=i.charCodeAt(0)===w;let o;n?(r.root="/",o=1):o=0;let a=-1,c=0,s=-1,f=!0,P=i.length-1,L=0;for(;P>=o;--P){const T=i.charCodeAt(P);if(T===w){if(!f){c=P+1;break}continue}s===-1&&(f=!1,s=P+1),T===I?a===-1?a=P:L!==1&&(L=1):a!==-1&&(L=-1)}if(s!==-1){const T=c===0&&n?1:c;a===-1||L===0||L===1&&a===s-1&&a===c+1?r.base=r.name=i.slice(T,s):(r.name=i.slice(T,a),r.base=i.slice(T,s),r.ext=i.slice(a,s))}return c>0?r.dir=i.slice(0,c-1):n&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b?e.win32.normalize:e.posix.normalize,e.isAbsolute=b?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b?e.win32.join:e.posix.join,e.resolve=b?e.win32.resolve:e.posix.resolve,e.relative=b?e.win32.relative:e.posix.relative,e.dirname=b?e.win32.dirname:e.posix.dirname,e.basename=b?e.win32.basename:e.posix.basename,e.extname=b?e.win32.extname:e.posix.extname,e.format=b?e.win32.format:e.posix.format,e.parse=b?e.win32.parse:e.posix.parse,e.toNamespacedPath=b?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b?e.win32.sep:e.posix.sep,e.delimiter=b?e.win32.delimiter:e.posix.delimiter}),define(te[80],ne([0,1,4]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function M(I,...w){const g=w.reduce((v,h)=>(v[h]=!0,v),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(v=>!g[v]).forEach(v=>{for(let h=0;h<p.length;h++)if(v.search(p[h])!==-1){delete I[v];break}})}e.sanitizeProcessEnvironment=M;function A(I){!I||(delete I.DEBUG,S.isMacintosh&&delete I.DYLD_LIBRARY_PATH,S.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(te[81],ne([0,1,4]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=S.globals.performance&&typeof S.globals.performance.now=="function";class k{static create(A=!0){return new k(A)}constructor(A){this.a=t&&A,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?S.globals.performance.now():Date.now()}}e.StopWatch=k}),define(te[3],ne([0,1,13,50,2,96,81]),function(V,e,S,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,w=!1;var g;(function(c){c.None=()=>k.Disposable.None;function s(j){if(w){const{onDidAddListener:q}=j,X=d.create();let B=0;j.onDidAddListener=()=>{++B===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),X.print()),q?.()}}}function f(j,q){return Z(j,()=>{},0,void 0,void 0,q)}c.defer=f;function P(j){return(q,X=null,B)=>{let Q=!1,ie;return ie=j(ae=>{if(!Q)return ie?ie.dispose():Q=!0,q.call(X,ae)},null,B),Q&&ie.dispose(),ie}}c.once=P;function L(j,q,X){return se((B,Q=null,ie)=>j(ae=>B.call(Q,q(ae)),null,ie),X)}c.map=L;function T(j,q,X){return se((B,Q=null,ie)=>j(ae=>{q(ae),B.call(Q,ae)},null,ie),X)}c.forEach=T;function U(j,q,X){return se((B,Q=null,ie)=>j(ae=>q(ae)&&B.call(Q,ae),null,ie),X)}c.filter=U;function G(j){return j}c.signal=G;function H(...j){return(q,X=null,B)=>(0,k.combinedDisposable)(...j.map(Q=>Q(ie=>q.call(X,ie),null,B)))}c.any=H;function K(j,q,X,B){let Q=X;return L(j,ie=>(Q=q(Q,ie),Q),B)}c.reduce=K;function se(j,q){let X;const B={onWillAddFirstListener(){X=j(Q.fire,Q)},onDidRemoveLastListener(){X?.dispose()}};q||s(B);const Q=new l(B);return q?.add(Q),Q.event}function Z(j,q,X=100,B=!1,Q,ie){let ae,de,ke,Oe=0;const De={leakWarningThreshold:Q,onWillAddFirstListener(){ae=j(ve=>{Oe++,de=q(de,ve),B&&!ke&&(Me.fire(de),de=void 0),clearTimeout(ke),ke=setTimeout(()=>{const we=de;de=void 0,ke=void 0,(!B||Oe>1)&&Me.fire(we),Oe=0},X)})},onDidRemoveLastListener(){ae.dispose()}};ie||s(De);const Me=new l(De);return ie?.add(Me),Me.event}c.debounce=Z;function ce(j,q=0,X){return c.debounce(j,(B,Q)=>B?(B.push(Q),B):[Q],q,void 0,void 0,X)}c.accumulate=ce;function ge(j,q=(B,Q)=>B===Q,X){let B=!0,Q;return U(j,ie=>{const ae=B||!q(ie,Q);return B=!1,Q=ie,ae},X)}c.latch=ge;function _(j,q,X){return[c.filter(j,q,X),c.filter(j,B=>!q(B),X)]}c.split=_;function $(j,q=!1,X=[]){let B=X.slice(),Q=j(de=>{B?B.push(de):ae.fire(de)});const ie=()=>{B?.forEach(de=>ae.fire(de)),B=null},ae=new l({onWillAddFirstListener(){Q||(Q=j(de=>ae.fire(de)))},onDidAddFirstListener(){B&&(q?setTimeout(ie):ie())},onDidRemoveLastListener(){Q&&Q.dispose(),Q=null}});return ae.event}c.buffer=$;class N{constructor(q){this.event=q,this.c=new k.DisposableStore}map(q){return new N(L(this.event,q,this.c))}forEach(q){return new N(T(this.event,q,this.c))}filter(q){return new N(U(this.event,q,this.c))}reduce(q,X){return new N(K(this.event,q,X,this.c))}latch(){return new N(ge(this.event,void 0,this.c))}debounce(q,X=100,B=!1,Q){return new N(Z(this.event,q,X,B,Q,this.c))}on(q,X,B){return this.event(q,X,B)}once(q,X,B){return P(this.event)(q,X,B)}dispose(){this.c.dispose()}}function W(j){return new N(j)}c.chain=W;function z(j,q,X=B=>B){const B=(...de)=>ae.fire(X(...de)),Q=()=>j.on(q,B),ie=()=>j.removeListener(q,B),ae=new l({onWillAddFirstListener:Q,onDidRemoveLastListener:ie});return ae.event}c.fromNodeEventEmitter=z;function Y(j,q,X=B=>B){const B=(...de)=>ae.fire(X(...de)),Q=()=>j.addEventListener(q,B),ie=()=>j.removeEventListener(q,B),ae=new l({onWillAddFirstListener:Q,onDidRemoveLastListener:ie});return ae.event}c.fromDOMEventEmitter=Y;function oe(j){return new Promise(q=>P(j)(q))}c.toPromise=oe;function ee(j,q){return q(void 0),j(X=>q(X))}c.runAndSubscribe=ee;function D(j,q){let X=null;function B(ie){X?.dispose(),X=new k.DisposableStore,q(ie,X)}B(void 0);const Q=j(ie=>B(ie));return(0,k.toDisposable)(()=>{Q.dispose(),X?.dispose()})}c.runAndSubscribeWithStore=D;class O{constructor(q,X){this.obs=q,this.c=0,this.d=!1;const B={onWillAddFirstListener:()=>{q.addObserver(this)},onDidRemoveLastListener:()=>{q.removeObserver(this)}};X||s(B),this.emitter=new l(B),X&&X.add(this.emitter)}beginUpdate(q){this.c++}handleChange(q,X){this.d=!0}endUpdate(q){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function F(j,q){return new O(j,q).emitter.event}c.fromObservable=F})(g=e.Event||(e.Event={}));class p{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${p.c++}`,p.all.add(this)}start(s){this.d=new A.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=p,p.all=new Set,p.c=0;let y=-1;function v(c){const s=y;return y=c,{dispose(){y=s}}}e.setGlobalLeakWarningThreshold=v;class h{constructor(s,f=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=f,this.d=0}dispose(){this.c?.clear()}check(s,f){const P=this.threshold;if(P<=0||f<P)return;this.c||(this.c=new Map);const L=this.c.get(s.value)||0;if(this.c.set(s.value,L+1),this.d-=1,this.d<=0){this.d=P*.5;let T,U=0;for(const[G,H]of this.c)(!T||U<H)&&(T=G,U=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${U}):`),console.warn(T)}return()=>{const T=this.c.get(s.value)||0;this.c.set(s.value,T-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(s,f,P){this.callback=s,this.callbackThis=f,this.stack=P,this.subscription=new k.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class l{constructor(s){this.j=!1,this.d=s,this.f=y>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??y):void 0,this.g=this.d?._profName?new p(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(I){const s=Array.from(this.q);queueMicrotask(()=>{for(const f of s)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,f,P)=>{if(this.q||(this.q=new M.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.Disposable.None;const L=this.q.isEmpty();L&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let T,U;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(U=d.create(),T=this.f.check(U,this.q.size+1)),I&&(U=U??d.create());const G=new b(s,f,U),H=this.q.push(G);L&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,f);const K=G.subscription.set(()=>{T?.(),this.j||(H(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return P instanceof k.DisposableStore?P.add(K):Array.isArray(P)&&P.push(K),K}),this.l}fire(s){if(this.q){this.m||(this.m=new m);for(const f of this.q)this.m.push(this,f,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=l;class u{constructor(){this.c=new M.LinkedList}get size(){return this.c.size}push(s,f,P){this.c.push(new C(s,f,P))}clear(s){const f=new M.LinkedList;for(const P of this.c)P.emitter!==s&&f.push(P);this.c=f}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(f){(0,S.onUnexpectedError)(f)}}}}e.EventDeliveryQueue=u;class m extends u{clear(s){this.c.clear()}}class C{constructor(s,f,P){this.emitter=s,this.listener=f,this.event=P}}class E extends l{async fireAsync(s,f,P){if(!!this.q){this.c||(this.c=new M.LinkedList);for(const L of this.q)this.c.push([L,s]);for(;this.c.size>0&&!f.isCancellationRequested;){const[L,T]=this.c.shift(),U=[],G={...T,token:f,waitUntil:H=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");P&&(H=P(H,L.callback)),U.push(H)}};try{L.invoke(G)}catch(H){(0,S.onUnexpectedError)(H);continue}Object.freeze(U),await Promise.allSettled(U).then(H=>{for(const K of H)K.status==="rejected"&&(0,S.onUnexpectedError)(K.reason)})}}}}e.AsyncEmitter=E;class R extends l{constructor(s){super(s),this.h=0,this.s=new M.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=R;class i extends R{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=i;class r extends l{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(f=>super.fire(f)),this.c=[]}))}}e.MicrotaskEmitter=r;class n{constructor(){this.d=!1,this.f=[],this.c=new l({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const f={event:s,listener:null};this.f.push(f),this.d&&this.j(f);const P=()=>{this.d&&this.k(f);const L=this.f.indexOf(f);this.f.splice(L,1)};return(0,k.toDisposable)((0,t.once)(P))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(f=>this.c.fire(f))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=n;class o{constructor(){this.c=[]}wrapEvent(s){return(f,P,L)=>s(T=>{const U=this.c[this.c.length-1];U?U.push(()=>f.call(P,T)):f.call(P,T)},void 0,L)}bufferEvents(s){const f=[];this.c.push(f);const P=s();return this.c.pop(),f.forEach(L=>L()),P}}e.EventBufferer=o;class a{constructor(){this.c=!1,this.d=g.None,this.f=k.Disposable.None,this.g=new l({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=a}),define(te[22],ne([0,1,3]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(I,w){const g=setTimeout(I.bind(w),0);return{dispose(){clearTimeout(g)}}});var k;(function(I){function w(g){return g===I.None||g===I.Cancelled||g instanceof M?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}I.isCancellationToken=w,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new S.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(w){this.a=void 0,this.b=void 0,this.b=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new M),this.a}cancel(){this.a?this.a instanceof M&&this.a.cancel():this.a=k.Cancelled}dispose(w=!1){w&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof M&&this.a.dispose():this.a=k.None}}e.CancellationTokenSource=A}),define(te[139],ne([0,1,22]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(I){this.b=I,this.a=null}get(){if(this.a)return this.a;const I=new S.CancellationTokenSource,w=this.b(I.token);return this.a={promise:w,dispose:()=>{this.a=null,I.cancel(),I.dispose()}},this.a}}e.Cache=t;class k{constructor(I){this.c=I,this.a=void 0,this.b=void 0}get(I){const w=JSON.stringify(I);return this.b!==w&&(this.b=w,this.a=this.c(I)),this.a}}e.LRUCachedFunction=k;class M{get cachedValues(){return this.a}constructor(I){this.b=I,this.a=new Map}get(I){if(this.a.has(I))return this.a.get(I);const w=this.b(I);return this.a.set(I,w),w}}e.CachedFunction=M}),define(te[26],ne([0,1,139,125]),function(V,e,S,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function M(J){return!J||typeof J!="string"?!0:J.trim().length===0}e.isFalsyOrWhitespace=M;const A=/{(\d+)}/g;function I(J,...le){return le.length===0?J:J.replace(A,function(ue,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=le.length?ue:le[Se]})}e.format=I;const w=/{([^}]+)}/g;function g(J,le){return J.replace(w,(ue,me)=>le[me]??ue)}e.format2=g;function p(J){return J.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=p;function y(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function v(J,le){let ue=0;const me=le.charCodeAt(0);for(let Se=J.length-1;Se>=0;Se--)J.charCodeAt(Se)===me&&ue++;return ue}e.count=v;function h(J,le,ue="\u2026"){return J.length<=le?J:`${J.substr(0,le)}${ue}`}e.truncate=h;function d(J,le=" "){const ue=b(J,le);return l(ue,le)}e.trim=d;function b(J,le){if(!J||!le)return J;const ue=le.length;if(ue===0||J.length===0)return J;let me=0;for(;J.indexOf(le,me)===me;)me=me+ue;return J.substring(me)}e.ltrim=b;function l(J,le){if(!J||!le)return J;const ue=le.length,me=J.length;if(ue===0||me===0)return J;let Se=me,Le=-1;for(;Le=J.lastIndexOf(le,Se-1),!(Le===-1||Le+ue!==Se);){if(Le===0)return"";Se=Le}return J.substring(0,Se)}e.rtrim=l;function u(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function m(J){return J.replace(/\*/g,"")}e.stripWildcards=m;function C(J,le,ue={}){if(!J)throw new Error("Cannot create regex from empty string");le||(J=y(J)),ue.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let me="";return ue.global&&(me+="g"),ue.matchCase||(me+="i"),ue.multiline&&(me+="m"),ue.unicode&&(me+="u"),new RegExp(J,me)}e.createRegExp=C;function E(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function R(J){return!!J.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=R;function i(J){return(J.global?"g":"")+(J.ignoreCase?"i":"")+(J.multiline?"m":"")+(J.unicode?"u":"")}e.regExpFlags=i;function r(J){return J.split(/\r\n|\r|\n/)}e.splitLines=r;function n(J){for(let le=0,ue=J.length;le<ue;le++){const me=J.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=n;function o(J,le=0,ue=J.length){for(let me=le;me<ue;me++){const Se=J.charCodeAt(me);if(Se!==32&&Se!==9)return J.substring(le,me)}return J.substring(le,ue)}e.getLeadingWhitespace=o;function a(J,le=J.length-1){for(let ue=le;ue>=0;ue--){const me=J.charCodeAt(ue);if(me!==32&&me!==9)return ue}return-1}e.lastNonWhitespaceIndex=a;function c(J,le,ue){const me=[];let Se=0;for(const Le of J.matchAll(le)){if(me.push(J.slice(Se,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");Se=Le.index+Le[0].length,me.push(ue(Le[0],...Le.slice(1),Le.index,J,Le.groups))}return me.push(J.slice(Se)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=c;function s(J,le){return J<le?-1:J>le?1:0}e.compare=s;function f(J,le,ue=0,me=J.length,Se=0,Le=le.length){for(;ue<me&&Se<Le;ue++,Se++){const xe=J.charCodeAt(ue),He=le.charCodeAt(Se);if(xe<He)return-1;if(xe>He)return 1}const Be=me-ue,it=Le-Se;return Be<it?-1:Be>it?1:0}e.compareSubstring=f;function P(J,le){return L(J,le,0,J.length,0,le.length)}e.compareIgnoreCase=P;function L(J,le,ue=0,me=J.length,Se=0,Le=le.length){for(;ue<me&&Se<Le;ue++,Se++){let xe=J.charCodeAt(ue),He=le.charCodeAt(Se);if(xe===He)continue;if(xe>=128||He>=128)return f(J.toLowerCase(),le.toLowerCase(),ue,me,Se,Le);U(xe)&&(xe-=32),U(He)&&(He-=32);const tt=xe-He;if(tt!==0)return tt}const Be=me-ue,it=Le-Se;return Be<it?-1:Be>it?1:0}e.compareSubstringIgnoreCase=L;function T(J){return J>=48&&J<=57}e.isAsciiDigit=T;function U(J){return J>=97&&J<=122}e.isLowerAsciiLetter=U;function G(J){return J>=65&&J<=90}e.isUpperAsciiLetter=G;function H(J,le){return J.length===le.length&&L(J,le)===0}e.equalsIgnoreCase=H;function K(J,le){const ue=le.length;return le.length>J.length?!1:L(J,le,0,ue)===0}e.startsWithIgnoreCase=K;function se(J,le){const ue=Math.min(J.length,le.length);let me;for(me=0;me<ue;me++)if(J.charCodeAt(me)!==le.charCodeAt(me))return me;return ue}e.commonPrefixLength=se;function Z(J,le){const ue=Math.min(J.length,le.length);let me;const Se=J.length-1,Le=le.length-1;for(me=0;me<ue;me++)if(J.charCodeAt(Se-me)!==le.charCodeAt(Le-me))return me;return ue}e.commonSuffixLength=Z;function ce(J){return 55296<=J&&J<=56319}e.isHighSurrogate=ce;function ge(J){return 56320<=J&&J<=57343}e.isLowSurrogate=ge;function _(J,le){return(J-55296<<10)+(le-56320)+65536}e.computeCodePoint=_;function $(J,le,ue){const me=J.charCodeAt(ue);if(ce(me)&&ue+1<le){const Se=J.charCodeAt(ue+1);if(ge(Se))return _(me,Se)}return me}e.getNextCodePoint=$;function N(J,le){const ue=J.charCodeAt(le-1);if(ge(ue)&&le>1){const me=J.charCodeAt(le-2);if(ce(me))return _(me,ue)}return ue}class W{get offset(){return this.e}constructor(le,ue=0){this.c=le,this.d=le.length,this.e=ue}setOffset(le){this.e=le}prevCodePoint(){const le=N(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=$(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}e.CodePointIterator=W;class z{get offset(){return this.c.offset}constructor(le,ue=0){this.c=new W(le,ue)}nextGraphemeLength(){const le=We.getInstance(),ue=this.c,me=ue.offset;let Se=le.getGraphemeBreakType(ue.nextCodePoint());for(;!ue.eol();){const Le=ue.offset,Be=le.getGraphemeBreakType(ue.nextCodePoint());if(be(Se,Be)){ue.setOffset(Le);break}Se=Be}return ue.offset-me}prevGraphemeLength(){const le=We.getInstance(),ue=this.c,me=ue.offset;let Se=le.getGraphemeBreakType(ue.prevCodePoint());for(;ue.offset>0;){const Le=ue.offset,Be=le.getGraphemeBreakType(ue.prevCodePoint());if(be(Be,Se)){ue.setOffset(Le);break}Se=Be}return me-ue.offset}eol(){return this.c.eol()}}e.GraphemeIterator=z;function Y(J,le){return new z(J,le).nextGraphemeLength()}e.nextCharLength=Y;function oe(J,le){return new z(J,le).prevGraphemeLength()}e.prevCharLength=oe;function ee(J,le){le>0&&ge(J.charCodeAt(le))&&le--;const ue=le+Y(J,le);return[ue-oe(J,ue),ue]}e.getCharContainingOffset=ee;function D(J){const le=new z(J);let ue=0;for(;!le.eol();)ue++,le.nextGraphemeLength();return ue}e.charCount=D;let O;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(J){return O||(O=F()),O.test(J)}e.containsRTL=j;const q=/^[\t\n\r\x20-\x7E]*$/;function X(J){return q.test(J)}e.isBasicASCII=X,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(J){return e.UNUSUAL_LINE_TERMINATORS.test(J)}e.containsUnusualLineTerminators=B;function Q(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}e.isFullWidthCharacter=Q;function ie(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}e.isEmojiImprecise=ie;function ae(J,le){if(J.length<le)return J;const ue=/\b/g;let me=0;for(;ue.test(J)&&!(J.length-ue.lastIndex<le);)me=ue.lastIndex,ue.lastIndex+=1;return J.substring(me).replace(/^\s/,"")}e.lcut=ae;const de=/\x1B\x5B[12]?K/g,ke=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function De(J){return J&&(J=J.replace(de,""),J=J.replace(ke,""),J=J.replace(Oe,"")),J}e.removeAnsiEscapeCodes=De,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Me(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Me;function ve(J){return Me(J)?J.substr(1):J}e.stripUTF8BOM=ve;function we(J,le){if(!J||!le||J.length<le.length)return!1;const ue=le.length,me=J.toLowerCase();let Se=0,Le=-1;for(;Se<ue;){const Be=me.indexOf(le[Se],Le+1);if(Be<0)return!1;Le=Be,Se++}return!0}e.fuzzyContains=we;function ye(J,le=!1){return J?(le&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}e.containsUppercaseCharacter=ye;function Re(J){return J.charAt(0).toUpperCase()+J.slice(1)}e.uppercaseFirstLetter=Re;function re(J,le=1){if(le===0)return"";let ue=-1;do ue=J.indexOf(`
`,ue+1),le--;while(le>0&&ue>=0);return ue===-1?J:(J[ue-1]==="\r"&&ue--,J.substr(0,ue))}e.getNLines=re;function he(J){return J=J%(2*26),J<26?String.fromCharCode(97+J):String.fromCharCode(65+J-26)}e.singleLetterHash=he;function fe(J){return We.getInstance().getGraphemeBreakType(J)}e.getGraphemeBreakType=fe;function be(J,le){return J===0?le!==5&&le!==7:J===2&&le===3?!1:J===4||J===2||J===3||le===4||le===2||le===3?!0:!(J===8&&(le===8||le===9||le===11||le===12)||(J===11||J===9)&&(le===9||le===10)||(J===12||J===10)&&le===10||le===5||le===13||le===7||J===1||J===13&&le===14||J===6&&le===6)}var Pe;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=Te()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const ue=this.d,me=ue.length/3;let Se=1;for(;Se<=me;)if(le<ue[3*Se])Se=2*Se;else if(le>ue[3*Se+1])Se=2*Se+1;else return ue[3*Se+2];return 0}}We.c=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(J,le){if(J===0)return 0;const ue=Ue(J,le);if(ue!==void 0)return ue;const me=new W(le,J);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=qe;function Ue(J,le){const ue=new W(le,J);let me=ue.prevCodePoint();for(;je(me)||me===65039||me===8419;){if(ue.offset===0)return;me=ue.prevCodePoint()}if(!ie(me))return;let Se=ue.offset;return Se>0&&ue.prevCodePoint()===8205&&(Se=ue.offset),Se}function je(J){return 127995<=J&&J<=127999}var Xe;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.noBreakWhitespace="\xA0";class $e{static getInstance(le){return $e.d.get(Array.from(le))}static getLocales(){return $e.e.getValue()}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=$e,k=$e,$e.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),$e.d=new S.LRUCachedFunction(J=>{function le(He){const tt=new Map;for(let nt=0;nt<He.length;nt+=2)tt.set(He[nt],He[nt+1]);return tt}function ue(He,tt){const nt=new Map(He);for(const[lt,at]of tt)nt.set(lt,at);return nt}function me(He,tt){if(!He)return tt;const nt=new Map;for(const[lt,at]of He)tt.has(lt)&&nt.set(lt,at);return nt}const Se=k.c.getValue();let Le=J.filter(He=>!He.startsWith("_")&&He in Se);Le.length===0&&(Le=["_default"]);let Be;for(const He of Le){const tt=le(Se[He]);Be=me(Be,tt)}const it=le(Se._common),xe=ue(it,Be);return new $e(xe)}),$e.e=new t.Lazy(()=>Object.keys($e.c.getValue()).filter(J=>!J.startsWith("_")));class Ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ke.c())),this.d}static isInvisibleCharacter(le){return Ke.e().has(le)}static get codePoints(){return Ke.e()}}e.InvisibleCharacters=Ke,Ke.d=void 0}),define(te[31],ne([0,1,9,4,26,11]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(a){return a===47||a===92}e.isPathSeparator=A;function I(a){return a.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=I;function w(a){return a.indexOf("/")===-1&&(a=I(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=w;function g(a,c=S.posix.sep){if(!a)return"";const s=a.length,f=a.charCodeAt(0);if(A(f)){if(A(a.charCodeAt(1))&&!A(a.charCodeAt(2))){let L=3;const T=L;for(;L<s&&!A(a.charCodeAt(L));L++);if(T!==L&&!A(a.charCodeAt(L+1))){for(L+=1;L<s;L++)if(A(a.charCodeAt(L)))return a.slice(0,L+1).replace(/[\\/]/g,c)}}return c}else if(u(f)&&a.charCodeAt(1)===58)return A(a.charCodeAt(2))?a.slice(0,2)+c:a.slice(0,2);let P=a.indexOf("://");if(P!==-1){for(P+=3;P<s;P++)if(A(a.charCodeAt(P)))return a.slice(0,P+1)}return""}e.getRoot=g;function p(a){if(!t.isWindows||!a||a.length<5)return!1;let c=a.charCodeAt(0);if(c!==92||(c=a.charCodeAt(1),c!==92))return!1;let s=2;const f=s;for(;s<a.length&&(c=a.charCodeAt(s),c!==92);s++);return!(f===s||(c=a.charCodeAt(s+1),isNaN(c)||c===92))}e.isUNC=p;const y=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(a,c=t.isWindows){const s=c?y:v;return!(!a||a.length===0||/^\s+$/.test(a)||(s.lastIndex=0,s.test(a))||c&&h.test(a)||a==="."||a===".."||c&&a[a.length-1]==="."||c&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=d;function b(a,c,s){const f=a===c;return!s||f?f:!a||!c?!1:(0,k.equalsIgnoreCase)(a,c)}e.isEqual=b;function l(a,c,s,f=S.sep){if(a===c)return!0;if(!a||!c||c.length>a.length)return!1;if(s){if(!(0,k.startsWithIgnoreCase)(a,c))return!1;if(c.length===a.length)return!0;let L=c.length;return c.charAt(c.length-1)===f&&L--,a.charAt(L)===f}return c.charAt(c.length-1)!==f&&(c+=f),a.indexOf(c)===0}e.isEqualOrParent=l;function u(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=u;function m(a,c){return t.isWindows&&a.endsWith(":")&&(a+=S.sep),(0,S.isAbsolute)(a)||(a=(0,S.join)(c,a)),a=(0,S.normalize)(a),t.isWindows?(a=(0,k.rtrim)(a,S.sep),a.endsWith(":")&&(a+=S.sep)):(a=(0,k.rtrim)(a,S.sep),a||(a=S.sep)),a}e.sanitizeFilePath=m;function C(a){const c=(0,S.normalize)(a);return t.isWindows?a.length>3?!1:E(c)&&(a.length===2||c.charCodeAt(2)===92):c===S.posix.sep}e.isRootOrDriveLetter=C;function E(a,c=t.isWindows){return c?u(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function R(a){return E(a)?a[0]:void 0}e.getDriveLetter=R;function i(a,c,s){return c.length>a.length?-1:a===c?0:(s&&(a=a.toLowerCase(),c=c.toLowerCase()),a.indexOf(c))}e.indexOfPath=i;function r(a){const c=a.split(":");let s,f,P;for(const L of c){const T=Number(L);(0,M.isNumber)(T)?f===void 0?f=T:P===void 0&&(P=T):s=s?[s,L].join(":"):L}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:f!==void 0?f:void 0,column:P!==void 0?P:f!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(a,c,s=8){let f="";for(let L=0;L<s;L++)f+=n.charAt(Math.floor(Math.random()*n.length));let P;return c?P=`${c}-${f}`:P=f,a?(0,S.join)(a,P):P}e.randomPath=o}),define(te[68],ne([0,1,26]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(u){return k(u,0)}e.hash=t;function k(u,m){switch(typeof u){case"object":return u===null?M(349,m):Array.isArray(u)?w(u,m):g(u,m);case"string":return I(u,m);case"boolean":return A(u,m);case"number":return M(u,m);case"undefined":return M(937,m);default:return M(617,m)}}e.doHash=k;function M(u,m){return(m<<5)-m+u|0}e.numberHash=M;function A(u,m){return M(u?433:863,m)}function I(u,m){m=M(149417,m);for(let C=0,E=u.length;C<E;C++)m=M(u.charCodeAt(C),m);return m}e.stringHash=I;function w(u,m){return m=M(104579,m),u.reduce((C,E)=>k(E,C),m)}function g(u,m){return m=M(181387,m),Object.keys(u).sort().reduce((C,E)=>(C=I(E,C),k(u[E],C)),m)}class p{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=k(m,this.g),this.g}}e.Hasher=p;var y;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function v(u,m,C=32){const E=C-m,R=~((1<<E)-1);return(u<<m|(R&u)>>>E)>>>0}function h(u,m=0,C=u.byteLength,E=0){for(let R=0;R<C;R++)u[m+R]=E}function d(u,m,C="0"){for(;u.length<m;)u=C+u;return u}function b(u,m=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(C=>C.toString(16).padStart(2,"0")).join(""):d((u>>>0).toString(16),m/4)}e.toHexString=b;class l{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const C=m.length;if(C===0)return;const E=this.p;let R=this.r,i=this.u,r,n;for(i!==0?(r=i,n=-1,i=0):(r=m.charCodeAt(0),n=0);;){let o=r;if(S.isHighSurrogate(r))if(n+1<C){const a=m.charCodeAt(n+1);S.isLowSurrogate(a)?(n++,o=S.computeCodePoint(r,a)):o=65533}else{i=r;break}else S.isLowSurrogate(r)&&(o=65533);if(R=this.w(E,R,o),n++,n<C)r=m.charCodeAt(n);else break}this.r=R,this.u=i}w(m,C,E){return E<128?m[C++]=E:E<2048?(m[C++]=192|(E&1984)>>>6,m[C++]=128|(E&63)>>>0):E<65536?(m[C++]=224|(E&61440)>>>12,m[C++]=128|(E&4032)>>>6,m[C++]=128|(E&63)>>>0):(m[C++]=240|(E&1835008)>>>18,m[C++]=128|(E&258048)>>>12,m[C++]=128|(E&4032)>>>6,m[C++]=128|(E&63)>>>0),C>=64&&(this.y(),C-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),C}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=l.g,C=this.q;for(let s=0;s<64;s+=4)m.setUint32(s,C.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)m.setUint32(s,v(m.getUint32(s-12,!1)^m.getUint32(s-32,!1)^m.getUint32(s-56,!1)^m.getUint32(s-64,!1),1),!1);let E=this.h,R=this.l,i=this.m,r=this.n,n=this.o,o,a,c;for(let s=0;s<80;s++)s<20?(o=R&i|~R&r,a=1518500249):s<40?(o=R^i^r,a=1859775393):s<60?(o=R&i|R&r|i&r,a=2400959708):(o=R^i^r,a=3395469782),c=v(E,5)+o+n+a+m.getUint32(s*4,!1)&4294967295,n=r,r=i,i=v(R,30),R=E,E=c;this.h=this.h+E&4294967295,this.l=this.l+R&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+n&4294967295}}e.StringSHA1=l,l.g=new DataView(new ArrayBuffer(320))}),define(te[98],ne([0,1,26]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const M="error",A="warning",I="warn",w="info",g="ignore";function p(v){return v?S.equalsIgnoreCase(M,v)?k.Error:S.equalsIgnoreCase(A,v)||S.equalsIgnoreCase(I,v)?k.Warning:S.equalsIgnoreCase(w,v)?k.Info:k.Ignore:k.Ignore}k.fromValue=p;function y(v){switch(v){case k.Error:return M;case k.Warning:return A;case k.Info:return w;default:return g}}k.toString=y}(t||(t={})),e.default=t}),define(te[60],ne([0,1,24,26]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const d=h.charCodeAt(0),b=this.b.charCodeAt(this.c);return d-b}value(){return this.b[this.c]}}e.StringIterator=k;class M{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,t.compareSubstring)(h,this.b,0,h.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class A{constructor(h=!0,d=!0){this.f=h,this.g=d}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let d=h.length-1;d>=0;d--,this.c--){const b=this.b.charCodeAt(d);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,t.compareSubstring)(h,this.b,0,h.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=A;var I;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(I||(I={}));class w{constructor(h,d){this.f=h,this.g=d,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(h,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,t.compare)(h,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=w;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(p||(p={}));class y{static forUris(h=()=>!1,d=()=>!1){return new y(new w(h,d))}static forPaths(h=!1){return new y(new A(void 0,!h))}static forStrings(){return new y(new k)}static forConfigKeys(){return new y(new M)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,d){if(d){const b=d.slice(0);(0,S.shuffle)(b);for(const l of b)this.set(l,h)}else{const b=h.slice(0);(0,S.shuffle)(b);for(const l of b)this.set(l[0],l[1])}}set(h,d){const b=this.b.reset(h);let l;this.c||(this.c=new g,this.c.segment=b.value());const u=[];for(l=this.c;;){const C=b.cmp(l.segment);if(C>0)l.left||(l.left=new g,l.left.segment=b.value()),u.push([-1,l]),l=l.left;else if(C<0)l.right||(l.right=new g,l.right.segment=b.value()),u.push([1,l]),l=l.right;else if(b.hasNext())b.next(),l.mid||(l.mid=new g,l.mid.segment=b.value()),u.push([0,l]),l=l.mid;else break}const m=l.value;l.value=d,l.key=h;for(let C=u.length-1;C>=0;C--){const E=u[C][1];E.updateHeight();const R=E.balanceFactor();if(R<-1||R>1){const i=u[C][0],r=u[C+1][0];if(i===1&&r===1)u[C][1]=E.rotateLeft();else if(i===-1&&r===-1)u[C][1]=E.rotateRight();else if(i===1&&r===-1)E.right=u[C+1][1]=u[C+1][1].rotateRight(),u[C][1]=E.rotateLeft();else if(i===-1&&r===1)E.left=u[C+1][1]=u[C+1][1].rotateLeft(),u[C][1]=E.rotateRight();else throw new Error;if(C>0)switch(u[C-1][0]){case-1:u[C-1][1].left=u[C][1];break;case 1:u[C-1][1].right=u[C][1];break;case 0:u[C-1][1].mid=u[C][1];break}else this.c=u[0][1]}}return m}get(h){return this.d(h)?.value}d(h){const d=this.b.reset(h);let b=this.c;for(;b;){const l=d.cmp(b.segment);if(l>0)b=b.left;else if(l<0)b=b.right;else if(d.hasNext())d.next(),b=b.mid;else break}return b}has(h){const d=this.d(h);return!(d?.value===void 0&&d?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,d){const b=this.b.reset(h),l=[];let u=this.c;for(;u;){const m=b.cmp(u.segment);if(m>0)l.push([-1,u]),u=u.left;else if(m<0)l.push([1,u]),u=u.right;else if(b.hasNext())b.next(),l.push([0,u]),u=u.mid;else break}if(!!u){if(d?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const m=this.f(u.right);if(m.key){const{key:C,value:E,segment:R}=m;this.e(m.key,!1),u.key=C,u.value=E,u.segment=R}}else{const m=u.left??u.right;if(l.length>0){const[C,E]=l[l.length-1];switch(C){case-1:E.left=m;break;case 0:E.mid=m;break;case 1:E.right=m;break}}else this.c=m}for(let m=l.length-1;m>=0;m--){const C=l[m][1];C.updateHeight();const E=C.balanceFactor();if(E>1?(C.right.balanceFactor()>=0||(C.right=C.right.rotateRight()),l[m][1]=C.rotateLeft()):E<-1&&(C.left.balanceFactor()<=0||(C.left=C.left.rotateLeft()),l[m][1]=C.rotateRight()),m>0)switch(l[m-1][0]){case-1:l[m-1][1].left=l[m][1];break;case 1:l[m-1][1].right=l[m][1];break;case 0:l[m-1][1].mid=l[m][1];break}else this.c=l[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const d=this.b.reset(h);let b=this.c,l;for(;b;){const u=d.cmp(b.segment);if(u>0)b=b.left;else if(u<0)b=b.right;else if(d.hasNext())d.next(),l=b.value||l,b=b.mid;else break}return b&&b.value||l}findSuperstr(h){return this.g(h,!1)}g(h,d){const b=this.b.reset(h);let l=this.c;for(;l;){const u=b.cmp(l.segment);if(u>0)l=l.left;else if(u<0)l=l.right;else if(b.hasNext())b.next(),l=l.mid;else return l.mid?this.h(l.mid):d?l.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[d,b]of this)h(b,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const d=[];return this.j(h,d),d[Symbol.iterator]()}j(h,d){!h||(h.left&&this.j(h.left,d),h.value&&d.push([h.key,h.value]),h.mid&&this.j(h.mid,d),h.right&&this.j(h.right,d))}_isBalanced(){const h=d=>{if(!d)return!0;const b=d.balanceFactor();return b<-1||b>1?!1:h(d.left)&&h(d.right)};return h(this.c)}}e.TernarySearchTree=y}),define(te[7],ne([0,1,9,4]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,M=/^\//,A=/^\/\//;function I(n,o){if(!n.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!M.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(n,o){return!n&&!o?"file":n}function g(n,o){switch(n){case"https":case"http":case"file":o?o[0]!==y&&(o=y+o):o=y;break}return o}const p="",y="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(o){return o instanceof h?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,a,c,s,f,P=!1){typeof o=="object"?(this.scheme=o.scheme||p,this.authority=o.authority||p,this.path=o.path||p,this.query=o.query||p,this.fragment=o.fragment||p):(this.scheme=w(o,P),this.authority=a||p,this.path=g(this.scheme,c||p),this.query=s||p,this.fragment=f||p,I(this,P))}get fsPath(){return C(this,!1)}with(o){if(!o)return this;let{scheme:a,authority:c,path:s,query:f,fragment:P}=o;return a===void 0?a=this.scheme:a===null&&(a=p),c===void 0?c=this.authority:c===null&&(c=p),s===void 0?s=this.path:s===null&&(s=p),f===void 0?f=this.query:f===null&&(f=p),P===void 0?P=this.fragment:P===null&&(P=p),a===this.scheme&&c===this.authority&&s===this.path&&f===this.query&&P===this.fragment?this:new b(a,c,s,f,P)}static parse(o,a=!1){const c=v.exec(o);return c?new b(c[2]||p,r(c[4]||p),r(c[5]||p),r(c[7]||p),r(c[9]||p),a):new b(p,p,p,p,p)}static file(o){let a=p;if(t.isWindows&&(o=o.replace(/\\/g,y)),o[0]===y&&o[1]===y){const c=o.indexOf(y,2);c===-1?(a=o.substring(2),o=y):(a=o.substring(2,c),o=o.substring(c)||y)}return new b("file",a,o,p,p)}static from(o){const a=new b(o.scheme,o.authority,o.path,o.query,o.fragment);return I(a,!0),a}static joinPath(o,...a){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&o.scheme==="file"?c=h.file(S.win32.join(C(o,!0),...a)).path:c=S.posix.join(o.path,...a),o.with({path:c})}toString(o=!1){return E(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof h)return o;{const a=new b(o);return a._formatted=o.external,a._fsPath=o._sep===d?o.fsPath:null,a}}else return o}}e.URI=h;const d=t.isWindows?1:void 0;class b extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=C(this,!1)),this._fsPath}toString(o=!1){return o?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=d),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(n,o,a){let c,s=-1;for(let f=0;f<n.length;f++){const P=n.charCodeAt(f);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||o&&P===47||a&&P===91||a&&P===93||a&&P===58)s!==-1&&(c+=encodeURIComponent(n.substring(s,f)),s=-1),c!==void 0&&(c+=n.charAt(f));else{c===void 0&&(c=n.substr(0,f));const L=l[P];L!==void 0?(s!==-1&&(c+=encodeURIComponent(n.substring(s,f)),s=-1),c+=L):s===-1&&(s=f)}}return s!==-1&&(c+=encodeURIComponent(n.substring(s))),c!==void 0?c:n}function m(n){let o;for(let a=0;a<n.length;a++){const c=n.charCodeAt(a);c===35||c===63?(o===void 0&&(o=n.substr(0,a)),o+=l[c]):o!==void 0&&(o+=n[a])}return o!==void 0?o:n}function C(n,o){let a;return n.authority&&n.path.length>1&&n.scheme==="file"?a=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?o?a=n.path.substr(1):a=n.path[1].toLowerCase()+n.path.substr(2):a=n.path,t.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=C;function E(n,o){const a=o?m:u;let c="",{scheme:s,authority:f,path:P,query:L,fragment:T}=n;if(s&&(c+=s,c+=":"),(f||s==="file")&&(c+=y,c+=y),f){let U=f.indexOf("@");if(U!==-1){const G=f.substr(0,U);f=f.substr(U+1),U=G.lastIndexOf(":"),U===-1?c+=a(G,!1,!1):(c+=a(G.substr(0,U),!1,!1),c+=":",c+=a(G.substr(U+1),!1,!0)),c+="@"}f=f.toLowerCase(),U=f.lastIndexOf(":"),U===-1?c+=a(f,!1,!0):(c+=a(f.substr(0,U),!1,!0),c+=f.substr(U))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const U=P.charCodeAt(1);U>=65&&U<=90&&(P=`/${String.fromCharCode(U+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const U=P.charCodeAt(0);U>=65&&U<=90&&(P=`${String.fromCharCode(U+32)}:${P.substr(2)}`)}c+=a(P,!0,!1)}return L&&(c+="?",c+=a(L,!1,!1)),T&&(c+="#",c+=o?T:u(T,!1,!1)),c}function R(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+R(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(i)?n.replace(i,o=>R(o)):n}}),define(te[140],ne([0,1,7]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(g){const p=g;return p&&typeof p.type=="string"&&typeof p.severity=="string"}e.isRemoteConsoleLog=t;function k(g){const p=[];let y;try{const v=JSON.parse(g.arguments),h=v[v.length-1];h&&h.__$stack&&(v.pop(),y=h.__$stack),p.push(...v)}catch{p.push("Unable to log remote console arguments",g.arguments)}return{args:p,stack:y}}e.parse=k;function M(g){if(typeof g!="string")return M(k(g).stack);const p=g;if(p){const y=A(p),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(v&&v.length===4)return{uri:S.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=M;function A(g){if(!g)return g;const p=g.indexOf(`
`);return p===-1?g:g.substring(0,p)}function I(g,p){const{args:y,stack:v}=k(g),h=typeof y[0]=="string"&&y.length===1;let d=A(v);d&&(d=`(${d.trim()})`);let b=[];if(typeof y[0]=="string"?d&&h?b=[`%c[${p}] %c${y[0]} %c${d}`,w("blue"),w(""),w("grey")]:b=[`%c[${p}] %c${y[0]}`,w("blue"),w(""),...y.slice(1)]:b=[`%c[${p}]%`,w("blue"),...y],d&&!h&&b.push(d),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,b)}e.log=I;function w(g){return`color: ${g}`}}),define(te[69],ne([0,1,17,26,7]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(g){return JSON.stringify(g,I)}e.stringify=M;function A(g){let p=JSON.parse(g);return p=w(p),p}e.parse=A;function I(g,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,t.regExpFlags)(p)}:p}function w(g,p=0){if(!g||p>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return k.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 16:return new Date(g.source)}if(g instanceof S.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let y=0;y<g.length;++y)g[y]=w(g[y],p+1);else for(const y in g)Object.hasOwnProperty.call(g,y)&&(g[y]=w(g[y],p+1))}return g}e.revive=w}),define(te[15],ne([0,1,13,4,7]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebook="vscode-notebook",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractive="vscode-interactive",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${M.vscodeRemoteResource}`}set(p,y,v){this.a[p]=y,this.b[p]=v}setConnectionToken(p,y){this.c[p]=y}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(l){return S.onUnexpectedError(l),p}const y=p.authority;let v=this.a[y];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const h=this.b[y],d=this.c[y];let b=`path=${encodeURIComponent(p.path)}`;return typeof d=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(d)}`),k.URI.from({scheme:t.isWeb?this.d:M.vscodeRemoteResource,authority:`${v}:${h}`,path:this.f,query:b})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class I{asBrowserUri(p){const y=this.b(p,V);return this.uriToBrowserUri(y)}uriToBrowserUri(p){return p.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(p):p.scheme===M.file&&(t.isNative||t.isWebWorker&&t.globals.origin===`${M.vscodeFileResource}://${I.a}`)?p.with({scheme:M.vscodeFileResource,authority:p.authority||I.a,query:null,fragment:null}):p}asFileUri(p){const y=this.b(p,V);return this.uriToFileUri(y)}uriToFileUri(p){return p.scheme===M.vscodeFileResource?p.with({scheme:M.file,authority:p.authority!==I.a?p.authority:null,query:null,fragment:null}):p}b(p,y){return k.URI.isUri(p)?p:k.URI.parse(y.toUrl(p))}}I.a="vscode-app",e.FileAccess=new I;var w;(function(g){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(p.get("3"));const y="vscode-coi";function v(d){let b;typeof d=="string"?b=new URL(d).searchParams:d instanceof URL?b=d.searchParams:k.URI.isUri(d)&&(b=new URL(d.toString(!0)).searchParams);const l=b?.get(y);if(!!l)return p.get(l)}g.getHeadersFromQuery=v;function h(d,b,l){if(!globalThis.crossOriginIsolated)return;const u=b&&l?"3":l?"2":"1";d instanceof URLSearchParams?d.set(y,u):d[y]=u}g.addSearchParam=h})(w=e.COI||(e.COI={}))}),define(te[20],ne([0,1,31,15,9,4,26,7]),function(V,e,S,t,k,M,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(h){return(0,I.uriToFsPath)(h,!0)}e.originalFSPath=w;class g{constructor(d){this.a=d}compare(d,b,l=!1){return d===b?0:(0,A.compare)(this.getComparisonKey(d,l),this.getComparisonKey(b,l))}isEqual(d,b,l=!1){return d===b?!0:!d||!b?!1:this.getComparisonKey(d,l)===this.getComparisonKey(b,l)}getComparisonKey(d,b=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,b,l=!1){if(d.scheme===b.scheme){if(d.scheme===t.Schemas.file)return S.isEqualOrParent(w(d),w(b),this.a(d))&&d.query===b.query&&(l||d.fragment===b.fragment);if((0,e.isEqualAuthority)(d.authority,b.authority))return S.isEqualOrParent(d.path,b.path,this.a(d),"/")&&d.query===b.query&&(l||d.fragment===b.fragment)}return!1}joinPath(d,...b){return I.URI.joinPath(d,...b)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let b;return d.scheme===t.Schemas.file?b=I.URI.file(k.dirname(w(d))).path:(b=k.posix.dirname(d.path),d.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),b="/")),d.with({path:b})}normalizePath(d){if(!d.path.length)return d;let b;return d.scheme===t.Schemas.file?b=I.URI.file(k.normalize(w(d))).path:b=k.posix.normalize(d.path),d.with({path:b})}relativePath(d,b){if(d.scheme!==b.scheme||!(0,e.isEqualAuthority)(d.authority,b.authority))return;if(d.scheme===t.Schemas.file){const m=k.relative(w(d),w(b));return M.isWindows?S.toSlashes(m):m}let l=d.path||"/";const u=b.path||"/";if(this.a(d)){let m=0;for(const C=Math.min(l.length,u.length);m<C&&!(l.charCodeAt(m)!==u.charCodeAt(m)&&l.charAt(m).toLowerCase()!==u.charAt(m).toLowerCase());m++);l=u.substr(0,m)+l.substr(m)}return k.posix.relative(l,u)}resolvePath(d,b){if(d.scheme===t.Schemas.file){const l=I.URI.file(k.resolve(w(d),b));return d.with({authority:l.authority,path:l.path})}return b=S.toPosixPath(b),d.with({path:k.posix.resolve(d.path,b)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,b){return d===b||d!==void 0&&b!==void 0&&(0,A.equalsIgnoreCase)(d,b)}hasTrailingPathSeparator(d,b=k.sep){if(d.scheme===t.Schemas.file){const l=w(d);return l.length>S.getRoot(l).length&&l[l.length-1]===b}else{const l=d.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,b=k.sep){return(0,e.hasTrailingPathSeparator)(d,b)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,b=k.sep){let l=!1;if(d.scheme===t.Schemas.file){const u=w(d);l=u!==void 0&&u.length===S.getRoot(u).length&&u[u.length-1]===b}else{b="/";const u=d.path;l=u.length===1&&u.charCodeAt(u.length-1)===47}return!l&&!(0,e.hasTrailingPathSeparator)(d,b)?d.with({path:d.path+"/"}):d}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(h=>h.scheme===t.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new g(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function p(h,d){const b=[];for(let l=0;l<h.length;l++){const u=d(h[l]);h.some((m,C)=>C===l?!1:(0,e.isEqualOrParent)(u,d(m)))||b.push(h[l])}return b}e.distinctParents=p;var y;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function d(b){const l=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(C=>{const[E,R]=C.split(":");E&&R&&l.set(E,R)});const m=b.path.substring(0,b.path.indexOf(";"));return m&&l.set(h.META_DATA_MIME,m),l}h.parseMetaData=d})(y=e.DataUri||(e.DataUri={}));function v(h,d,b){if(d){let l=h.path;return l&&l[0]!==k.posix.sep&&(l=k.posix.sep+l),h.with({scheme:b,authority:d,path:l})}return h.with({scheme:b})}e.toLocalResource=v}),define(te[8],ne([0,1,22,13,3,2,20,4]),function(V,e,S,t,k,M,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(ee){return!!ee&&typeof ee.then=="function"}e.isThenable=w;function g(ee){const D=new S.CancellationTokenSource,O=ee(D.token),F=new Promise((j,q)=>{const X=D.token.onCancellationRequested(()=>{X.dispose(),D.dispose(),q(new t.CancellationError)});Promise.resolve(O).then(B=>{X.dispose(),D.dispose(),j(B)},B=>{X.dispose(),D.dispose(),q(B)})});return new class{cancel(){D.cancel()}then(j,q){return F.then(j,q)}catch(j){return this.then(void 0,j)}finally(j){return F.finally(j)}}}e.createCancelablePromise=g;function p(ee,D,O){return new Promise((F,j)=>{const q=D.onCancellationRequested(()=>{q.dispose(),F(O)});ee.then(F,j).finally(()=>q.dispose())})}e.raceCancellation=p;function y(ee,D){return new Promise((O,F)=>{const j=D.onCancellationRequested(()=>{j.dispose(),F(new t.CancellationError)});ee.then(O,F).finally(()=>j.dispose())})}e.raceCancellationError=y;async function v(ee){let D=-1;const O=ee.map((j,q)=>j.then(X=>(D=q,X))),F=await Promise.race(O);return ee.forEach((j,q)=>{q!==D&&j.cancel()}),F}e.raceCancellablePromises=v;function h(ee,D,O){let F;const j=setTimeout(()=>{F?.(void 0),O?.()},D);return Promise.race([ee.finally(()=>clearTimeout(j)),new Promise(q=>F=q)])}e.raceTimeout=h;function d(ee){return new Promise((D,O)=>{const F=ee();w(F)?F.then(D,O):D(F)})}e.asPromise=d;class b{constructor(){this.a=null,this.b=null,this.d=null}queue(D){if(this.a){if(this.d=D,!this.b){const O=()=>{this.b=null;const F=this.queue(this.d);return this.d=null,F};this.b=new Promise(F=>{this.a.then(O,O).then(F)})}return new Promise((O,F)=>{this.b.then(O,F)})}return this.a=D(),new Promise((O,F)=>{this.a.then(j=>{this.a=null,O(j)},j=>{this.a=null,F(j)})})}}e.Throttler=b;class l{constructor(){this.a=Promise.resolve(null)}queue(D){return this.a=this.a.then(()=>D(),()=>D())}}e.Sequencer=l;class u{constructor(){this.a=new Map}queue(D,O){const j=(this.a.get(D)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.a.get(D)===j&&this.a.delete(D)});return this.a.set(D,j),j}}e.SequencerByKey=u;const m=(ee,D)=>{let O=!0;const F=setTimeout(()=>{O=!1,D()},ee);return{isTriggered:()=>O,dispose:()=>{clearTimeout(F),O=!1}}},C=ee=>{let D=!0;return queueMicrotask(()=>{D&&(D=!1,ee())}),{isTriggered:()=>D,dispose:()=>{D=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class E{constructor(D){this.defaultDelay=D,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(D,O=this.defaultDelay){this.g=D,this.h(),this.b||(this.b=new Promise((j,q)=>{this.d=j,this.f=q}).then(()=>{if(this.b=null,this.d=null,this.g){const j=this.g;return this.g=null,j()}}));const F=()=>{this.a=null,this.d?.(null)};return this.a=O===e.MicrotaskDelay?C(F):m(O,F),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=E;class R{constructor(D){this.a=new E(D),this.b=new b}trigger(D,O){return this.a.trigger(()=>this.b.queue(D),O)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=R;class i{constructor(){this.a=!1,this.b=new Promise((D,O)=>{this.d=D})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class r extends i{constructor(D){super(),this.f=setTimeout(()=>this.open(),D)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function n(ee,D){return D?new Promise((O,F)=>{const j=setTimeout(()=>{q.dispose(),O()},ee),q=D.onCancellationRequested(()=>{clearTimeout(j),q.dispose(),F(new t.CancellationError)})}):g(O=>n(ee,O))}e.timeout=n;function o(ee,D=0){const O=setTimeout(ee,D);return(0,M.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=o;function a(ee){const D=[];let O=0;const F=ee.length;function j(){return O<F?ee[O++]():null}function q(X){X!=null&&D.push(X);const B=j();return B?B.then(q):Promise.resolve(D)}return Promise.resolve(null).then(q)}e.sequence=a;function c(ee,D=F=>!!F,O=null){let F=0;const j=ee.length,q=()=>{if(F>=j)return Promise.resolve(O);const X=ee[F++];return Promise.resolve(X()).then(Q=>D(Q)?Promise.resolve(Q):q())};return q()}e.first=c;function s(ee,D=F=>!!F,O=null){if(ee.length===0)return Promise.resolve(O);let F=ee.length;const j=()=>{F=-1;for(const q of ee)q.cancel?.()};return new Promise((q,X)=>{for(const B of ee)B.then(Q=>{--F>=0&&D(Q)?(j(),q(Q)):F===0&&q(O)}).catch(Q=>{--F>=0&&(j(),X(Q))})})}e.firstParallel=s;class f{constructor(D){this.a=0,this.d=D,this.f=[],this.b=0,this.g=new k.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(D){return this.a++,new Promise((O,F)=>{this.f.push({factory:D,c:O,e:F}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const D=this.f.shift();this.b++;const O=D.factory();O.then(D.c,D.e),O.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=f;class P extends f{constructor(){super(1)}}e.Queue=P;class L{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const D=new $;return this.b.add(D),D.p}d(){for(const[,D]of this.a)if(D.size>0)return!1;return!0}queueFor(D,O=A.extUri){const F=O.getComparisonKey(D);let j=this.a.get(F);return j||(j=new P,k.Event.once(j.onDrained)(()=>{j?.dispose(),this.a.delete(F),this.f()}),this.a.set(F,j)),j}f(){!this.d()||this.g()}g(){for(const D of this.b)D.complete();this.b.clear()}dispose(){for(const[,D]of this.a)D.dispose();this.a.clear(),this.g()}}e.ResourceQueue=L;class T{constructor(D,O){this.a=-1,typeof D=="function"&&typeof O=="number"&&this.setIfNotSet(D,O)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(D,O){this.cancel(),this.a=setTimeout(()=>{this.a=-1,D()},O)}setIfNotSet(D,O){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,D()},O))}}e.TimeoutTimer=T;class U{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(D,O){this.cancel(),this.a=setInterval(()=>{D()},O)}}e.IntervalTimer=U;class G{constructor(D,O){this.b=-1,this.a=D,this.d=O,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(D=this.d){this.cancel(),this.b=setTimeout(this.f,D)}get delay(){return this.d}set delay(D){this.d=D}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=G;class H{constructor(D,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.a=D,this.b=O,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(D=this.b){D%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${D}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(D/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=H;class K extends G{constructor(D,O){super(D,O),this.j=[]}work(D){this.j.push(D),this.isScheduled()||this.schedule()}h(){const D=this.j;this.j=[],this.a?.(D)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=K;class se extends M.Disposable{constructor(D,O){super(),this.g=D,this.h=O,this.a=[],this.b=this.B(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(D){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+D.length>this.g.maxBufferedWork)return!1}else if(this.pending+D.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const O of D)this.a.push(O);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ee=>{(0,I.setTimeout0)(()=>{if(D)return;const O=Date.now()+15;ee(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let D=!1;return{dispose(){D||(D=!0)}}}:e.runWhenIdle=(ee,D)=>{const O=requestIdleCallback(ee,typeof D=="number"?{timeout:D}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(O))}}}}();class Z{constructor(D){this.d=!1,this.a=()=>{try{this.f=D()}catch(O){this.g=O}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=Z;async function ce(ee,D,O){let F;for(let j=0;j<O;j++)try{return await ee()}catch(q){F=q,await n(D)}throw F}e.retry=ce;class ge{hasPending(D){return this.a?typeof D=="number"?this.a.taskId===D:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(D,O,F){return this.a={taskId:D,cancel:()=>F?.(),promise:O},O.then(()=>this.d(D),()=>this.d(D)),O}d(D){this.a&&D===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const D=this.b;this.b=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}setNext(D){if(this.b)this.b.run=D;else{let O,F;const j=new Promise((q,X)=>{O=q,F=X});this.b={run:D,promise:j,promiseResolve:O,promiseReject:F}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=ge;class _{constructor(D,O=()=>Date.now()){this.d=D,this.f=O,this.a=0,this.b=0}increment(){const D=this.f();return D-this.a>this.d&&(this.a=D,this.b=0),this.b++,this.b}}e.IntervalCounter=_;class ${get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((D,O)=>{this.a=D,this.b=O})}complete(D){return new Promise(O=>{this.a(D),this.f=!0,O()})}error(D){return new Promise(O=>{this.b(D),this.d=!0,O()})}cancel(){new Promise(D=>{this.b(new t.CancellationError),this.d=!0,D()})}}e.DeferredPromise=$;var N;(function(ee){async function D(F){let j;const q=await Promise.all(F.map(X=>X.then(B=>B,B=>{j||(j=B)})));if(typeof j<"u")throw j;return q}ee.settled=D;function O(F){return new Promise(async(j,q)=>{try{await F(j,q)}catch(X){q(X)}})}ee.withAsyncBody=O})(N=e.Promises||(e.Promises={}));var W;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(W||(W={}));class z{static fromArray(D){return new z(O=>{O.emitMany(D)})}static fromPromise(D){return new z(async O=>{O.emitMany(await D)})}static fromPromises(D){return new z(async O=>{await Promise.all(D.map(async F=>O.emitOne(await F)))})}static merge(D){return new z(async O=>{await Promise.all(D.map(async F=>{for await(const j of F)O.emitOne(j)}))})}constructor(D){this.a=0,this.b=[],this.d=null,this.f=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:F=>this.g(F),emitMany:F=>this.h(F),reject:F=>this.k(F)};try{await Promise.resolve(D(O)),this.j()}catch(F){this.k(F)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let D=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(D<this.b.length)return{done:!1,value:this.b[D++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(D,O){return new z(async F=>{for await(const j of D)F.emitOne(O(j))})}map(D){return z.map(this,D)}static filter(D,O){return new z(async F=>{for await(const j of D)O(j)&&F.emitOne(j)})}filter(D){return z.filter(this,D)}static coalesce(D){return z.filter(D,O=>!!O)}coalesce(){return z.coalesce(this)}static async toPromise(D){const O=[];for await(const F of D)O.push(F);return O}toPromise(){return z.toPromise(this)}g(D){this.a===0&&(this.b.push(D),this.f.fire())}h(D){this.a===0&&(this.b=this.b.concat(D),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(D){this.a===0&&(this.a=2,this.d=D,this.f.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class Y extends z{constructor(D,O){super(O),this.l=D}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Y;function oe(ee){const D=new S.CancellationTokenSource,O=ee(D.token);return new Y(D,async F=>{const j=D.token.onCancellationRequested(()=>{j.dispose(),D.dispose(),F.reject(new t.CancellationError)});try{for await(const q of O){if(D.token.isCancellationRequested)return;F.emitOne(q)}j.dispose(),D.dispose()}catch(q){j.dispose(),D.dispose(),F.reject(q)}})}e.createCancelableAsyncIterable=oe}),define(te[99],ne([0,1,24,8,31,40,9,4,26]),function(V,e,S,t,k,M,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const p="[/\\\\]",y="[^/\\\\]",v=/\//g;function h($,N){switch($){case 0:return"";case 1:return`${y}*?`;default:return`(?:${p}|${y}+${p}${N?`|${p}${y}+`:""})*?`}}function d($,N){if(!$)return[];const W=[];let z=!1,Y=!1,oe="";for(const ee of $){switch(ee){case N:if(!z&&!Y){W.push(oe),oe="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}oe+=ee}return oe&&W.push(oe),W}e.splitGlobAware=d;function b($){if(!$)return"";let N="";const W=d($,e.GLOB_SPLIT);if(W.every(z=>z===e.GLOBSTAR))N=".*";else{let z=!1;W.forEach((Y,oe)=>{if(Y===e.GLOBSTAR){if(z)return;N+=h(2,oe===W.length-1)}else{let ee=!1,D="",O=!1,F="";for(const j of Y){if(j!=="}"&&ee){D+=j;continue}if(O&&(j!=="]"||!F)){let q;j==="-"?q=j:(j==="^"||j==="!")&&!F?q="^":j===e.GLOB_SPLIT?q="":q=(0,w.escapeRegExpCharacters)(j),F+=q;continue}switch(j){case"{":ee=!0;continue;case"[":O=!0;continue;case"}":{N+=`(?:${d(D,",").map(B=>b(B)).join("|")})`,ee=!1,D="";break}case"]":{N+="["+F+"]",O=!1,F="";break}case"?":N+=y;continue;case"*":N+=h(1);continue;default:N+=(0,w.escapeRegExpCharacters)(j)}}oe<W.length-1&&(W[oe+1]!==e.GLOBSTAR||oe+2<W.length)&&(N+=p)}z=Y===e.GLOBSTAR})}return N}const l=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,C=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,R=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.LRUCache(1e4),r=function(){return!1},n=function(){return null};function o($,N){if(!$)return n;let W;typeof $!="string"?W=$.pattern:W=$,W=W.trim();const z=`${W}_${!!N.trimForExclusions}`;let Y=i.get(z);if(Y)return a(Y,$);let oe;return l.test(W)?Y=s(W.substr(4),W):(oe=u.exec(c(W,N)))?Y=f(oe[1],W):(N.trimForExclusions?C:m).test(W)?Y=P(W,N):(oe=E.exec(c(W,N)))?Y=L(oe[1].substr(1),W,!0):(oe=R.exec(c(W,N)))?Y=L(oe[1],W,!1):Y=T(W),i.set(z,Y),a(Y,$)}function a($,N){if(typeof N=="string")return $;const W=function(z,Y){return(0,k.isEqualOrParent)(z,N.base,!I.isLinux)?$((0,w.ltrim)(z.substr(N.base.length),A.sep),Y):null};return W.allBasenames=$.allBasenames,W.allPaths=$.allPaths,W.basenames=$.basenames,W.patterns=$.patterns,W}function c($,N){return N.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function s($,N){return function(W,z){return typeof W=="string"&&W.endsWith($)?N:null}}function f($,N){const W=`/${$}`,z=`\\${$}`,Y=function(ee,D){return typeof ee!="string"?null:D?D===$?N:null:ee===$||ee.endsWith(W)||ee.endsWith(z)?N:null},oe=[$];return Y.basenames=oe,Y.patterns=[N],Y.allBasenames=oe,Y}function P($,N){const W=ge($.slice(1,-1).split(",").map(D=>o(D,N)).filter(D=>D!==n),$),z=W.length;if(!z)return n;if(z===1)return W[0];const Y=function(D,O){for(let F=0,j=W.length;F<j;F++)if(W[F](D,O))return $;return null},oe=W.find(D=>!!D.allBasenames);oe&&(Y.allBasenames=oe.allBasenames);const ee=W.reduce((D,O)=>O.allPaths?D.concat(O.allPaths):D,[]);return ee.length&&(Y.allPaths=ee),Y}function L($,N,W){const z=A.sep===A.posix.sep,Y=z?$:$.replace(v,A.sep),oe=A.sep+Y,ee=A.posix.sep+$;let D;return W?D=function(O,F){return typeof O=="string"&&(O===Y||O.endsWith(oe)||!z&&(O===$||O.endsWith(ee)))?N:null}:D=function(O,F){return typeof O=="string"&&(O===Y||!z&&O===$)?N:null},D.allPaths=[(W?"*/":"./")+$],D}function T($){try{const N=new RegExp(`^${b($)}$`);return function(W){return N.lastIndex=0,typeof W=="string"&&N.test(W)?$:null}}catch{return n}}function U($,N,W){return!$||typeof N!="string"?!1:G($)(N,void 0,W)}e.match=U;function G($,N={}){if(!$)return r;if(typeof $=="string"||H($)){const W=o($,N);if(W===n)return r;const z=function(Y,oe){return!!W(Y,oe)};return W.allBasenames&&(z.allBasenames=W.allBasenames),W.allPaths&&(z.allPaths=W.allPaths),z}return Z($,N)}e.parse=G;function H($){const N=$;return N?typeof N.base=="string"&&typeof N.pattern=="string":!1}e.isRelativePattern=H;function K($){return $.allBasenames||[]}e.getBasenameTerms=K;function se($){return $.allPaths||[]}e.getPathTerms=se;function Z($,N){const W=ge(Object.getOwnPropertyNames($).map(D=>ce(D,$[D],N)).filter(D=>D!==n)),z=W.length;if(!z)return n;if(!W.some(D=>!!D.requiresSiblings)){if(z===1)return W[0];const D=function(j,q){let X;for(let B=0,Q=W.length;B<Q;B++){const ie=W[B](j,q);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(X||(X=[]),X.push(ie))}return X?(async()=>{for(const B of X){const Q=await B;if(typeof Q=="string")return Q}return null})():null},O=W.find(j=>!!j.allBasenames);O&&(D.allBasenames=O.allBasenames);const F=W.reduce((j,q)=>q.allPaths?j.concat(q.allPaths):j,[]);return F.length&&(D.allPaths=F),D}const Y=function(D,O,F){let j,q;for(let X=0,B=W.length;X<B;X++){const Q=W[X];Q.requiresSiblings&&F&&(O||(O=(0,A.basename)(D)),j||(j=O.substr(0,O.length-(0,A.extname)(D).length)));const ie=Q(D,O,j,F);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(q||(q=[]),q.push(ie))}return q?(async()=>{for(const X of q){const B=await X;if(typeof B=="string")return B}return null})():null},oe=W.find(D=>!!D.allBasenames);oe&&(Y.allBasenames=oe.allBasenames);const ee=W.reduce((D,O)=>O.allPaths?D.concat(O.allPaths):D,[]);return ee.length&&(Y.allPaths=ee),Y}function ce($,N,W){if(N===!1)return n;const z=o($,W);if(z===n)return n;if(typeof N=="boolean")return z;if(N){const Y=N.when;if(typeof Y=="string"){const oe=(ee,D,O,F)=>{if(!F||!z(ee,D))return null;const j=Y.replace("$(basename)",()=>O),q=F(j);return(0,t.isThenable)(q)?q.then(X=>X?$:null):q?$:null};return oe.requiresSiblings=!0,oe}}return z}function ge($,N){const W=$.filter(D=>!!D.basenames);if(W.length<2)return $;const z=W.reduce((D,O)=>{const F=O.basenames;return F?D.concat(F):D},[]);let Y;if(N){Y=[];for(let D=0,O=z.length;D<O;D++)Y.push(N)}else Y=W.reduce((D,O)=>{const F=O.patterns;return F?D.concat(F):D},[]);const oe=function(D,O){if(typeof D!="string")return null;if(!O){let j;for(j=D.length;j>0;j--){const q=D.charCodeAt(j-1);if(q===47||q===92)break}O=D.substr(j)}const F=z.indexOf(O);return F!==-1?Y[F]:null};oe.basenames=z,oe.patterns=Y,oe.allBasenames=z;const ee=$.filter(D=>!D.basenames);return ee.push(oe),ee}function _($,N){return(0,S.equals)($,N,(W,z)=>typeof W=="string"&&typeof z=="string"?W===z:typeof W!="string"&&typeof z!="string"?W.base===z.base&&W.pattern===z.pattern:!1)}e.patternsEquals=_}),define(te[36],ne([0,1,24,31,9,4,20,26]),function(V,e,S,t,k,M,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(n,o){const{os:a,tildify:c,relative:s}=o;if(s){const L=g(n,s,a);if(typeof L=="string")return L}let f=n.fsPath;if(a===1&&!M.isWindows?f=f.replace(/\//g,"\\"):a!==1&&M.isWindows&&(f=f.replace(/\\/g,"/")),a!==1&&c?.userHome){const L=c.userHome.fsPath;let T;n.scheme!==c.userHome.scheme&&n.path.startsWith(k.posix.sep)?T=c.userHome.with({path:n.path}).fsPath:T=n.fsPath,f=v(T,L,a)}return(a===1?k.win32:k.posix).normalize(p(f,a===1))}e.getPathLabel=w;function g(n,o,a){const c=a===1?k.win32:k.posix,s=a===3?A.extUri:A.extUriIgnorePathCase,f=o.getWorkspace(),P=(0,S.firstOrDefault)(f.folders);if(!P)return;n.scheme!==P.uri.scheme&&n.path.startsWith(k.posix.sep)&&(n=P.uri.with({path:n.path}));const L=o.getWorkspaceFolder(n);if(!L)return;let T;if(s.isEqual(L.uri,n)?T="":T=s.relativePath(L.uri,n)??"",T&&(T=c.normalize(T)),f.folders.length>1&&!o.noPrefix){const U=L.name?L.name:s.basenameOrAuthority(L.uri);T=T?`${U} \u2022 ${T}`:U}return T}function p(n,o=M.isWindows){return(0,t.hasDriveLetter)(n,o)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=p;let y=Object.create(null);function v(n,o,a=M.OS){if(a===1||!n||!o)return n;let c=y.original===o?y.normalized:void 0;c||(c=o,M.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,I.rtrim)(c,k.posix.sep)}${k.posix.sep}`,y={original:o,normalized:c});let s=n;return M.isWindows&&(s=(0,t.toSlashes)(s)),(a===3?s.startsWith(c):(0,I.startsWithIgnoreCase)(s,c))?`~/${s.substr(c.length)}`:n}e.tildify=v;function h(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=h;const d="\u2026",b="\\\\",l="~";function u(n,o=k.sep){const a=new Array(n.length);let c=!1;for(let s=0;s<n.length;s++){const f=n[s];if(f===""){a[s]=`.${o}`;continue}if(!f){a[s]=f;continue}c=!0;let P="",L=f;L.indexOf(b)===0?(P=L.substr(0,L.indexOf(b)+b.length),L=L.substr(L.indexOf(b)+b.length)):L.indexOf(o)===0?(P=L.substr(0,L.indexOf(o)+o.length),L=L.substr(L.indexOf(o)+o.length)):L.indexOf(l)===0&&(P=L.substr(0,L.indexOf(l)+l.length),L=L.substr(L.indexOf(l)+l.length));const T=L.split(o);for(let U=1;c&&U<=T.length;U++)for(let G=T.length-U;c&&G>=0;G--){c=!1;let H=T.slice(G,G+U).join(o);for(let K=0;!c&&K<n.length;K++)if(K!==s&&n[K]&&n[K].indexOf(H)>-1){const se=G+U===T.length,Z=G>0&&n[K].indexOf(o)>-1?o+H:H,ce=n[K].endsWith(Z);c=!se||ce}if(!c){let K="";(T[0].endsWith(":")||P!=="")&&(G===1&&(G=0,U++,H=T[0]+o+H),G>0&&(K=T[0]+o),K=P+K),G>0&&(K=K+d+o),K=K+H,G+U<T.length&&(K=K+o+d),a[s]=K}}c&&(a[s]=f)}return a}e.shorten=u;var m;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function C(n,o=Object.create(null)){const a=[];let c=!1,s="";for(const f of n)if(f==="$"||c&&f==="{")s&&a.push({value:s,type:m.TEXT}),s="",c=!0;else if(f==="}"&&c){const P=o[s];if(typeof P=="string")P.length&&a.push({value:P,type:m.VARIABLE});else if(P){const L=a[a.length-1];(!L||L.type!==m.SEPARATOR)&&a.push({value:P.label,type:m.SEPARATOR})}s="",c=!1}else s+=f;return s&&!c&&a.push({value:s,type:m.TEXT}),a.filter((f,P)=>{if(f.type===m.SEPARATOR){const L=a[P-1],T=a[P+1];return[L,T].every(U=>U&&(U.type===m.VARIABLE||U.type===m.TEXT)&&U.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=C;function E(n,o){return M.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function R(n,o){return M.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):M.isWindows?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=R;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function r(n){const o=n.indexOf("/")!==-1?k.posix:k.win32,a=o.basename(n),c=o.dirname(n);return a.length?{name:a,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(te[141],ne([0,1,7]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(p){return p.toJSON()}class k{constructor(y){this.a=y}transformIncoming(y){const v=this.a.transformIncoming(y);return v===y?y:t(S.URI.from(v))}transformOutgoing(y){const v=this.a.transformOutgoing(y);return v===y?y:t(S.URI.from(v))}transformOutgoingURI(y){const v=this.a.transformOutgoing(y);return v===y?y:S.URI.from(v)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function M(p,y,v){if(!p||v>200)return null;if(typeof p=="object"){if(p instanceof S.URI)return y.transformOutgoing(p);for(const h in p)if(Object.hasOwnProperty.call(p,h)){const d=M(p[h],y,v+1);d!==null&&(p[h]=d)}}return null}function A(p,y){const v=M(p,y,0);return v===null?p:v}e.transformOutgoingURIs=A;function I(p,y,v,h){if(!p||h>200)return null;if(typeof p=="object"){if(p.$mid===1)return v?S.URI.revive(y.transformIncoming(p)):y.transformIncoming(p);for(const d in p)if(Object.hasOwnProperty.call(p,d)){const b=I(p[d],y,v,h+1);b!==null&&(p[d]=b)}}return null}function w(p,y){const v=I(p,y,!1,0);return v===null?p:v}e.transformIncomingURIs=w;function g(p,y){const v=I(p,y,!0,0);return v===null?p:v}e.transformAndReviveIncomingURIs=g}),define(te[82],ne([0,1,25,13,60,30,129]),function(V,e,S,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(p){return this.a||(this.a=k.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,y=0;const v=(0,S.networkInterfaces)();for(const h in v){const d=v[h];if(d)for(const{mac:b,internal:l}of d)l||(y+=1,this.c(b.toUpperCase())&&(p+=1))}this.b=y>0?p/y:0}return this.b}};let I;async function w(){return I||(I=(async()=>await g()||M.generateUuid())()),I}e.getMachineId=w;async function g(){try{const p=await new Promise((v,h)=>{V(["crypto"],v,h)}),y=(0,A.getMac)();return p.createHash("sha256").update(y,"utf8").digest("hex")}catch(p){t.onUnexpectedError(p);return}}}),define(te[23],ne([0,1,41,25,142,8,31,77,9,4,20,7]),function(V,e,S,t,k,M,A,I,w,g,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(Z){Z[Z.UNLINK=0]="UNLINK",Z[Z.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function h(Z,ce=v.UNLINK){if((0,A.isRootOrDriveLetter)(Z))throw new Error("rimraf - will refuse to recursively delete root");return ce===v.UNLINK?b(Z):d(Z)}async function d(Z){try{const ce=(0,A.randomPath)((0,t.tmpdir)());try{await S.promises.rename(Z,ce)}catch(ge){return ge.code==="ENOENT"?void 0:b(Z)}b(ce).catch(ge=>{})}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function b(Z){return(0,k.promisify)(S.rm)(Z,{recursive:!0,force:!0,maxRetries:3})}function l(Z){if((0,A.isRootOrDriveLetter)(Z))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(Z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=l;async function u(Z,ce){return E(await(ce?m(Z):(0,k.promisify)(S.readdir)(Z)))}async function m(Z){try{return await(0,k.promisify)(S.readdir)(Z,{withFileTypes:!0})}catch(_){console.warn("[node.js fs] readdir with filetypes failed with error: ",_)}const ce=[],ge=await u(Z);for(const _ of ge){let $=!1,N=!1,W=!1;try{const z=await e.Promises.lstat((0,w.join)(Z,_));$=z.isFile(),N=z.isDirectory(),W=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}ce.push({name:_,isFile:()=>$,isDirectory:()=>N,isSymbolicLink:()=>W})}return ce}function C(Z){return E(S.readdirSync(Z))}e.readdirSync=C;function E(Z){return Z.map(ce=>typeof ce=="string"?g.isMacintosh?(0,I.normalizeNFC)(ce):ce:(ce.name=g.isMacintosh?(0,I.normalizeNFC)(ce.name):ce.name,ce))}async function R(Z){const ce=await u(Z),ge=[];for(const _ of ce)await r.existsDirectory((0,w.join)(Z,_))&&ge.push(_);return ge}function i(Z,ce=1e3){return new Promise(ge=>{let _=!1;const $=setInterval(()=>{_||(_=!0,S.access(Z,N=>{_=!1,N&&(clearInterval($),ge(void 0))}))},ce)})}e.whenDeleted=i;var r;(function(Z){async function ce($){let N;try{if(N=await e.Promises.lstat($),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat($),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(g.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw z}throw W}}Z.stat=ce;async function ge($){try{const{stat:N,symbolicLink:W}=await Z.stat($);return N.isFile()&&W?.dangling!==!0}catch{}return!1}Z.existsFile=ge;async function _($){try{const{stat:N,symbolicLink:W}=await Z.stat($);return N.isDirectory()&&W?.dangling!==!0}catch{}return!1}Z.existsDirectory=_})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new M.ResourceQueue;function o(Z,ce,ge){return n.queueFor(y.URI.file(Z),p.extUriBiasedIgnorePathCase).queue(()=>{const _=P(ge);return new Promise(($,N)=>s(Z,ce,_,W=>W?N(W):$()))})}let a=!0;function c(Z){a=Z}e.configureFlushOnWrite=c;function s(Z,ce,ge,_){if(!a)return S.writeFile(Z,ce,{mode:ge.mode,flag:ge.flag},_);S.open(Z,ge.flag,ge.mode,($,N)=>{if($)return _($);S.writeFile(N,ce,W=>{if(W)return S.close(N,()=>_(W));S.fdatasync(N,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),c(!1)),S.close(N,Y=>_(Y))))})})}function f(Z,ce,ge){const _=P(ge);if(!a)return S.writeFileSync(Z,ce,{mode:_.mode,flag:_.flag});const $=S.openSync(Z,_.flag,_.mode);try{S.writeFileSync($,ce);try{S.fdatasyncSync($)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),c(!1)}}finally{S.closeSync($)}}e.writeFileSync=f;function P(Z){return Z?{mode:typeof Z.mode=="number"?Z.mode:438,flag:typeof Z.flag=="string"?Z.flag:"w"}:{mode:438,flag:"w"}}async function L(Z,ce){if(Z!==ce)try{await e.Promises.rename(Z,ce)}catch(ge){if(Z.toLowerCase()!==ce.toLowerCase()&&ge.code==="EXDEV"||Z.endsWith("."))await T(Z,ce,{preserveSymlinks:!1}),await h(Z,v.MOVE);else throw ge}}async function T(Z,ce,ge){return G(Z,ce,{root:{source:Z,target:ce},options:ge,handledSourcePaths:new Set})}const U=511;async function G(Z,ce,ge){if(ge.handledSourcePaths.has(Z))return;ge.handledSourcePaths.add(Z);const{stat:_,symbolicLink:$}=await r.stat(Z);if($){if(ge.options.preserveSymlinks)try{return await se(Z,ce,ge)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if($.dangling)return}return _.isDirectory()?H(Z,ce,_.mode&U,ge):K(Z,ce,_.mode&U)}async function H(Z,ce,ge,_){await e.Promises.mkdir(ce,{recursive:!0,mode:ge});const $=await u(Z);for(const N of $)await G((0,w.join)(Z,N),(0,w.join)(ce,N),_)}async function K(Z,ce,ge){await e.Promises.copyFile(Z,ce),await e.Promises.chmod(ce,ge)}async function se(Z,ce,ge){let _=await e.Promises.readlink(Z);(0,A.isEqualOrParent)(_,ge.root.source,!g.isLinux)&&(_=(0,w.join)(ge.root.target,_.substr(ge.root.source.length+1))),await e.Promises.symlink(_,ce)}e.Promises=new class{get access(){return(0,k.promisify)(S.access)}get stat(){return(0,k.promisify)(S.stat)}get lstat(){return(0,k.promisify)(S.lstat)}get utimes(){return(0,k.promisify)(S.utimes)}get read(){return(Z,ce,ge,_,$)=>new Promise((N,W)=>{S.read(Z,ce,ge,_,$,(z,Y,oe)=>z?W(z):N({bytesRead:Y,buffer:oe}))})}get readFile(){return(0,k.promisify)(S.readFile)}get write(){return(Z,ce,ge,_,$)=>new Promise((N,W)=>{S.write(Z,ce,ge,_,$,(z,Y,oe)=>z?W(z):N({bytesWritten:Y,buffer:oe}))})}get appendFile(){return(0,k.promisify)(S.appendFile)}get fdatasync(){return(0,k.promisify)(S.fdatasync)}get truncate(){return(0,k.promisify)(S.truncate)}get rename(){return(0,k.promisify)(S.rename)}get copyFile(){return(0,k.promisify)(S.copyFile)}get open(){return(0,k.promisify)(S.open)}get close(){return(0,k.promisify)(S.close)}get symlink(){return(0,k.promisify)(S.symlink)}get readlink(){return(0,k.promisify)(S.readlink)}get chmod(){return(0,k.promisify)(S.chmod)}get mkdir(){return(0,k.promisify)(S.mkdir)}get unlink(){return(0,k.promisify)(S.unlink)}get rmdir(){return(0,k.promisify)(S.rmdir)}get realpath(){return(0,k.promisify)(S.realpath)}async exists(Z){try{return await e.Promises.access(Z),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return R}get writeFile(){return o}get rm(){return h}get move(){return L}get copy(){return T}}}),define(te[100],ne([0,1,41,9,4,26,23]),function(V,e,S,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(v){if(k.isLinux)return v;const h=(0,t.dirname)(v);if(v===h)return v;const d=((0,t.basename)(v)||v).toLowerCase();try{const l=(0,A.readdirSync)(h).filter(u=>u.toLowerCase()===d);if(l.length===1){const u=I(h);if(u)return(0,t.join)(u,l[0])}else if(l.length>1){const u=l.indexOf(d);if(u>=0){const m=I(h);if(m)return(0,t.join)(m,l[u])}}}catch{}return null}e.realcaseSync=I;async function w(v){if(k.isLinux)return v;const h=(0,t.dirname)(v);if(v===h)return v;const d=((0,t.basename)(v)||v).toLowerCase();try{const l=(await A.Promises.readdir(h)).filter(u=>u.toLowerCase()===d);if(l.length===1){const u=await w(h);if(u)return(0,t.join)(u,l[0])}else if(l.length>1){const u=l.indexOf(d);if(u>=0){const m=await w(h);if(m)return(0,t.join)(m,l[u])}}}catch{}return null}e.realcase=w;async function g(v){try{return await A.Promises.realpath(v)}catch{const d=y(v);return await A.Promises.access(d,S.constants.R_OK),d}}e.realpath=g;function p(v){try{return S.realpathSync(v)}catch{const d=y(v);return S.accessSync(d,S.constants.R_OK),d}}e.realpathSync=p;function y(v){return(0,M.rtrim)((0,t.normalize)(v),t.sep)}}),define(te[143],ne([0,1,25,9,23]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,A=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var w;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(w||(w={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class y{constructor(R,i,r){this.exePath=R,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:E=!1}={}){return E?g===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:E=!1,findPreview:R=!1}={}){const i=v({useAlternateBitness:E});if(!i)return null;const r=t.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let n=-1,o=null;for(const s of await k.Promises.readdir(r)){let f=-1;if(R){const L=s.indexOf("-");if(L<0)continue;const T=s.substring(0,L);if(!M.test(T)||s.substring(L+1)!=="preview")continue;f=parseInt(T,10)}else{if(!M.test(s))continue;f=parseInt(s,10)}if(f<=n)continue;const P=t.join(r,s,"pwsh.exe");!await k.SymlinkSupport.existsFile(P)||(o=P,n=f)}if(!o)return null;const a=i.includes("x86")?" (x86)":"",c=R?" Preview":"";return new y(o,`PowerShell${c}${a}`,!0)}async function d({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const R=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(R))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=E?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(R))if(i.test(n)){const o=t.join(R,n,"pwsh.exe");return new y(o,r)}return null}function b(){const E=t.join(S.homedir(),".dotnet","tools","pwsh.exe");return new y(E,".NET Core PowerShell Global Tool")}function l(){const E=t.join(process.env.windir,g===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(E,"Windows PowerShell",!0)}async function*u(){let E=await h();E&&(yield E),E=await h({useAlternateBitness:!0}),E&&(yield E),E=await d(),E&&(yield E),E=b(),E&&(yield E),E=await h({findPreview:!0}),E&&(yield E),E=await d({findPreview:!0}),E&&(yield E),E=await h({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=l(),E&&(yield E)}async function*m(){for await(const E of u())await E.exists()&&(yield E)}e.enumeratePowerShellInstallations=m;async function C(){for await(const E of m())return E;return null}e.getFirstAvailablePowerShellInstallation=C}),define(te[83],ne([0,1,9,4,35,80,11,23]),function(V,e,S,t,k,M,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function w(y=k.env){return y.comspec||"cmd.exe"}e.getWindowsShell=w;function g(y){let v=[],h=!1;const d=function(b){if(h){v.push(b);return}(!y.send(b,u=>{if(u&&console.error(u),h=!1,v.length>0){const m=v.slice(0);v=[],m.forEach(C=>d(C))}})||t.isWindows)&&(h=!0)};return{send:d}}e.createQueuedSender=g;var p;(function(y){async function v(h,d,b){if(S.isAbsolute(h))return h;if(d===void 0&&(d=k.cwd()),S.dirname(h)!=="."||(b===void 0&&A.isString(k.env.PATH)&&(b=k.env.PATH.split(S.delimiter)),b===void 0||b.length===0))return S.join(d,h);async function u(m){if(await I.Promises.exists(m)){let C;try{C=await I.Promises.stat(m)}catch(E){E.message.startsWith("EACCES")&&(C=await I.Promises.lstat(m))}return C?!C.isDirectory():!1}return!1}for(const m of b){let C;if(S.isAbsolute(m)?C=S.join(m,h):C=S.join(d,m,h),await u(C))return C;let E=C+".com";if(await u(E)||(E=C+".exe",await u(E)))return E}return S.join(d,h)}y.findExecutable=v})(p=e.win32||(e.win32={}))}),define(te[101],ne([0,1,46,15]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(A){return new Promise((I,w)=>{let g;const p=new Map;function y(h,d,b,l,u){const m=p.get(d);if(h===A||m){const C={name:v(b),cmd:b,pid:h,ppid:d,load:l,mem:u};p.set(h,C),h===A&&(g=C),m&&(m.children||(m.children=[]),m.children.push(C),m.children.length>1&&(m.children=m.children.sort((E,R)=>E.pid-R.pid)))}}function v(h){const d=/--vscode-window-kind=shared-process/,b=/--vscode-window-kind=issue-reporter/,l=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,C=/--crashes-directory/,E=/\\pipe\\winpty-control/,R=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(C.exec(h))return"electron-crash-reporter";if(E.exec(h))return"winpty-process";if(R.exec(h))return"console-window-host (Windows internal process)";let r=i.exec(h);if(r&&r.length===2){if(r[1]==="renderer")return d.exec(h)?"shared-process":b.exec(h)?"issue-reporter":l.exec(h)?"process-explorer":"window";if(r[1]==="utility"){if(u.exec(h))return"utility-network-service";if(m.exec(h))return"extension-host"}else if(r[1]==="extensionHost")return"extension-host";return r[1]}const n=/[a-zA-Z-]+\.js/g;let o="";do r=n.exec(h),r&&(o+=r+" ");while(r);return o&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron_node ${o}`:h}if(process.platform==="win32"){const h=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,b)=>{V(["windows-process-tree"],d,b)}).then(d=>{d.getProcessList(A,b=>{if(!b){w(new Error(`Root process ${A} not found`));return}d.getProcessCpuUsage(b,l=>{const u=new Map;l.forEach(m=>{const C=h(m.commandLine||"");u.set(m.pid,{name:v(C),cmd:C,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),g=u.get(A),g?(u.forEach(m=>{const C=u.get(m.ppid);C&&(C.children||(C.children=[]),C.children.push(m))}),u.forEach(m=>{m.children&&(m.children=m.children.sort((C,E)=>C.pid-E.pid))}),I(g)):w(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let h=function(){let d=[g];const b=[];for(;d.length;){const u=d.shift();u&&(b.push(u.pid),u.children&&(d=d.concat(u.children)))}let l=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);l+=" "+b.join(" "),(0,S.exec)(l,{},(u,m,C)=>{if(u||C)w(u||new Error(C.toString()));else{const E=m.toString().split(`
`);for(let R=0;R<b.length;R++){const i=p.get(b[R]);i.load=parseFloat(E[R])}if(!g){w(new Error(`Root process ${A} not found`));return}I(g)}})};(0,S.exec)("which ps",{},(d,b,l)=>{if(d||l)if(process.platform!=="linux")w(d||new Error(l.toString()));else{const u=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)(u,{},(m,C,E)=>{m||E?w(m||new Error(E.toString())):(M(C,y),h())})}else{const u=b.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${u} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(C,E,R)=>{C||R&&!R.includes("screen size is bogus")?w(C||new Error(R.toString())):(M(E,y),process.platform==="linux"?h():g?I(g):w(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=k;function M(A,I){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=A.toString().split(`
`);for(const p of g){const y=w.exec(p.trim());y&&y.length===6&&I(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(te[144],ne([0,1,25,4,143,83]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function A(y,v){return y===1?t.isWindows?p():M.getWindowsShell(v):w(y,v)}e.getSystemShell=A;let I=null;function w(y,v){if(t.isLinux&&y===2||t.isMacintosh&&y===3)return"/bin/bash";if(!I){let h;if(t.isWindows)h="/bin/bash";else{if(h=v.SHELL,!h)try{h=(0,S.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}I=h}return I}let g=null;async function p(){return g||(g=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),g}});var pe=this&&this.__decorate||function(V,e,S,t){var k=arguments.length,M=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,S):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(V,e,S,t);else for(var I=V.length-1;I>=0;I--)(A=V[I])&&(M=(k<3?A(M):k>3?A(e,S,M):A(e,S))||M);return k>3&&M&&Object.defineProperty(e,S,M),M};define(te[47],ne([0,1,24,8,17,22,54,13,3,2,69,26,11]),function(V,e,S,t,k,M,A,I,w,g,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var h;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(h||(h={}));function d(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(b||(b={}));function l(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(u||(u={}));function m(N){let W=0;for(let z=0;;z+=7){const Y=N.read(1);if(W|=(Y.buffer[0]&127)<<z,!(Y.buffer[0]&128))return W}}const C=n(0);function E(N,W){if(W===0){N.write(C);return}let z=0;for(let oe=W;oe!==0;oe=oe>>>7)z++;const Y=k.VSBuffer.alloc(z);for(let oe=0;W!==0;oe++)Y.buffer[oe]=W&127,W=W>>>7,W>0&&(Y.buffer[oe]|=128);N.write(Y)}class R{constructor(W){this.b=W,this.a=0}read(W){const z=this.b.slice(this.a,this.a+W);return this.a+=z.byteLength,z}}e.BufferReader=R;class i{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(W){this.a.push(W)}}e.BufferWriter=i;var r;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object",N[N.Int=6]="Int"})(r||(r={}));function n(N){const W=k.VSBuffer.alloc(1);return W.writeUInt8(N,0),W}const o={Undefined:n(r.Undefined),String:n(r.String),Buffer:n(r.Buffer),VSBuffer:n(r.VSBuffer),Array:n(r.Array),Object:n(r.Object),Uint:n(r.Int)},a=typeof Buffer<"u";function c(N,W){if(typeof W>"u")N.write(o.Undefined);else if(typeof W=="string"){const z=k.VSBuffer.fromString(W);N.write(o.String),E(N,z.byteLength),N.write(z)}else if(a&&Buffer.isBuffer(W)){const z=k.VSBuffer.wrap(W);N.write(o.Buffer),E(N,z.byteLength),N.write(z)}else if(W instanceof k.VSBuffer)N.write(o.VSBuffer),E(N,W.byteLength),N.write(W);else if(Array.isArray(W)){N.write(o.Array),E(N,W.length);for(const z of W)c(N,z)}else if(typeof W=="number"&&(W|0)===W)N.write(o.Uint),E(N,W);else{const z=k.VSBuffer.fromString(JSON.stringify(W));N.write(o.Object),E(N,z.byteLength),N.write(z)}}e.serialize=c;function s(N){switch(N.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return N.read(m(N)).toString();case r.Buffer:return N.read(m(N)).buffer;case r.VSBuffer:return N.read(m(N));case r.Array:{const z=m(N),Y=[];for(let oe=0;oe<z;oe++)Y.push(s(N));return Y}case r.Object:return JSON.parse(N.read(m(N)).toString());case r.Int:return m(N)}}e.deserialize=s;class f{constructor(W,z,Y=null,oe=1e3){this.h=W,this.j=z,this.k=Y,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ee=>this.q(ee)),this.m({type:200})}registerChannel(W,z){this.b.set(W,z),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const z=this.o([W.type]);this.k?.logOutgoing(z,0,1,l(W.type));return}case 201:case 202:case 204:case 203:{const z=this.o([W.type,W.id],W.data);this.k?.logOutgoing(z,W.id,1,l(W.type),W.data);return}}}o(W,z=void 0){const Y=new i;return c(Y,W),c(Y,z),this.p(Y.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const z=new R(W),Y=s(z),oe=s(z),ee=Y[0];switch(ee){case 100:return this.k?.logIncoming(W.byteLength,Y[1],1,`${d(ee)}: ${Y[2]}.${Y[3]}`,oe),this.s({type:ee,id:Y[1],channelName:Y[2],name:Y[3],arg:oe});case 102:return this.k?.logIncoming(W.byteLength,Y[1],1,`${d(ee)}: ${Y[2]}.${Y[3]}`,oe),this.t({type:ee,id:Y[1],channelName:Y[2],name:Y[3],arg:oe});case 101:return this.k?.logIncoming(W.byteLength,Y[1],1,`${d(ee)}`),this.u({type:ee,id:Y[1]});case 103:return this.k?.logIncoming(W.byteLength,Y[1],1,`${d(ee)}`),this.u({type:ee,id:Y[1]})}}s(W){const z=this.b.get(W.channelName);if(!z){this.v(W);return}const Y=new M.CancellationTokenSource;let oe;try{oe=z.call(this.j,W.name,W.arg,Y.token)}catch(O){oe=Promise.reject(O)}const ee=W.id;oe.then(O=>{this.m({id:ee,data:O,type:201}),this.d.delete(W.id)},O=>{O instanceof Error?this.m({id:ee,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.m({id:ee,data:O,type:203}),this.d.delete(W.id)});const D=(0,g.toDisposable)(()=>Y.cancel());this.d.set(W.id,D)}t(W){const z=this.b.get(W.channelName);if(!z){this.v(W);return}const Y=W.id,ee=z.listen(this.j,W.name,W.arg)(D=>this.m({id:Y,data:D,type:204}));this.d.set(W.id,ee)}u(W){const z=this.d.get(W.id);z&&(z.dispose(),this.d.delete(W.id))}v(W){let z=this.g.get(W.channelName);z||(z=[],this.g.set(W.channelName,z));const Y=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:W,timeoutTimer:Y})}w(W){const z=this.g.get(W);if(z){for(const Y of z)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.s(Y.request);break;case 102:this.t(Y.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=f;var P;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(W,z=null){this.l=W,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=z}getChannel(W){const z=this;return{call(Y,oe,ee){return z.a?Promise.reject(new I.CancellationError):z.m(W,Y,oe,ee)},listen(Y,oe){return z.a?w.Event.None:z.o(W,Y,oe)}}}m(W,z,Y,oe=M.CancellationToken.None){const ee=this.g++,O={id:ee,type:100,channelName:W,name:z,arg:Y};if(oe.isCancellationRequested)return Promise.reject(new I.CancellationError);let F;return new Promise((q,X)=>{if(oe.isCancellationRequested)return X(new I.CancellationError);const B=()=>{const de=ke=>{switch(ke.type){case 201:this.f.delete(ee),q(ke.data);break;case 202:{this.f.delete(ee);const Oe=new Error(ke.data.message);Oe.stack=Array.isArray(ke.data.stack)?ke.data.stack.join(`
`):ke.data.stack,Oe.name=ke.data.name,X(Oe);break}case 203:this.f.delete(ee),X(ke.data);break}};this.f.set(ee,de),this.p(O)};let Q=null;this.b===u.Idle?B():(Q=(0,t.createCancelablePromise)(de=>this.u()),Q.then(()=>{Q=null,B()}));const ie=()=>{Q?(Q.cancel(),Q=null):this.p({id:ee,type:101}),X(new I.CancellationError)},ae=oe.onCancellationRequested(ie);F=(0,g.combinedDisposable)((0,g.toDisposable)(ie),ae),this.d.add(F)}).finally(()=>{this.d.delete(F)})}o(W,z,Y){const oe=this.g++,D={id:oe,type:102,channelName:W,name:z,arg:Y};let O=null;const F=new w.Emitter({onWillAddFirstListener:()=>{O=(0,t.createCancelablePromise)(q=>this.u()),O.then(()=>{O=null,this.d.add(F),this.p(D)})},onDidRemoveLastListener:()=>{O?(O.cancel(),O=null):(this.d.delete(F),this.p({id:oe,type:103}))}}),j=q=>F.fire(q.data);return this.f.set(oe,j),F.event}p(W){switch(W.type){case 100:case 102:{const z=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(z,W.id,0,`${d(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const z=this.q([W.type,W.id]);this.j?.logOutgoing(z,W.id,0,d(W.type));return}}}q(W,z=void 0){const Y=new i;return c(Y,W),c(Y,z),this.r(Y.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const z=new R(W),Y=s(z),oe=s(z),ee=Y[0];switch(ee){case 200:return this.j?.logIncoming(W.byteLength,0,0,l(ee)),this.t({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,Y[1],0,l(ee),oe),this.t({type:Y[0],id:Y[1],data:oe})}}t(W){if(W.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.dispose)(this.d.values()),this.d.clear()}}pe([A.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class T{get connections(){const W=[];return this.f.forEach(z=>W.push(z)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new w.Emitter,this.onDidAddConnection=this.g.event,this.h=new w.Emitter,this.onDidRemoveConnection=this.h.event,W(({protocol:z,onDidClientDisconnect:Y})=>{w.Event.once(z.onMessage)(ee=>{const D=new R(ee),O=s(D),F=new f(z,O),j=new L(z);this.a.forEach((X,B)=>F.registerChannel(B,X));const q={channelServer:F,channelClient:j,ctx:O};this.f.add(q),this.g.fire(q),Y(()=>{F.dispose(),j.dispose(),this.f.delete(q),this.h.fire(q)})})})}getChannel(W,z){const Y=this;return{call(oe,ee,D){let O;if((0,v.isFunction)(z)){const j=(0,S.getRandomElement)(Y.connections.filter(z));O=j?Promise.resolve(j):w.Event.toPromise(w.Event.filter(Y.onDidAddConnection,z))}else O=z.routeCall(Y,oe,ee);const F=O.then(j=>j.channelClient.getChannel(W));return G(F).call(oe,ee,D)},listen(oe,ee){if((0,v.isFunction)(z))return Y.j(W,z,oe,ee);const D=z.routeEvent(Y,oe,ee).then(O=>O.channelClient.getChannel(W));return G(D).listen(oe,ee)}}}j(W,z,Y,oe){const ee=this;let D=new g.DisposableStore;const O=new w.Emitter({onWillAddFirstListener:()=>{D=new g.DisposableStore;const F=new w.EventMultiplexer,j=new Map,q=B=>{const ie=B.channelClient.getChannel(W).listen(Y,oe),ae=F.add(ie);j.set(B,ae)},X=B=>{const Q=j.get(B);!Q||(Q.dispose(),j.delete(B))};ee.connections.filter(z).forEach(q),w.Event.filter(ee.onDidAddConnection,z)(q,void 0,D),ee.onDidRemoveConnection(X,void 0,D),F.event(O.fire,O,D),D.add(F)},onDidRemoveLastListener:()=>{D.dispose()}});return O.event}registerChannel(W,z){this.a.set(W,z),this.f.forEach(Y=>{Y.channelServer.registerChannel(W,z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class U{constructor(W,z,Y=null){const oe=new i;c(oe,z),W.send(oe.buffer),this.a=new L(W,Y),this.d=new f(W,z,Y)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,z){this.d.registerChannel(W,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=U;function G(N){return{call(W,z,Y){return N.then(oe=>oe.call(W,z,Y))},listen(W,z){const Y=new w.Relay;return N.then(oe=>Y.input=oe.listen(W,z)),Y.event}}}e.getDelayedChannel=G;function H(N){let W=!1;return{call(z,Y,oe){return W?N.call(z,Y,oe):(0,t.timeout)(0).then(()=>W=!0).then(()=>N.call(z,Y,oe))},listen(z,Y){if(W)return N.listen(z,Y);const oe=new w.Relay;return(0,t.timeout)(0).then(()=>W=!0).then(()=>oe.input=N.listen(z,Y)),oe.event}}}e.getNextTickChannel=H;class K{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const z of W.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await w.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.StaticRouter=K;var se;(function(N){function W(ee,D){const O=ee,F=D&&D.disableMarshalling,j=new Map;for(const q in O)Y(q)&&j.set(q,w.Event.buffer(O[q],!0));return new class{listen(q,X,B){const Q=j.get(X);if(Q)return Q;if(oe(X)){const ie=O[X];if(typeof ie=="function")return ie.call(O,B)}throw new Error(`Event not found: ${X}`)}call(q,X,B){const Q=O[X];if(typeof Q=="function"){if(!F&&Array.isArray(B))for(let ie=0;ie<B.length;ie++)B[ie]=(0,p.revive)(B[ie]);return Q.apply(O,B)}throw new Error(`Method not found: ${X}`)}}}N.fromService=W;function z(ee,D){const O=D&&D.disableMarshalling;return new Proxy({},{get(F,j){if(typeof j=="string")return D?.properties?.has(j)?D.properties.get(j):oe(j)?function(q){return ee.listen(j,q)}:Y(j)?ee.listen(j):async function(...q){let X;D&&!(0,v.isUndefinedOrNull)(D.context)?X=[D.context,...q]:X=q;const B=await ee.call(j,X);return O?B:(0,p.revive)(B)};throw new Error(`Property not found: ${String(j)}`)}})}N.toService=z;function Y(ee){return ee[0]==="o"&&ee[1]==="n"&&y.isUpperAsciiLetter(ee.charCodeAt(2))}function oe(ee){return/^onDynamic/.test(ee)&&y.isUpperAsciiLetter(ee.charCodeAt(9))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const W=N.toString();if(W!=="[object Object]")return W}return N}function ge(N){return Array.isArray(N)?N.map(ce):ce(N)}function _(N,W,z,Y,oe,ee,D){D=ge(D);const O=Z[oe],F=O[Y%O.length];let j=[`%c[${N}]%c[${String(W).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(ee)?(j=j.concat(D),j.push(")")):j.push(D),console.log.apply(console,j)}class ${constructor(W,z){this.d=W,this.f=z,this.a=0,this.b=0}logOutgoing(W,z,Y,oe,ee){this.b+=W,_(this.d,this.b,W,z,Y,oe,ee)}logIncoming(W,z,Y,oe,ee){this.a+=W,_(this.f,this.a,W,z,Y,oe,ee)}}e.IPCLogger=$}),define(te[145],ne([0,1,17,3,47]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(w){this.a=w,this.onMessage=t.Event.fromDOMEventEmitter(this.a,"message",g=>S.VSBuffer.wrap(g.data)),w.start()}send(w){this.a.postMessage(w.buffer)}disconnect(){this.a.close()}}e.Protocol=M;class A extends k.IPCClient{constructor(w,g){const p=new M(w);super(p,g),this.b=p}dispose(){this.b.disconnect()}}e.Client=A}),define(te[102],ne([0,1,8,17,3,2,47]),function(V,e,S,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(L){L.Created="created",L.Read="read",L.Write="write",L.Open="open",L.Error="error",L.Close="close",L.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",L.NodeEndReceived="nodeEndReceived",L.NodeEndSent="nodeEndSent",L.NodeDrainBegin="nodeDrainBegin",L.NodeDrainEnd="nodeDrainEnd",L.zlibInflateError="zlibInflateError",L.zlibInflateData="zlibInflateData",L.zlibInflateInitialWrite="zlibInflateInitialWrite",L.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",L.zlibInflateWrite="zlibInflateWrite",L.zlibInflateFlushFired="zlibInflateFlushFired",L.zlibDeflateError="zlibDeflateError",L.zlibDeflateData="zlibDeflateData",L.zlibDeflateWrite="zlibDeflateWrite",L.zlibDeflateFlushFired="zlibDeflateFlushFired",L.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",L.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",L.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",L.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",L.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",L.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",L.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",L.ProtocolHeaderRead="protocolHeaderRead",L.ProtocolMessageRead="protocolMessageRead",L.ProtocolHeaderWrite="protocolHeaderWrite",L.ProtocolMessageWrite="protocolMessageWrite",L.ProtocolWrite="protocolWrite"})(I=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var w;(function(L){L.enableDiagnostics=!1,L.records=[];const T=new WeakMap;let U=0;function G(K,se){if(!T.has(K)){const Z=String(++U);T.set(K,Z)}return T.get(K)}function H(K,se,Z,ce){if(!L.enableDiagnostics)return;const ge=G(K,se);if(ce instanceof t.VSBuffer||ce instanceof Uint8Array||ce instanceof ArrayBuffer||ArrayBuffer.isView(ce)){const _=t.VSBuffer.alloc(ce.byteLength);_.set(ce),L.records.push({timestamp:Date.now(),id:ge,label:se,type:Z,buff:_})}else L.records.push({timestamp:Date.now(),id:ge,label:se,type:Z,data:ce})}L.traceSocketEvent=H})(w=e.SocketDiagnostics||(e.SocketDiagnostics={}));var g;(function(L){L[L.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",L[L.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g=e.SocketCloseEventType||(e.SocketCloseEventType={}));let p=null;function y(){return p||(p=t.VSBuffer.alloc(0)),p}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(T){this.a.push(T),this.b+=T.byteLength}read(T){return this.c(T,!0)}peek(T){return this.c(T,!1)}c(T,U){if(T===0)return y();if(T>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===T){const se=this.a[0];return U&&(this.a.shift(),this.b-=T),se}if(this.a[0].byteLength>T){const se=this.a[0].slice(0,T);return U&&(this.a[0]=this.a[0].slice(T),this.b-=T),se}const G=t.VSBuffer.alloc(T);let H=0,K=0;for(;T>0;){const se=this.a[K];if(se.byteLength>T){const Z=se.slice(0,T);G.set(Z,H),H+=T,U&&(this.a[K]=se.slice(T),this.b-=T),T-=T}else G.set(se,H),H+=se.byteLength,U?(this.a.shift(),this.b-=se.byteLength):K++,T-=se.byteLength}return G}}e.ChunkStream=v;var h;(function(L){L[L.None=0]="None",L[L.Regular=1]="Regular",L[L.Control=2]="Control",L[L.Ack=3]="Ack",L[L.Disconnect=5]="Disconnect",L[L.ReplayRequest=6]="ReplayRequest",L[L.Pause=7]="Pause",L[L.Resume=8]="Resume",L[L.KeepAlive=9]="KeepAlive",L[L.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",L[L.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(h||(h={}));function d(L){switch(L){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var b;(function(L){L[L.HeaderLength=13]="HeaderLength",L[L.AcknowledgeTime=2e3]="AcknowledgeTime",L[L.TimeoutTime=2e4]="TimeoutTime",L[L.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",L[L.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",L[L.KeepAliveSendTime=5e3]="KeepAliveSendTime",L[L.LatencySampleTime=6e4]="LatencySampleTime",L[L.LatencySampleCount=5]="LatencySampleCount",L[L.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",L[L.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class l{constructor(T,U,G,H){this.type=T,this.id=U,this.ack=G,this.data=H,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends M.Disposable{constructor(T){super(),this.f=this.B(new k.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=T,this.b=!1,this.c=new v,this.B(this.a.onData(U=>this.acceptChunk(U))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(T);this.c.byteLength>=this.g.readLen;){const U=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=U.readUInt32BE(9),this.g.messageType=U.readUInt8(0),this.g.id=U.readUInt32BE(1),this.g.ack=U.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const G=this.g.messageType,H=this.g.id,K=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",U),this.f.fire(new l(G,H,K,U)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(T){this.k=null,this.a=!1,this.b=!1,this.c=T,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(T){if(this.a)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const U=t.VSBuffer.alloc(13);U.writeUInt8(T.type,0),U.writeUInt32BE(T.id,1),U.writeUInt32BE(T.ack,5),U.writeUInt32BE(T.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",T.data),this.j(U,T.data)}g(T,U){const G=this.f===0;return this.d.push(T,U),this.f+=T.byteLength+U.byteLength,G}h(){const T=t.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,T}j(T,U){this.g(T,U)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const T=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this.c.write(T)}}class C extends M.Disposable{constructor(T){super(),this.f=new k.Emitter,this.onMessage=this.f.event,this.g=new k.Emitter,this.onDidDispose=this.g.event,this.a=T,this.b=this.B(new m(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(U=>{U.type===1&&this.f.fire(U.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(T){this.b.write(new l(1,0,0,T))}}e.Protocol=C;class E extends A.IPCClient{static fromSocket(T,U){return new E(new C(T),U)}get onDidDispose(){return this.b.onDidDispose}constructor(T,U,G=null){super(T,U,G),this.b=T}dispose(){super.dispose();const T=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),T.end()}}e.Client=E;class R{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new k.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(T){this.b?this.d.length>0?this.d.push(T):this.a.fire(T):this.d.push(T)}flushBuffer(){this.d=[]}}e.BufferedEmitter=R;class i{constructor(T){this.data=T,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let T=0,U=this.a;for(;U;)U=U.next,T++;return T}peek(){return this.a?this.a.data:null}toArray(){const T=[];let U=0,G=this.a;for(;G;)T[U++]=G.data,G=G.next;return T}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(T){const U=new i(T);if(!this.a){this.a=U,this.b=U;return}this.b.next=U,this.b=U}}class n{static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const T=Date.now();for(let U=0;U<n.a;U++)this.c[U]=T-1e3*U;setInterval(()=>{for(let U=n.a;U>=1;U--)this.c[U]=this.c[U-1];this.c[0]=Date.now()},1e3)}d(){const T=Date.now(),U=(1+n.a)*1e3;let G=0;for(let H=0;H<n.a;H++)T-this.c[H]<=U&&G++;return 1-G/n.a}hasHighLoad(){return this.d()>=.5}}n.a=10,n.b=null;var o;(function(L){L[L.Good=0]="Good",L[L.Poor=1]="Poor"})(o=e.ConnectionHealth||(e.ConnectionHealth={}));function a(L){switch(L){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=a;class c{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=c;class s{constructor(T,U){this.roundTripTime=T,this.recentHighRoundTripCount=U}}e.HighRoundTripTimeEvent=s;class f{get unacknowledgedCount(){return this.c-this.d}constructor(T){this.x=new R,this.onControlMessage=this.x.event,this.y=new R,this.onMessage=this.y.event,this.z=new R,this.onDidDispose=this.z.event,this.A=new R,this.onSocketClose=this.A.event,this.B=new R,this.onSocketTimeout=this.B.event,this.C=new R,this.onHighRoundTripTime=this.C.event,this.D=new R,this.onDidChangeConnectionHealth=this.D.event,this.u=T.loadEstimator??n.getInstance(),this.v=T.measureRoundTripTime??!1,this.w=T.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new M.DisposableStore,this.o=T.socket,this.p=this.t.add(new m(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(U=>this.E(U))),this.t.add(this.o.onClose(U=>this.A.fire(U))),this.r=this.t.add(new P),this.t.add(this.r.onSendLatencyRequest(U=>this.J(U))),this.t.add(this.r.onHighRoundTripTime(U=>this.C.fire(U))),this.t.add(this.r.onDidChangeConnectionHealth(U=>this.D.fire(U))),this.v&&this.r.start(),T.initialChunk&&this.q.acceptChunk(T.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const T=new l(5,0,0,y());this.p.write(T),this.p.flush()}sendPause(){const T=new l(7,0,0,y());this.p.write(T)}sendResume(){const T=new l(8,0,0,y());this.p.write(T)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(T,U){this.a=!0,this.t.dispose(),this.t=new M.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=T,this.p=this.t.add(new m(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(G=>this.E(G))),this.t.add(this.o.onClose(G=>this.A.fire(G))),this.r=this.t.add(new P),this.t.add(this.r.onSendLatencyRequest(G=>this.J(G))),this.t.add(this.r.onHighRoundTripTime(G=>this.C.fire(G))),this.t.add(this.r.onDidChangeConnectionHealth(G=>this.D.fire(G))),this.q.acceptChunk(U)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const T=new l(3,0,this.h,y());this.p.write(T);const U=this.b.toArray();for(let G=0,H=U.length;G<H;G++)this.p.write(U[G]);this.G()}acceptDisconnect(){this.z.fire()}E(T){if(T.ack>this.d){this.d=T.ack;do{const U=this.b.peek();if(U&&U.id<=T.ack)this.b.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this.g)if(T.id!==this.g+1){const U=Date.now();U-this.m>1e4&&(this.m=U,this.p.write(new l(6,0,0,y())))}else this.g=T.id,this.j=Date.now(),this.F(),this.y.fire(T.data);break}case 2:{this.x.fire(T.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const U=this.b.toArray();for(let G=0,H=U.length;G<H;G++)this.p.write(U[G]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(T.data);break}case 11:{this.r.handleResponse(T.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(T){const U=++this.c;this.h=this.g;const G=new l(1,U,this.h,T);this.b.push(G),this.a||(this.p.write(G),this.G())}sendControl(T){const U=new l(2,0,0,T);this.p.write(U)}F(){if(this.g<=this.h||this.k)return;const T=Date.now()-this.j;if(T>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-T+5)}G(){if(this.c<=this.d||this.f||this.a)return;const T=this.b.peek(),U=Date.now()-T.writtenTime,G=Date.now()-this.q.lastReadTime,H=Date.now()-this.n;if(U>=2e4&&G>=2e4&&H>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:U,timeSinceLastReceivedSomeData:G});return}const K=Math.max(2e4-U,2e4-G,2e4-H,500);this.f=setTimeout(()=>{this.f=null,this.G()},K)}H(){if(this.g<=this.h)return;this.h=this.g;const T=new l(3,0,this.h,y());this.p.write(T)}I(){this.h=this.g;const T=new l(9,0,this.h,y());this.p.write(T)}J(T){this.h=this.g;const U=new l(10,0,this.h,T);this.p.write(U)}K(T){this.h=this.g;const U=new l(11,0,this.h,T);this.p.write(U)}}e.PersistentProtocol=f;class P extends M.Disposable{constructor(){super(),this.a=this.B(new k.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new k.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new k.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new S.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},T=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const T=++this.h,U=t.VSBuffer.alloc(4);U.writeUInt32BE(T,0),this.a.fire(U)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const U=T.readUInt32BE(0);if(this.g<=0||U!==this.h)return;const G=Date.now()-this.g,H=this.k++;this.j[H%this.j.length]=G;const K=this.l,se=this.j.filter(Z=>Z>=1e3).length;this.l=se>=3?1:0,G>1e3&&this.b.fire(new s(G,se)),K!==this.l&&this.c.fire(this.l)}}}),define(te[146],ne([0,1,42,17,3,2,47,131]),function(V,e,S,t,k,M,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(p,y){const v=k.Event.fromNodeEventEmitter(S.validatedIpcMain,y,(d,b)=>({event:d,message:b})),h=k.Event.filter(v,({event:d})=>d.sender.id===p);return k.Event.map(h,({message:d})=>d&&t.VSBuffer.wrap(d))}class g extends A.IPCServer{static d(){const y=k.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:hello",({sender:v})=>v);return k.Event.map(y,v=>{const h=v.id;g.b.get(h)?.dispose();const b=new k.Emitter;g.b.set(h,(0,M.toDisposable)(()=>b.fire()));const l=w(h,"vscode:message"),u=k.Event.any(k.Event.signal(w(h,"vscode:disconnect")),b.event);return{protocol:new I.Protocol(v,l),onDidClientDisconnect:u}})}constructor(){super(g.d())}}e.Server=g,g.b=new Map}),define(te[103],ne([0,1,42,3,30,145]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class A extends M.Client{constructor(g,p){super({addEventListener:(y,v)=>g.addListener(y,v),removeEventListener:(y,v)=>g.removeListener(y,v),postMessage:y=>g.postMessage(y),start:()=>g.start(),close:()=>g.close()},p)}}e.Client=A;async function I(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const g=(0,k.generateUuid)();w.webContents.send("vscode:createMessageChannel",g);const p=t.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:createMessageChannelResult",(v,h)=>({nonce:h,port:v.ports[0]})),{port:y}=await t.Event.toPromise(t.Event.once(t.Event.filter(p,v=>v.nonce===g)));return y}e.connect=I}),define(te[147],ne([0,1,46,8,17,22,140,13,3,2,44,83,80,47]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends h.ChannelServer{constructor(u){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",m=>k.VSBuffer.wrap(Buffer.from(m,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=d;class b{constructor(u,m){this.i=u,this.j=m,this.c=new Set,this.g=new Map,this.h=new w.Emitter,this.onDidProcessExit=this.h.event;const C=m&&m.timeout?m.timeout:6e4;this.b=new t.Delayer(C),this.d=null,this.f=null}getChannel(u){const m=this;return{call(C,E,R){return m.k(u,C,E,R)},listen(C,E){return m.l(u,C,E)}}}k(u,m,C,E=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(I.canceled());this.b.cancel();const R=this.n(u),i=(0,t.createCancelablePromise)(o=>R.call(m,C,o)),r=E.onCancellationRequested(()=>i.cancel()),n=(0,g.toDisposable)(()=>i.cancel());return this.c.add(n),i.finally(()=>{r.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(u,m,C){if(!this.b)return w.Event.None;this.b.cancel();let E;const R=new w.Emitter({onWillAddFirstListener:()=>{E=this.n(u).listen(m,C)(R.fire,R),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return R.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),(0,v.removeDangerousEnvVariables)(m.env),this.d=(0,S.fork)(this.i,u,m);const C=new w.Emitter;w.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,A.isRemoteConsoleLog)(a)){(0,A.log)(a,`IPC Library: ${this.j.serverName}`);return}C.fire(k.VSBuffer.wrap(Buffer.from(a,"base64")))});const R=this.j.useQueue?(0,y.createQueuedSender)(this.d):this.d,i=a=>this.d&&this.d.connected&&R.send(a.buffer.toString("base64")),r=C.event,n={send:i,onMessage:r};this.f=new h.ChannelClient(n);const o=()=>this.o();process.once("exit",o),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,c)=>{process.removeListener("exit",o),this.c.forEach(s=>(0,g.dispose)(s)),this.c.clear(),a!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:c})})}return this.f}n(u){let m=this.g.get(u);return m||(m=this.m.getChannel(u),this.g.set(u,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=b}),define(te[84],ne([0,1,17,13,3,2,9,4,30,47,102]),function(V,e,S,t,k,M,A,I,w,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function y(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(s,f){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,f)}constructor(s,f=""){this.f=!0,this.debugLabel=f,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const f=P=>{this.traceSocketEvent("read",P),s(S.VSBuffer.wrap(P))};return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(s){const f=P=>{s({type:0,hadError:P,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(s){const f=()=>{s()};return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,f)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=v;var h;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(h||(h={}));var d;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(d||(d={}));class b extends M.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,f){this.socket.traceSocketEvent(s,f)}constructor(s,f,P,L){super(),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:f,inflateBytesLength:P?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new l(this,f,P,L,this.f,(T,U)=>this.k(T,U))),this.B(this.a.onError(T=>{console.error(T),(0,t.onUnexpectedError)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new p.ChunkStream,this.B(this.socket.onData(T=>this.l(T))),this.B(this.socket.onClose(T=>this.g.fire(T)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this.a.writeMessage(s)}k(s,f){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let P=2;s.byteLength<126?P+=0:s.byteLength<2**16?P+=2:P+=8;const L=S.VSBuffer.alloc(P);if(f?L.writeUInt8(194,0):L.writeUInt8(130,0),s.byteLength<126)L.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){L.writeUInt8(126,1);let T=1;L.writeUInt8(s.byteLength>>>8&255,++T),L.writeUInt8(s.byteLength>>>0&255,++T)}else{L.writeUInt8(127,1);let T=1;L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(s.byteLength>>>24&255,++T),L.writeUInt8(s.byteLength>>>16&255,++T),L.writeUInt8(s.byteLength>>>8&255,++T),L.writeUInt8(s.byteLength>>>0&255,++T)}this.socket.write(S.VSBuffer.concat([L,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const f=this.b.peek(this.j.readLen),P=f.readUInt8(0),L=(P&128)>>>7,T=(P&64)>>>6,U=f.readUInt8(1),G=(U&128)>>>7,H=U&127;this.j.state=2,this.j.readLen=2+(G?4:0)+(H===126?2:0)+(H===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(T)),this.j.firstFrameOfMessage=Boolean(L),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const f=this.b.read(this.j.readLen),P=f.readUInt8(1),L=(P&128)>>>7;let T=P&127,U=1;T===126?T=f.readUInt8(++U)*2**8+f.readUInt8(++U):T===127&&(T=f.readUInt8(++U)*0+f.readUInt8(++U)*0+f.readUInt8(++U)*0+f.readUInt8(++U)*0+f.readUInt8(++U)*2**24+f.readUInt8(++U)*2**16+f.readUInt8(++U)*2**8+f.readUInt8(++U));let G=0;L&&(G=f.readUInt8(++U)*2**24+f.readUInt8(++U)*2**16+f.readUInt8(++U)*2**8+f.readUInt8(++U)),this.j.state=3,this.j.readLen=T,this.j.mask=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const f=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",f),C(f,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",f),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(f,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class l extends M.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:S.VSBuffer.alloc(0)}constructor(s,f,P,L,T,U){super(),this.k=s,this.l=T,this.m=U,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,f?(this.b=this.B(new u(this.k,L,P,{windowBits:15})),this.f=this.B(new m(this.k,{windowBits:15})),this.B(this.b.onError(G=>this.a.fire(G))),this.B(this.f.onError(G=>this.a.fire(G)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const f=await this.r(this.f,s);this.m(f,!0)}else this.m(s,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(s,f){return new Promise((P,L)=>{s.write(f),s.flush(T=>P(T))})}acceptFrame(s,f,P){this.h.push({data:s,isCompressed:f,isLastFrameOfMessage:P}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const f=await this.u(this.b,s.data,s.isLastFrameOfMessage);this.l.fire(f)}else this.l.fire(s.data)}this.s=!1}}u(s,f,P){return new Promise((L,T)=>{s.write(f),P&&s.write(S.VSBuffer.fromByteArray([0,0,255,255])),s.flush(U=>L(U))})}}class u extends M.Disposable{get recordedInflateBytes(){return this.j?S.VSBuffer.concat(this.f):S.VSBuffer.alloc(0)}constructor(s,f,P,L){super(),this.h=s,this.j=f,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=y().zlib.createInflateRaw(L),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(S.VSBuffer.wrap(T))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const f=S.VSBuffer.concat(this.g);this.g.length=0,s(f)})}}class m extends M.Disposable{constructor(s,f){super(),this.g=s,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.b=y().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(S.VSBuffer.wrap(P))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let f=S.VSBuffer.concat(this.f);this.f.length=0,f=f.slice(0,f.byteLength-4),s(f)})}}function C(c,s){if(s===0)return;const f=c.byteLength>>>2;for(let H=0;H<f;H++){const K=c.readUInt32BE(H*4);c.writeUInt32BE(K^s,H*4)}const P=f*4,L=c.byteLength-P,T=s>>>24&255,U=s>>>16&255,G=s>>>8&255;L>=1&&c.writeUInt8(c.readUInt8(P)^T,P),L>=2&&c.writeUInt8(c.readUInt8(P+1)^U,P+1),L>=3&&c.writeUInt8(c.readUInt8(P+2)^G,P+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const E={[2]:107,[1]:103};function R(){const c=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):s=(0,A.join)(y().os.tmpdir(),`vscode-ipc-${c}.sock`),r(s),s}e.createRandomIPCHandle=R;function i(c,s,f){const P=y().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${f}-${s}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${P.substr(0,8)}-${f}-${s}.sock`):L=(0,A.join)(c,`${f}-${s}.sock`),r(L),L}e.createStaticIPCHandle=i;function r(c){const s=E[I.platform];typeof s=="number"&&c.length>=s&&console.warn(`WARNING: IPC handle "${c}" is longer than ${s} chars, try a shorter --user-data-dir`)}class n extends g.IPCServer{static b(s){const f=k.Event.fromNodeEventEmitter(s,"connection");return k.Event.map(f,P=>({protocol:new p.Protocol(new v(P,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(P,"close"))}))}constructor(s){super(n.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=n;function o(c){return new Promise((s,f)=>{const P=y().net.createServer();P.on("error",f),P.listen(c,()=>{P.removeListener("error",f),s(new n(P))})})}e.serve=o;function a(c,s){return new Promise((f,P)=>{const L=y().net.createConnection(c,()=>{L.removeListener("error",P),f(p.Client.fromSocket(new v(L,`ipc-client${s}`),s))});L.once("error",P)})}e.connect=a}),define(te[104],ne([0,1,8,3,2,11]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A=e.StorageHint||(e.StorageHint={}));function I(y){const v=y;return v?.changed instanceof Map||v?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var w;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(w=e.StorageState||(e.StorageState={}));class g extends k.Disposable{constructor(v,h=Object.create(null)){super(),this.m=v,this.n=h,this.b=this.B(new t.Emitter),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=new S.ThrottledDelayer(g.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(v=>this.r(v)))}r(v){v.changed?.forEach((h,d)=>this.s(d,h)),v.deleted?.forEach(h=>this.s(h,void 0))}s(v,h){if(this.c===w.Closed)return;let d=!1;(0,M.isUndefinedOrNull)(h)?d=this.f.delete(v):this.f.get(v)!==h&&(this.f.set(v,h),d=!0),d&&this.b.fire(v)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.n.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(v,h){const d=this.f.get(v);return(0,M.isUndefinedOrNull)(d)?h:d}getBoolean(v,h){const d=this.get(v);return(0,M.isUndefinedOrNull)(d)?h:d==="true"}getNumber(v,h){const d=this.get(v);return(0,M.isUndefinedOrNull)(d)?h:parseInt(d,10)}async set(v,h){if(this.c===w.Closed)return;if((0,M.isUndefinedOrNull)(h))return this.delete(v);const d=String(h);if(this.f.get(v)!==d)return this.f.set(v,d),this.j.set(v,d),this.h.delete(v),this.b.fire(v),this.w()}async delete(v){if(!(this.c===w.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire(v),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=w.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(v).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(v){if(!!this.u)return this.w(v)}async w(v){return this.g.trigger(()=>this.v(),v)}async whenFlushed(){if(!!this.u)return new Promise(v=>this.l.push(v))}isInMemory(){return this.n.hint===A.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=g,g.a=100;class p{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((h,d)=>this.a.set(d,h)),v.delete?.forEach(h=>this.a.delete(h))}async close(){}}e.InMemoryStorageDatabase=p}),define(te[148],ne([0,1,8,3,40,9,23]),function(V,e,S,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{get onDidChangeItemsExternal(){return t.Event.None}constructor(p,y=Object.create(null)){this.g=p,this.h=y,this.c=(0,M.basename)(this.g),this.d=new w(this.h.logging),this.f=this.n(this.g)}async getItems(){const p=await this.f,y=new Map;return(await this.s(p,"SELECT * FROM ItemTable")).forEach(h=>y.set(h.key,h.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${y.size} rows`),y}async updateItems(p){const y=await this.f;return this.j(y,p)}j(p,y){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${y.insert?(0,k.mapToString)(y.insert):"0"}), delete(${y.delete?(0,k.setToString)(y.delete):"0"})`),this.t(p,()=>{const v=y.insert,h=y.delete;if(v&&v.size>0){const d=[];d.push([]);let b=0;v.forEach((l,u)=>{let m=d[b];m.length>I.b&&(b++,m=[],d.push(m)),m.push(u,l)}),d.forEach(l=>{this.u(p,`INSERT INTO ItemTable VALUES ${new Array(l.length/2).fill("(?,?)").join(",")}`,u=>u.run(l),()=>{const u=[];let m=0;return v.forEach((C,E)=>{u.push(E),m+=C.length}),`Keys: ${u.join(", ")} Length: ${m}`})})}if(h&&h.size){const d=[];d.push([]);let b=0;h.forEach(l=>{let u=d[b];u.length>I.b&&(b++,u=[],d.push(u)),u.push(l)}),d.forEach(l=>{this.u(p,`DELETE FROM ItemTable WHERE key IN (${new Array(l.length).fill("?").join(",")})`,u=>u.run(l),()=>{const u=[];return h.forEach(m=>{u.push(m)}),`Keys: ${u.join(", ")}`})})}})}async close(p){this.d.trace(`[storage ${this.c}] close()`);const y=await this.f;return this.k(y,p)}k(p,y){return new Promise((v,h)=>{p.db.close(d=>(d&&this.o(p,`[storage ${this.c}] close(): ${d}`),this.g===I.IN_MEMORY_PATH?v():!p.isErroneous&&!p.isInMemory?this.l().then(v,b=>(this.d.error(`[storage ${this.c}] backup(): ${b}`),v())):typeof y=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(b=>{const l=()=>this.k(b,void 0);return this.j(b,{insert:y()}).then(()=>l(),u=>(l(),Promise.reject(u)))})).then(v,h):h(d||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const p=this.m(this.g);return A.Promises.copy(this.g,p,{preserveSymlinks:!1})}m(p){return`${p}.backup`}async checkIntegrity(p){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${p})`);const y=await this.f,v=await this.r(y,p?"PRAGMA integrity_check":"PRAGMA quick_check"),h=p?v.integrity_check:v.quick_check;return y.isErroneous?`${h} (last error: ${y.lastError})`:y.isInMemory?`${h} (in-memory!)`:h}async n(p,y=!0){this.d.trace(`[storage ${this.c}] open(${p}, retryOnBusy: ${y})`);try{return await this.p(p)}catch(v){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&y)return await(0,S.timeout)(I.a),this.n(p,!1);try{await A.Promises.unlink(p);try{await A.Promises.rename(this.m(p),p)}catch{}return await this.p(p)}catch(h){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${h}`),this.p(I.IN_MEMORY_PATH)}}}o(p,y){p.isErroneous=!0,p.lastError=y,this.d.error(y)}p(p){return new Promise((y,v)=>{new Promise((h,d)=>{V(["@vscode/sqlite3"],h,d)}).then(h=>{const d={db:new(this.d.isTracing?h.verbose().Database:h.Database)(p,b=>b?d.db&&b.code!=="SQLITE_CANTOPEN"?d.db.close(()=>v(b)):v(b):this.q(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(d),l=>d.db.close(()=>v(l)))),isInMemory:p===I.IN_MEMORY_PATH};d.db.on("error",b=>this.o(d,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&d.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},v)})}q(p,y){return new Promise((v,h)=>{p.db.exec(y,d=>d?(this.o(p,`[storage ${this.c}] exec(): ${d}`),h(d)):v())})}r(p,y){return new Promise((v,h)=>{p.db.get(y,(d,b)=>d?(this.o(p,`[storage ${this.c}] get(): ${d}`),h(d)):v(b))})}s(p,y){return new Promise((v,h)=>{p.db.all(y,(d,b)=>d?(this.o(p,`[storage ${this.c}] all(): ${d}`),h(d)):v(b))})}t(p,y){return new Promise((v,h)=>{p.db.serialize(()=>{p.db.run("BEGIN TRANSACTION"),y(),p.db.run("END TRANSACTION",d=>d?(this.o(p,`[storage ${this.c}] transaction(): ${d}`),h(d)):v())})})}u(p,y,v,h){const d=p.db.prepare(y),b=l=>{this.o(p,`[storage ${this.c}] prepare(): ${l} (${y}). Details: ${h()}`)};d.on("error",b),v(d),d.finalize(l=>{l&&b(l),d.removeListener("error",b)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.a=2e3,I.b=256;class w{constructor(p){p&&typeof p.logTrace=="function"&&process.env[w.VSCODE_TRACE_STORAGE]&&(this.a=p.logTrace),p&&typeof p.logError=="function"&&(this.b=p.logError)}get isTracing(){return!!this.a}trace(p){this.a?.(p)}error(p){this.b?.(p)}}w.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(te[149],ne([12,10]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(te[150],ne([12,10]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[151],ne([12,10]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[152],ne([12,10]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(te[153],ne([12,10]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(te[154],ne([12,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[155],ne([12,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[156],ne([12,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[157],ne([12,10]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[158],ne([12,10]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[159],ne([12,10]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(te[160],ne([12,10]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(te[161],ne([12,10]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(te[162],ne([12,10]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[163],ne([12,10]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[164],ne([12,10]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[165],ne([12,10]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[166],ne([12,10]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[167],ne([12,10]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(te[168],ne([12,10]),function(V,e){return V.create("vs/platform/shell/node/shellEnv",e)}),define(te[169],ne([12,10]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[170],ne([12,10]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(te[171],ne([12,10]),function(V,e){return V.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[172],ne([12,10]),function(V,e){return V.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[173],ne([12,10]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[174],ne([12,10]),function(V,e){return V.create("vs/platform/workspace/common/workspace",e)}),define(te[175],ne([12,10]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[176],ne([12,10]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[177],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function S(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=S;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(te[178],ne([0,1,7]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(A){return typeof A?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(A){let I=[];try{Array.isArray(A.workspaces)&&(I=A.workspaces.map(w=>({workspace:{id:w.id,configPath:S.URI.parse(w.configURIPath)},remoteAuthority:w.remoteAuthority})))}catch{}return I}e.deserializeWorkspaceInfos=k;function M(A){let I=[];try{Array.isArray(A.folders)&&(I=A.folders.map(w=>({folderUri:S.URI.parse(w.folderUri),remoteAuthority:w.remoteAuthority})))}catch{}return I}e.deserializeFolderInfos=M}),define(te[179],ne([0,1,3,2]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this.a=new S.Emitter,this.b=new S.Emitter,this.c=new S.Emitter,this.d=new S.Emitter}call(I,w,g){switch(w){case"close":return Promise.resolve(this.a.fire({sessionId:g[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:g[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:g[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:g[0],port:g[1],subId:g[2]}))}throw new Error("Method not implemented.")}listen(I,w,g){switch(w){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class M extends t.Disposable{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,w,g){this.b.call("attach",[I,w,g])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,w){this.b.call("terminate",[I,w])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,w){return this.b.call("openExtensionDevelopmentHostWindow",[I,w])}}e.ExtensionHostDebugChannelClient=M}),define(te[180],ne([0,1,134,54,15,9,35,20,7]),function(V,e,S,t,k,M,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class g{get appRoot(){return(0,M.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return w.URI.file((0,M.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(w.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=A.env.VSCODE_PORTABLE;return d?w.URI.file((0,M.join)(d,"argv.json")):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,M.resolve)(d):(0,M.normalize)((0,M.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?w.URI.file((0,M.resolve)(d)):w.URI.file((0,M.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,M.resolve)(d);const b=A.env.VSCODE_EXTENSIONS;if(b)return b;const l=A.env.VSCODE_PORTABLE;return l?(0,M.join)(l,"extensions"):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(b=>/^[^:/?#]+?:\/\//.test(b)?w.URI.parse(b):w.URI.file((0,M.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?w.URI.parse(d):w.URI.file((0,M.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const b of this.args.log||[]){const l=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(b);l&&l[1]&&l[2]&&d.push([l[1],l[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return w.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=A.env.VSCODE_PORTABLE;return d?w.URI.file((0,M.join)(d,"policy.json")):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,b,l){this.a=d,this.b=b,this.c=l,this.editSessionId=this.args.editSessionId}}pe([t.memoize],g.prototype,"appRoot",null),pe([t.memoize],g.prototype,"userHome",null),pe([t.memoize],g.prototype,"userDataPath",null),pe([t.memoize],g.prototype,"appSettingsHome",null),pe([t.memoize],g.prototype,"tmpDir",null),pe([t.memoize],g.prototype,"cacheHome",null),pe([t.memoize],g.prototype,"stateResource",null),pe([t.memoize],g.prototype,"userRoamingDataHome",null),pe([t.memoize],g.prototype,"userDataSyncHome",null),pe([t.memoize],g.prototype,"userDataSyncLogResource",null),pe([t.memoize],g.prototype,"editSessionsLogResource",null),pe([t.memoize],g.prototype,"sync",null),pe([t.memoize],g.prototype,"machineSettingsResource",null),pe([t.memoize],g.prototype,"workspaceStorageHome",null),pe([t.memoize],g.prototype,"localHistoryHome",null),pe([t.memoize],g.prototype,"keyboardLayoutResource",null),pe([t.memoize],g.prototype,"argvResource",null),pe([t.memoize],g.prototype,"isExtensionDevelopment",null),pe([t.memoize],g.prototype,"untitledWorkspacesHome",null),pe([t.memoize],g.prototype,"installSourcePath",null),pe([t.memoize],g.prototype,"builtinExtensionsPath",null),pe([t.memoize],g.prototype,"extensionsPath",null),pe([t.memoize],g.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],g.prototype,"extensionDevelopmentKind",null),pe([t.memoize],g.prototype,"extensionTestsLocationURI",null),pe([t.memoize],g.prototype,"debugExtensionHost",null),pe([t.memoize],g.prototype,"logLevel",null),pe([t.memoize],g.prototype,"extensionLogLevel",null),pe([t.memoize],g.prototype,"serviceMachineIdResource",null),pe([t.memoize],g.prototype,"telemetryLogResource",null),pe([t.memoize],g.prototype,"disableWorkspaceTrust",null),pe([t.memoize],g.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=g;function p(h,d){return v(h["inspect-extensions"],h["inspect-brk-extensions"],5870,d,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=p;function y(h,d){return v(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,d,h.extensionEnvironment)}e.parsePtyHostPort=y;function v(h,d,b,l,u,m){const E=Number(d||h)||(l?null:b),R=E?Boolean(!!d):!1;let i;if(m)try{i=JSON.parse(m)}catch{}return{port:E,break:R,debugId:u,env:i}}}),define(te[105],ne([0,1,281,4,152]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,k.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},category:{type:"string",cat:"e",description:(0,k.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(b,l,u=A){const m=b.find(c=>c.length>0&&c[0]!=="-"),C={},E=["_"],R=[],i={};let r;for(const c in l){const s=l[c];s.type==="subcommand"?c===m&&(r=s):(s.alias&&(C[c]=s.alias),s.type==="string"||s.type==="string[]"?(E.push(c),s.deprecates&&E.push(...s.deprecates)):s.type==="boolean"&&(R.push(c),s.deprecates&&R.push(...s.deprecates)),s.global&&(i[c]=s))}if(r&&m){const c=i;for(const L in r.options)c[L]=r.options[L];const s=b.filter(L=>L!==m),f=u.getSubcommandReporter?u.getSubcommandReporter(m):void 0,P=I(s,c,f);return{[m]:P,_:[]}}const n=S(b,{string:E,boolean:R,alias:C}),o={},a=n;o._=n._.map(c=>String(c)).filter(c=>c.length>0),delete a._;for(const c in l){const s=l[c];if(s.type==="subcommand")continue;s.alias&&delete a[s.alias];let f=a[c];if(s.deprecates)for(const P of s.deprecates)a.hasOwnProperty(P)&&(f||(f=a[P],f&&u.onDeprecatedOption(P,s.deprecationMessage||(0,k.localize)(36,null,c))),delete a[P]);if(typeof f<"u"){if(s.type==="string[]"){if(Array.isArray(f)||(f=[f]),!s.allowEmptyValue){const P=f.filter(L=>L.length>0);P.length!==f.length&&(u.onEmptyValue(c),f=P.length>0?P:void 0)}}else s.type==="string"&&(Array.isArray(f)?(f=f.pop(),u.onMultipleValues(c,f)):!f&&!s.allowEmptyValue&&(u.onEmptyValue(c),f=void 0));o[c]=f,s.deprecationMessage&&u.onDeprecatedOption(c,s.deprecationMessage)}delete a[c]}for(const c in a)u.onUnknownOption(c);return o}e.parseArgs=I;function w(b,l){let u="";return l.args&&(Array.isArray(l.args)?u=` <${l.args.join("> <")}>`:u=` <${l.args}>`),l.alias?`-${l.alias} --${b}${u}`:`--${b}${u}`}function g(b,l){const u=[];for(const m in b){const C=b[m],E=w(m,C);u.push([E,C.description])}return p(u,l)}e.formatOptions=g;function p(b,l){const m=b.reduce((R,i)=>Math.max(R,i[0].length),12)+2+1;if(l-m<25)return b.reduce((R,i)=>R.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const C=l-m-1,E=[];for(const R of b){const i=R[0],r=v(R[1],C),n=y(m-i.length-2);E.push("  "+i+n+r[0]);for(let o=1;o<r.length;o++)E.push(y(m)+r[o])}return E}function y(b){return" ".repeat(b)}function v(b,l){const u=[];for(;b.length;){const m=b.length<l?b.length:b.lastIndexOf(" ",l),C=b.slice(0,m).trim();b=b.slice(m),u.push(C)}return u}function h(b,l,u,m,C){const E=process.stdout.isTTY&&process.stdout.columns||80,R=C?.noInputFiles!==!0?`[${(0,k.localize)(37,null)}...]`:"",i=[`${b} ${u}`];i.push(""),i.push(`${(0,k.localize)(38,null)}: ${l} [${(0,k.localize)(39,null)}]${R}`),i.push(""),C?.noPipe!==!0&&(t.isWindows?i.push((0,k.localize)(40,null,l)):i.push((0,k.localize)(41,null,l)),i.push(""));const r={},n=[];for(const o in m){const a=m[o];if(a.type==="subcommand")a.description&&n.push({command:o,description:a.description});else if(a.description&&a.cat){let c=r[a.cat];c||(r[a.cat]=c={}),c[o]=a}}for(const o in r){const a=o,c=r[a];c&&(i.push(M[a]),i.push(...g(c,E)),i.push(""))}return n.length&&(i.push((0,k.localize)(42,null)),i.push(...p(n.map(o=>[o.command,o.description]),E)),i.push("")),i.join(`
`)}e.buildHelpMessage=h;function d(b,l){return`${b||(0,k.localize)(43,null)}
${l||(0,k.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=d}),define(te[181],ne([0,1,79,179,105]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends t.ExtensionHostDebugBroadcastChannel{constructor(I){super(),this.f=I}call(I,w,g){return w==="openExtensionDevelopmentHostWindow"?this.g(g[0],g[1]):super.call(I,w,g)}async g(I,w){const g=(0,k.parseArgs)(I,k.OPTIONS);g.debugRenderer=w;const p=g.extensionDevelopmentPath;if(!p)return{success:!1};const[y]=await this.f.openExtensionDevelopmentHostWindow(p,{context:5,cli:g,forceProfile:g.profile,forceTempProfile:g["profile-temp"]});if(!w)return{success:!0};const v=y.win;if(!v)return{success:!0};const h=v.webContents.debugger;let d=h.isAttached()?1/0:0;const b=(0,S.createServer)(l=>{d++===0&&h.attach();let u=!1;const m=R=>{u||l.write(JSON.stringify(R)+"\0")},C=(R,i,r,n)=>m({method:i,params:r,sessionId:n});v.on("close",()=>{h.removeListener("message",C),l.end(),u=!0}),h.addListener("message",C);let E=Buffer.alloc(0);l.on("data",R=>{E=Buffer.concat([E,R]);for(let i=E.indexOf(0);i!==-1;i=E.indexOf(0)){let r;try{const n=E.slice(0,i).toString("utf8");E=E.slice(i+1),r=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}h.sendCommand(r.method,r.params,r.sessionId).then(n=>m({id:r.id,sessionId:r.sessionId,result:n})).catch(n=>m({id:r.id,sessionId:r.sessionId,error:{code:0,message:n.message}}))}}),l.on("error",R=>{console.error("error on cdp pipe:",R)}),l.on("close",()=>{u=!0,--d===0&&h.detach()})});return await new Promise(l=>b.listen(0,l)),v.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),define(te[61],ne([0,1,282,153,105]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const M=2048;function A(v,h){const d=(E,R)=>{console.warn((0,t.localize)(0,null,E,R))},b=E=>{console.warn((0,t.localize)(1,null,E))},l=(E,R)=>{console.warn((0,t.localize)(2,null,E,R))},u=E=>({onUnknownOption:R=>{E!=="tunnel"&&console.warn((0,t.localize)(3,null,R,E))},onMultipleValues:d,onEmptyValue:b,onDeprecatedOption:l,getSubcommandReporter:E!=="tunnel"?u:void 0}),m={onUnknownOption:E=>{console.warn((0,t.localize)(4,null,E))},onMultipleValues:d,onEmptyValue:b,onDeprecatedOption:l,getSubcommandReporter:u},C=(0,k.parseArgs)(v,k.OPTIONS,h?m:void 0);return C.goto&&C._.forEach(E=>S(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,t.localize)(5,null))),C["max-memory"]&&S(parseInt(C["max-memory"])>=M,`The max-memory argument cannot be specified lower than ${M} MB.`),C}function I(v){const h=v.findIndex(d=>!/^-/.test(d));if(h>-1)return[...v.slice(0,h),...v.slice(h+1)]}function w(v){let[,...h]=v;process.env.VSCODE_DEV&&(h=I(h)||[]);const d=!y(process.env);return A(h,d)}e.parseMainProcessArgv=w;function g(v){let[,,...h]=v;return process.env.VSCODE_DEV&&(h=I(h)||[]),A(h,!0)}e.parseCLIProcessArgv=g;function p(v,...h){const d=v.indexOf("--");return d===-1?v.push(...h):v.splice(d,0,...h),v}e.addArg=p;function y(v){return v.VSCODE_CLI==="1"}e.isLaunchedFromCli=y}),function(){"use strict";function V(e,S,t){function k(A,I){const w=M(A,I),g=[w];return e.isAbsolute(w)||g.unshift(t),e.resolve(...g)}function M(A,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,I);const p=A["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(y,"AppData","Roaming")}break;case"darwin":g=e.join(S.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,I)}return{getUserDataPath:k}}if(typeof define=="function")define(te[182],ne([183,25,35]),function(e,S,t){return V(e,S,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=V(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[184],ne([0,1,25,180,182]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends t.AbstractNativeEnvironmentService{constructor(I,w){super(I,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,k.getUserDataPath)(I,w.nameShort)},w)}}e.NativeEnvironmentService=M}),define(te[185],ne([0,1,41,25,31]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function M(A){const I=(0,k.randomPath)((0,t.tmpdir)());try{return(0,S.writeFileSync)(I,""),A&&console.log(`Marker file for --wait created: ${I}`),I}catch(w){A&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFileSync=M}),define(te[186],ne([0,1,11,155]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(A,I,w){try{M(A,I,w)}catch(g){console.error(g?.message??g)}return A}e.localizeManifest=k;function M(A,I,w){const g=(p,y,v)=>{const h=p[y];if((0,S.isString)(h)){const d=h,b=d.length;if(b>1&&d[0]==="%"&&d[b-1]==="%"){const l=d.substr(1,b-2);let u=I[l];u===void 0&&w&&(u=w[l]);const m=typeof u=="string"?u:u?.message,C=w?.[l],E=typeof C=="string"?C:C?.message;if(!m){E||console.warn(`[${A.name}]: ${(0,t.localize)(0,null,l)}`);return}if(v&&(y==="title"||y==="category")&&E&&E!==m){const R={value:m,original:E};p[y]=R}else p[y]=m}}else if((0,S.isObject)(h))for(const d in h)h.hasOwnProperty(d)&&(d==="commands"?g(h,d,!0):g(h,d,v));else if(Array.isArray(h))for(let d=0;d<h.length;d++)g(h,d,v)};for(const p in A)A.hasOwnProperty(p)&&g(A,p)}}),define(te[187],ne([0,1,13]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(M,A){this.a.set(M,A)}updateManifest(M){if(!(typeof M.main>"u"&&typeof M.browser>"u")&&(M.activationEvents===void 0&&Object.assign(M,{activationEvents:[]}),!(!Array.isArray(M.activationEvents)||!M.contributes)))for(const A in M.contributes){const I=this.a.get(A);if(!I)continue;const w=M.contributes[A],g=Array.isArray(w)?w:[w];try{I(g,M.activationEvents)}catch(p){(0,S.onUnexpectedError)(p)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(te[188],ne([0,1,20,98,157,189]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function w(u){return u=u.trim(),u==="*"||A.test(u)}e.isValidVersionStr=w;function g(u){if(!w(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=u.match(A);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=g;function p(u){if(!u)return null;const m=u.majorBase,C=u.majorMustEqual,E=u.minorBase;let R=u.minorMustEqual;const i=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(m===0||(R=!1),r=!1);let n=0;if(u.preRelease){const o=I.exec(u.preRelease);if(o){const[,a,c,s]=o;n=Date.UTC(Number(a),Number(c)-1,Number(s))}}return{majorBase:m,majorMustEqual:C,minorBase:E,minorMustEqual:R,patchBase:i,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:n}}e.normalizeVersion=p;function y(u,m,C){let E;typeof u=="string"?E=p(g(u)):E=u;let R;m instanceof Date?R=m.getTime():typeof m=="string"&&(R=new Date(m).getTime());let i;if(typeof C=="string"?i=p(g(C)):i=C,!E||!i)return!1;const r=E.majorBase,n=E.minorBase,o=E.patchBase;let a=i.majorBase,c=i.minorBase,s=i.patchBase;const f=i.notBefore;let P=i.majorMustEqual,L=i.minorMustEqual,T=i.patchMustEqual;return i.isMinimum?r>a?!0:r<a?!1:n>c?!0:n<c||R&&R<f?!1:o>=s:(r===1&&a===0&&(!P||!L||!T)&&(a=1,c=0,s=0,P=!0,L=!1,T=!1),r<a?!1:r>a?!P:n<c?!1:n>c?!L:o<s?!1:o>s?!T:!(R&&R<f))}e.isValidVersion=y;function v(u,m,C,E,R){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([t.default.Error,k.localize(0,null)]),i;if(typeof E.name!="string")return i.push([t.default.Error,k.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([t.default.Error,k.localize(2,null,"version")]),i;if(!E.engines)return i.push([t.default.Error,k.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([t.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!l(E.extensionDependencies))return i.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!l(E.activationEvents))return i.push([t.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([t.default.Error,k.localize(9,null,"main")]),i;{const o=(0,S.joinPath)(C,E.main);(0,S.isEqualOrParent)(o,C)||i.push([t.default.Warning,k.localize(10,null,o.path,C.path)])}if(typeof E.activationEvents>"u")return i.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([t.default.Error,k.localize(12,null,"browser")]),i;{const o=(0,S.joinPath)(C,E.browser);(0,S.isEqualOrParent)(o,C)||i.push([t.default.Warning,k.localize(13,null,o.path,C.path)])}if(typeof E.activationEvents>"u")return i.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!M.valid(E.version))return i.push([t.default.Error,k.localize(15,null)]),i;const r=[];if(!h(u,m,E,R,r))for(const o of r)i.push([t.default.Error,o]);return i}e.validateExtensionManifest=v;function h(u,m,C,E,R){return E||typeof C.main>"u"&&typeof C.browser>"u"?!0:b(u,m,C.engines.vscode,R)}e.isValidExtensionVersion=h;function d(u,m,C){return u==="*"||b(m,C,u)}e.isEngineValid=d;function b(u,m,C,E=[]){const R=p(g(C));if(!R)return E.push(k.localize(16,null,C)),!1;if(R.majorBase===0){if(!R.majorMustEqual||!R.minorMustEqual)return E.push(k.localize(17,null,C)),!1}else if(!R.majorMustEqual)return E.push(k.localize(18,null,C)),!1;return y(u,m,R)?!0:(E.push(k.localize(19,null,u,C)),!1)}function l(u){if(!Array.isArray(u))return!1;for(let m=0,C=u.length;m<C;m++)if(typeof u[m]!="string")return!1;return!0}}),define(te[190],ne([0,1,17,30]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(M,A,I){let w=I&&I.get("storage.serviceMachineId",-1)||null;if(w)return w;try{const p=(await A.readFile(M.serviceMachineIdResource)).value.toString();w=(0,t.isUUID)(p)?p:null}catch{w=null}if(!w){w=(0,t.generateUuid)();try{await A.writeFile(M.serviceMachineIdResource,S.VSBuffer.fromString(w))}catch{}}return I?.store("storage.serviceMachineId",w,-1,1),w}e.getServiceMachineId=k}),define(te[70],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(k,M=[],A=!1){this.ctor=k,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=S}),define(te[191],ne([0,1,70]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function M(I,w,g){w instanceof S.SyncDescriptor||(w=new S.SyncDescriptor(w,[],Boolean(g))),t.push([I,w])}e.registerSingleton=M;function A(){return t}e.getSingletonServiceDescriptors=A}),define(te[192],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=S;class t{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const I=this.lookupOrInsertNode(M),w=this.lookupOrInsertNode(A);I.outgoing.set(w.key,w),w.incoming.set(I.key,I)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const I of this.a.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let I=this.a.get(A);return I||(I=new S(A,M),this.a.set(A,I)),I}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,I]of this.a)M.push(`${A}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const I=new Set([M]),w=this.c(A,I);if(w)return w}}c(M,A){for(const[I,w]of M.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const g=this.c(w,A);if(g)return g;A.delete(I)}}}e.Graph=t}),define(te[5],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function I(w){return w[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=I})(S=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(A,I,w){I[S.DI_TARGET]===I?I[S.DI_DEPENDENCIES].push({id:A,index:w}):(I[S.DI_DEPENDENCIES]=[{id:A,index:w}],I[S.DI_TARGET]=I)}function k(A){if(S.serviceIds.has(A))return S.serviceIds.get(A);const I=function(w,g,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,w,p)};return I.toString=()=>A,S.serviceIds.set(A,I),I}e.createDecorator=k;function M(A){return A}e.refineServiceDecorator=M}),define(te[62],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,S.createDecorator)("backupMainService")}),define(te[18],ne([0,1,11,7,5]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function M(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationOverrides=M;function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function g(u,m){const C=Object.create(null);for(const E in u)p(C,E,u[E],m);return C}e.toValuesTree=g;function p(u,m,C,E){const R=m.split("."),i=R.pop();let r=u;for(let n=0;n<R.length;n++){const o=R[n];let a=r[o];switch(typeof a){case"undefined":a=r[o]=Object.create(null);break;case"object":break;default:E(`Ignoring ${m} as ${R.slice(0,n+1).join(".")} is ${JSON.stringify(a)}`);return}r=a}if(typeof r=="object"&&r!==null)try{r[i]=C}catch{E(`Ignoring ${m} as ${R.join(".")} is ${JSON.stringify(r)}`)}else E(`Ignoring ${m} as ${R.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=p;function y(u,m){const C=m.split(".");v(u,C)}e.removeFromValueTree=y;function v(u,m){const C=m.shift();if(m.length===0){delete u[C];return}if(Object.keys(u).indexOf(C)!==-1){const E=u[C];typeof E=="object"&&!Array.isArray(E)&&(v(E,m),Object.keys(E).length===0&&delete u[C])}}function h(u,m,C){function E(r,n){let o=r;for(const a of n){if(typeof o!="object"||o===null)return;o=o[a]}return o}const R=m.split("."),i=E(u,R);return typeof i>"u"?C:i}e.getConfigurationValue=h;function d(u,m,C){Object.keys(m).forEach(E=>{E!=="__proto__"&&(E in u?S.isObject(u[E])&&S.isObject(m[E])?d(u[E],m[E],C):C&&(u[E]=m[E]):u[E]=m[E])})}e.merge=d;function b(u,m,C){const E=u.inspect(m),R=u.inspect(C);return typeof E.userValue<"u"||typeof E.workspaceValue<"u"||typeof E.workspaceFolderValue<"u"?E.value:typeof R.userValue<"u"||typeof R.workspaceValue<"u"||typeof R.workspaceFolderValue<"u"?R.value:E.defaultValue}e.getMigratedSettingValue=b;function l(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=l}),define(te[71],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,S.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,S.createDecorator)("credentialsMainService");class t{constructor(){this.a={}}async getPassword(M,A){return this.a[M]?.[A]??null}async setPassword(M,A,I){this.a[M]=this.a[M]??{},this.a[M][A]=I}async deletePassword(M,A){return this.a[M]?.[A]?(delete this.a[M][A],Object.keys(this.a[M]).length===0&&delete this.a[M],!0):!1}async findPassword(M){return JSON.stringify(this.a[M])??null}async findCredentials(M){const A=[];for(const I of Object.keys(this.a[M]||{}))A.push({account:I,password:this.a[M][I]});return A}async clear(){this.a={}}}e.InMemoryCredentialsProvider=t}),define(te[85],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function t(M){return!!M.hostName&&!!M.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(A,I){return{}}async getSystemInfo(A,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,I){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=k}),define(te[106],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,S.createDecorator)("encryptionMainService")}),define(te[33],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(te[27],ne([0,1,54,9,84,33,184,5]),function(V,e,S,t,k,M,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(M.IEnvironmentService);class w extends A.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}pe([S.memoize],w.prototype,"cachedLanguagesPath",null),pe([S.memoize],w.prototype,"backupHome",null),pe([S.memoize],w.prototype,"mainIPCHandle",null),pe([S.memoize],w.prototype,"mainLockfile",null),pe([S.memoize],w.prototype,"disableUpdates",null),pe([S.memoize],w.prototype,"disableKeytar",null),pe([S.memoize],w.prototype,"crossOriginIsolated",null),pe([S.memoize],w.prototype,"codeCachePath",null),pe([S.memoize],w.prototype,"useCodeCache",null),e.EnvironmentMainService=w}),define(te[193],ne([0,1,154,5]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function M(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function A(u,m){switch(u){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function I(u,m){return m==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function w(u,m,C){return I(m,C)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===C?!0:g(C).includes(u)}e.isTargetPlatformCompatible=w;function g(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=g;function p(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=p;var y;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var v;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var h;(function(u){u.Install="install",u.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var d;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var b;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class l extends Error{constructor(m,C){super(m),this.code=C,this.name=C}}e.ExtensionManagementError=l,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,S.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(te[194],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,S.createDecorator)("extensionUrlTrustService")}),define(te[195],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,S.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[107],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,S.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,S.createDecorator)("externalTerminal")}),define(te[196],ne([0,1,46,15,9,4,80,23,83,158,107]),function(V,e,S,t,k,M,A,I,w,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=g.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends v{openTerminal(E,R){return this.spawnTerminal(S,E,w.getWindowsShell(),R)}spawnTerminal(E,R,i,r){const n=R.windowsExec||h.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const o=k.basename(n).toLowerCase();if(o==="cmder"||o==="cmder.exe")return E.spawn(n,r?[r]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return n.indexOf(" ")>=0&&a.push('""'),a.push(n),(o==="wt"||o==="wt.exe")&&a.push("-d ."),new Promise((c,s)=>{const f=l(process),P=E.spawn(i,a,{cwd:r,env:f});P.on("error",s),P.on("exit",()=>c())})}runInTerminal(E,R,i,r,n){const o="windowsExec"in n&&n.windowsExec?n.windowsExec:h.getDefaultTerminalWindows();return new Promise((a,c)=>{const s=`"${R} - ${y}"`,f=`""${i.join('" "')}" & pause"`,P=["/c","start",s,"/wait",o,"/c",f],L=Object.assign({},l(process),r);Object.keys(L).filter(G=>L[G]===null).forEach(G=>delete L[G]);const T={cwd:R,env:L,windowsVerbatimArguments:!0};S.spawn(h.b,P,T).on("error",G=>{c(u(G))}),a(void 0)})}static getDefaultTerminalWindows(){if(!h.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return h.d}}e.WindowsExternalTerminalService=h,h.b="cmd.exe";class d extends v{openTerminal(E,R){return this.spawnTerminal(S,E,R)}runInTerminal(E,R,i,r,n){const o=n.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((a,c)=>{if(o===p.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const s=o===p.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",P=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${s}.scpt`).fsPath,"-t",E||y,"-w",R];for(const U of i)P.push("-a"),P.push(U);if(r){const U=Object.assign({},l(process),r);for(const G in U){const H=U[G];H===null?(P.push("-u"),P.push(G)):(P.push("-e"),P.push(`${G}=${H}`))}}let L="";const T=S.spawn(d.b,P);T.on("error",U=>{c(u(U))}),T.stderr.on("data",U=>{L+=U.toString()}),T.on("exit",U=>{if(U===0)a(void 0);else if(L){const G=L.split(`
`,1);c(new Error(G[0]))}else c(new Error(g.localize(1,null,s,U)))})}else c(new Error(g.localize(2,null,o)))})}spawnTerminal(E,R,i){const r=R.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((n,o)=>{const a=["-a",r];i&&a.push(i);const c=l(process),s=E.spawn("/usr/bin/open",a,{cwd:i,env:c});s.on("error",o),s.on("exit",()=>n())})}}e.MacExternalTerminalService=d,d.b="/usr/bin/osascript";class b extends v{openTerminal(E,R){return this.spawnTerminal(S,E,R)}runInTerminal(E,R,i,r,n){const o=n.linuxExec?Promise.resolve(n.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((a,c)=>{const s=[];o.then(f=>{f.indexOf("gnome-terminal")>=0?s.push("-x"):s.push("-e"),s.push("bash"),s.push("-c");const P=`${m(i)}; echo; read -p "${b.b}" -n1;`;s.push(`''${P}''`);const L=Object.assign({},l(process),r);Object.keys(L).filter(H=>L[H]===null).forEach(H=>delete L[H]);const T={cwd:R,env:L};let U="";const G=S.spawn(f,s,T);G.on("error",H=>{c(u(H))}),G.stderr.on("data",H=>{U+=H.toString()}),G.on("exit",H=>{if(H===0)a(void 0);else if(U){const K=U.split(`
`,1);c(new Error(K[0]))}else c(new Error(g.localize(4,null,f,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!b.d)if(!M.isLinux)b.d=Promise.resolve("xterm");else{const E=await I.Promises.exists("/etc/debian_version");b.d=new Promise(R=>{E?R("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?R("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?R("konsole"):process.env.COLORTERM?R(process.env.COLORTERM):process.env.TERM?R(process.env.TERM):R("xterm")})}return b.d}spawnTerminal(E,R,i){const r=R.linuxExec?Promise.resolve(R.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{r.then(a=>{const c=l(process),s=E.spawn(a,[],{cwd:i,env:c});s.on("error",o),s.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=b,b.b=g.localize(3,null);function l(C){const E={...C.env};return(0,A.sanitizeProcessEnvironment)(E),E}function u(C){return"errno"in C&&C.errno==="ENOENT"&&"path"in C&&typeof C.path=="string"?new Error(g.localize(5,null,C.path)):C}function m(C){let E="";for(const R of C)R.indexOf(" ")>=0?E+='"'+R+'"':E+=R,E+=" ";return E}}),define(te[16],ne([0,1,60,9,26,11,7,160,5]),function(V,e,S,t,k,M,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function g(_){return _.create===!0}e.isFileOpenForWriteOptions=g;var p;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(p=e.FileType||(e.FileType={}));var y;(function(_){_[_.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var v;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileClone=32768]="FileClone"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=h;function d(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=d;function b(_){return!!(_.capabilities&32768)}e.hasFileCloneCapability=b;function l(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function u(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=u;function m(_){return h(_)?!!(_.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var C;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor($,N){super($),this.code=N}}e.FileSystemProviderError=E;function R(_,$){const N=new E(_.toString(),$);return r(N,$),N}e.createFileSystemProviderError=R;function i(_){return _||R((0,I.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=i;function r(_,$){return _.name=$?`${$} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=r;function n(_){if(!_)return C.Unknown;if(_ instanceof E)return _.code;const $=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!$)return C.Unknown;switch($[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=n;function o(_){if(_ instanceof L)return _.fileOperationResult;switch(n(_)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var a;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class c{constructor($,N,W){this.resource=$,this.operation=N,this.target=W}isOperation($){return this.operation===$}}e.FileOperationEvent=c;var s;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class f{constructor($,N){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const W=new Map;for(const z of $){const Y=W.get(z.type);switch(Y?Y.push([z.resource,z]):W.set(z.type,[[z.resource,z]]),z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}}for(const[z,Y]of W)switch(z){case 1:this.a=S.TernarySearchTree.forUris(()=>N),this.a.fill(Y);break;case 0:this.b=S.TernarySearchTree.forUris(()=>N),this.b.fill(Y);break;case 2:this.c=S.TernarySearchTree.forUris(()=>N),this.c.fill(Y);break}}contains($,...N){return this.d($,{includeChildren:!1},...N)}affects($,...N){return this.d($,{includeChildren:!0},...N)}d($,N,...W){if(!$)return!1;const z=W.length>0;return!!((!z||W.includes(1))&&(this.a?.get($)||N.includeChildren&&this.a?.findSuperstr($))||(!z||W.includes(0))&&(this.b?.get($)||N.includeChildren&&this.b?.findSuperstr($))||(!z||W.includes(2))&&(this.c?.findSubstr($)||N.includeChildren&&this.c?.findSuperstr($)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=f;function P(_,$,N){return!_||!$||_===$||$.length>_.length?!1:($.charAt($.length-1)!==t.sep&&($+=t.sep),N?(0,k.startsWithIgnoreCase)(_,$):_.indexOf($)===0)}e.isParent=P;class L extends Error{constructor($,N,W){super($),this.fileOperationResult=N,this.options=W}}e.FileOperationError=L;class T extends L{constructor($,N,W,z){super($,N,z),this.fileOperationResult=N,this.size=W}}e.TooLargeFileOperationError=T;class U extends L{constructor($,N,W){super($,2,W),this.stat=N}}e.NotModifiedSinceFileOperationError=U;var G;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(G=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var H;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(H=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function K(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=K;async function se(_,$){if(!$.hasProvider(A.URI.from({scheme:_.scheme})))return new Promise(N=>{const W=$.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===_.scheme&&z.added&&(W.dispose(),N())})})}e.whenProviderRegistered=se,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Z{static formatSize($){return(0,M.isNumber)($)||($=0),$<Z.KB?(0,I.localize)(1,null,$.toFixed(0)):$<Z.MB?(0,I.localize)(2,null,($/Z.KB).toFixed(2)):$<Z.GB?(0,I.localize)(3,null,($/Z.MB).toFixed(2)):$<Z.TB?(0,I.localize)(4,null,($/Z.GB).toFixed(2)):(0,I.localize)(5,null,($/Z.TB).toFixed(2))}}e.ByteSize=Z,Z.KB=1024,Z.MB=Z.KB*Z.KB,Z.GB=Z.MB*Z.KB,Z.TB=Z.GB*Z.KB;var ce;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(ce=e.Arch||(e.Arch={}));function ge(_){return{maxFileSize:_===0?300*Z.MB:16*Z.GB,maxHeapSize:_===0?700*Z.MB:2*700*Z.MB}}e.getPlatformLimits=ge}),define(te[197],ne([0,1,17,45,13,3,2,59,7,30,16]),function(V,e,S,t,k,M,A,I,w,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends A.Disposable{constructor(h,d){super(),this.a=h,this.b=d,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new M.Emitter),this.onDidWatchError=this.g.event,this.h=(0,g.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,d){const{buffer:b}=await this.a.call("readFile",[h,d]);return b}readFileStream(h,d,b){const l=(0,I.newWriteableStream)(m=>S.VSBuffer.concat(m.map(C=>S.VSBuffer.wrap(C))).buffer),u=this.a.listen("readFileStream",[h,d])(m=>{if(m instanceof S.VSBuffer)l.write(m.buffer);else{if(m==="end")l.end();else{let C;if(m instanceof Error)C=m;else{const E=m;C=(0,p.createFileSystemProviderError)(E.message??(0,t.toErrorMessage)(E),E.code??p.FileSystemProviderErrorCode.Unknown)}l.error(C),l.end()}u.dispose()}});return b.onCancellationRequested(()=>{l.error((0,k.canceled)()),l.end(),u.dispose()}),l}writeFile(h,d,b){return this.a.call("writeFile",[h,S.VSBuffer.wrap(d),b])}open(h,d){return this.a.call("open",[h,d])}close(h){return this.a.call("close",[h])}async read(h,d,b,l,u){const[m,C]=await this.a.call("read",[h,d,u]);return b.set(m.buffer.slice(0,C),l),C}write(h,d,b,l,u){return this.a.call("write",[h,d,S.VSBuffer.wrap(b),l,u])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,d){return this.a.call("delete",[h,d])}rename(h,d,b){return this.a.call("rename",[h,d,b])}copy(h,d,b){return this.a.call("copy",[h,d,b])}cloneFile(h,d){return this.a.call("cloneFile",[h,d])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const d=h;this.f.fire(d.map(b=>({resource:w.URI.revive(b.resource),type:b.type})))}else{const d=h;this.g.fire(d)}}))}watch(h,d){const b=(0,g.generateUuid)();return this.a.call("watch",[this.h,b,h,d]),(0,A.toDisposable)(()=>this.a.call("unwatch",[this.h,b]))}}e.DiskFileSystemProviderClient=y}),define(te[108],ne([0,1,17,13,161,16]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(p,y,v,h,d,b){let l;try{await I(p,y,v,h,d,b)}catch(u){l=u}finally{l&&d.errorTransformer&&(l=d.errorTransformer(l)),typeof l<"u"&&v.error(l),v.end()}}e.readFileIntoStream=A;async function I(p,y,v,h,d,b){w(b);const l=await p.open(y,{create:!1});try{w(b);let u=0,m=0,C=d&&typeof d.length=="number"?d.length:void 0,E=S.VSBuffer.alloc(Math.min(d.bufferSize,typeof C=="number"?C:d.bufferSize)),R=d&&typeof d.position=="number"?d.position:0,i=0;do m=await p.read(l,R,E.buffer,i,E.byteLength-i),R+=m,i+=m,u+=m,typeof C=="number"&&(C-=m),i===E.byteLength&&(await v.write(h(E)),E=S.VSBuffer.alloc(Math.min(d.bufferSize,typeof C=="number"?C:d.bufferSize)),i=0);while(m>0&&(typeof C!="number"||C>0)&&w(b)&&g(u,d));if(i>0){let r=i;typeof C=="number"&&(r=Math.min(i,C)),v.write(h(E.slice(0,r)))}}catch(u){throw(0,M.ensureFileSystemProviderError)(u)}finally{await p.close(l)}}function w(p){if(p.isCancellationRequested)throw(0,t.canceled)();return!0}function g(p,y){if(y?.limits){if(typeof y.limits.memory=="number"&&p>y.limits.memory)throw(0,M.createFileSystemProviderError)((0,k.localize)(0,null),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&p>y.limits.size)throw(0,M.createFileSystemProviderError)((0,k.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[72],ne([0,1,99,2,9,4,7,16]),function(V,e,S,t,k,M,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function w(u){return u.recursive===!0}e.isRecursiveWatchRequest=w;class g extends t.Disposable{constructor(m,C,E,R){super(),this.h=m,this.i=C,this.j=E,this.k=R,this.c=this.B(new t.MutableDisposable),this.f=void 0,this.g=0}m(){const m=new t.DisposableStore;this.c.value=m,this.b=this.l(m),this.b.setVerboseLogging(this.j),m.add(this.b.onDidChangeFile(C=>this.h(C))),m.add(this.b.onDidLogMessage(C=>this.i(C))),m.add(this.b.onDidError(C=>this.n(C)))}n(m){this.k.restartOnError?this.g<g.a&&this.f?(this.r(`restarting watcher after error: ${m}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${m}`):this.r(m)}p(m){this.g++,this.m(),this.watch(m)}async watch(m){this.f=m,await this.b?.watch(m)}async setVerboseLogging(m){this.j=m,await this.b?.setVerboseLogging(m)}r(m){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${m}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=g,g.a=5;class p extends g{constructor(m,C,E){super(m,C,E,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=p;class y extends g{constructor(m,C,E){super(m,C,E,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function v(u){return u.map(m=>({type:m.type,resource:A.URI.file(m.path)}))}e.toFileChanges=v;function h(u){const m=new l;for(const C of u)m.processEvent(C);return m.coalesce()}e.coalesceEvents=h;function d(u,m){return typeof m=="string"&&!m.startsWith(S.GLOBSTAR)&&!(0,k.isAbsolute)(m)?{base:u,pattern:m}:m}e.normalizeWatcherPattern=d;function b(u,m){const C=[];for(const E of m)C.push((0,S.parse)(d(u,E)));return C}e.parseWatcherPatterns=b;class l{constructor(){this.a=new Set,this.b=new Map}c(m){return M.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const C=this.b.get(this.c(m));let E=!1;if(C){const R=C.type,i=m.type;C.path!==m.path&&(m.type===2||m.type===1)?E=!0:R===1&&i===2?(this.b.delete(this.c(m)),this.a.delete(C)):R===2&&i===1?C.type=0:R===1&&i===0||(C.type=i)}else E=!0;E&&(this.a.add(m),this.b.set(this.c(m),m))}coalesce(){const m=[],C=[];return Array.from(this.a).filter(E=>E.type!==2?(m.push(E),!1):!0).sort((E,R)=>E.path.length-R.path.length).filter(E=>C.some(R=>(0,I.isParent)(E.path,R,!M.isLinux))?!1:(C.push(E.path),!0)).concat(m)}}}),define(te[198],ne([0,1,41,8,22,31,2,77,9,4,100,23,72]),function(V,e,S,t,k,M,A,I,w,g,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends A.Disposable{constructor(l,u,m,C){super(),this.j=l,this.k=u,this.l=m,this.m=C,this.c=this.B(new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.k(E))),this.f=this.B(new t.RunOnceWorker(E=>this.u(E),h.b)),this.g=(0,v.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,v.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new k.CancellationTokenSource,this.ready=this.n()}async n(){try{const l=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await y.Promises.stat(l);this.B(await this.s(l,u.isDirectory()))}catch(l){l.code!=="ENOENT"?this.w(l):this.z(l)}}async r(l){let u=l.path;try{u=await y.Promises.realpath(l.path),l.path===u&&(u=await(0,p.realcase)(l.path)??l.path),l.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${l.path}, real: ${u})`)}catch{}return u}async s(l,u){if(g.isMacintosh&&(0,M.isEqualOrParent)(l,"/Volumes/",!0))return this.w(`Refusing to watch ${l} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const m=new k.CancellationTokenSource(this.i.token),C=new A.DisposableStore;try{const E=(0,w.basename)(l),R=(0,S.watch)(l);C.add((0,A.toDisposable)(()=>{R.removeAllListeners(),R.close()})),this.z(`Started watching: '${l}'`);const i=new Set;if(u)try{for(const n of await y.Promises.readdir(l))i.add(n)}catch(n){this.w(n)}const r=new Map;C.add((0,A.toDisposable)(()=>{for(const[,n]of r)n.dispose();r.clear()})),R.on("error",(n,o)=>{this.w(`Failed to watch ${l} for changes using fs.watch() (${n}, ${o})`),this.dispose()}),R.on("change",(n,o)=>{if(m.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${o}`);let a="";if(o&&(a=o.toString(),g.isMacintosh&&(a=(0,I.normalizeNFC)(a))),!(!a||n!=="change"&&n!=="rename"))if(u)if(n==="rename"){r.get(a)?.dispose();const c=setTimeout(async()=>{if(r.delete(a),a===E&&!await y.Promises.exists(l)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,w.join)(l,a));if(m.token.isCancellationRequested)return;let f;s?i.has(a)?f=0:(f=1,i.add(a)):(i.delete(a),f=2),this.t({path:(0,w.join)(this.j.path,a),type:f})},h.a);r.set(a,(0,A.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(a)?c=0:(c=1,i.add(a)),this.t({path:(0,w.join)(this.j.path,a),type:c})}else if(n==="rename"||a!==E){const c=setTimeout(async()=>{const s=await y.Promises.exists(l);m.token.isCancellationRequested||(s?(this.t({path:this.j.path,type:0},!0),C.add(await this.s(l,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},h.a);C.clear(),C.add((0,A.toDisposable)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(E){await y.Promises.exists(l)&&!m.token.isCancellationRequested&&this.w(`Failed to watch ${l} for changes using fs.watch() (${E.toString()})`)}return(0,A.toDisposable)(()=>{m.dispose(!0),C.dispose()})}t(l,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`),!u&&this.g.some(m=>m(l.path))?this.m&&this.z(` >> ignored (excluded) ${l.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(m=>m(l.path))?this.m&&this.z(` >> ignored (not included) ${l.path}`):this.f.work(l))}u(l){const u=(0,v.coalesceEvents)(l);if(u.length>0){if(this.m)for(const C of u)this.z(`>> normalized ${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(l){if(g.isLinux)return y.Promises.exists(l);try{const u=(0,w.basename)(l);return(await y.Promises.readdir((0,w.dirname)(l))).some(C=>C===u)}catch(u){return this.z(u),!1}}setVerboseLogging(l){this.m=l}w(l){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${l}`})}y(l){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${l}`})}z(l){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${l}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=h,h.a=100,h.b=75;async function d(b,l,u,m,C=512){const E=await y.Promises.open(b,"r"),R=Buffer.allocUnsafe(C),i=new k.CancellationTokenSource(m);let r,n=!1;const o={path:b,excludes:[],recursive:!1},a=new h(o,c=>{(async()=>{for(const{type:s}of c)if(s===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:f}=await y.Promises.read(E,R,0,C,null);if(!f||i.token.isCancellationRequested)break;l(R.slice(0,f))}}catch(f){r=new Error(f),i.dispose(!0)}finally{n=!1}}})()});return await a.ready,u(),new Promise((c,s)=>{i.token.onCancellationRequested(async()=>{a.dispose();try{await y.Promises.close(E)}catch(f){r=new Error(f)}r?s(r):c()})})}e.watchFileContents=d}),define(te[199],ne([0,1,3,99,2,4,198]),function(V,e,S,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new S.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new S.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(g){const p=this.i(g),y=p.filter(h=>{const d=this.c.get(h.path);return d?!(0,t.patternsEquals)(d.request.excludes,h.excludes)||!(0,t.patternsEquals)(d.request.includes,h.includes):!0}),v=Array.from(this.c.values()).filter(({request:h})=>!p.find(d=>d.path===h.path&&(0,t.patternsEquals)(d.excludes,h.excludes)&&(0,t.patternsEquals)(d.includes,h.includes))).map(({request:h})=>h.path);y.length&&this.j(`Request to start watching: ${y.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),v.length&&this.j(`Request to stop watching: ${v.join(",")}`);for(const h of v)this.h(h);for(const h of y)this.g(h)}g(g){const p=new A.NodeJSFileWatcherLibrary(g,v=>this.a.fire(v),v=>this.b.fire(v),this.f),y={request:g,instance:p};this.c.set(g.path,y)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const p=this.c.get(g);p&&(this.c.delete(g),p.instance.dispose())}i(g){const p=new Map;for(const y of g){const v=M.isLinux?y.path:y.path.toLowerCase();p.set(v,y)}return Array.from(p.values())}async setVerboseLogging(g){this.f=g;for(const[,p]of this.c)p.instance.setVerboseLogging(g)}j(g){this.f&&this.b.fire({type:"trace",message:this.k(g)})}k(g,p){return p?`[File Watcher (node.js)] ${g} (path: ${p.request.path})`:`[File Watcher (node.js)] ${g}`}}e.NodeJSWatcher=I}),define(te[200],ne([0,1,72,199]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends S.AbstractNonRecursiveWatcherClient{constructor(A,I,w){super(A,I,w),this.m()}l(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(te[201],ne([0,1,15,47,147,72]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends M.AbstractUniversalWatcherClient{constructor(w,g,p){super(w,g,p),this.m()}l(w){const g=w.add(new k.Client(S.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(g.onDidProcessExit(({code:p,signal:y})=>this.n(`terminated by itself with code ${p}, signal: ${y}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(g.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(te[86],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...k){this.a=new Map;for(const[M,A]of k)this.set(M,A)}set(k,M){const A=this.a.get(k);return this.a.set(k,M),A}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=S}),define(te[202],ne([0,1,8,13,2,70,192,5,86,96]),function(V,e,S,t,k,M,A,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class y extends Error{constructor(l){super("cyclic dependency between services"),this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class v{constructor(l=new w.ServiceCollection,u=!1,m,C=p){this.f=l,this.g=u,this.h=m,this.i=C,this.o=new Set,this.f.set(I.IInstantiationService,this),this._globalGraph=C?m?._globalGraph??new A.Graph(E=>E):void 0}createChild(l){return new v(l,this.g,this,this.i)}invokeFunction(l,...u){const m=d.traceInvocation(this.i,l);let C=!1;try{return l({get:R=>{if(C)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(R,m);if(!i)throw new Error(`[invokeFunction] unknown service '${R}'`);return i}},...u)}finally{C=!0,m.stop()}}createInstance(l,...u){let m,C;return l instanceof M.SyncDescriptor?(m=d.traceCreation(this.i,l.ctor),C=this.j(l.ctor,l.staticArguments.concat(u),m)):(m=d.traceCreation(this.i,l),C=this.j(l,u,m)),m.stop(),C}j(l,u=[],m){const C=I._util.getServiceDependencies(l).sort((i,r)=>i.index-r.index),E=[];for(const i of C){const r=this.m(i.id,m);r||this.u(`[createInstance] ${l.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(r)}const R=C.length>0?C[0].index:u.length;if(u.length!==R){console.trace(`[createInstance] First service dependency of ${l.name} at position ${R+1} conflicts with ${u.length} static arguments`);const i=R-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,R)}return Reflect.construct(l,u.concat(E))}k(l,u){if(this.f.get(l)instanceof M.SyncDescriptor)this.f.set(l,u);else if(this.h)this.h.k(l,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(l){const u=this.f.get(l);return!u&&this.h?this.h.l(l):u}m(l,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(l));const m=this.l(l);return m instanceof M.SyncDescriptor?this.q(l,m,u.branch(l,!0)):(u.branch(l,!1),m)}q(l,u,m){if(this.o.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this.o.add(l);try{return this.r(l,u,m)}finally{this.o.delete(l)}}r(l,u,m){const C=new A.Graph(i=>i.id.toString());let E=0;const R=[{id:l,desc:u,_trace:m}];for(;R.length;){const i=R.pop();if(C.lookupOrInsertNode(i),E++>1e3)throw new y(C);for(const r of I._util.getServiceDependencies(i.desc.ctor)){const n=this.l(r.id);if(n||this.u(`[createInstance] ${l} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),n instanceof M.SyncDescriptor){const o={id:r.id,desc:n,_trace:i._trace.branch(r.id,!0)};C.insertEdge(i,o),R.push(o)}}}for(;;){const i=C.roots();if(i.length===0){if(!C.isEmpty())throw new y(C);break}for(const{data:r}of i){if(this.l(r.id)instanceof M.SyncDescriptor){const o=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,o)}C.removeNode(r)}}return this.l(l)}s(l,u,m=[],C,E){if(this.f.get(l)instanceof M.SyncDescriptor)return this.t(l,u,m,C,E);if(this.h)return this.h.s(l,u,m,C,E);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(l,u,m=[],C,E){if(C){const R=new v(void 0,this.g,this,this.i);R.c=String(l);const i=new Map,r=new S.IdleValue(()=>{const n=R.j(u,m,E);for(const[o,a]of i){const c=n[o];if(typeof c=="function")for(const s of a)c.apply(n,s)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let s=i.get(o);return s||(s=new g.LinkedList,i.set(o,s)),(P,L,T)=>{const U=s.push([P,L,T]);return(0,k.toDisposable)(U)}}if(o in n)return n[o];const a=r.value;let c=a[o];return typeof c!="function"||(c=c.bind(a),n[o]=c),c},set(n,o,a){return r.value[o]=a,!0},getPrototypeOf(n){return u.prototype}})}else return this.j(u,m,E)}u(l,u){if(u&&console.warn(l),this.g)throw new Error(l)}}e.InstantiationService=v;var h;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(h||(h={}));class d{static traceInvocation(l,u){return l?new d(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(l,u){return l?new d(1,u.name):d.c}constructor(l,u){this.type=l,this.name=u,this.g=Date.now(),this.h=[]}branch(l,u){const m=new d(3,l.toString());return this.h.push([l,u,m]),m}stop(){const l=Date.now()-this.g;d.f+=l;let u=!1;function m(E,R){const i=[],r=new Array(E+1).join("	");for(const[n,o,a]of R.h)if(o&&a){u=!0,i.push(`${r}CREATES -> ${n}`);const c=m(E+1,a);c&&i.push(c)}else i.push(`${r}uses -> ${n}`);return i.join(`
`)}const C=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(l>2||u)&&d.all.add(C.join(`
`))}}e.Trace=d,d.all=new Set,d.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}},d.f=0}),define(te[6],ne([0,1,45,3,2,40,4,7,5]),function(V,e,S,t,k,M,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function g(){return new Date().toISOString()}var p;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;function y(c,s,f){switch(s){case p.Trace:c.trace(f);break;case p.Debug:c.debug(f);break;case p.Info:c.info(f);break;case p.Warning:c.warn(f);break;case p.Error:c.error(f);break;case p.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=y;function v(c){let s="";for(let f=0;f<c.length;f++){let P=c[f];if(typeof P=="object")try{P=JSON.stringify(P)}catch{}s+=(f>0?" ":"")+P}return s}e.format=v;class h extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(s){this.b!==s&&(this.b=s,this.c.fire(this.b))}getLevel(){return this.b}f(s){return this.b!==p.Off&&this.b<=s}}e.AbstractLogger=h;class d extends h{constructor(s){super(),this.h=s}f(s){return this.h||super.f(s)}trace(s,...f){this.f(p.Trace)&&this.g(p.Trace,v([s,...f]))}debug(s,...f){this.f(p.Debug)&&this.g(p.Debug,v([s,...f]))}info(s,...f){this.f(p.Info)&&this.g(p.Info,v([s,...f]))}warn(s,...f){this.f(p.Warning)&&this.g(p.Warning,v([s,...f]))}error(s,...f){if(this.f(p.Error))if(s instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=s.stack,this.g(p.Error,v(P))}else this.g(p.Error,v([s,...f]))}flush(){}}e.AbstractMessageLogger=d;class b extends h{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.g=!A.isWindows}trace(s,...f){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,s,...f):console.log(`[main ${g()}]`,s,...f))}debug(s,...f){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,s,...f):console.log(`[main ${g()}]`,s,...f))}info(s,...f){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,s,...f):console.log(`[main ${g()}]`,s,...f))}warn(s,...f){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,s,...f):console.warn(`[main ${g()}]`,s,...f))}error(s,...f){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,s,...f):console.error(`[main ${g()}]`,s,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class l extends h{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...f){this.f(p.Trace)&&console.log("%cTRACE","color: #888",s,...f)}debug(s,...f){this.f(p.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...f)}info(s,...f){this.f(p.Info)&&console.log("%c INFO","color: #33f",s,...f)}warn(s,...f){this.f(p.Warning)&&console.log("%c WARN","color: #993",s,...f)}error(s,...f){this.f(p.Error)&&console.log("%c  ERR","color: #f33",s,...f)}dispose(){}flush(){}}e.ConsoleLogger=l;class u extends h{constructor(s,f=e.DEFAULT_LOG_LEVEL){super(),this.g=s,this.setLevel(f)}trace(s,...f){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(s),...f])}debug(s,...f){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(s),...f])}info(s,...f){this.f(p.Info)&&this.g.log(p.Info,[this.h(s),...f])}warn(s,...f){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(s),...f])}error(s,...f){this.f(p.Error)&&this.g.log(p.Error,[this.h(s),...f])}h(s){return typeof s=="string"?s:(0,S.toErrorMessage)(s,this.f(p.Trace))}dispose(){}flush(){}}e.AdapterLogger=u;class m extends h{constructor(s){super(),this.g=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const f of this.g)f.setLevel(s);super.setLevel(s)}trace(s,...f){for(const P of this.g)P.trace(s,...f)}debug(s,...f){for(const P of this.g)P.debug(s,...f)}info(s,...f){for(const P of this.g)P.info(s,...f)}warn(s,...f){for(const P of this.g)P.warn(s,...f)}error(s,...f){for(const P of this.g)P.error(s,...f)}flush(){for(const s of this.g)s.flush()}dispose(){for(const s of this.g)s.dispose()}}e.MultiplexLogService=m;class C extends k.Disposable{constructor(s){super(),this.b=s,this.B(s)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(s){this.b.setLevel(s)}getLevel(){return this.b.getLevel()}trace(s,...f){this.b.trace(s,...f)}debug(s,...f){this.b.debug(s,...f)}info(s,...f){this.b.info(s,...f)}warn(s,...f){this.b.warn(s,...f)}error(s,...f){this.b.error(s,...f)}flush(){this.b.flush()}}e.LogService=C;class E extends k.Disposable{constructor(s,f){super(),this.c=s,this.b=new M.ResourceMap,this.B(f(P=>this.setLevel(P)))}getLoggers(){return[...this.b.values()].map(({logger:s})=>s)}getLogger(s){return this.b.get(s)?.logger}createLogger(s,f,P){let L=this.b.get(s)?.logger;return L||(P=f?.always?p.Trace:P,L=this.f(s,P??this.c,f),this.b.set(s,{logger:L,logLevel:P})),L}setLevel(s,f){const P=I.URI.isUri(s)?s:void 0,L=P?f:s;if(P){const T=this.b.get(P);T&&T.logLevel!==L&&(T.logLevel=L,T.logger.setLevel(L))}else this.c=L,this.b.forEach(({logLevel:T,logger:U})=>{T===void 0&&U.setLevel(this.c)})}getLogLevel(s){return this.b.get(s)?.logLevel}dispose(){this.b.forEach(({logger:s})=>s.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=E;class R{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(s){}getLevel(){return p.Info}trace(s,...f){}debug(s,...f){}info(s,...f){}warn(s,...f){}error(s,...f){}critical(s,...f){}dispose(){}flush(){}}e.NullLogger=R;class i extends R{}e.NullLogService=i;class r extends E{constructor(){super(p.Info,t.Event.None)}f(s,f,P){return new R}}e.NullLoggerService=r;function n(c){if(c.verbose)return p.Trace;if(typeof c.logLevel=="string"){const s=a(c.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function o(c){switch(c){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.LogLevelToString=o;function a(c){switch(c){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.parseLogLevel=a});var x=this&&this.__param||function(V,e){return function(S,t){e(S,t,V)}};define(te[203],ne([0,1,71,3,2,6,4,8]),function(V,e,S,t,k,M,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let w=class Et extends k.Disposable{constructor(p){super(),this.g=p,this.c=this.B(new t.Emitter),this.onDidChangePassword=this.c.event}async getPassword(p,y){this.g.trace("Getting password from keytar:",p,y);let v;try{v=await this.h()}catch{return null}const h=await(0,I.retry)(()=>v.getPassword(p,y),50,3);if(!h)return this.g.trace("Did not get a password from keytar for account:",y),h;let d,b;try{const l=JSON.parse(h);d=l.content,b=l.hasNextChunk}catch{}if(!d||!b)return this.g.trace("Got password from keytar for account:",y),h;try{let l=1;for(;b;){const u=await(0,I.retry)(()=>v.getPassword(p,`${y}-${l}`),50,3),m=JSON.parse(u);d+=m.content,b=m.hasNextChunk,l++}return this.g.trace(`Got ${l}-chunked password from keytar for account:`,y),d}catch(l){return this.g.error(l),h}}async setPassword(p,y,v){this.g.trace("Setting password using keytar:",p,y);let h;try{h=await this.h()}catch(d){throw this.i?.(d),d}if(A.isWindows&&v.length>Et.a){let d=0,b=0,l=!0;for(;l;){const u=v.substring(d,d+Et.b);d+=Et.b,l=v.length-d>0;const m={content:u,hasNextChunk:l};await(0,I.retry)(()=>h.setPassword(p,b?`${y}-${b}`:y,JSON.stringify(m)),50,3),b++}this.g.trace(`Got${b?` ${b}-chunked`:""} password from keytar for account:`,y)}else await(0,I.retry)(()=>h.setPassword(p,y,v),50,3),this.g.trace("Got password from keytar for account:",y);this.c.fire({service:p,account:y})}async deletePassword(p,y){this.g.trace("Deleting password using keytar:",p,y);let v;try{v=await this.h()}catch(u){throw this.i?.(u),u}const h=await v.getPassword(p,y);if(!h)return this.g.trace("Did not get a password to delete from keytar for account:",y),!1;let d,b;try{const u=JSON.parse(h);d=u.content,b=u.hasNextChunk}catch{}let l=0;if(d&&b)try{for(l++;b;){const u=`${y}-${l}`,m=await v.getPassword(p,u);await v.deletePassword(p,u),b=JSON.parse(m).hasNextChunk,l++}}catch(u){this.g.error(u)}return await v.deletePassword(p,y)?(this.c.fire({service:p,account:y}),this.g.trace(`Deleted${l?` ${l}-chunked`:""} password from keytar for account:`,y),!0):(this.g.trace(`Keytar failed to delete${l?` ${l}-chunked`:""} password for account:`,y),!1)}async findPassword(p){let y;try{y=await this.h()}catch{return null}return await y.findPassword(p)}async findCredentials(p){let y;try{y=await this.h()}catch{return[]}return await y.findCredentials(p)}clear(){return this.f instanceof S.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};w.a=2500,w.b=w.a-100,w=pe([x(0,M.ILogService)],w),e.BaseCredentialsMainService=w}),define(te[204],ne([0,1,6]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(M,A){this.a=M,this.b=A}c(){return new Promise((M,A)=>V(["vscode-encrypt"],M,A))}async encrypt(M){let A;try{A=await this.c()}catch{return M}try{return A.encrypt(this.a,M)}catch(I){return this.b.error(I),M}}async decrypt(M){let A;try{A=await this.c()}catch{return M}try{return A.decrypt(this.a,M)}catch(I){return this.b.error(I),M}}};t=pe([x(1,S.ILogService)],t),e.EncryptionMainService=t}),define(te[205],ne([0,1,24,8,13,3,2,9,72,6]),function(V,e,S,t,k,M,A,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class p extends A.Disposable{constructor(v,h){super(),this.a=v,this.b=h,this.c=this.B(new M.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new M.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new t.ThrottledDelayer(0)),this.s=[],this.t=this.B(new t.ThrottledDelayer(0))}watch(v,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(v,h):this.u(v,h)}l(v,h){const d={path:this.C(v),excludes:h.excludes,includes:h.includes,recursive:h.recursive},b=(0,S.insert)(this.j,d);return this.m(),(0,A.toDisposable)(()=>{b(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(v=>(0,k.onUnexpectedError)(v))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,w.toFileChanges)(h)),h=>this.z(h),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const h of this.j)(0,w.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const h of this.j)(0,w.isRecursiveWatchRequest)(h)&&v.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(v,h){const d={path:this.C(v),excludes:h.excludes,includes:h.includes,recursive:!1},b=(0,S.insert)(this.s,d);return this.v(),(0,A.toDisposable)(()=>{b(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(v=>(0,k.onUnexpectedError)(v))}w(){return this.r||(this.r=this.B(this.y(v=>this.c.fire((0,w.toFileChanges)(v)),v=>this.z(v),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.r.watch(this.s)}z(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}C(v){return(0,I.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=p}),define(te[206],ne([0,1,24,8,17,22,3,68,67,2,60,15,73,20,59,159,16,108,6,13]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=class extends g.Disposable{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new A.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new A.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new A.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new t.ResourceQueue)}registerProvider(i,r){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${i}`);const n=new g.DisposableStore;return this.h.set(i,r),this.c.fire({added:!0,scheme:i,provider:r}),n.add(r.onDidChangeFile(o=>this.R.fire(new l.FileChangesEvent(o,!this.O(r))))),typeof r.onDidWatchError=="function"&&n.add(r.onDidWatchError(o=>this.S.fire(new Error(o)))),n.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:i}))),(0,g.toDisposable)(()=>{this.c.fire({added:!1,scheme:i,provider:r}),this.h.delete(i),(0,g.dispose)(n)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const r=[];this.f.fire({scheme:i,join(n){r.push(n)}}),!this.h.has(i)&&await t.Promises.settled(r)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,r){const n=this.h.get(i.scheme);return!!(n&&n.capabilities&r)}listCapabilities(){return w.Iterable.map(this.h,([i,r])=>({scheme:i,capabilities:r.capabilities}))}async j(i){if(!(0,h.isAbsolutePath)(i))throw new l.FileOperationError((0,b.localize)(0,null,this.nb(i)),8);await this.activateProvider(i.scheme);const r=this.h.get(i.scheme);if(!r){const n=new C.ErrorNoTelemetry;throw n.message=(0,b.localize)(1,null,i.toString()),n}return r}async k(i){const r=await this.j(i);if((0,l.hasOpenReadWriteCloseCapability)(r)||(0,l.hasReadWriteCapability)(r)||(0,l.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(i){const r=await this.j(i);if((0,l.hasOpenReadWriteCloseCapability)(r)||(0,l.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,r){try{return await this.n(i,r)}catch(n){throw(0,l.toFileSystemProviderErrorCode)(n)===l.FileSystemProviderErrorCode.FileNotFound?new l.FileOperationError((0,b.localize)(2,null,this.nb(i)),1):(0,l.ensureFileSystemProviderError)(n)}}async n(i,r){const n=await this.j(i),o=this.O(n),a=r?.resolveTo,c=r?.resolveSingleChildDescendants,s=r?.resolveMetadata,f=await n.stat(i);let P;return this.p(n,i,f,void 0,!!s,(L,T)=>(P||(P=p.TernarySearchTree.forUris(()=>!o),P.set(i,!0),a&&P.fill(!0,a)),P.get(L.resource)||P.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&c?T===1:!1))}async p(i,r,n,o,a,c){const{providerExtUri:s}=this.N(i),f={resource:r,name:s.basename(r),isFile:(n.type&l.FileType.File)!==0,isDirectory:(n.type&l.FileType.Directory)!==0,isSymbolicLink:(n.type&l.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&l.FilePermission.Readonly)||Boolean(i.capabilities&2048),etag:(0,l.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(f.isDirectory&&c(f,o)){try{const P=await i.readdir(r),L=await t.Promises.settled(P.map(async([T,U])=>{try{const G=s.joinPath(r,T),H=a?await i.stat(G):{type:U};return await this.p(i,G,H,P.length,a,c)}catch(G){return this.b.trace(G),null}}));f.children=(0,S.coalesce)(L)}catch(P){this.b.trace(P),f.children=[]}return f}return f}async resolveAll(i){return t.Promises.settled(i.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(i){const r=await this.j(i),n=await r.stat(i);return this.p(r,i,n,void 0,!0,()=>!1)}async exists(i){const r=await this.j(i);try{return!!await r.stat(i)}catch{return!1}}async canCreateFile(i,r){try{await this.r(i,r)}catch(n){return n}return!0}async r(i,r){if(!r?.overwrite&&await this.exists(i))throw new l.FileOperationError((0,b.localize)(3,null,this.nb(i)),3,r)}async createFile(i,r=k.VSBuffer.fromString(""),n){await this.r(i,n);const o=await this.writeFile(i,r);return this.m.fire(new l.FileOperationEvent(i,0,o)),o}async writeFile(i,r,n){const o=this.lb(await this.l(i),i),{providerExtUri:a}=this.N(o);try{await this.s(o,i,n)||await this.P(o,a.dirname(i));let s;if((0,l.hasReadWriteCapability)(o)&&!(r instanceof k.VSBuffer))if((0,d.isReadableStream)(r)){const f=await(0,d.peekStream)(r,3);f.ended?s=k.VSBuffer.concat(f.buffer):s=f}else s=(0,d.peekReadable)(r,f=>k.VSBuffer.concat(f),3);else s=r;!(0,l.hasOpenReadWriteCloseCapability)(o)||(0,l.hasReadWriteCapability)(o)&&s instanceof k.VSBuffer?await this.cb(o,i,n,s):await this.Y(o,i,n,s instanceof k.VSBuffer?(0,k.bufferToReadable)(s):s),this.m.fire(new l.FileOperationEvent(i,4))}catch(c){throw new l.FileOperationError((0,b.localize)(4,null,this.nb(i),(0,l.ensureFileSystemProviderError)(c).toString()),(0,l.toFileOperationResult)(c),n)}return this.resolve(i,{resolveMetadata:!0})}async s(i,r,n){if(!!n?.unlock&&!(i.capabilities&8192))throw new Error((0,b.localize)(5,null,this.nb(r)));let a;try{a=await i.stat(r)}catch{return}if((a.type&l.FileType.Directory)!==0)throw new l.FileOperationError((0,b.localize)(6,null,this.nb(r)),0,n);if(this.mb(r,a),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==l.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&n.mtime<a.mtime&&n.etag!==(0,l.etag)({mtime:n.mtime,size:a.size}))throw new l.FileOperationError((0,b.localize)(7,null),3,n);return a}async readFile(i,r,n){const o=await this.k(i);return r?.atomic?this.t(o,i,r,n):this.u(o,i,r,n)}async t(i,r,n,o){return new Promise((a,c)=>{this.X.queueFor(r,this.N(i).providerExtUri).queue(async()=>{try{const s=await this.u(i,r,n,o);a(s)}catch(s){c(s)}})})}async u(i,r,n,o){const a=await this.v(i,r,{...n,preferUnbuffered:!0},o);return{...a,value:await(0,k.streamToBuffer)(a.value)}}async readFileStream(i,r,n){const o=await this.k(i);return this.v(o,i,r,n)}async v(i,r,n,o){const a=new M.CancellationTokenSource(o),c=this.F(r,n).then(f=>f,f=>{throw a.cancel(),f});let s;try{return typeof n?.etag=="string"&&n.etag!==l.ETAG_DISABLED&&await c,n?.atomic&&(0,l.hasFileAtomicReadCapability)(i)||!((0,l.hasOpenReadWriteCloseCapability)(i)||(0,l.hasFileReadStreamCapability)(i))||(0,l.hasReadWriteCapability)(i)&&n?.preferUnbuffered?s=this.D(i,r,n):(0,l.hasFileReadStreamCapability)(i)?s=this.z(i,r,a.token,n):s=this.C(i,r,a.token,n),{...await c,value:s}}catch(f){throw s&&await(0,d.consumeStream)(s),this.w(f,r,n)}}w(i,r,n){const o=(0,b.localize)(8,null,this.nb(r),(0,l.ensureFileSystemProviderError)(i).toString());return i instanceof l.NotModifiedSinceFileOperationError?new l.NotModifiedSinceFileOperationError(o,i.stat,n):i instanceof l.TooLargeFileOperationError?new l.TooLargeFileOperationError(o,i.fileOperationResult,i.size,i.options):new l.FileOperationError(o,(0,l.toFileOperationResult)(i),n)}z(i,r,n,o=Object.create(null)){const a=i.readFileStream(r,o,n);return(0,d.transform)(a,{data:c=>c instanceof k.VSBuffer?c:k.VSBuffer.wrap(c),error:c=>this.w(c,r,o)},c=>k.VSBuffer.concat(c))}C(i,r,n,o=Object.create(null)){const a=(0,k.newWriteableBufferStream)();return(0,u.readFileIntoStream)(i,r,a,c=>c,{...o,bufferSize:this.a,errorTransformer:c=>this.w(c,r,o)},n),a}D(i,r,n){const o=(0,d.newWriteableStream)(a=>k.VSBuffer.concat(a));return(async()=>{try{let a;n?.atomic&&(0,l.hasFileAtomicReadCapability)(i)?a=await i.readFile(r,{atomic:!0}):a=await i.readFile(r),typeof n?.position=="number"&&(a=a.slice(n.position)),typeof n?.length=="number"&&(a=a.slice(0,n.length)),this.G(r,a.byteLength,n),o.end(k.VSBuffer.wrap(a))}catch(a){o.error(a),o.end()}})(),o}async F(i,r){const n=await this.resolve(i,{resolveMetadata:!0});if(n.isDirectory)throw new l.FileOperationError((0,b.localize)(9,null,this.nb(i)),0,r);if(typeof r?.etag=="string"&&r.etag!==l.ETAG_DISABLED&&r.etag===n.etag)throw new l.NotModifiedSinceFileOperationError((0,b.localize)(10,null),n,r);return this.G(i,n.size,r),n}G(i,r,n){if(n?.limits){let o;if(typeof n.limits.memory=="number"&&r>n.limits.memory&&(o=9),typeof n.limits.size=="number"&&r>n.limits.size&&(o=7),typeof o=="number")throw new l.TooLargeFileOperationError((0,b.localize)(11,null,this.nb(i)),o,r,n)}}async canMove(i,r,n){return this.H(i,r,"move",n)}async canCopy(i,r,n){return this.H(i,r,"copy",n)}async H(i,r,n,o){if(i.toString()!==r.toString())try{const a=n==="move"?this.lb(await this.l(i),i):await this.k(i),c=this.lb(await this.l(r),r);await this.M(a,i,c,r,n,o)}catch(a){return a}return!0}async move(i,r,n){const o=this.lb(await this.l(i),i),a=this.lb(await this.l(r),r),c=await this.I(o,i,a,r,"move",!!n),s=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new l.FileOperationEvent(i,c==="move"?2:3,s)),s}async copy(i,r,n){const o=await this.k(i),a=this.lb(await this.l(r),r),c=await this.I(o,i,a,r,"copy",!!n),s=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new l.FileOperationEvent(i,c==="copy"?3:2,s)),s}async I(i,r,n,o,a,c){if(r.toString()===o.toString())return a;const{exists:s,isSameResourceWithDifferentPathCase:f}=await this.M(i,r,n,o,a,c);if(s&&!f&&c&&await this.del(o,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(o)),a==="copy"){if(i===n&&(0,l.hasFileFolderCopyCapability)(i))await i.copy(r,o,{overwrite:c});else{const P=await this.resolve(r);P.isDirectory?await this.L(i,P,n,o):await this.J(i,r,n,o)}return a}else return i===n?(await i.rename(r,o,{overwrite:c}),a):(await this.I(i,r,n,o,"copy",c),await this.del(r,{recursive:!0}),"copy")}async J(i,r,n,o){if((0,l.hasOpenReadWriteCloseCapability)(i)&&(0,l.hasOpenReadWriteCloseCapability)(n))return this.eb(i,r,n,o);if((0,l.hasOpenReadWriteCloseCapability)(i)&&(0,l.hasReadWriteCapability)(n))return this.kb(i,r,n,o);if((0,l.hasReadWriteCapability)(i)&&(0,l.hasOpenReadWriteCloseCapability)(n))return this.ib(i,r,n,o);if((0,l.hasReadWriteCapability)(i)&&(0,l.hasReadWriteCapability)(n))return this.gb(i,r,n,o)}async L(i,r,n,o){await n.mkdir(o),Array.isArray(r.children)&&await t.Promises.settled(r.children.map(async a=>{const c=this.N(n).providerExtUri.joinPath(o,a.name);return a.isDirectory?this.L(i,await this.resolve(a.resource),n,c):this.J(i,a.resource,n,c)}))}async M(i,r,n,o,a,c){let s=!1;if(i===n){const{providerExtUri:P,isPathCaseSensitive:L}=this.N(i);if(L||(s=P.isEqual(r,o)),s&&a==="copy")throw new Error((0,b.localize)(12,null,this.nb(r),this.nb(o)));if(!s&&P.isEqualOrParent(o,r))throw new Error((0,b.localize)(13,null,this.nb(r),this.nb(o)))}const f=await this.exists(o);if(f&&!s){if(!c)throw new l.FileOperationError((0,b.localize)(14,null,this.nb(r),this.nb(o)),4);if(i===n){const{providerExtUri:P}=this.N(i);if(P.isEqualOrParent(r,o))throw new Error((0,b.localize)(15,null,this.nb(r),this.nb(o)))}}return{exists:f,isSameResourceWithDifferentPathCase:s}}N(i){const r=this.O(i);return{providerExtUri:r?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:r}}O(i){return!!(i.capabilities&1024)}async createFolder(i){const r=this.lb(await this.j(i),i);await this.P(r,i);const n=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new l.FileOperationEvent(i,0,n)),n}async P(i,r){const n=[],{providerExtUri:o}=this.N(i);for(;!o.isEqual(r,o.dirname(r));)try{if(((await i.stat(r)).type&l.FileType.Directory)===0)throw new Error((0,b.localize)(16,null,this.nb(r)));break}catch(a){if((0,l.toFileSystemProviderErrorCode)(a)!==l.FileSystemProviderErrorCode.FileNotFound)throw a;n.push(o.basename(r)),r=o.dirname(r)}for(let a=n.length-1;a>=0;a--){r=o.joinPath(r,n[a]);try{await i.mkdir(r)}catch(c){if((0,l.toFileSystemProviderErrorCode)(c)!==l.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(i,r){try{await this.Q(i,r)}catch(n){return n}return!0}async Q(i,r){const n=this.lb(await this.j(i),i);if(!!r?.useTrash&&!(n.capabilities&4096))throw new Error((0,b.localize)(17,null,this.nb(i)));let a;try{a=await n.stat(i)}catch{}if(a)this.mb(i,a);else throw new l.FileOperationError((0,b.localize)(18,null,this.nb(i)),1);if(!!!r?.recursive){const s=await this.resolve(i);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,b.localize)(19,null,this.nb(i)))}return n}async del(i,r){const n=await this.Q(i,r),o=!!r?.useTrash,a=!!r?.recursive;await n.delete(i,{recursive:a,useTrash:o}),this.m.fire(new l.FileOperationEvent(i,1))}async cloneFile(i,r){const n=await this.j(i),o=this.lb(await this.l(r),r);if(n===o&&this.N(n).providerExtUri.isEqual(i,r))return;if(n===o&&(0,l.hasFileCloneCapability)(n))return n.cloneFile(i,r);await this.P(o,this.N(o).providerExtUri.dirname(r));const a=this.X.queueFor(i,this.N(n).providerExtUri);return n===o&&(0,l.hasFileFolderCopyCapability)(n)?a.queue(()=>n.copy(i,r,{overwrite:!0})):a.queue(()=>this.J(n,i,o,r))}watch(i,r={recursive:!1,excludes:[]}){const n=new g.DisposableStore;let o=!1,a=()=>{o=!0};return n.add((0,g.toDisposable)(()=>a())),(async()=>{try{const c=await this.W(i,r);o?(0,g.dispose)(c):a=()=>(0,g.dispose)(c)}catch(c){this.b.error(c)}})(),n}async W(i,r){const n=await this.j(i),o=(0,I.hash)([this.N(n).providerExtUri.getComparisonKey(i),r]);let a=this.U.get(o);return a||(a={count:0,disposable:n.watch(i,r)},this.U.set(o,a)),a.count+=1,(0,g.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,g.dispose)(a.disposable),this.U.delete(o)))})}dispose(){super.dispose();for(const[,i]of this.U)(0,g.dispose)(i.disposable);this.U.clear()}async Y(i,r,n,o){return this.X.queueFor(r,this.N(i).providerExtUri).queue(async()=>{const a=await i.open(r,{create:!0,unlock:n?.unlock??!1});try{(0,d.isReadableStream)(o)||(0,d.isReadableBufferedStream)(o)?await this.Z(i,a,o):await this.ab(i,a,o)}catch(c){throw(0,l.ensureFileSystemProviderError)(c)}finally{await i.close(a)}})}async Z(i,r,n){let o=0,a;if((0,d.isReadableBufferedStream)(n)){if(n.buffer.length>0){const c=k.VSBuffer.concat(n.buffer);await this.bb(i,r,c,c.byteLength,o,0),o+=c.byteLength}if(n.ended)return;a=n.stream}else a=n;return new Promise((c,s)=>{(0,d.listenStream)(a,{onData:async f=>{a.pause();try{await this.bb(i,r,f,f.byteLength,o,0)}catch(P){return s(P)}o+=f.byteLength,setTimeout(()=>a.resume())},onError:f=>s(f),onEnd:()=>c()})})}async ab(i,r,n){let o=0,a;for(;(a=n.read())!==null;)await this.bb(i,r,a,a.byteLength,o,0),o+=a.byteLength}async bb(i,r,n,o,a,c){let s=0;for(;s<o;)s+=await i.write(r,a+s,n.buffer,c+s,o-s)}async cb(i,r,n,o){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.db(i,r,n,o))}async db(i,r,n,o){let a;o instanceof k.VSBuffer?a=o:(0,d.isReadableStream)(o)?a=await(0,k.streamToBuffer)(o):(0,d.isReadableBufferedStream)(o)?a=await(0,k.bufferedStreamToBuffer)(o):a=(0,k.readableToBuffer)(o),await i.writeFile(r,a.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async eb(i,r,n,o){return this.X.queueFor(o,this.N(n).providerExtUri).queue(()=>this.fb(i,r,n,o))}async fb(i,r,n,o){let a,c;try{a=await i.open(r,{create:!1}),c=await n.open(o,{create:!0,unlock:!1});const s=k.VSBuffer.alloc(this.a);let f=0,P=0,L=0;do L=await i.read(a,f,s.buffer,P,s.byteLength-P),await this.bb(n,c,s,L,f,P),f+=L,P+=L,P===s.byteLength&&(P=0);while(L>0)}catch(s){throw(0,l.ensureFileSystemProviderError)(s)}finally{await t.Promises.settled([typeof a=="number"?i.close(a):Promise.resolve(),typeof c=="number"?n.close(c):Promise.resolve()])}}async gb(i,r,n,o){return this.X.queueFor(o,this.N(n).providerExtUri).queue(()=>this.hb(i,r,n,o))}async hb(i,r,n,o){return n.writeFile(o,await i.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async ib(i,r,n,o){return this.X.queueFor(o,this.N(n).providerExtUri).queue(()=>this.jb(i,r,n,o))}async jb(i,r,n,o){const a=await n.open(o,{create:!0,unlock:!1});try{const c=await i.readFile(r);await this.bb(n,a,k.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,l.ensureFileSystemProviderError)(c)}finally{await n.close(a)}}async kb(i,r,n,o){const a=await(0,k.streamToBuffer)(this.C(i,r,M.CancellationToken.None));await this.cb(n,o,void 0,a)}lb(i,r){if(i.capabilities&2048)throw new l.FileOperationError((0,b.localize)(20,null,this.nb(r)),6);return i}mb(i,r){if((r.permissions??0)&l.FilePermission.Readonly)throw new l.FileOperationError((0,b.localize)(21,null,this.nb(i)),6)}nb(i){return i.scheme===y.Schemas.file?i.fsPath:i.toString(!0)}};E=pe([x(0,m.ILogService)],E),e.FileService=E}),define(te[87],ne([0,1,41,283,8,40,17,3,31,2,9,4,20,59,23,163,16,108,205,45,201,200]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(S)}catch(r){console.error(`Error enabling graceful-fs: ${(0,C.toErrorMessage)(r)}`)}})();class i extends m.AbstractDiskFileSystemProvider{constructor(n,o){super(n,o),this.onDidChangeCapabilities=I.Event.None,this.H=new M.ResourceMap(a=>v.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,y.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:o,symbolicLink:a}=await d.SymlinkSupport.stat(this.C(n));return{type:this.G(o,a),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.Y(o)}}async readdir(n){try{const o=await d.Promises.readdir(this.C(n),{withFileTypes:!0}),a=[];return await Promise.all(o.map(async c=>{try{let s;c.isSymbolicLink()?s=(await this.stat((0,v.joinPath)(n,c.name))).type:s=this.G(c),a.push([c.name,s])}catch(s){this.a.trace(s)}})),a}catch(o){throw this.Y(o)}}G(n,o){let a;return o?.dangling?a=l.FileType.Unknown:n.isFile()?a=l.FileType.File:n.isDirectory()?a=l.FileType.Directory:a=l.FileType.Unknown,o&&(a|=l.FileType.SymbolicLink),a}async I(n){const o=this.C(n);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let a;for(;a=this.H.get(n);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await a.wait();const c=new k.Barrier;return this.H.set(n,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,g.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.H.get(n)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.H.delete(n)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),c.open()})}async readFile(n,o){let a;try{o?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),a=await this.I(n));const c=this.C(n);return await d.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{a?.dispose()}}J(n){i.D&&this.a.trace(n)}readFileStream(n,o,a){const c=(0,h.newWriteableStream)(s=>A.VSBuffer.concat(s.map(f=>A.VSBuffer.wrap(f))).buffer);return(0,u.readFileIntoStream)(this,n,c,s=>s.buffer,{...o,bufferSize:256*1024},a),c}async writeFile(n,o,a){let c;try{const s=this.C(n);if(!a.create||!a.overwrite){if(await d.Promises.exists(s)){if(!a.overwrite)throw(0,l.createFileSystemProviderError)((0,b.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,l.createFileSystemProviderError)((0,b.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(n,{create:!0,unlock:a.unlock}),await this.write(c,0,o,0,o.byteLength)}catch(s){throw await this.Z(n,s)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(n){i.O=n}async open(n,o){const a=this.C(n);let c;(0,l.isFileOpenForWriteOptions)(o)&&(c=await this.I(n));let s;try{if((0,l.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:P}=await d.SymlinkSupport.stat(a);P.mode&128||await d.Promises.chmod(a,P.mode|128)}catch(P){this.a.trace(P)}let f;if((0,l.isFileOpenForWriteOptions)(o)){if(y.isWindows)try{await d.Promises.truncate(a,0),f="r+"}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}f||(f="w")}else f="r";s=await d.Promises.open(a,f)}catch(f){throw c?.dispose(),(0,l.isFileOpenForWriteOptions)(o)?await this.Z(n,f):this.Y(f)}if(this.L.set(s,0),(0,l.isFileOpenForWriteOptions)(o)&&this.N.set(s,n),c){const f=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${a})`),this.M.set(s,c),f&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${a})`),f.dispose())}return s}async close(n){const o=this.M.get(n);try{if(this.L.delete(n),this.N.delete(n)&&i.O)try{await d.Promises.fdatasync(n)}catch(a){i.configureFlushOnWrite(!1),this.a.error(a)}return await d.Promises.close(n)}catch(a){throw this.Y(a)}finally{o&&(this.M.get(n)===o&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.M.delete(n)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),o.dispose())}}async read(n,o,a,c,s){const f=this.P(n,o);let P=null;try{P=(await d.Promises.read(n,a,c,s,f)).bytesRead}catch(L){throw this.Y(L)}finally{this.Q(n,f,P)}return P}P(n,o){return o===this.L.get(n)?null:o}Q(n,o,a){const c=this.L.get(n);typeof c=="number"&&(typeof o=="number"||(typeof a=="number"?this.L.set(n,c+a):this.L.delete(n)))}async write(n,o,a,c,s){return(0,k.retry)(()=>this.R(n,o,a,c,s),100,3)}async R(n,o,a,c,s){const f=this.P(n,o);let P=null;try{P=(await d.Promises.write(n,a,c,s,f)).bytesWritten}catch(L){throw await this.Z(this.N.get(n),L)}finally{this.Q(n,f,P)}return P}async mkdir(n){try{await d.Promises.mkdir(this.C(n))}catch(o){throw this.Y(o)}}async delete(n,o){try{const a=this.C(n);o.recursive?await d.Promises.rm(a,d.RimRafMode.MOVE):await d.Promises.unlink(a)}catch(a){throw this.Y(a)}}async rename(n,o,a){const c=this.C(n),s=this.C(o);if(c!==s)try{await this.S(n,o,"move",a.overwrite),await d.Promises.move(c,s)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,b.localize)(2,null,(0,p.basename)(c),(0,p.basename)((0,p.dirname)(s)),f.toString()))),this.Y(f)}}async copy(n,o,a){const c=this.C(n),s=this.C(o);if(c!==s)try{await this.S(n,o,"copy",a.overwrite),await d.Promises.copy(c,s,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,b.localize)(3,null,(0,p.basename)(c),(0,p.basename)((0,p.dirname)(s)),f.toString()))),this.Y(f)}}async S(n,o,a,c){const s=this.C(n),f=this.C(o);let P=!1;if(!!(this.capabilities&1024)||(P=(0,w.isEqual)(s,f,!0)),P&&a==="copy")throw(0,l.createFileSystemProviderError)((0,b.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!P&&await d.Promises.exists(f)){if(!c)throw(0,l.createFileSystemProviderError)((0,b.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(n,o){return this.U(n,o,!1)}async U(n,o,a){const c=this.C(n),s=this.C(o),f=!!(this.capabilities&1024);if((0,w.isEqual)(c,s,!f))return;const P=new g.DisposableStore;try{const[L,T]=await Promise.all([this.I(n),this.I(o)]);P.add(L),P.add(T),a&&await d.Promises.mkdir((0,p.dirname)(s),{recursive:!0}),await d.Promises.copyFile(c,s)}catch(L){if(L.code==="ENOENT"&&!a)return this.U(n,o,!0);throw this.Y(L)}finally{P.dispose()}}p(n,o,a){return new E.UniversalWatcherClient(c=>n(c),c=>o(c),a)}y(n,o,a){return new R.NodeJSWatcherClient(c=>n(c),c=>o(c),a)}Y(n){if(n instanceof l.FileSystemProviderError)return n;let o;switch(n.code){case"ENOENT":o=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=l.FileSystemProviderErrorCode.NoPermissions;break;default:o=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(n,o)}async Z(n,o){let a=this.Y(o);if(n&&a.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.C(n));c.mode&128||(a=(0,l.createFileSystemProviderError)(o,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return a}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(te[207],ne([0,1,3,87,2,17,59,22]),function(V,e,S,t,k,M,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class w extends k.Disposable{constructor(y,v){super(),this.a=y,this.b=v,this.w=new Map,this.y=new Map}call(y,v,h){const d=this.c(y);switch(v){case"stat":return this.g(d,h[0]);case"readdir":return this.h(d,h[0]);case"open":return this.l(d,h[0],h[1]);case"close":return this.m(h[0]);case"read":return this.n(h[0],h[1],h[2]);case"readFile":return this.i(d,h[0],h[1]);case"write":return this.p(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.k(d,h[0],h[1],h[2]);case"rename":return this.t(d,h[0],h[1],h[2]);case"copy":return this.u(d,h[0],h[1],h[2]);case"cloneFile":return this.v(d,h[0],h[1]);case"mkdir":return this.r(d,h[0]);case"delete":return this.s(d,h[0],h[1]);case"watch":return this.C(d,h[0],h[1],h[2],h[3]);case"unwatch":return this.D(h[0],h[1])}throw new Error(`IPC Command ${v} not found`)}listen(y,v,h){const d=this.c(y);switch(v){case"fileChange":return this.z(d,h[0]);case"readFileStream":return this.j(d,h[0],h[1])}throw new Error(`Unknown event ${v}`)}g(y,v){const h=this.f(y,v,!0);return this.a.stat(h)}h(y,v){const h=this.f(y,v);return this.a.readdir(h)}async i(y,v,h){const d=this.f(y,v,!0),b=await this.a.readFile(d,h);return M.VSBuffer.wrap(b)}j(y,v,h){const d=this.f(y,v,!0),b=new I.CancellationTokenSource,l=new S.Emitter({onDidRemoveLastListener:()=>{b.cancel()}}),u=this.a.readFileStream(d,h,b.token);return(0,A.listenStream)(u,{onData:m=>l.fire(M.VSBuffer.wrap(m)),onError:m=>l.fire(m),onEnd:()=>{l.fire("end"),l.dispose(),b.dispose()}}),l.event}k(y,v,h,d){const b=this.f(y,v);return this.a.writeFile(b,h.buffer,d)}l(y,v,h){const d=this.f(y,v,!0);return this.a.open(d,h)}m(y){return this.a.close(y)}async n(y,v,h){const d=M.VSBuffer.alloc(h),b=0,l=await this.a.read(y,v,d.buffer,b,h);return[d,l]}p(y,v,h,d,b){return this.a.write(y,v,h.buffer,d,b)}r(y,v){const h=this.f(y,v);return this.a.mkdir(h)}s(y,v,h){const d=this.f(y,v);return this.a.delete(d,h)}t(y,v,h,d){const b=this.f(y,v),l=this.f(y,h);return this.a.rename(b,l,d)}u(y,v,h,d){const b=this.f(y,v),l=this.f(y,h);return this.a.copy(b,l,d)}v(y,v,h){const d=this.f(y,v),b=this.f(y,h);return this.a.cloneFile(d,b)}z(y,v){const h=new S.Emitter({onWillAddFirstListener:()=>{this.w.set(v,this.F(y,h))},onDidRemoveLastListener:()=>{(0,k.dispose)(this.w.get(v)),this.w.delete(v)}});return h.event}async C(y,v,h,d,b){const l=this.w.get(v);if(l){const u=this.f(y,d),m=l.watch(h,u,b);this.y.set(v+h,m)}}async D(y,v){const h=y+v,d=this.y.get(h);d&&((0,k.dispose)(d),this.y.delete(h))}dispose(){super.dispose();for(const[,y]of this.y)y.dispose();this.y.clear();for(const[,y]of this.w)y.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=w;class g extends k.Disposable{constructor(y,v,h,d){super(),this.c=y,this.f=h,this.g=d,this.a=new Map,this.b=this.B(new t.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(v)}h(y){const v=this.B(new S.Emitter);this.B(v.event(h=>{y.fire(h.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type})))})),this.B(this.b.onDidChangeFile(h=>v.fire(h))),this.B(this.b.onDidWatchError(h=>y.fire(h)))}i(y){}j(y){}watch(y,v,h){const d=this.j(this.g);return Array.isArray(d)&&(h.excludes=[...h.excludes,...d]),this.a.set(y,this.b.watch(v,h)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.a.get(y)),this.a.delete(y)})}dispose(){super.dispose();for(const[,y]of this.a)y.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=g}),define(te[208],ne([0,1,14,162,4,7,16,9,207,141]),function(V,e,S,t,k,M,A,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class p extends w.AbstractDiskFileSystemProviderChannel{constructor(h,d,b){super(h,d),this.G=b}c(h){return g.DefaultURITransformer}f(h,d){return M.URI.revive(d)}async s(h,d,b){if(!b.useTrash)return super.s(h,d,b);const l=this.f(h,d),u=(0,I.normalize)(l.fsPath);try{await S.shell.trashItem(u)}catch{throw(0,A.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,I.basename)(u)):(0,t.localize)(1,null,(0,I.basename)(u)),A.FileSystemProviderErrorCode.Unknown)}}F(h,d){return new y(h,d,this.b,this.G)}}e.DiskFileSystemProviderChannel=p;class y extends w.AbstractSessionFileWatcher{watch(h,d,b){if(b.recursive)throw(0,A.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(h,d,b)}}}),define(te[209],ne([0,1,6]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;class t extends S.AbstractMessageLogger{constructor(M=S.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(A=>{this.l?.setLevel(A)}))}set logger(M){this.l=M;for(const{level:A,message:I}of this.k)(0,S.log)(M,A,I);this.k=[]}g(M,A){this.l?(0,S.log)(this.l,M,A):this.getLevel()<=M&&this.k.push({level:M,message:A})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogService=t}),define(te[210],ne([0,1,3,7,6]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(v,h){this.a=v,this.b=h,this.onDidChangeLogLevel=S.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,h){switch(h){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${h}`)}async call(v,h,d){switch(h){case"setLevel":return d[1]?this.b.setLevel(t.URI.revive(d[1]),d[0]):this.a.setLevel(d[0])}throw new Error(`Call not found: ${h}`)}}e.LogLevelChannel=M;class A{constructor(v){this.a=v}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(v,h){A.setLevel(this.a,v,h)}static setLevel(v,h,d){return v.call("setLevel",[h,d])}}e.LogLevelChannelClient=A;class I{constructor(v){this.b=v,this.a=new Map}listen(v,h){throw new Error(`Event not found: ${h}`)}async call(v,h,d){switch(h){case"createLogger":this.c(t.URI.revive(d[0]),d[1]);return;case"log":return this.e(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.d(d[0],d[1])}throw new Error(`Call not found: ${h}`)}c(v,h){this.a.set(v.toString(),this.b.createLogger(v,h))}d(v,h){let d=console.log;switch(v){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...h)}e(v,h){const d=this.a.get(v.toString());if(!d)throw new Error("Create the logger before logging");for(const[b,l]of h)(0,k.log)(d,b,l)}}e.LoggerChannel=I;class w extends k.AbstractLoggerService{constructor(v,h,d){super(v,h),this.g=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(v,h)=>{this.g.call("consoleLog",[v,h])}})}f(v,h,d){return new g(this.g,v,h,d)}}e.LoggerChannelClient=w;class g extends k.AbstractMessageLogger{constructor(v,h,d,b){super(b?.always),this.m=v,this.n=h,this.k=!1,this.l=[],this.setLevel(d),this.m.call("createLogger",[h,b]).then(()=>{this.r(this.l),this.k=!0})}g(v,h){const d=[[v,h]];this.k?this.r(d):this.l.push(...d)}r(v){this.m.call("log",[this.n,v])}}class p extends k.LogService{constructor(v,h){super(h),this.c=v,this.B(v.onDidChangeLogLevel(d=>h.setLevel(d)))}setLevel(v){super.setLevel(v),this.c.setLevel(v)}}e.FollowerLogService=p}),define(te[211],ne([0,1,16,6]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(k||(k={}));async function M(g,p,y,v,h){try{const d=await new Promise((l,u)=>{V(["spdlog"],l,u)});d.setFlushOn(k.Trace);const b=await d.createAsyncRotatingLogger(g,p,y,v);return h?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(d){console.error(d)}return null}function A(g,p,y){switch(p){case t.LogLevel.Trace:g.trace(y);break;case t.LogLevel.Debug:g.debug(y);break;case t.LogLevel.Info:g.info(y);break;case t.LogLevel.Warning:g.warn(y);break;case t.LogLevel.Error:g.error(y);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function I(g,p){switch(p){case t.LogLevel.Trace:g.setLevel(k.Trace);break;case t.LogLevel.Debug:g.setLevel(k.Debug);break;case t.LogLevel.Info:g.setLevel(k.Info);break;case t.LogLevel.Warning:g.setLevel(k.Warning);break;case t.LogLevel.Error:g.setLevel(k.Error);break;case t.LogLevel.Off:g.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class w extends t.AbstractMessageLogger{constructor(p,y,v,h,d){super(),this.k=[],this.setLevel(d),this.l=this.n(p,y,v,h),this.B(this.onDidChangeLogLevel(b=>{this.m&&I(this.m,b)}))}async n(p,y,v,h){const d=v?6:1,b=30/d*S.ByteSize.MB,l=await M(p,y,b,d,h);if(l){this.m=l,I(this.m,this.getLevel());for(const{level:u,message:m}of this.k)A(this.m,u,m);this.k=[]}}g(p,y){this.m?A(this.m,p,y):this.getLevel()<=p&&this.k.push({level:p,message:y})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=w}),define(te[212],ne([0,1,30,6,211]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let M=class extends t.AbstractLoggerService{constructor(I){super(I.getLevel(),I.onDidChangeLogLevel)}f(I,w,g){return new k.SpdLogLogger(g?.name||(0,S.generateUuid)(),I.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,w)}};M=pe([x(0,t.ILogService)],M),e.LoggerService=M}),define(te[213],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function S(A){return A.submenu!==void 0}e.isMenubarMenuItemSubmenu=S;function t(A){return A.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(A){return A.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function M(A){return!S(A)&&!t(A)&&!k(A)}e.isMenubarMenuItemAction=M}),define(te[38],ne([0,1,3,67,2,5]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,M.createDecorator)("policy");class A extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const p=Object.keys(this.f).length;return this.f={...g,...this.f},p!==Object.keys(this.f).length&&await this.i(g),t.Iterable.reduce(this.g.entries(),(y,[v,h])=>({...y,[v]:h}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return t.Iterable.reduce(Object.entries(this.f),(g,[p,y])=>({...g,[p]:{definition:y,value:this.g.get(p)}}),{})}}e.AbstractPolicyService=A;class I{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(te[214],ne([0,1,8,3,67,11,16,6,38]),function(V,e,S,t,k,M,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function g(y,v){const h=[];for(const d of new Set(k.Iterable.concat(y.keys(),v.keys())))y.get(d)!==v.get(d)&&h.push(d);return h}let p=class extends w.AbstractPolicyService{constructor(v,h,d){super(),this.j=v,this.k=h,this.l=d,this.c=this.B(new S.ThrottledDelayer(500));const b=t.Event.filter(h.onDidFilesChange,l=>l.affects(v));this.B(h.watch(v)),this.B(b(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const v=new Map;try{const h=await this.k.readFile(this.j),d=JSON.parse(h.value.toString());if(!(0,M.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(d))this.f[b]&&v.set(b,d[b])}catch(h){h.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",h)}return v}async p(){const v=await this.n(),h=g(this.g,v);this.g=v,h.length>0&&this.h.fire(h)}};p=pe([x(1,A.IFileService),x(2,I.ILogService)],p),e.FilePolicyService=p}),define(te[215],ne([0,1,3,2,38]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class M{constructor(w){this.b=w,this.a=new t.DisposableStore}listen(w,g){switch(g){case"onDidChange":return S.Event.map(this.b.onDidChange,p=>p.reduce((y,v)=>({...y,[v]:this.b.getPolicyValue(v)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(w,g,p){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(p)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.PolicyChannel=M;class A extends k.AbstractPolicyService{constructor(w,g){super(),this.a=g;for(const p in w){const{definition:y,value:v}=w[p];this.f[p]=y,v!==void 0&&this.g.set(p,v)}this.a.listen("onDidChange")(p=>{for(const y in p){const v=p[y];v===null?this.g.delete(y):this.g.set(y,v)}this.h.fire(Object.keys(p))})}async i(w){const g=await this.a.call("updatePolicyDefinitions",w);for(const p in g)this.g.set(p,g[p])}}e.PolicyChannelClient=A}),define(te[63],ne([0,1,4,35]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof S.globals.vscode<"u"&&typeof S.globals.vscode.context<"u"){const M=S.globals.vscode.context.configuration();if(M)k=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(k=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),!k.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(k,{version:M.version})}}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(te[19],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[216],ne([0,1,78,6,19]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(I,w){this.b=I,this.c=w,this.a=new Map}async isExtensionUrlTrusted(I,w){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const g=/^(.*)#([^#]+)$/.exec(w);if(!g)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,p,y]=g;let v=this.a.get(I);if(!v){if(v=this.b.trustedExtensionUrlPublicKeys[I],!v||v.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.a.set(I,[...v])}const h=Buffer.from(decodeURIComponent(y),"base64");if(h.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const d=h.slice(0,6),b=h.readUIntBE(0,6),l=Date.now()-b;if(l<0||l>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const u=h.slice(6),m=S.createVerify("SHA256");m.write(d),m.write(Buffer.from(p)),m.end();for(let C=0;C<v.length;C++){let E=v[C];if(E!==null){if(typeof E=="string")try{E=S.createPublicKey({key:Buffer.from(E,"base64"),format:"der",type:"spki"}),v[C]=E}catch(R){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${C+1} for ${I}:`,R),v[C]=null;continue}if(m.verify(E,u))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};M=pe([x(0,k.IProductService),x(1,t.ILogService)],M),e.ExtensionUrlTrustService=M}),define(te[217],ne([0,1,8,6]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let k=class{constructor(A,I,w){this.a=A,this.b=I,this.c=w}async inspect(A){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.timeout)(A);const w=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),w.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};k=pe([x(2,t.ILogService)],k),e.WindowProfiler=k}),define(te[64],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,S.createDecorator)("protocolMainService")}),define(te[48],ne([0,1,122,11]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(A,I){S.ok(t.isString(A)),S.ok(t.isObject(I)),S.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,I)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.Registry=new k}),define(te[218],ne([0,1,3,48]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class M{constructor(){this.b=new S.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,g){this.a[k(w)]=g,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;t.Registry.add(e.Extensions.JSONContribution,A)}),define(te[65],ne([0,1,24,3,11,150,18,218,48]),function(V,e,S,t,k,M,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(R){R.Multiline="multilineText",R.Singleline="singlelineText"})(g=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(R){R[R.APPLICATION=1]="APPLICATION",R[R.MACHINE=2]="MACHINE",R[R.WINDOW=3]="WINDOW",R[R.RESOURCE=4]="RESOURCE",R[R.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",R[R.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=w.Registry.as(I.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const n=new Set;this.n(i,r,n),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const r=new Set;this.o(i,r),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const n=new Set;this.o(r,n),this.n(i,!1,n),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const n=[];for(const{overrides:o,source:a}of i)for(const c in o)if(r.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const s=this.a.get(c),f=s?.valuesSources??new Map;if(a)for(const U of Object.keys(o[c]))f.set(U,a);const P={...s?.value||{},...o[c]};this.a.set(c,{source:a,value:P,valuesSources:f});const L=(0,A.getLanguageTagSettingPlainKey)(c),T={type:"object",default:P,description:M.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:P,source:k.isString(a)?void 0:a,defaultValueSource:a};n.push(...b(c)),this.d[c]=T,this.b.properties[c]=T}else{this.a.set(c,{value:o[c],source:a});const s=this.d[c];s&&(this.w(c,s),this.r(c,s))}this.m(n)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:n,source:o}of i)for(const a in n){const c=this.a.get(a),s=k.isString(o)?o:o?.id,f=k.isString(c?.source)?c?.source:c?.source?.id;if(s===f)if(r.add(a),this.a.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.d[a],delete this.b.properties[a];else{const P=this.d[a];P&&(this.w(a,P),this.r(a,P))}}this.u()}deltaConfiguration(i){let r=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,n){i.forEach(o=>{this.p(o,r,o.extensionInfo,o.restrictedProperties,void 0,n),this.c.push(o),this.q(o)})}o(i,r){const n=o=>{if(o.properties)for(const a in o.properties){r.add(a);const c=this.d[a];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[a],this.s(a,o.properties[a])}o.allOf?.forEach(a=>n(a))};for(const o of i){n(o);const a=this.c.indexOf(o);a!==-1&&this.c.splice(a,1)}}p(i,r=!0,n,o,a=3,c){a=k.isUndefinedOrNull(i.scope)?a:i.scope;const s=i.properties;if(s)for(const P in s){const L=s[P];if(r&&C(P,L)){delete s[P];continue}if(L.source=n,L.defaultDefaultValue=s[P].default,this.w(P,L),e.OVERRIDE_PROPERTY_REGEX.test(P)?L.scope=void 0:(L.scope=k.isUndefinedOrNull(L.scope)?a:L.scope,L.restricted=k.isUndefinedOrNull(L.restricted)?!!o?.includes(P):L.restricted),s[P].hasOwnProperty("included")&&!s[P].included){this.f[P]=s[P],delete s[P];continue}else this.d[P]=s[P],s[P].policy?.name&&this.e.set(s[P].policy.name,P);!s[P].deprecationMessage&&s[P].markdownDeprecationMessage&&(s[P].deprecationMessage=s[P].markdownDeprecationMessage),c.add(P)}const f=i.allOf;if(f)for(const P of f)this.p(P,r,n,o,a,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=n=>{const o=n.properties;if(o)for(const c in o)this.r(c,o[c]);n.allOf?.forEach(r)};r(i)}r(i,r){switch(e.allSettings.properties[i]=r,r.scope){case 1:e.applicationSettings.properties[i]=r;break;case 2:e.machineSettings.properties[i]=r;break;case 6:e.machineOverridableSettings.properties[i]=r;break;case 3:e.windowSettings.properties[i]=r;break;case 4:e.resourceSettings.properties[i]=r;break;case 5:e.resourceSettings.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.allSettings.properties[i],r.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,n={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,n),e.allSettings.properties[r]=n,e.applicationSettings.properties[r]=n,e.machineSettings.properties[r]=n,e.machineOverridableSettings.properties[r]=n,e.windowSettings.properties[r]=n,e.resourceSettings.properties[r]=n}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,r){const n=this.a.get(i);let o=n?.value,a=n?.source;k.isUndefined(o)&&(o=r.defaultDefaultValue,a=void 0),k.isUndefined(o)&&(o=u(r.type)),r.default=o,r.defaultValueSource=a}}const h="\\[([^\\]]+)\\]",d=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(R){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(R)){let r=d.exec(R);for(;r?.length;){const n=r[1].trim();n&&i.push(n),r=d.exec(R)}}return(0,S.distinct)(i)}e.overrideIdentifiersFromKey=b;function l(R){return R.reduce((i,r)=>`${i}[${r}]`,"")}e.keyFromOverrideIdentifiers=l;function u(R){switch(Array.isArray(R)?R[0]:R){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const m=new v;w.Registry.add(e.Extensions.Configuration,m);function C(R,i){return R.trim()?e.OVERRIDE_PROPERTY_REGEX.test(R)?M.localize(7,null,R):m.getConfigurationProperties()[R]!==void 0?M.localize(8,null,R):i.policy?.name&&m.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,R,i.policy?.name,m.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.validateProperty=C;function E(){const R=[],i=m.getConfigurationProperties();for(const r of Object.keys(i))R.push([r,i[r].scope]);return R.push(["launch",4]),R.push(["task",4]),R}e.getScopes=E}),define(te[109],ne([0,1,24,3,43,2,40,44,11,7,18,65,48]),function(V,e,S,t,k,M,A,I,w,g,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class h{constructor(r={},n=[],o=[],a){this.c=r,this.d=n,this.f=o,this.raw=a,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(n=>{if(n instanceof h)return n;const o=new d("");return o.parseRaw(n),o.configurationModel});this.g=r.reduce((n,o)=>o===n?o:n.merge(o),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,p.getConfigurationValue)(this.contents,r):this.contents}inspect(r,n){const o=this.rawConfiguration.getValue(r),a=n?this.rawConfiguration.getOverrideValue(r,n):void 0,c=n?this.rawConfiguration.override(n).getValue(r):o;return{value:o,override:a,merged:c}}getOverrideValue(r,n){const o=this.l(n);return o?r?(0,p.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const o of this.overrides)o.identifiers.includes(r)&&n.push(...o.keys);return S.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return S.distinct(r)}override(r){let n=this.b.get(r);return n||(n=this.h(r),this.b.set(r,n)),n}merge(...r){const n=I.deepClone(this.contents),o=I.deepClone(this.overrides),a=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const s of r)if(c.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.j(n,s.contents);for(const f of s.overrides){const[P]=o.filter(L=>S.equals(L.identifiers,f.identifiers));P?(this.j(P.contents,f.contents),P.keys.push(...f.keys),P.keys=S.distinct(P.keys)):o.push(I.deepClone(f))}for(const f of s.keys)a.indexOf(f)===-1&&a.push(f)}return new h(n,a,o,c.every(s=>s instanceof h)?void 0:c)}freeze(){return this.a=!0,this}h(r){const n=this.l(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const a of S.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[a];const s=n[a];s&&(typeof c=="object"&&typeof s=="object"?(c=I.deepClone(c),this.j(c,s)):c=s),o[a]=c}return new h(o,this.keys,this.overrides)}j(r,n){for(const o of Object.keys(n)){if(o in r&&w.isObject(r[o])&&w.isObject(n[o])){this.j(r[o],n[o]);continue}r[o]=I.deepClone(n[o])}}k(r){return this.a&&!Object.isFrozen(r)?I.deepFreeze(r):r}l(r){let n=null,o=null;const a=c=>{c&&(o?this.j(o,c):o=I.deepClone(c))};for(const c of this.overrides)S.equals(c.identifiers,[r])?n=c.contents:c.identifiers.includes(r)&&a(c.contents);return a(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,n){this.m(r),(0,p.addToValueTree)(this.contents,r,n,o=>{throw new Error(o)})}removeValue(r){this.n(r)&&(0,p.removeFromValueTree)(this.contents,r)}m(r){let n=this.keys.length;for(let o=0;o<n;o++)r.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,r)}n(r){const n=this.keys.indexOf(r);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=h;class d{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new h}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,n){if(!w.isUndefinedOrNull(r)){const o=this.g(r);this.parseRaw(o,n)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,n){this.a=r;const{contents:o,keys:a,overrides:c,restricted:s,hasExcludedProperties:f}=this.h(r,n);this.b=new h(o,a,c,f?[r]:void 0),this.c=s||[]}g(r){let n={},o=null,a=[];const c=[],s=[];function f(L){Array.isArray(a)?a.push(L):o!==null&&(a[o]=L)}const P={onObjectBegin:()=>{const L={};f(L),c.push(a),a=L,o=null},onObjectProperty:L=>{o=L},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const L=[];f(L),c.push(a),a=L,o=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:f,onError:(L,T,U)=>{s.push({error:L,offset:T,length:U})}};if(r)try{k.visit(r,P),n=a[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return n}h(r,n){const o=v.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),a=this.j(r,o,!0,n);r=a.raw;const c=(0,p.toValuesTree)(r,P=>console.error(`Conflict in settings file ${this.f}: ${P}`)),s=Object.keys(r),f=this.l(r,P=>console.error(`Conflict in settings file ${this.f}: ${P}`));return{contents:c,keys:s,overrides:f,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}j(r,n,o,a){let c=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const s={},f=[];for(const P in r)if(y.OVERRIDE_PROPERTY_REGEX.test(P)&&o){const L=this.j(r[P],n,!1,a);s[P]=L.raw,c=c||L.hasExcludedProperties,f.push(...L.restricted)}else{const L=n[P],T=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&f.push(P),(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&!(a.skipRestricted&&L?.restricted)?s[P]=r[P]:c=!0}return{raw:s,restricted:f,hasExcludedProperties:c}}l(r,n){const o=[];for(const a of Object.keys(r))if(y.OVERRIDE_PROPERTY_REGEX.test(a)){const c={};for(const s in r[a])c[s]=r[a][s];o.push({identifiers:(0,y.overrideIdentifiersFromKey)(a),keys:Object.keys(c),contents:(0,p.toValuesTree)(c,n)})}return o}}e.ConfigurationModelParser=d;class b extends M.Disposable{constructor(r,n,o,a){super(),this.f=r,this.g=n,this.h=a,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new d(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&o.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new h}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=b;class l{constructor(r,n,o,a,c,s,f,P,L,T,U,G,H){this.a=r,this.b=n,this.value=o,this.overrideIdentifiers=a,this.c=c,this.d=s,this.f=f,this.g=P,this.h=L,this.j=T,this.k=U,this.l=G,this.m=H}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class u{constructor(r,n,o,a,c=new h,s=new h,f=new A.ResourceMap,P=new h,L=new A.ResourceMap,T=!0){this.c=r,this.d=n,this.f=o,this.g=a,this.h=c,this.j=s,this.l=f,this.m=P,this.n=L,this.p=T,this.a=null,this.b=new A.ResourceMap,this.q=null}getValue(r,n,o){return this.s(r,n,o).getValue(r)}updateValue(r,n,o={}){let a;o.resource?(a=this.n.get(o.resource),a||(a=new h,this.n.set(o.resource,a))):a=this.m,n===void 0?a.removeValue(r):a.setValue(r,n),o.resource||(this.a=null)}inspect(r,n,o){const a=this.s(r,n,o),c=this.w(n.resource,o),s=n.resource?this.n.get(n.resource)||this.m:this.m,f=new Set;for(const P of a.overrides)for(const L of P.identifiers)a.getOverrideValue(r,L)!==void 0&&f.add(L);return new l(r,n,a.getValue(r),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),o?this.j.freeze():void 0,c?c.freeze():void 0,s.inspect(r,n.overrideIdentifier))}keys(r){const n=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,n){this.l.set(r,n),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const o=[];if(!n){const{added:a,updated:c,removed:s}=E(this.c,r);n=[...a,...c,...s]}for(const a of n)for(const c of(0,y.overrideIdentifiersFromKey)(a)){const s=this.c.getKeysForOverrideIdentifier(c),f=r.getKeysForOverrideIdentifier(c),P=[...f.filter(L=>s.indexOf(L)===-1),...s.filter(L=>f.indexOf(L)===-1),...s.filter(L=>!I.equals(this.c.override(c).getValue(L),r.override(c).getValue(L)))];o.push([c,P])}return this.updateDefaultConfiguration(r),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(r){const{added:n,updated:o,removed:a}=E(this.d,r),c=[...n,...o,...a];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:n,updated:o,removed:a,overrides:c}=E(this.applicationConfiguration,r),s=[...n,...o,...a];return s.length&&this.updateApplicationConfiguration(r),{keys:s,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:o,removed:a,overrides:c}=E(this.localUserConfiguration,r),s=[...n,...o,...a];return s.length&&this.updateLocalUserConfiguration(r),{keys:s,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:o,removed:a,overrides:c}=E(this.remoteUserConfiguration,r),s=[...n,...o,...a];return s.length&&this.updateRemoteUserConfiguration(r),{keys:s,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:o,removed:a,overrides:c}=E(this.workspaceConfiguration,r),s=[...n,...o,...a];return s.length&&this.updateWorkspaceConfiguration(r),{keys:s,overrides:c}}compareAndUpdateFolderConfiguration(r,n){const o=this.r.get(r),{added:a,updated:c,removed:s,overrides:f}=E(o,n),P=[...a,...c,...s];return(P.length||!o)&&this.updateFolderConfiguration(r,n),{keys:P,overrides:f}}compareAndDeleteFolderConfiguration(r){const n=this.r.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:a,removed:c,overrides:s}=E(n,void 0);return{keys:[...o,...a,...c],overrides:s}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,n,o){let a=this.t(n,o);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(a=a.merge(this.d)),a}t({resource:r},n){let o=this.u();if(n&&r){const a=n.getFolder(r);a&&(o=this.v(a.uri)||o);const c=this.n.get(r);c&&(o=o.merge(c))}return o}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let n=this.b.get(r);if(!n){const o=this.u(),a=this.l.get(r);a?(n=o.merge(a),this.p&&(n=n.freeze()),this.b.set(r,n)):n=o}return n}w(r,n){if(n&&r){const o=n.getFolder(r);if(o)return this.l.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,n)=>{const{contents:o,overrides:a,keys:c}=this.l.get(n);return r.push([n,{contents:o,overrides:a,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(n=>r.add(n)),this.userConfiguration.freeze().keys.forEach(n=>r.add(n)),this.j.freeze().keys.forEach(n=>r.add(n)),this.l.forEach(n=>n.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.j.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.l.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}y(r){const n=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this.j.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o)),this.l.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a))),[...n.values()]}static parse(r){const n=this.z(r.defaults),o=this.z(r.policy),a=this.z(r.application),c=this.z(r.user),s=this.z(r.workspace),f=r.folders.reduce((P,L)=>(P.set(g.URI.revive(L[0]),this.z(L[1])),P),new A.ResourceMap);return new u(n,o,a,c,new h,s,f,new h,new A.ResourceMap,!1)}static z(r){return new h(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=u;function m(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const r=new Set,n=new Map;for(const a of i)a.keys.forEach(c=>r.add(c)),a.overrides.forEach(([c,s])=>{const f=(0,A.getOrSet)(n,c,new Set);s.forEach(P=>f.add(P))});const o=[];return n.forEach((a,c)=>o.push([c,[...a.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=m;class C{constructor(r,n,o,a){this.change=r,this.f=n,this.g=o,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.j=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const s of c)this.affectedKeys.add(s);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=u.parse(this.f.data)),this.j}affectsConfiguration(r,n){const o=this.a+r,a=this.d.indexOf(o);if(a<0)return!1;const c=a+o.length;if(c>=this.d.length)return!1;const s=this.d.charCodeAt(c);if(s!==this.b&&s!==this.c)return!1;if(n){const f=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.f?.workspace):void 0,P=this.g.getValue(r,n,this.h);return!I.equals(f,P)}return!0}}e.ConfigurationChangeEvent=C;function E(i,r){const{added:n,removed:o,updated:a}=R(r?.rawConfiguration,i?.rawConfiguration),c=[],s=i?.getAllOverrideIdentifiers()||[],f=r?.getAllOverrideIdentifiers()||[];if(r){const P=f.filter(L=>!s.includes(L));for(const L of P)c.push([L,r.getKeysForOverrideIdentifier(L)])}if(i){const P=s.filter(L=>!f.includes(L));for(const L of P)c.push([L,i.getKeysForOverrideIdentifier(L)])}if(r&&i){for(const P of s)if(f.includes(P)){const L=R({contents:i.getOverrideValue(void 0,P)||{},keys:i.getKeysForOverrideIdentifier(P)},{contents:r.getOverrideValue(void 0,P)||{},keys:r.getKeysForOverrideIdentifier(P)});c.push([P,[...L.added,...L.removed,...L.updated]])}}return{added:n,removed:o,updated:a,overrides:c}}function R(i,r){const n=i?r?i.keys.filter(c=>r.keys.indexOf(c)===-1):[...i.keys]:[],o=r?i?r.keys.filter(c=>i.keys.indexOf(c)===-1):[...r.keys]:[],a=[];if(i&&r){for(const c of r.keys)if(i.keys.indexOf(c)!==-1){const s=(0,p.getConfigurationValue)(r.contents,c),f=(0,p.getConfigurationValue)(i.contents,c);I.equals(s,f)||a.push(c)}}return{added:n,removed:o,updated:a}}}),define(te[219],ne([0,1,24,3,2,44,11,18,109,65,6,38,48]),function(V,e,S,t,k,M,A,I,w,g,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class h extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new d(this.f())),this.b}async initialize(){return this.b=void 0,this.B(v.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:C})=>this.c(Array.from(m),C))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(m,C){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}}e.DefaultConfiguration=h;class d extends w.ConfigurationModel{constructor(m={}){const C=v.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),E=Object.keys(C),R=Object.create(null),i=[];for(const r in C){const n=m[r],o=n!==void 0?n:C[r].default;(0,I.addToValueTree)(R,r,o,a=>console.error(`Conflict in default settings: ${a}`))}for(const r of Object.keys(R))g.OVERRIDE_PROPERTY_REGEX.test(r)&&i.push({identifiers:(0,g.overrideIdentifiersFromKey)(r),keys:Object.keys(R[r]),contents:(0,I.toValuesTree)(R[r],n=>console.error(`Conflict in default settings file: ${n}`))});super(R,E,i)}}e.DefaultConfigurationModel=d;class b{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new w.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=b;let l=class extends k.Disposable{get configurationModel(){return this.b}constructor(m,C,E){super(),this.c=m,this.f=C,this.g=E,this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new w.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.i(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.j(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const C={},E=[],R=v.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const i of m){const r=R[i];if(!r){E.push(i);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}E.push(i),C[r.policy.name]={type:r.type}}}return(0,A.isEmptyObject)(C)||await this.f.updatePolicyDefinitions(C),E}i(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const C=v.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),E=(0,S.coalesce)(m.map(R=>C.get(R)));this.j(E,!0)}j(m,C){this.g.trace("PolicyConfiguration#update",m);const E=v.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),R=[],i=this.b.isEmpty();for(const r of m){const n=E[r]?.policy?.name;if(n){const o=this.f.getPolicyValue(n);(i?o!==void 0:!(0,M.equals)(this.b.getValue(r),o))&&R.push([r,o])}else this.b.getValue(r)!==void 0&&R.push([r,void 0])}if(R.length){this.g.trace("PolicyConfiguration#changed",R);const r=this.b;this.b=new w.ConfigurationModel;for(const n of r.keys)this.b.setValue(n,r.getValue(n));for(const[n,o]of R)o===void 0?this.b.removeValue(n):this.b.setValue(n,o);C&&this.a.fire(this.b)}}};l=pe([x(1,y.IPolicyService),x(2,p.ILogService)],l),e.PolicyConfiguration=l}),define(te[220],ne([0,1,8,3,2,20,18,109,219,38]),function(V,e,S,t,k,M,A,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class p extends k.Disposable{constructor(v,h,d,b){super(),this.i=v,this.h=this.B(new t.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.DefaultConfiguration),this.c=d instanceof g.NullPolicyService?new w.NullPolicyConfiguration:this.B(new w.PolicyConfiguration(this.b,d,b)),this.f=this.B(new I.UserSettings(this.i,void 0,M.extUriBiasedIgnorePathCase,h)),this.a=new I.Configuration(this.b.configurationModel,this.c.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.g=this.B(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:l,properties:u})=>this.k(l,u))),this.B(this.c.onDidChangeConfiguration(l=>this.l(l))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,h,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new I.Configuration(v,h,new I.ConfigurationModel,d)}getConfigurationData(){return this.a.toData()}getValue(v,h){const d=typeof v=="string"?v:void 0,b=(0,A.isConfigurationOverrides)(v)?v:(0,A.isConfigurationOverrides)(h)?h:{};return this.a.getValue(d,b,void 0)}updateValue(v,h,d,b){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.j(v)}j(v){const h=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(v);this.m(d,h,2)}k(v,h){const d=this.a.toData(),b=this.a.compareAndUpdateDefaultConfiguration(v,h);this.m(b,d,7)}l(v){const h=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(v);this.m(d,h,7)}m(v,h,d){const b=new I.ConfigurationChangeEvent(v,{data:h},this.a);b.source=d,b.sourceConfig=this.n(d),this.h.fire(b)}n(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=p}),define(te[221],ne([0,1,13,5]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends S.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof M&&I._code===k.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof M&&I._code===k.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof M&&I._code===k.NoResolverFound}static isHandled(I){return I instanceof M&&I.isHandled}constructor(I,w=k.Unknown,g){super(I),this._message=I,this._code=w,this._detail=g,this.isHandled=w===k.NotAvailable&&g===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M}),define(te[55],ne([0,1,15]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(g){return g.scheme===S.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=t;function k(g){if(!g)return;const p=g.indexOf("+");return p<0?g:g.substr(0,p)}e.getRemoteName=k;function M(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.getRemoteServerRootPath=M;function A(g){const{host:p,port:y}=w(g);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:p,port:y}}e.parseAuthorityWithPort=A;function I(g,p){let{host:y,port:v}=w(g);return typeof v>"u"&&(v=p),{host:y,port:v}}e.parseAuthorityWithOptionalPort=I;function w(g){const p=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const y=g.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const v=g.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:g,port:void 0}}}),define(te[88],ne([0,1,26,5,55]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=M;function A(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var w;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class g{constructor(b){this.value=b,this.c=b.toLowerCase()}static equals(b,l){if(typeof b>"u"||b===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof b=="string"||typeof l=="string"){const u=typeof b=="string"?b:b.value,m=typeof l=="string"?l:l.value;return S.equalsIgnoreCase(u,m)}return b.c===l.c}static toKey(b){return typeof b=="string"?b.toLowerCase():b.c}}e.ExtensionIdentifier=g;function p(d){return y(d)}e.isApplicationScopedExtension=p;function y(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function v(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function h(d,b){if(b){const l=`onResolveRemoteAuthority:${(0,k.getRemoteName)(b)}`;return d.activationEvents?.indexOf(l)!==-1}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[222],ne([0,1,8,17,22,13,3,2,30,102,221,55]),function(V,e,S,t,k,M,A,I,w,g,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const v=30*1e3;var h;(function(D){D[D.Management=1]="Management",D[D.ExtensionHost=2]="ExtensionHost",D[D.Tunnel=3]="Tunnel"})(h=e.ConnectionType||(e.ConnectionType={}));function d(D){switch(D){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function b(D){const O=new k.CancellationTokenSource;return setTimeout(()=>O.cancel(),D),O.token}function l(D,O){if(D.isCancellationRequested||O.isCancellationRequested)return k.CancellationToken.Cancelled;const F=new k.CancellationTokenSource;return D.onCancellationRequested(()=>F.cancel()),O.onCancellationRequested(()=>F.cancel()),F.token}class u{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new I.DisposableStore,this.promise=new Promise((F,j)=>{this.f=F,this.g=j}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function m(D,O){const F=new u(O);return F.registerDisposable(D.onControlMessage(j=>{const q=JSON.parse(j.toString()),X=N(q);X?F.reject(X):F.resolve(q)})),F.promise}function C(D,O,F,j,q,X,B,Q){const ie=new u(Q);return O.connect(F,j,q,X,B,(ae,de)=>{ie.didTimeout?(ae&&D.error(ae),de?.dispose()):ae||!de?ie.reject(ae):ie.resolve(de)}),ie.promise}function E(D,O){const F=new u(O);return D.then(j=>{F.didTimeout||F.resolve(j)},j=>{F.didTimeout||F.reject(j)}),F.promise}async function R(D,O,F,j){const q=oe(D,O);D.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let X;try{X=await C(D.logService,D.socketFactory,D.host,D.port,(0,y.getRemoteServerRootPath)(D),`reconnectionToken=${D.reconnectionToken}&reconnection=${D.reconnectionProtocol?"true":"false"}`,`renderer-${d(O)}-${D.reconnectionToken}`,j)}catch(de){throw D.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),D.logService.error(de),de}D.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let B,Q;D.reconnectionProtocol?(D.reconnectionProtocol.beginAcceptReconnection(X,null),B=D.reconnectionProtocol,Q=!1):(B=new g.PersistentProtocol({socket:X,measureRoundTripTime:!0}),Q=!0),D.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const ie=await E(D.signService.createNewMessage((0,w.generateUuid)()),j),ae={type:"auth",auth:D.connectionToken||"00000000000000000000",data:ie.data};B.sendControl(t.VSBuffer.fromString(JSON.stringify(ae)));try{const de=await m(B,l(j,b(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const Me=new Error("Unexpected handshake message");throw Me.code="VSCODE_CONNECTION_ERROR",Me}if(D.logService.trace(`${q} 4/6. received SignRequest control message.`),!await E(D.signService.validate(ie,de.signedData),j)){const Me=new Error("Refused to connect to unsupported server");throw Me.code="VSCODE_CONNECTION_ERROR",Me}const Oe=await E(D.signService.sign(de.data),j),De={type:"connectionType",commit:D.commit,signedData:Oe,desiredConnectionType:O};return F&&(De.args=F),D.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),B.sendControl(t.VSBuffer.fromString(JSON.stringify(De))),{protocol:B,ownsProtocol:Q}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(D.logService.error(`${q} the handshake timed out. Error:`),D.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(D.logService.error(`${q} received error control message when negotiating connection. Error:`),D.logService.error(de)),Q&&$(B),de}}async function i(D,O,F,j){const q=Date.now(),X=oe(D,O),{protocol:B,ownsProtocol:Q}=await R(D,O,F,j),ie=new u(j);return ie.registerDisposable(B.onControlMessage(ae=>{const de=JSON.parse(ae.toString()),ke=N(de);ke?(D.logService.error(`${X} received error control message when negotiating connection. Error:`),D.logService.error(ke),Q&&$(B),ie.reject(ke)):(D.reconnectionProtocol?.endAcceptReconnection(),D.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${ee(q)}!`),ie.resolve({protocol:B,firstMessage:de}))})),ie.promise}async function r(D,O){const{protocol:F}=await i(D,1,void 0,O);return{protocol:F}}async function n(D,O,F){const{protocol:j,firstMessage:q}=await i(D,2,O,F),X=q&&q.debugPort;return{protocol:j,debugPort:X}}async function o(D,O,F){const j=Date.now(),q=oe(D,3),{protocol:X}=await R(D,3,O,F);return D.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${ee(j)}!`),X}async function a(D,O,F){const{host:j,port:q,connectionToken:X}=await D.addressProvider.getAddress();return{commit:D.commit,quality:D.quality,host:j,port:q,connectionToken:X,reconnectionToken:O,reconnectionProtocol:F,socketFactory:D.socketFactory,signService:D.signService,logService:D.logService}}async function c(D,O,F){return f(D,async j=>{const{protocol:q}=await r(j,k.CancellationToken.None);return new ge(D,O,F,j.reconnectionToken,q)})}e.connectRemoteAgentManagement=c;async function s(D,O){return f(D,async F=>{const{protocol:j,debugPort:q}=await n(F,O,k.CancellationToken.None);return new _(D,O,F.reconnectionToken,j,q)})}e.connectRemoteAgentExtensionHost=s;async function f(D,O){for(let j=1;;j++)try{const q=(0,w.generateUuid)(),X=await a(D,q,null);return await O(X)}catch(q){if(j<5)D.logService.error(`[remote-connection][attempt ${j}] An error occurred in initial connection! Will retry... Error:`),D.logService.error(q);else throw D.logService.error(`[remote-connection][attempt ${j}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),D.logService.error(q),ce.triggerPermanentFailure(0,0,p.RemoteAuthorityResolverError.isHandled(q)),q}}async function P(D,O,F){const j=await a(D,(0,w.generateUuid)(),null);return await o(j,{host:O,port:F},k.CancellationToken.None)}e.connectRemoteAgentTunnel=P;function L(D){return(0,S.createCancelablePromise)(O=>new Promise((F,j)=>{const q=setTimeout(F,D*1e3);O.onCancellationRequested(()=>{clearTimeout(q),F()})}))}var T;(function(D){D[D.ConnectionLost=0]="ConnectionLost",D[D.ReconnectionWait=1]="ReconnectionWait",D[D.ReconnectionRunning=2]="ReconnectionRunning",D[D.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",D[D.ConnectionGain=4]="ConnectionGain",D[D.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(O,F){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.type=0}}e.ConnectionLostEvent=U;class G{constructor(O,F,j,q){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.durationSeconds=j,this.c=q,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=G;class H{constructor(O,F,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=j,this.type=2}}e.ReconnectionRunningEvent=H;class K{constructor(O,F,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=j,this.type=4}}e.ConnectionGainEvent=K;class se{constructor(O,F){this.reconnectionToken=O,this.connectionHealth=F,this.type=5}}e.ConnectionHealthChangedEvent=se;class Z{constructor(O,F,j,q){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=j,this.handled=q,this.type=3}}e.ReconnectionPermanentFailureEvent=Z;class ce extends I.Disposable{static triggerPermanentFailure(O,F,j){this._permanentFailure=!0,this.f=O,this.g=F,this.h=j,this.i.forEach(q=>q.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(O=>O.r())}static debugPauseSocketWriting(){this.i.forEach(O=>O.v())}get k(){return this.c||ce._permanentFailure}constructor(O,F,j,q,X){super(),this.m=O,this.n=F,this.reconnectionToken=j,this.protocol=q,this.p=X,this.j=this.B(new A.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new K(this.reconnectionToken,0,0)),this.B(q.onSocketClose(B=>{const Q=Y(this.m,this.reconnectionToken,!0);B?B.type===0?(this.n.logService.info(`${Q} received socket close event (hadError: ${B.hadError}).`),B.error&&this.n.logService.error(B.error)):(this.n.logService.info(`${Q} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this.n.logService.error(B.event)):this.n.logService.info(`${Q} received socket close event.`),this.r()})),this.B(q.onSocketTimeout(B=>{const Q=Y(this.m,this.reconnectionToken,!0);this.n.logService.info(`${Q} received socket timeout event (unacknowledgedMsgCount: ${B.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${B.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${B.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(q.onHighRoundTripTime(B=>{const Q=z(this.m,this.reconnectionToken);this.n.logService.info(`${Q} high roundtrip time: ${B.roundTripTime}ms (${B.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(q.onDidChangeConnectionHealth(B=>{this.j.fire(new se(this.reconnectionToken,B))})),ce.i.push(this),this.B((0,I.toDisposable)(()=>{const B=ce.i.indexOf(this);B>=0&&ce.i.splice(B,1)})),this.k&&this.u(ce.f,ce.g,ce.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const O=Y(this.m,this.reconnectionToken,!0);this.n.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let j=-1;do{j++;const q=j<F.length?F[j]:F[F.length-1];try{if(q>0){const B=L(q);this.j.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,B)),this.n.logService.info(`${O} waiting for ${q} seconds before reconnecting...`);try{await B}catch{}}if(this.k){this.n.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1)),this.n.logService.info(`${O} resolving connection...`);const X=await a(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${O} connecting to ${X.host}:${X.port}...`),await this.w(X,b(v)),this.n.logService.info(`${O} reconnected!`),this.j.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(j>360){this.n.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(p.RemoteAuthorityResolverError.isTemporarilyNotAvailable(X)){this.n.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this.n.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(X);continue}if((0,M.isCancellationError)(X)){this.n.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(X);continue}if(X instanceof p.RemoteAuthorityResolverError){this.n.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),j+1,p.RemoteAuthorityResolverError.isHandled(X));break}this.n.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}}while(!this.k)}t(O,F,j){this.p?ce.triggerPermanentFailure(O,F,j):this.u(O,F,j)}u(O,F,j){this.j.fire(new Z(this.reconnectionToken,O,F,j)),$(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ce,ce._permanentFailure=!1,ce.f=0,ce.g=0,ce.h=!1,ce.i=[];class ge extends ce{constructor(O,F,j,q,X){super(1,O,q,X,!0),this.client=this.B(new g.Client(X,{remoteAuthority:F,clientId:j},O.ipcLogger))}async w(O,F){await r(O,F)}}e.ManagementPersistentConnection=ge;class _ extends ce{constructor(O,F,j,q,X){super(2,O,j,q,!1),this.y=F,this.debugPort=X}async w(O,F){await n(O,this.y,F)}}e.ExtensionHostPersistentConnection=_;function $(D){try{D.acceptDisconnect();const O=D.getSocket();D.dispose(),O.dispose()}catch(O){(0,M.onUnexpectedError)(O)}}function N(D){if(D&&D.type==="error"){const O=new Error(`Connection error: ${D.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function W(D,O){for(;D.length<O;)D+=" ";return D}function z(D,O){return`[remote-connection][${W(d(D),13)}][${O.substr(0,5)}\u2026]`}function Y(D,O,F){return`${z(D,O)}[${F?"reconnect":"initial"}]`}function oe(D,O){return`${Y(O,D.reconnectionToken,!!D.reconnectionProtocol)}[${D.host}:${D.port}]`}function ee(D){return`${Date.now()-D} ms`}}),define(te[223],ne([0,1,79,84]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,M,A,I,w,g){const p=v=>g(v,void 0),y=S.createConnection({host:k,port:M},()=>{y.removeListener("error",p);const v=Buffer.alloc(16);for(let l=0;l<16;l++)v[l]=Math.round(Math.random()*256);const h=v.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${M}${A}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`];y.write(d.join(`\r
`)+`\r
\r
`);const b=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",b),g(void 0,new t.NodeSocket(y,w)))};y.on("data",b)});y.setNoDelay(!0),y.once("error",p)}}}),define(te[224],ne([0,1,25,46,41,183]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let A;async function I(h=!1){return(A===void 0||h)&&(A=w()),A}e.hasWSLFeatureInstalled=I;async function w(){const h=g();if(h===void 0)return!1;if(h>=22e3){const d=y();if(d)return new Promise(b=>{t.execFile(d,["--status"],l=>b(!l))})}else{const d=v();if(d)try{if((await k.promises.stat(d)).isFile())return!0}catch{}}return!1}function g(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(h)return parseInt(h[3])}function p(h){const d=process.env.SystemRoot;if(d){const b=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(d,b?"Sysnative":"System32",h)}}function y(){return p("wsl.exe")}function v(){return p("lxss\\LxssManager.dll")}}),define(te[56],ne([0,1,17,167,65,5,48]),function(V,e,S,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function I(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}e.isSuccess=I;function w(b){return b.res.statusCode===204}async function g(b){return w(b)?null:(await(0,S.streamToBuffer)(b.stream)).toString()}e.asText=g;async function p(b){if(!I(b))throw new Error("Server returned "+b.res.statusCode);return g(b)}e.asTextOrError=p;async function y(b){if(!I(b))throw new Error("Server returned "+b.res.statusCode);if(w(b))return null;const u=(await(0,S.streamToBuffer)(b.stream)).toString();try{return JSON.parse(u)}catch(m){throw m.message+=`:
`+u,m}}e.asJson=y;function v(b){d(b)}e.updateProxyConfigurationsScope=v;let h;function d(b){const l=A.Registry.as(k.Extensions.Configuration),u=h;h={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},l.updateConfigurations({add:[h],remove:u?[u]:[]})}d(2)}),define(te[225],ne([0,1,17,22]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(I){this.a=I}listen(I,w){throw new Error("Invalid listen")}call(I,w,g,p=t.CancellationToken.None){switch(w){case"request":return this.a.request(g[0],p).then(async({res:y,stream:v})=>{const h=await(0,S.streamToBuffer)(v);return[{statusCode:y.statusCode,headers:y.headers},h]});case"resolveProxy":return this.a.resolveProxy(g[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class M{constructor(I){this.a=I}async request(I,w){const[g,p]=await this.a.call("request",[I],w);return{res:g,stream:(0,S.bufferToStream)(p)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}}e.RequestChannelClient=M}),define(te[226],ne([0,1,227,11]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(A,I){return A.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:A.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function M(A,I,w={}){const g=(0,S.parse)(A),p=w.proxyUrl||k(g,I);if(!p)return null;const y=(0,S.parse)(p);if(!/^https?:$/.test(y.protocol||""))return null;const v={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,t.isBoolean)(w.strictSSL)?w.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((h,d)=>{V(["http-proxy-agent"],h,d)}))(v):new(await new Promise((h,d)=>{V(["https-proxy-agent"],h,d)}))(v)}e.getProxyAgent=M}),define(te[110],ne([0,1,46,9,168,22,45,13,4,30,144,61,8,126]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let d;async function b(u,m,C,E){return C["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(E)&&!C["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(E)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=v.Promises.withAsyncBody(async(R,i)=>{const r=new M.CancellationTokenSource;let n=1e4;const o=u.getValue("application.shellEnvironmentResolutionTimeout");typeof o=="number"&&(n=(0,h.clamp)(o,1,120)*1e3);const a=setTimeout(()=>{r.dispose(!0),i(new Error((0,k.localize)(0,null)))},n);try{R(await l(m,r.token))}catch(c){!(0,I.isCancellationError)(c)&&!r.token.isCancellationRequested?i(new Error((0,k.localize)(1,null,(0,A.toErrorMessage)(c)))):R({})}finally{clearTimeout(a),r.dispose()}})),d)}e.getResolvedShellEnv=b;async function l(u,m){const C=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",C);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",E);const R=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(R+"({.*})"+R),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",r);const n=await(0,p.getSystemShell)(w.OS,r);return u.trace("getUnixShellEnvironment#shell",n),new Promise((o,a)=>{if(m.isCancellationRequested)return a(new I.CancellationError);const c=(0,t.basename)(n);let s,f;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(s=`& '${process.execPath}' ${P} -p '''${R}'' + JSON.stringify(process.env) + ''${R}'''`,f=["-Login","-Command"]):(s=`'${process.execPath}' ${P} -p '"${R}" + JSON.stringify(process.env) + "${R}"'`,c==="tcsh"||c==="csh"?f=["-ic"]:f=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),s);const L=(0,S.spawn)(n,[...f,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});m.onCancellationRequested(()=>(L.kill(),a(new I.CancellationError))),L.on("error",G=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(G)),a(G)});const T=[];L.stdout.on("data",G=>T.push(G));const U=[];L.stderr.on("data",G=>U.push(G)),L.on("close",(G,H)=>{const K=Buffer.concat(T).toString("utf8");u.trace("getUnixShellEnvironment#raw",K);const se=Buffer.concat(U).toString("utf8");if(se.trim()&&u.trace("getUnixShellEnvironment#stderr",se),G||H)return a(new Error((0,k.localize)(2,null,G,H)));const Z=i.exec(K),ce=Z?Z[1]:"{}";try{const ge=JSON.parse(ce);C?ge.ELECTRON_RUN_AS_NODE=C:delete ge.ELECTRON_RUN_AS_NODE,E?ge.ELECTRON_NO_ATTACH_CONSOLE=E:delete ge.ELECTRON_NO_ATTACH_CONSOLE,delete ge.VSCODE_RESOLVING_ENVIRONMENT,delete ge.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",ge),o(ge)}catch(ge){u.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(ge)),a(ge)}})})}}),define(te[89],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,S.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[228],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class S{constructor(){this.b=new Map}c(){return new Promise((k,M)=>V(["vsda"],k,M))}async createNewMessage(k){try{const M=await this.c(),A=new M.validator;if(A){const I=String(S.a++);return this.b.set(I,A),{id:I,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,M){if(!k.id)return!0;const A=this.b.get(k.id);if(!A)return!1;this.b.delete(k.id);try{return A.validate(M)==="ok"}catch{return!1}}async sign(k){try{const M=await this.c(),A=new M.signer;if(A)return A.sign(k)}catch{}return k}}e.SignService=S,S.a=1}),define(te[34],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,S.createDecorator)("stateMainService")}),define(te[21],ne([0,1,14,42,8,3,2,4,35,11,5,6,34,27]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,p.createDecorator)("lifecycleMainService");var d;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(d=e.ShutdownReason||(e.ShutdownReason={}));var b;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(b=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let l=class It extends A.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(m,C,E){super(),this.v=m,this.w=C,this.y=E,this.c=this.B(new M.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new M.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(It.b),this.j&&this.w.removeItem(It.b)}C(){const m=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.isMacintosh&&this.n===0&&this.D(1))};S.app.addListener("before-quit",m);const C=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!I.isMacintosh)&&S.app.quit()};S.app.addListener("window-all-closed",C),S.app.once("will-quit",E=>{this.L("Lifecycle#app.on(will-quit)"),E.preventDefault(),this.D(1).finally(()=>{this.H(!1),S.app.removeListener("before-quit",m),S.app.removeListener("window-all-closed",C),S.app.quit()})})}D(m){if(this.s)return this.s;this.L("Lifecycle#onWillShutdown.fire()");const C=[];return this.f.fire({reason:m,join(E){C.push(E)}}),this.s=(async()=>{try{await k.Promises.settled(C)}catch(E){this.v.error(E)}try{await this.w.close()}catch(E){this.v.error(E)}})(),this.s}set phase(m){if(m<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===m)return;this.L(`lifecycle (main): phase changed (value: ${m})`),this.k=m;const C=this.u.get(this.k);C&&(C.open(),this.u.delete(this.k))}async when(m){if(m<=this.k)return;let C=this.u.get(m);C||(C=new k.Barrier,this.u.set(m,C)),await C.wait()}registerWindow(m){const C=new A.DisposableStore;this.n++,C.add(m.onWillLoad(R=>this.g.fire({window:m,workspace:R.workspace,reason:R.reason})));const E=(0,g.assertIsDefined)(m.win);E.on("close",R=>{const i=m.id;if(this.l.has(i)){this.l.delete(i);return}this.L(`Lifecycle#window.on('close') - window ID ${m.id}`),R.preventDefault(),this.unload(m,1).then(r=>{if(r){this.l.delete(i);return}this.l.add(i),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this.h.fire(m),m.close()})}),E.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${m.id}`),this.n--,C.dispose(),this.n===0&&(!I.isMacintosh||this.i)&&this.D(1)})}async reload(m,C){await this.unload(m,3)||m.reload(C)}unload(m,C){const E=this.t.get(m.id);if(E)return E;const R=this.F(m,C).finally(()=>{this.t.delete(m.id)});return this.t.set(m.id,R),R}async F(m,C){if(!m.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${m.id}`);const E=this.i?2:C,R=await this.I(m,E);return R?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${m.id})`),this.G(R)):(await this.J(m,E),!1)}G(m){return m?(this.H(!0),this.i=!1,!0):!1}H(m){this.r&&(this.r(m),this.r=void 0,this.p=void 0)}I(m,C){return new Promise(E=>{const R=this.m++,i=`vscode:ok${R}`,r=`vscode:cancel${R}`;t.validatedIpcMain.once(i,()=>{E(!1)}),t.validatedIpcMain.once(r,()=>{E(!0)}),m.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:r,reason:C})})}J(m,C){return new Promise(E=>{const i=`vscode:reply${this.m++}`;t.validatedIpcMain.once(i,()=>E()),m.send("vscode:onWillUnload",{replyChannel:i,reason:C})})}quit(m){return this.L(`Lifecycle#quit() - begin (willRestart: ${m})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(m&&this.w.setItem(It.b,!0),this.p=new Promise(C=>{this.r=C,this.L("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.p)}L(m){this.y.args["enable-smoke-test-driver"]?this.v.info(m):this.v.trace(m)}async relaunch(m){this.L("Lifecycle#relaunch()");const C=process.argv.slice(1);if(m?.addArgs&&C.push(...m.addArgs),m?.removeArgs)for(const i of m.removeArgs){const r=C.indexOf(i);r>=0&&C.splice(r,1)}const E=()=>{try{if(I.isWindows){const i=(0,w.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.v.error(i)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:C})};S.app.once("quit",E),await this.quit(!0)&&S.app.removeListener("quit",E)}async kill(m){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const C of S.BrowserWindow.getAllWindows())if(C&&!C.isDestroyed()){let E;C.webContents&&!C.webContents.isDestroyed()?E=new Promise(R=>C.once("closed",R)):E=Promise.resolve(),C.destroy(),await E}})()]),S.app.exit(m)}};l.b="lifecycle.quitAndRestart",l=pe([x(0,y.ILogService),x(1,v.IStateMainService),x(2,h.IEnvironmentMainService)],l),e.LifecycleMainService=l}),define(te[229],ne([0,1,4,3,2,5,21]),function(V,e,S,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,M.createDecorator)("keyboardLayoutMainService");let I=class extends k.Disposable{constructor(p){super(),this.a=this.B(new t.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,p.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const p=await new Promise((y,v)=>{V(["native-keymap"],y,v)});this.c=w(p),S.isCI||p.onDidChangeKeyboardLayout(()=>{this.c=w(p),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};I=pe([x(0,A.ILifecycleMainService)],I),e.KeyboardLayoutMainService=I;function w(g){const p=g.getKeyMap(),y=g.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:y}}}),define(te[230],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,S.createDecorator)("stateService")}),define(te[231],ne([0,1,8,17,11,33,16,6]),function(V,e,S,t,k,M,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class w{constructor(y,v,h){this.f=y,this.g=v,this.h=h,this.a=Object.create(null),this.b="",this.c=new S.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.g.error(y)}}getItem(y,v){const h=this.a[y];return(0,k.isUndefinedOrNull)(h)?v:h}setItem(y,v){this.setItems([{key:y,data:v}])}setItems(y){let v=!1;for(const{key:h,data:d}of y)this.a[h]!==d&&((0,k.isUndefinedOrNull)(d)?(0,k.isUndefined)(this.a[h])||(this.a[h]=void 0,v=!0):(this.a[h]=d,v=!0));v&&this.j()}removeItem(y){(0,k.isUndefined)(this.a[y])||(this.a[y]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.h.writeFile(this.f,t.VSBuffer.fromString(y)),this.b=y}catch(v){this.g.error(v)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=w;let g=class{constructor(y,v,h){this.a=new w(y.stateResource,v,h)}async init(){await this.a.init()}getItem(y,v){return this.a.getItem(y,v)}};g=pe([x(0,M.IEnvironmentService),x(1,I.ILogService),x(2,A.IFileService)],g),e.StateService=g}),define(te[232],ne([0,1,231]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends S.StateService{setItem(M,A){this.a.setItem(M,A)}setItems(M){this.a.setItems(M)}removeItem(M){this.a.removeItem(M)}close(){return this.a.close()}}e.StateMainService=t}),define(te[90],ne([0,1,4,35,7,30]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(g){if(S.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function I(g,p,y,v,h,d,b,l,u,m){const C=Object.create(null);C["common.machineId"]=b,C.sessionID=(0,M.generateUuid)()+Date.now(),C.commitHash=h,C.version=d,C["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),C["common.platform"]=(0,S.PlatformToString)(S.platform),C["common.nodePlatform"]=t.platform,C["common.nodeArch"]=v,C["common.product"]=m||"desktop",l&&(C["common.msftInternal"]=l);let E=0;const R=Date.now();Object.defineProperties(C,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-R,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),S.isLinuxSnap&&(C["common.snap"]="true");const i=A(y);i&&(C["common.platformDetail"]=i);try{const r=await g.readFile(k.URI.file(u));C["common.source"]=r.value.toString().slice(0,30)}catch{}return C}e.resolveCommonProperties=I;function w(g){const p=t.env.USERDNSDOMAIN;if(!p)return!1;const y=p.toLowerCase();return g.some(v=>y===v)}e.verifyMicrosoftInternalDomain=w}),define(te[29],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[233],ne([0,1,25,8,43,15,9,4,7,82,23,101,85,16,19,29]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const l=new Map;async function u(i,r){const n=`${i}::${r.join(":")}`,o=l.get(n);if(o)return o;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,s=new Map,f=2e4;function P(T,U,G,H){const K=U.substring(T.length+1);return t.Promises.withAsyncBody(async se=>{let Z;try{Z=await p.Promises.readdir(U,{withFileTypes:!0})}catch{se();return}if(H.count>=f){H.count+=Z.length,H.maxReached=!0,se();return}let ce=Z.length;if(ce===0){se();return}let ge=Z;H.count+Z.length>f&&(H.maxReached=!0,ce=f-H.count,ge=Z.slice(0,ce)),H.count+=Z.length;for(const _ of ge)if(_.isDirectory()){if(G.includes(_.name)||await P(T,(0,A.join)(U,_.name),G,H),--ce===0){se();return}}else{const $=_.name.lastIndexOf(".");if($>=0){const N=_.name.substring($+1);N&&c.set(N,(c.get(N)??0)+1)}for(const N of a)N.relativePathPattern?.test(K)!==!1&&N.filePattern.test(_.name)&&s.set(N.tag,(s.get(N.tag)??0)+1);if(--ce===0){se();return}}})}const L=t.Promises.withAsyncBody(async T=>{const U={count:0,maxReached:!1};await P(i,i,r,U);const G=await E(i);T({configFiles:m(s),fileTypes:m(c),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:G})});return l.set(n,L),L}e.collectWorkspaceStats=u;function m(i){return Array.from(i.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function C(){const i={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.virtualMachineHint.value()*100)}%`},r=S.cpus();return r&&r.length>0&&(i.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),i}e.getMachineInfo=C;async function E(i){try{const r=new Map,n=(0,A.join)(i,".vscode","launch.json"),o=await p.Promises.readFile(n),a=[],c=(0,k.parse)(o.toString(),a);if(a.length)return console.log(`Unable to parse ${n}`),[];if((0,k.getNodeType)(c)==="object"&&c.configurations)for(const s of c.configurations){const f=s.type;f&&(r.has(f)?r.set(f,r.get(f)+1):r.set(f,1))}return m(r)}catch{return[]}}e.collectLaunchConfigs=E;let R=class{constructor(r,n){this.c=r,this.d=n}f(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}g(r){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const o=S.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||n.push(`Load (avg):       ${S.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(g.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,y.listProcesses)(r.mainPID),this.k(r)]).then(async o=>{let[a,c]=o,s=this.m(r,a);return n.forEach(f=>{if((0,v.isRemoteDiagnosticError)(f))s+=`
${f.errorMessage}`,c+=`
${f.errorMessage}`;else if(s+=`

Remote: ${f.hostName}`,f.processes&&(s+=`
${this.m(r,f.processes)}`),f.workspaceMetadata){c+=`
|  Remote: ${f.hostName}`;for(const P of Object.keys(f.workspaceMetadata)){const L=f.workspaceMetadata[P];let T=`${L.fileCount} files`;L.maxFilesReached&&(T=`more than ${T}`),c+=`|    Folder (${P}): ${T}`,c+=this.h(L)}}}),{processInfo:s,workspaceInfo:c}})}async getSystemInfo(r,n){const{memory:o,vmHint:a,os:c,cpus:s}=C(),f={os:c,memory:o,cpus:s,vmHint:a,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return I.isWindows||(f.load=`${S.loadavg().map(P=>Math.round(P)).join(", ")}`),I.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(r,n){const o=[];return(0,y.listProcesses)(r.mainPID).then(async a=>(o.push(""),o.push(this.g(r)),o.push(""),o.push(this.m(r,a)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.k(r))),n.forEach(c=>{if((0,v.isRemoteDiagnosticError)(c))o.push(`
${c.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${c.hostName}`),o.push(this.f(c.machineInfo)),c.processes&&o.push(this.m(r,c.processes)),c.workspaceMetadata)for(const s of Object.keys(c.workspaceMetadata)){const f=c.workspaceMetadata[s];let P=`${f.fileCount} files`;f.maxFilesReached&&(P=`more than ${P}`),o.push(`Folder (${s}): ${P}`),o.push(this.h(f))}}),o.push(""),o.push(""),o.join(`
`)))}h(r){const n=[];let a=0;const c=(L,T)=>{const U=` ${L}(${T})`;a+U.length>60?(n.push(s),s="|                 ",a=s.length):a+=U.length,s+=U};let s="|      File types:";const f=10,P=r.fileTypes.length>f?f:r.fileTypes.length;for(let L=0;L<P;L++){const T=r.fileTypes[L];c(T.name,T.count)}if(n.push(s),r.configFiles.length>=0&&(s="|      Conf files:",a=0,r.configFiles.forEach(L=>{c(L.name,L.count)}),n.push(s)),r.launchConfigFiles.length>0){let L="|      Launch Configs:";r.launchConfigFiles.forEach(T=>{L+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),n.push(L)}return n.join(`
`)}j(r){const n=Math.max(...Object.keys(r).map(o=>o.length));return Object.keys(r).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${r[o]}`).join(`
                  `)}k(r){const n=[],o=[];return r.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const s=w.URI.revive(c);if(s.scheme===M.Schemas.file){const f=s.fsPath;o.push(u(f,["node_modules",".git"]).then(P=>{let L=`${P.fileCount} files`;P.maxFilesReached&&(L=`more than ${L}`),n.push(`|    Folder (${(0,A.basename)(f)}): ${L}`),n.push(this.h(P))}).catch(P=>{n.push(`|      Error: Unable to collect workspace stats for folder ${f} (${P.toString()})`)}))}else n.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(r,n){const o=new Map;r.windows.forEach(c=>o.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.n(r.mainPID,o,a,n,0),a.join(`
`)}n(r,n,o,a,c){const s=c===0;let f;s?f=a.pid===r?`${this.d.applicationName} main`:"remote agent":(f=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(f=`${f} (${n.get(a.pid)})`));const P=process.platform==="win32"?a.mem:S.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(P/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(a.children)&&a.children.forEach(L=>this.n(r,n,o,L,c+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:o}of r.folders){const a=w.URI.revive(o);if(a.scheme!==M.Schemas.file)continue;const c=a.fsPath;try{(await u(c,["node_modules",".git"])).fileTypes.forEach(f=>n.add(f.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const o=w.URI.revive(n);if(o.scheme!==M.Schemas.file)continue;const a=o.fsPath;try{const c=await u(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:s.name,count:s.count})}),c.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:s.name,count:s.count})}),c.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};R=pe([x(0,b.ITelemetryService),x(1,d.IProductService)],R),e.DiagnosticsService=R}),define(te[234],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(M){this.b=M}listen(M,A){throw new Error(`Event not found: ${A}`)}call(M,A,{eventName:I,data:w}){return this.b.forEach(g=>g.log(I,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class t{constructor(M){this.b=M}log(M,A){return this.b.call("log",{eventName:M,data:A}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(te[51],ne([0,1,44,11,3,18,55,90,29]),function(V,e,S,t,k,M,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class g{constructor(s){this.value=s}}e.TelemetryTrustedValue=g;class p{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,f){return Promise.resolve(void 0)}publicLog2(s,f){return this.publicLog(s,f)}publicLogError(s,f){return Promise.resolve(void 0)}publicLogError2(s,f){return this.publicLogError(s,f)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class y{async publicLog(s,f,P){}async publicLogError(s,f,P){}}e.NullEndpointTelemetryService=y,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(c,s){return k.Event.debounce(s.onDidChangeConfiguration,(P,L)=>{const T=P?new Set([...P.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:T}},1e3,!0)(P=>{P.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(P.source),configurationKeys:E(P.affectedKeys)})})}e.configurationTelemetry=v;function h(c,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!c.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=h;function d(c,s){return!(s.isBuilt||s.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=d;function b(c){const s=c.getValue(w.TELEMETRY_SETTING_ID),f=c.getValue(w.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(w.TELEMETRY_OLD_SETTING_ID)===!1||f===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function l(c){const s={},f={},P={};C(c,P);for(let L in P){L=L.length>150?L.substr(L.length-149):L;const T=P[L];typeof T=="number"?f[L]=T:typeof T=="boolean"?f[L]=T?1:0:typeof T=="string"?(T.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${T.length}`),s[L]=T.substring(0,8191)):typeof T<"u"&&T!==null&&(s[L]=T)}return{properties:s,measurements:f}}e.validateTelemetryData=l;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function m(c){if(!c)return"none";const s=(0,A.getRemoteName)(c);return u.has(s)?s:"other"}e.cleanRemoteAuthority=m;function C(c,s,f=0,P){if(!!c)for(const L of Object.getOwnPropertyNames(c)){const T=c[L],U=P?P+L:L;Array.isArray(T)?s[U]=(0,S.safeStringify)(T):T instanceof Date?s[U]=T.toISOString():(0,t.isObject)(T)?f<2?C(T,s,f+1,U+"."):s[U]=(0,S.safeStringify)(T):s[U]=T}}function E(c){if(!c)return[];const s=[];return R(s,"",c),s}function R(c,s,f){f&&typeof f=="object"&&!Array.isArray(f)?Object.keys(f).forEach(P=>R(c,s?`${s}.${P}`:P,f[P])):c.push(s)}function i(c,s){const f=c.msftInternalDomains||[],P=s.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(f)||P}e.isInternalTelemetry=i;function r(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=r;function n(c,s){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let f=c;const P=[];for(const G of s)for(;;){const H=G.exec(c);if(!H)break;P.push([H.index,G.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,T=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let U=0;for(f="";;){const G=T.exec(c);if(!G)break;const H=P.some(([K,se])=>G.index<se&&K<T.lastIndex);!L.test(G[0])&&!H&&(f+=c.substring(U,G.index)+"<REDACTED: user-file-path>",U=T.lastIndex)}return U<c.length&&(f+=c.substr(U)),f}function o(c){if(!c)return c;const s=c.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const P of f)if(P.regex.test(s))return`<REDACTED: ${P.label}>`;return c}function a(c,s){return(0,S.cloneAndChange)(c,f=>{if(f instanceof g)return f.value;if(typeof f=="string"){let P=f.replaceAll("%20"," ");P=n(P,s);for(const L of s)P=P.replace(L,"");return P=o(P),P}})}e.cleanData=a}),define(te[111],ne([0,1,26,193,88,4,7,13,35,51]),function(V,e,S,t,k,M,A,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function p(n,o){return n.uuid&&o.uuid?n.uuid===o.uuid:n.id===o.id?!0:(0,S.compareIgnoreCase)(n.id,o.id)===0}e.areSameExtensions=p;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(o){const a=o.manifest?o.manifest.version:o.version,c=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new v(o.identifier,a,c)}static parse(o){const a=y.exec(o);return a&&a[1]&&a[2]?new v({id:a[1]},a[2],a[4]||void 0):null}constructor(o,a,c="undefined"){this.version=a,this.targetPlatform=c,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof v?p(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=v;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(n){const o=h.exec(n);return o&&o[1]?[l(o[1]),o[2]]:[l(n),void 0]}e.getIdAndVersion=d;function b(n,o){return`${n}.${o}`}e.getExtensionId=b;function l(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=l;function u(n,o){return l(b(n,o))}e.getGalleryExtensionId=u;function m(n,o){const a=[],c=s=>{for(const f of a)if(f.some(P=>p(o(P),o(s))))return f;return null};for(const s of n){const f=c(s);f?f.push(s):a.push([s])}return a}e.groupByExtension=m;function C(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=C;function E(n){return{id:new g.TelemetryTrustedValue(n.identifier.id),name:new g.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function R(n,o){const a=[],c=o.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const s=c.shift();if(s&&a.every(f=>!p(f.identifier,{id:s}))){const f=n.filter(P=>p(P.identifier,{id:s}));f.length===1&&(a.push(f[0]),c.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=R;async function i(n,o){if(!M.isLinux)return!1;let a;try{a=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){o.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(s))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function r(n,o){const a=await i(n,o),c=(0,t.getTargetPlatform)(a?"alpine":M.platform,w.arch);return o.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=r}),define(te[235],ne([0,1,190,51]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(M,A,I,w,g,p,y){const v={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${A.nameShort})`};if((0,t.supportsTelemetry)(A,I)&&(0,t.getTelemetryLevel)(w)===3){const h=await(0,S.getServiceMachineId)(I,g,p),{machineId:d}=await y.getTelemetryInfo();v["X-Market-User-Id"]=h,v["VSCode-SessionId"]=d||h}return v}e.resolveMarketplaceHeaders=k}),define(te[236],ne([0,1,13,44,51]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const M="https://mobile.events.data.microsoft.com/OneCollector/1.0",A="https://mobile.events.data.microsoft.com/ping";async function I(g,p,y){const v=await new Promise((u,m)=>{V(["@microsoft/1ds-core-js"],u,m)}),h=await new Promise((u,m)=>{V(["@microsoft/1ds-post-js"],u,m)}),d=new v.AppInsightsCore,b=new h.PostChannel,l={instrumentationKey:g,endpointUrl:M,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(y){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:y};l.extensionConfig[b.identifier]=u}return d.initialize(l,[]),d.addTelemetryInitializer(u=>{p&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),d}class w{constructor(p,y,v,h,d){this.e=p,this.f=y,this.g=v,this.h=d,this.c=M,this.d=A,this.g||(this.g={}),typeof h=="function"?this.a=h():this.a=h,this.b=null}i(p){if(!!this.a){if(typeof this.a!="string"){p(this.a);return}this.b||(this.b=I(this.a,this.e,this.h)),this.b.then(y=>{p(y)},y=>{(0,S.onUnexpectedError)(y),console.error(y)})}}log(p,y){if(!this.a)return;y=(0,t.mixin)(y,this.g),y=(0,k.validateTelemetryData)(y);const v=this.f+"/"+p;try{this.i(h=>{h.pluginVersionString=y?.properties.version??"Unknown",h.track({name:v,baseData:{name:v,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(p=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,p(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=w}),define(te[112],ne([0,1,2,44,4,26,169,18,65,63,19,48,29,51]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(u,m,C){this.k=m,this.l=C,this.d={},this.i=new S.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,M.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(v.TELEMETRY_SETTING_ID)||E.affectsConfiguration(v.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(v.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,m){this.d[u]=m}m(){let u=(0,h.getTelemetryLevel)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const C=m.usage?3:m.error?2:0;u=Math.min(u,C)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,m=u.sessionID,C=u["common.machineId"],E=u["common.firstSessionDate"],R=u["common.msftInternal"];return{sessionId:m,machineId:C,firstSessionDate:E,msftInternal:R}}dispose(){this.i.dispose()}n(u,m,C){return this.g<m?Promise.resolve(void 0):this.c.then(E=>{C=(0,t.mixin)(C,this.d),C=(0,h.cleanData)(C,this.j),C=(0,t.mixin)(C,E),this.b.forEach(R=>R.log(u,C))},E=>{console.error(E)})}publicLog(u,m){return this.n(u,3,m)}publicLog2(u,m){return this.publicLog(u,m)}publicLogError(u,m){return this.h?this.n(u,2,m):Promise.resolve(void 0)}publicLogError2(u,m){return this.publicLogError(u,m)}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=pe([x(1,I.IConfigurationService),x(2,p.IProductService)],d),e.TelemetryService=d;function b(){const l=(0,A.localize)(0,null,g.default.nameLong),u=g.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=k.isWeb?"":(0,A.localize)(3,null),C=(0,A.localize)(4,null),E=(0,A.localize)(5,null),R=(0,A.localize)(6,null),i=(0,A.localize)(7,null),r=`
|       | ${C} | ${E} | ${R} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,A.localize)(8,null);return`
${l} ${u} ${m}

&nbsp;

${i}
${r}

&nbsp;

${n}
`}y.Registry.as(w.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(w.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,A.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,A.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[237],ne([0,1,284,236]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends t.AbstractOneDataSystemAppender{constructor(A,I,w,g){const p={sendPOST:(y,v)=>{const h={method:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data)}};try{const d=S.request(y.urlString,h,b=>{b.on("data",function(l){v(b.statusCode??200,b.headers,l.toString())}),b.on("error",function(l){v(0,{})})});d.write(y.data),d.end()}catch{v(0,{})}}};super(A,I,w,g,p)}}e.OneDataSystemAppender=k}),define(te[238],ne([0,1,4,82,29]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function M(A){let I=A.getItem(k.machineIdKey);return(typeof I!="string"||S.isMacintosh&&I==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(I=await(0,t.getMachineId)()),I}e.resolveMachineId=M}),define(te[113],ne([0,1,29,238]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function k(M){const A=await(0,t.resolveMachineId)(M);return M.setItem(S.machineIdKey,A),A}e.resolveMachineId=k}),define(te[239],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var S;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(S=e.ColorScheme||(e.ColorScheme={}));function t(M){return M===S.HIGH_CONTRAST_DARK||M===S.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(M){return M===S.DARK||M===S.HIGH_CONTRAST_DARK}e.isDark=k}),define(te[240],ne([0,1,120,3,2,5,48,239]),function(V,e,S,t,k,M,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var w;(function(l){function u(m){return m&&typeof m=="object"&&typeof m.id=="string"}l.isThemeColor=u})(w=e.ThemeColor||(e.ThemeColor={}));function g(l){return{id:l}}e.themeColorFromId=g;var p;(function(l){function u(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||w.isThemeColor(o.color))}l.isThemeIcon=u;const m=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function C(o){const a=m.exec(o);if(!a)return;const[,c]=a;return{id:c}}l.fromString=C;function E(o){return{id:o}}l.fromId=E;function R(o,a){let c=o.id;const s=c.lastIndexOf("~");return s!==-1&&(c=c.substring(0,s)),a&&(c=`${c}~${a}`),{id:c}}l.modify=R;function i(o){const a=o.id.lastIndexOf("~");if(a!==-1)return o.id.substring(a+1)}l.getModifier=i;function r(o,a){return o.id===a.id&&o.color?.id===a.color?.id}l.isEqual=r;function n(o,a){return{id:o.id,color:a?g(a):void 0}}l.asThemeIcon=n,l.asClassNameArray=S.CSSIcon.asClassNameArray,l.asClassName=S.CSSIcon.asClassName,l.asCSSSelector=S.CSSIcon.asCSSSelector})(p=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function y(l){switch(l){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(u){return this.a.push(u),this.b.fire(u),(0,k.toDisposable)(()=>{const m=this.a.indexOf(u);this.a.splice(m,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const h=new v;A.Registry.add(e.Extensions.ThemingContribution,h);function d(l){return h.onColorThemeChange(l)}e.registerThemingParticipant=d;class b extends k.Disposable{constructor(u){super(),this.k=u,this.h=u.getColorTheme(),this.B(this.k.onDidColorThemeChange(m=>this.n(m)))}n(u){this.h=u,this.updateStyles()}updateStyles(){}w(u,m){let C=this.h.getColor(u);return C&&m&&(C=m(C,this.h)),C?C.toString():null}}e.Themable=b}),define(te[66],ne([0,1,14,3,2,4,18,5,34]),function(V,e,S,t,k,M,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const g="#FFFFFF",p="#1E1E1E",y="#000000",v="#FFFFFF",h="theme",d="themeBackground",b="windowSplash";e.IThemeMainService=(0,I.createDecorator)("themeMainService");let l=class extends k.Disposable{constructor(m,C){super(),this.b=m,this.c=C,this.a=this.B(new t.Emitter),this.onDidChangeColorScheme=this.a.event,S.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.isWindows){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.isMacintosh){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.isLinux&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const m=this.getColorScheme();if(m.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return m.dark?y:v;let C=this.b.getItem(d,null);if(!C)switch(this.b.getItem(h,"vs-dark").split(" ")[0]){case"vs":C=g;break;case"hc-black":C=y;break;case"hc-light":C=v;break;default:C=p}return M.isMacintosh&&C.toUpperCase()===p&&(C="#171717"),C}saveWindowSplash(m,C){this.b.setItems([{key:h,data:C.baseTheme},{key:d,data:C.colorInfo.background},{key:b,data:C}]),typeof m=="number"&&this.f(m,C)}f(m,C){for(const E of S.BrowserWindow.getAllWindows())if(E.id===m){E.setBackgroundColor(C.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(b)}};l=pe([x(0,w.IStateMainService),x(1,A.IConfigurationService)],l),e.ThemeMainService=l}),define(te[114],ne([0,1,3,18,5,6]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var A;(function(b){b.Http="http",b.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function g(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=g,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=p,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=y;function v(b,l,u,m){if(u===1)return!1;if(u===2&&y(l)){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(C?.length===4&&parseInt(C[1])>=18)return!1}return b<1024}e.isPortPrivileged=v;class h{constructor(l,u,m){this.remoteAddress=l,this.localAddress=u,this.b=m,this.a=new S.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=h;let d=class{constructor(l,u){this.i=l,this.j=u,this.a=new S.Emitter,this.onTunnelOpened=this.a.event,this.b=new S.Emitter,this.onTunnelClosed=this.b.event,this.c=new S.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const l=this.j.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.e=l,l?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.f=l.elevation,this.g=l.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const l=[],u=Array.from(this.d.values());for(const m of u){const C=Array.from(m.values());for(const E of C){const R=await E.value;R&&l.push(R)}}return l}async dispose(){for(const l of this.d.values()){for(const{value:u}of l.values())await u.then(m=>m?.dispose());l.clear()}this.d.clear()}setEnvironmentTunnel(l,u,m,C,E){this.o(l,u,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:u,localAddress:m,privacy:C,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,u){(y(l)||p(l))&&(l=e.LOCALHOST_ADDRESSES[0]);const m=this.q(l,u);if(m)return++m.refcount,m.value}openTunnel(l,u,m,C,E=!1,R,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${m} on local port ${C}.`),!l)return;if(u||(u="localhost"),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(l,u,m,C,E,R,i);return r?r.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(n);return(n.tunnelRemoteHost!==u||n.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const u=this.d.get(l.tunnelRemoteHost);if(u){const m=u.get(l.tunnelRemotePort);m&&(m.refcount--,await this.n(l.tunnelRemoteHost,l.tunnelRemotePort,m))}}}}async n(l,u,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${u}.`);const C=m.value.then(async E=>{E&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.d.has(l)&&this.d.get(l).delete(u),C}}async closeTunnel(l,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${u} `);const m=this.d.get(l);if(m&&m.has(u)){const C=m.get(u);C.refcount=0,await this.n(l,u,C)}}o(l,u,m){this.d.has(l)||this.d.set(l,new Map),this.d.get(l).set(u,{refcount:1,value:m})}async p(l,u){const m=this.d.get(l);m&&(await m.get(u)||m.delete(u),m.size===0&&this.d.delete(l))}q(l,u){const m=[l];p(l)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):y(l)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const C=m.map(E=>this.d.get(E));for(const E of C){const R=E?.get(u);if(R)return R}}canTunnel(l){return!!g(l)}s(l,u,m,C,E,R,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${m} on local port ${C}.`);const r=m;this.h.add(r);const n=C===void 0?m:C,o={elevationRequired:E?this.isPortPrivileged(n):!1},a={remoteAddress:{host:u,port:m},localAddressPort:C,privacy:R,public:R?R!==I.Private:void 0,protocol:i},c=l.forwardPort(a,o);return c?(this.o(u,m,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),c}};d=pe([x(0,M.ILogService),x(1,t.IConfigurationService)],d),e.AbstractTunnelService=d}),define(te[241],ne([0,1,79,25,97,223,8,2,18,6,19,222,114,89,4]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function b(E,R,i,r,n){let o;for(let a=3;a&&(o?.dispose(),o=await new l(E,R,i,r,n).waitForReady(),!(n&&k.BROWSER_RESTRICTED_PORTS[n]||!k.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));a--);return o}class l extends I.Disposable{constructor(R,i,r,n,o){super(),this.j=i,this.k=o,this.privacy=v.TunnelPrivacyId.Private,this.i=new Map,this.a=R,this.b=S.createServer(),this.c=new A.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.l(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const R=this.k??this.tunnelRemotePort,i=(0,v.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,k.findFreePortFaster)(R,2,1e3,i),n=null;return this.b.listen(r,this.j),await this.c.wait(),n=this.b.address(),n||(r=0,this.b.listen(r,this.j),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async l(R){R.pause();const i=(0,v.isLocalhost)(this.tunnelRemoteHost)||(0,v.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,y.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),n=r.getSocket().socket,o=r.readEntireBuffer();r.dispose(),o.byteLength>0&&R.write(o.buffer),R.on("end",()=>{R.localAddress&&this.i.delete(R.localAddress),n.end()}),R.on("close",()=>n.end()),R.on("error",()=>{R.localAddress&&this.i.delete(R.localAddress),n.destroy()}),n.on("end",()=>R.end()),n.on("close",()=>R.end()),n.on("error",()=>{R.destroy()}),R.pipe(n),n.pipe(R),R.localAddress&&this.i.set(R.localAddress,()=>{R.end(),n.end()})}}let u=class extends v.AbstractTunnelService{constructor(R,i,r,n,o){super(i,o),this.t=R,this.u=r,this.v=n}isPortPrivileged(R){return(0,v.isPortPrivileged)(R,this.k,d.OS,t.release())}r(R,i,r,n,o,a,c){const s=this.q(i,r);if(s)return++s.refcount,s.value;if(this.e)return this.s(this.e,i,r,n,o,a,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${r} on local port ${n}.`);const f={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:R,signService:this.u,logService:this.i,ipcLogger:null},P=b(f,this.k,i,r,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,r,P),P}}};u=pe([x(1,g.ILogService),x(2,h.ISignService),x(3,p.IProductService),x(4,w.IConfigurationService)],u),e.BaseTunnelService=u;let m=class extends u{constructor(R,i,r,n){super(M.nodeSocketFactory,R,i,r,n)}};m=pe([x(0,g.ILogService),x(1,h.ISignService),x(2,p.IProductService),x(3,w.IConfigurationService)],m),e.TunnelService=m;let C=class extends I.Disposable{constructor(R,i,r,n){super(),this.b=R,this.c=i,this.f=r,this.g=n,this.a=new Map}async openTunnel(R,i,r,n,o,a,c,s){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${n} on local port ${o}.`),!this.a.has(R)){const f=new m(this.b,this.f,this.c,this.g);this.B(f),this.a.set(R,f),f.onTunnelClosed(async()=>{(await f.tunnels).length===0&&(f.dispose(),this.a.delete(R))})}return this.a.get(R).openTunnel(i,r,n,o,a,c,s)}};C=pe([x(0,g.ILogService),x(1,p.IProductService),x(2,h.ISignService),x(3,w.IConfigurationService)],C),e.SharedTunnelsService=C}),define(te[49],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,A)=>({type:"idle",updateType:M,error:A}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,S.createDecorator)("updateService")}),define(te[242],ne([0,1,4,170,65,48]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[243],ne([0,1,3,49]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(I){this.a=I}listen(I,w){switch(w){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${w}`)}call(I,w,g){switch(w){case"checkForUpdates":return this.a.checkForUpdates(g);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(g)}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=k;class M{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new S.Emitter,this.onStateChange=this.a.event,this.b=t.State.Uninitialized,this.c.listen("onStateChange")(w=>this.state=w),this.c.call("_getInitialState").then(w=>this.state=w)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.UpdateChannelClient=M}),define(te[91],ne([0,1,8,22,3,18,27,21,6,19,56,49]),function(V,e,S,t,k,M,A,I,w,g,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function v(d,b,l){return`${l.updateUrl}/api/update/${d}/${b}/${l.commit}`}e.createUpdateURL=v;let h=class{get state(){return this.b}d(b){this.j.info("update#setState",b.type),this.b=b,this.c.fire(b)}constructor(b,l,u,m,C,E){this.f=b,this.g=l,this.h=u,this.i=m,this.j=C,this.k=E,this.b=y.State.Uninitialized,this.c=new k.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.l(),l=this.m(b);if(!l){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(l),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(y.State.Idle(this.q())),b==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,u=>this.j.error(u))}l(){return(0,M.getMigratedSettingValue)(this.g,"update.mode","update.channel")}m(b){return b==="none"?void 0:this.k.quality}n(b=60*60*1e3){return(0,S.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(b){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(b)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(b){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){return this.a?await this.l()==="none"?!1:(await this.i.request({url:this.a},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(b){}q(){return 1}r(){}};h=pe([x(0,I.ILifecycleMainService),x(1,M.IConfigurationService),x(2,A.IEnvironmentMainService),x(3,p.IRequestService),x(4,w.ILogService),x(5,g.IProductService)],h),e.AbstractUpdateService=h}),define(te[244],ne([0,1,14,54,3,2,18,27,21,6,19,56,29,49,91]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let b=class extends d.AbstractUpdateService{get v(){return k.Event.fromNodeEventEmitter(S.autoUpdater,"error",(u,m)=>m)}get w(){return k.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return k.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(u,m,C)=>({url:m,version:C,productVersion:C}))}get y(){return k.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(u,m,C,E)=>({releaseNotes:m,version:C,productVersion:C,date:E}))}constructor(u,m,C,E,R,i,r){super(u,m,E,R,i,r),this.z=C,this.u=new M.DisposableStore}async initialize(){await super.initialize(),this.v(this.A,this,this.u),this.x(this.D,this,this.u),this.y(this.E,this,this.u),this.w(this.F,this,this.u)}A(u){this.j.error("UpdateService error:",u);const C=(this.state.type==="checking for updates"?this.state.explicit:!0)?u:void 0;this.d(h.State.Idle(1,C))}s(u){let m;this.k.darwinUniversalAssetId?m=this.k.darwinUniversalAssetId:m=process.arch==="x64"?"darwin":"darwin-arm64";const C=(0,d.createUpdateURL)(m,u,this.k);try{S.autoUpdater.setFeedURL({url:C})}catch(E){this.j.error("Failed to set update feed URL",E);return}return C}t(u){this.d(h.State.CheckingForUpdates(u)),S.autoUpdater.checkForUpdates()}D(u){this.state.type==="checking for updates"&&this.d(h.State.Downloading(u))}E(u){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:u.version}),this.d(h.State.Ready(u)))}F(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(h.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};pe([t.memoize],b.prototype,"v",null),pe([t.memoize],b.prototype,"w",null),pe([t.memoize],b.prototype,"x",null),pe([t.memoize],b.prototype,"y",null),b=pe([x(0,w.ILifecycleMainService),x(1,A.IConfigurationService),x(2,v.ITelemetryService),x(3,I.IEnvironmentMainService),x(4,y.IRequestService),x(5,g.ILogService),x(6,p.IProductService)],b),e.DarwinUpdateService=b}),define(te[245],ne([0,1,46,41,8,3,9,27,21,6,29,49]),function(V,e,S,t,k,M,A,I,w,g,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let v=class{get state(){return this.a}d(b){this.g.info("update#setState",b.type),this.a=b,this.b.fire(b)}constructor(b,l,u){if(this.f=b,this.g=u,this.a=y.State.Uninitialized,this.b=new M.Emitter,this.onStateChange=this.b.event,l.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(y.State.Idle(this.k())),this.h(30*1e3).then(void 0,m=>this.g.error(m))}h(b=60*60*1e3){return(0,k.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(b){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(b)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(b){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(b){}};v=pe([x(0,w.ILifecycleMainService),x(1,I.IEnvironmentMainService),x(2,g.ILogService)],v);let h=class extends v{constructor(b,l,u,m,C,E){super(u,m,C),this.o=b,this.p=l,this.q=E;const R=(0,t.watch)(A.dirname(this.o)),i=M.Event.fromNodeEventEmitter(R,"change",(a,c)=>c),r=M.Event.filter(i,a=>a==="current"),o=M.Event.debounce(r,(a,c)=>c,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{o.dispose(),R.close()})}m(){this.d(y.State.CheckingForUpdates(!1)),this.u().then(b=>{b?this.d(y.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.State.Idle(2)))},b=>{this.g.error(b),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.State.Idle(2,b.message||b))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+A.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const b=await new Promise((u,m)=>(0,t.realpath)(`${A.dirname(this.o)}/current`,(C,E)=>C?m(C):u(E))),l=A.basename(b);return this.p!==l}isLatestVersion(){return this.u().then(void 0,b=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};h=pe([x(2,w.ILifecycleMainService),x(3,I.IEnvironmentMainService),x(4,g.ILogService),x(5,p.ITelemetryService)],h),e.SnapUpdateService=h}),define(te[39],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,S.createDecorator)("IUriIdentityService")}),define(te[246],ne([0,1,39,191,16,20,127,3,2]),function(V,e,S,t,k,M,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class g{constructor(v){this.uri=v,this.time=g._clock++}touch(){return this.time=g._clock++,this}}g._clock=0;let p=class{constructor(v){this.g=v,this.c=new w.DisposableStore,this.f=2**16;const h=new Map,d=b=>{let l=h.get(b.scheme);return l===void 0&&(l=v.hasProvider(b)&&!this.g.hasCapability(b,1024),h.set(b.scheme,l)),l};this.c.add(I.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(b=>{h.delete(b.scheme)})),this.extUri=new M.ExtUri(d),this.d=new A.SkipList((b,l)=>this.extUri.compare(b,l,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,M.normalizePath)(v));const h=this.d.get(v);return h?h.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new g(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((d,b)=>d[1].touch<b[1].touch?1:d[1].touch>b[1].touch?-1:0);g._clock=0,this.d.clear();const h=this.f*.5;for(let d=0;d<h;d++)this.d.set(v[d][0],v[d][1].touch())}};p=pe([x(0,k.IFileService)],p),e.UriIdentityService=p,(0,t.registerSingleton)(S.IUriIdentityService,p,1)}),define(te[115],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,S.createDecorator)("urlService")}),define(te[247],ne([0,1,7]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(I){this.a=I}listen(I,w){throw new Error(`Event not found: ${w}`)}call(I,w,g){switch(w){case"handleURL":return this.a.handleURL(S.URI.revive(g[0]),g[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=t;class k{constructor(I){this.a=I}handleURL(I,w){return this.a.call("handleURL",[I.toJSON(),w])}}e.URLHandlerChannelClient=k;class M{constructor(I){this.a=I}async routeCall(I,w,g,p){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(g){const y=S.URI.revive(g);if(y&&y.query){const v=/\bwindowId=(\d+)/.exec(y.query);if(v){const h=v[1],d=new RegExp(`window:${h}`),b=I.connections.find(l=>d.test(l.ctx));if(b)return b}}}return this.a.routeCall(I,w,g,p)}routeEvent(I,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=M}),define(te[248],ne([0,1,8,2,7,19]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class A extends t.Disposable{constructor(){super(...arguments),this.a=new Set}open(g,p){const y=[...this.a.values()];return(0,S.first)(y.map(v=>()=>v.handleURL(g,p)),void 0,!1).then(v=>v||!1)}registerHandler(g){return this.a.add(g),(0,t.toDisposable)(()=>this.a.delete(g))}}e.AbstractURLService=A;let I=class extends A{constructor(g){super(),this.b=g}create(g){let{authority:p,path:y,query:v,fragment:h}=g||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return p&&y&&y.indexOf("/")!==0&&(y=`/${y}`),k.URI.from({scheme:this.b.urlProtocol,authority:p,path:y,query:v,fragment:h})}};I=pe([x(0,M.IProductService)],I),e.NativeURLService=I}),define(te[249],ne([0,1,14,8,3,2,4,7]),function(V,e,S,t,k,M,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(p){try{return I.URI.parse(p)}catch{return null}}class g{constructor(y,v,h,d,b){if(this.f=v,this.a=[],this.b=0,this.c=M.Disposable.None,this.d=new M.DisposableStore,this.a=y,A.isWindows){const m=d.isBuilt?[]:[`"${d.appRoot}"`];m.push("--open-url","--"),S.app.setAsDefaultProtocolClient(b.urlProtocol,process.execPath,m)}const l=k.Event.map(k.Event.fromNodeEventEmitter(S.app,"open-url",(m,C)=>({event:m,url:C})),({event:m,url:C})=>(m.preventDefault(),C));this.d.add(l(m=>{const C=w(m);!C||this.f.open(C,{originalUrl:m})})),h.getWindows().filter(m=>m.isReady).length>0?this.g():k.Event.once(h.onDidSignalReadyWindow)(this.g,this,this.d)}async g(){if(this.b++>10)return;const y=[];for(const v of this.a)await this.f.open(v.uri,{originalUrl:v.url})||y.push(v);y.length!==0&&(this.a=y,this.c=(0,t.disposableTimeout)(()=>this.g(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=g}),define(te[250],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,S.createDecorator)("webviewManagerService")}),define(te[251],ne([0,1,14,2,15,7]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class A extends t.Disposable{constructor(){super();const w=this.b.bind(this);S.protocol.registerFileProtocol(k.Schemas.vscodeWebview,w)}b(w,g){try{const p=M.URI.parse(w.url),y=A.a.get(p.path);if(typeof y=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${y}`,h=k.FileAccess.asFileUri(v);return g({path:decodeURIComponent(h.fsPath),headers:{...k.COI.getHeadersFromQuery(w.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return g({error:-10})}catch{}return g({error:-2})}}e.WebviewProtocolProvider=A,A.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(te[74],ne([0,1,4]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(p){return!!p.workspaceUri}e.isWorkspaceToOpen=t;function k(p){return!!p.folderUri}e.isFolderToOpen=k;function M(p){return!!p.fileUri}e.isFileToOpen=M;function A(p){const y=I(p),v=p.getValue("window.menuBarVisibility");return v==="default"||y==="native"&&v==="compact"||S.isMacintosh&&S.isNative?"classic":v}e.getMenuBarVisibility=A;function I(p){if(S.isWeb)return"custom";const y=p.getValue("window");if(y){if(S.isMacintosh&&y.nativeTabs===!0||S.isMacintosh&&y.nativeFullScreen===!1)return"native";const d=y.titleBarStyle;if(d==="native"||d==="custom")return d}return S.isLinux?"native":"custom"}e.getTitleBarStyle=I;function w(p){if(!S.isWindows||S.isWeb||I(p)==="native")return!1;const y=p.getValue("window.experimental.windowControlsOverlay.enabled");return typeof y=="boolean"?y:!0}e.useWindowControlsOverlay=w;function g(p=0){return Math.pow(1.2,p)}e.zoomLevelToZoomFactor=g}),define(te[116],ne([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var S;(function(I){I[I.INITIAL=1]="INITIAL",I[I.LOAD=2]="LOAD",I[I.RELOAD=3]="RELOAD"})(S=e.LoadReason||(e.LoadReason={}));var t;(function(I){I[I.CLOSE=1]="CLOSE",I[I.QUIT=2]="QUIT",I[I.RELOAD=3]="RELOAD",I[I.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(I=1){return{width:1024,height:768,mode:I}};e.defaultWindowState=k;var M;(function(I){I[I.Maximized=0]="Maximized",I[I.Normal=1]="Normal",I[I.Minimized=2]="Minimized",I[I.Fullscreen=3]="Fullscreen"})(M=e.WindowMode||(e.WindowMode={}));var A;(function(I){I[I.UNRESPONSIVE=1]="UNRESPONSIVE",I[I.PROCESS_GONE=2]="PROCESS_GONE",I[I.LOAD=3]="LOAD"})(A=e.WindowError||(e.WindowError={}))}),define(te[32],ne([0,1,5]),function(V,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,S.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(te[252],ne([0,1,14,22,3,68,2,30,71,106,6,19,32]),function(V,e,S,t,k,M,A,I,w,g,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var h;(function(b){b[b.Initial=1]="Initial",b[b.StoredCredentialsUsed=2]="StoredCredentialsUsed",b[b.LoginDialogShown=3]="LoginDialogShown"})(h||(h={}));let d=class extends A.Disposable{constructor(l,u,m,C,E){super(),this.g=l,this.h=u,this.i=m,this.j=C,this.k=E,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=h.Initial,this.f=void 0,this.l()}l(){const l=k.Event.fromNodeEventEmitter(S.app,"login",(u,m,C,E,R)=>({event:u,webContents:m,req:C,authInfo:E,callback:R}));this.B(l(this.m,this))}async m({event:l,authInfo:u,req:m,callback:C}){if(!u.isProxy)return;if(!this.b&&this.c===h.LoginDialogShown&&m.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}l.preventDefault();let E;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),E=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(u);try{E=await this.b}finally{this.b=void 0}}C(E?.username,E?.password)}async n(l){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const u=await this.p(l);if(u)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),u;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(l){this.g.trace("auth#doResolveProxyCredentials - enter",l);const u=String((0,M.hash)({scheme:l.scheme,host:l.host,port:l.port}));let m,C;try{const r=await this.i.getPassword(this.a,u);if(r){const n=JSON.parse(await this.j.decrypt(r));m=n.username,C=n.password}}catch(r){this.g.error(r)}if(this.c!==h.StoredCredentialsUsed&&typeof m=="string"&&typeof C=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=h.StoredCredentialsUsed,{username:m,password:C};const E=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!E){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${E.id} to handle proxy login`);const R={authInfo:l,username:this.f?.username??m,password:this.f?.password??C,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};E.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,R),this.c=h.LoginDialogShown;const i=await new Promise(r=>{const n=async(o,a,c)=>{if(a===R.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${E.id}`),E.win?.webContents.off("ipc-message",n),c){const s={username:c.username,password:c.password};try{if(c.remember){const f=await this.j.encrypt(JSON.stringify(s));await this.i.setPassword(this.a,u,f)}else await this.i.deletePassword(this.a,u)}catch(f){this.g.error(f)}r({username:s.username,password:s.password})}else r(void 0)};E.win?.webContents.on("ipc-message",n)});return this.f=i,i}};d=pe([x(0,p.ILogService),x(1,v.IWindowsMainService),x(2,w.ICredentialsMainService),x(3,g.IEncryptionMainService),x(4,y.IProductService)],d),e.ProxyAuthHandler=d}),define(te[253],ne([0,1,71,6,33,19,32,203]),function(V,e,S,t,k,M,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let w=class extends I.BaseCredentialsMainService{constructor(p,y,v,h){super(p),this.j=y,this.k=v,this.l=h,this.i=d=>{this.l.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new S.InMemoryCredentialsProvider,this.f;const p=await new Promise((y,v)=>{V(["keytar"],y,v)});return await p.findCredentials("test-keytar-loads"),this.f=p,this.f}};w=pe([x(0,t.ILogService),x(1,k.INativeEnvironmentService),x(2,M.IProductService),x(3,A.IWindowsMainService)],w),e.CredentialsNativeMainService=w}),define(te[254],ne([0,1,13,2,3,6,21,81,46,285,8,15,44,4,35,14,32]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const u=b.utilityProcess,m=typeof u<"u";let C=class Ut{constructor(r,n,o){this.d=r,this.f=o,this.c=!1,this.b=new Map,n.onWillShutdown(a=>{this.c=!0,a.join(this._waitForAllExit(6e3))})}dispose(){}g(r){const n=this.b.get(r);if(!n)throw new Error("Unknown extension host!");return n}onDynamicStdout(r){return this.g(r).onStdout}onDynamicStderr(r){return this.g(r).onStderr}onDynamicMessage(r){return this.g(r).onMessage}onDynamicError(r){return this.g(r).onError}onDynamicExit(r){return this.g(r).onExit}async canUseUtilityProcess(){return m}async createExtensionHost(r){if(this.c)throw(0,S.canceled)();const n=String(++Ut.a);let o;if(r){if(!m)throw new Error("Cannot use UtilityProcess!");o=new R(n,this.d,this.f)}else o=new E(n,this.d);return this.b.set(n,o),o.onExit(({pid:a,code:c,signal:s})=>{this.d.info(`Extension host with pid ${a} exited with code: ${c}, signal: ${s}.`),setTimeout(()=>{o.dispose(),this.b.delete(n)})}),{id:n}}async start(r,n){if(this.c)throw(0,S.canceled)();return this.g(r).start(n)}async enableInspectPort(r){if(this.c)throw(0,S.canceled)();const n=this.b.get(r);return n?n.enableInspectPort():!1}async kill(r){if(this.c)throw(0,S.canceled)();const n=this.b.get(r);!n||n.kill()}async _killAllNow(){for(const[,r]of this.b)r.kill()}async _waitForAllExit(r){const n=[];for(const[,o]of this.b)n.push(o.waitForExit(r));return p.Promises.settled(n).then(()=>{})}};C.a=0,C=pe([x(0,M.ILogService),x(1,A.ILifecycleMainService),x(2,l.IWindowsMainService)],C),e.ExtensionHostStarter=C;let E=class extends t.Disposable{constructor(r,n){super(),this.id=r,this.c=n,this._onStdout=this.B(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new k.Emitter),this.onError=this._onError.event,this._onExit=this.B(new k.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(r){h.isCI&&this.c.info("Calling fork to start extension host...");const n=I.StopWatch.create(!1);this.a=(0,w.fork)(y.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,v.mixin)({cwd:(0,d.cwd)()},r));const o=n.elapsed(),a=this.a.pid;this.c.info(`Starting extension host with pid ${a} (fork() took ${o} ms).`);const c=new g.StringDecoder("utf-8");this.a.stdout?.on("data",f=>{const P=typeof f=="string"?f:c.write(f);this._onStdout.fire(P)});const s=new g.StringDecoder("utf-8");this.a.stderr?.on("data",f=>{const P=typeof f=="string"?f:s.write(f);this._onStderr.fire(P)}),this.a.on("message",f=>{this._onMessage.fire(f)}),this.a.on("error",f=>{this._onError.fire({error:(0,S.transformErrorForSerialization)(f)})}),this.a.on("exit",(f,P)=>{this.b=!0,this._onExit.fire({pid:a,code:f,signal:P})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):h.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(r){if(!this.a)return;const n=this.a.pid;this.c.info(`Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,p.timeout)(r)]),this.b||(this.c.info(`Extension host with pid ${n} did not exit within ${r}ms.`),this.a.kill())}};E=pe([x(1,M.ILogService)],E);let R=class extends t.Disposable{constructor(r,n,o){super(),this.id=r,this.c=n,this.f=o,this.onError=k.Event.None,this._onStdout=this.B(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this.B(new k.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(r){const n=this.f.getWindowById(r.responseWindowId);if(!n){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const o=n.win;if(!o||o.isDestroyed()||o.webContents.isDestroyed()){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const a=`extensionHost${this.id}`,c=y.FileAccess.asFileUri("bootstrap-fork.js").fsPath,s=["--type=extensionHost","--skipWorkspaceStorageLock"],f=r.execArgv||[],P={...r.env},L=!0,T="pipe";for(const Z of Object.keys(P))P[Z]=String(P[Z]);this.c.info(`UtilityProcess<${this.id}>: Creating new...`),this.a=u.fork(c,s,{serviceName:a,env:P,execArgv:f,allowLoadingUnsignedLibraries:L,stdio:T});const U=new g.StringDecoder("utf-8");this.a.stdout?.on("data",Z=>{const ce=typeof Z=="string"?Z:U.write(Z);this._onStdout.fire(ce)});const G=new g.StringDecoder("utf-8");this.a.stderr?.on("data",Z=>{const ce=typeof Z=="string"?Z:G.write(Z);this._onStderr.fire(ce)}),this.a.on("message",Z=>{this._onMessage.fire(Z)}),this.B(k.Event.fromNodeEventEmitter(this.a,"spawn")(()=>{this.c.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const H=k.Event.fromNodeEventEmitter(this.a,"exit",Z=>Z);this.B(H(Z=>{this.c.info(`UtilityProcess<${this.id}>: received exit event with code ${Z}.`),this.b=!0,this._onExit.fire({pid:this.a.pid,code:Z,signal:""})}));const{port1:K,port2:se}=new b.MessageChannelMain;this.a.postMessage("null",[se]),o.webContents.postMessage(r.responseChannel,r.responseNonce,[K])}enableInspectPort(){return this.a?(this.c.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):!1):!1}kill(){!this.a||(this.c.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(r){if(!this.a)return;const n=this.a.pid;this.c.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,p.timeout)(r)]),this.b||(this.c.info(`UtilityProcess<${this.id}>: Extension host with pid ${n} did not exit within ${r}ms, will kill it now.`),this.a.kill())}};R=pe([x(1,M.ILogService),x(2,l.IWindowsMainService)],R)}),define(te[255],ne([0,1,14,24,4,7,23,18,61,5,6,115,32]),function(V,e,S,t,k,M,A,I,w,g,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,g.createDecorator)(e.ID);let h=class{constructor(b,l,u,m){this.a=b,this.b=l,this.c=u,this.d=m}async start(b,l){this.a.trace("Received data from other instance: ",b,l),k.isMacintosh&&S.app.focus({steal:!0});const u=this.e(b);if(u.length){let m=Promise.resolve();if(this.b.getWindowCount()===0){const C=(0,t.firstOrDefault)(await this.b.openEmptyWindow({context:4}));C&&(m=C.ready())}m.then(()=>{for(const{uri:C,url:E}of u)this.c.open(C,{originalUrl:E})})}else return this.f(b,l)}e(b){return b["open-url"]&&b._urls&&b._urls.length>0?(0,t.coalesce)(b._urls.map(l=>{try{return{uri:M.URI.parse(l),url:l}}catch{return null}})):[]}async f(b,l){const u=(0,w.isLaunchedFromCli)(l)?0:4;let m=[];const C=b.wait&&b.waitMarkerFilePath?M.URI.file(b.waitMarkerFilePath):void 0,E=b.remote||void 0,R={context:u,cli:b,userEnv:l,waitMarkerFileURI:C,remoteAuthority:E,forceProfile:b.profile,forceTempProfile:b["profile-temp"]};if(b.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(b.extensionDevelopmentPath,R);else if(!b._.length&&!b["folder-uri"]&&!b["file-uri"]){let i=!1;if(b["new-window"]||b["unity-launch"]||R.forceProfile||R.forceTempProfile)i=!0;else if(b["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!k.isMacintosh}if(i)m=await this.b.open({...R,forceNewWindow:!0,forceEmpty:!0});else{const r=this.b.getLastActiveWindow();r?(this.b.openExistingWindow(r,R),m=[r]):m=await this.b.open({...R,forceEmpty:!0})}}else m=await this.b.open({...R,forceNewWindow:b["new-window"],preferNewWindow:!b["reuse-window"]&&!b.wait,forceReuseWindow:b["reuse-window"],diffMode:b.diff,mergeMode:b.merge,addMode:b.add,noRecentEntry:!!b["skip-add-to-recently-opened"],gotoLineMode:b.goto});if(C&&m.length===1&&m[0])return Promise.race([m[0].whenClosedOrLoaded,(0,A.whenDeleted)(C.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};h=pe([x(0,p.ILogService),x(1,v.IWindowsMainService),x(2,y.IURLService),x(3,I.IConfigurationService)],h),e.LaunchMainService=h}),define(te[256],ne([0,1,14,3,2,251,32]),function(V,e,S,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends k.Disposable{constructor(g){super(),this.b=g,this.a=this.B(new t.Emitter),this.onFoundInFrame=this.a.event,this.B(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(g,p){let y;if(typeof g.windowId=="number"){const{windowId:v}=g,h=this.b.getWindowById(v);if(!h?.win)throw new Error(`Invalid windowId: ${v}`);y=h.win.webContents}else{const{webContentsId:v}=g;if(y=S.webContents.fromId(v),!y)throw new Error(`Invalid webContentsId: ${v}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(p)}async findInFrame(g,p,y,v){const d=this.c(g,p);if(typeof d.findInFrame=="function"){d.findInFrame(y,{findNext:v.findNext,forward:v.forward});const b=(l,u)=>{u.finalUpdate&&(this.a.fire(u),d.removeListener("found-in-frame",b))};d.on("found-in-frame",b)}}async stopFindInFrame(g,p,y){const h=this.c(g,p);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}c(g,p){const y=this.b.getWindowById(g.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${g}`);const v=y.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===p);if(!v)throw new Error(`Unknown frame: ${p}`);return v}};I=pe([x(0,A.IWindowsMainService)],I),e.WebviewMainService=I}),define(te[257],ne([0,1,8,3,2]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends k.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:w,getActiveWindowId:g}){super(),this.a=this.B(new k.DisposableStore),t.Event.latch(t.Event.any(I,w))(this.f,this,this.a),this.b=(0,S.createCancelablePromise)(()=>g()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=M}),define(te[28],ne([0,1,174,9,60,20,7,5,15]),function(V,e,S,t,k,M,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function g(n){const o=n;return typeof o?.id=="string"&&A.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=g;function p(n){return typeof n?.id=="string"&&!g(n)&&!v(n)}e.isEmptyWorkspaceIdentifier=p,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(n,o){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,t.basename)(n)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const a=n;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.toWorkspaceIdentifier=y;function v(n){const o=n;return typeof o?.id=="string"&&A.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=v;function h(n){const o=n;if(o?.uri)return{id:o.id,uri:A.URI.revive(o.uri)};const a=n;if(a?.configPath)return{id:a.id,configPath:A.URI.revive(a.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=h;var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d=e.WorkbenchState||(e.WorkbenchState={}));function b(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=b;function l(n){const o=n;return!!(o&&typeof o=="object"&&A.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=l;class u{constructor(o,a,c,s,f){this.h=o,this.j=c,this.k=s,this.l=f,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class m{constructor(o,a){this.raw=a,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,M.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function C(n){return new m({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=C,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(n,o){return M.extUriBiasedIgnorePathCase.isEqualOrParent(n,o.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function R(n){let o;return A.URI.isUri(n)?o=n:o=n.configuration,o?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=R;function i(n,o){return!E(n,o)&&!R(n)}e.isSavedWorkspace=i;function r(n){return(typeof n=="string"?(0,t.extname)(n):(0,M.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(te[57],ne([0,1,14,8,68,36,2,77,4,11,23,151,5,6,28]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,v.createDecorator)("dialogMainService");let b=class{constructor(u){this.d=u,this.a=new Map,this.b=new Map,this.c=new t.Queue}pickFileFolder(u,m){return this.e({...u,pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)},m)}pickFolder(u,m){return this.e({...u,pickFolders:!0,title:(0,y.localize)(1,null)},m)}pickFile(u,m){return this.e({...u,pickFiles:!0,title:(0,y.localize)(2,null)},m)}pickWorkspace(u,m){const C=(0,y.localize)(3,null),E=(0,M.mnemonicButtonLabel)((0,y.localize)(4,null)),R=d.WORKSPACE_FILTER;return this.e({...u,pickFiles:!0,title:C,filters:R,buttonLabel:E},m)}async e(u,m){const C={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(C.properties=void 0,u.pickFiles&&u.pickFolders&&(C.properties=["multiSelections","openDirectory","openFile","createDirectory"])),C.properties||(C.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&C.properties.push("treatPackageAsDirectory");const E=await this.showOpenDialog(C,(0,g.withNullAsUndefined)(m||S.BrowserWindow.getFocusedWindow()));if(E&&E.filePaths&&E.filePaths.length>0)return E.filePaths}f(u){if(u){let m=this.b.get(u.id);return m||(m=new t.Queue,this.b.set(u.id,m)),m}else return this.c}showMessageBox(u,m){return this.f(m).queue(async()=>m?S.dialog.showMessageBox(m,u):S.dialog.showMessageBox(u))}async showSaveDialog(u,m){const C=this.i(u,m);if(!C)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(m).queue(async()=>{let E;return m?E=await S.dialog.showSaveDialog(m,u):E=await S.dialog.showSaveDialog(u),E.filePath=this.g(E.filePath),E})}finally{(0,A.dispose)(C)}}g(u){return u&&w.isMacintosh&&(u=(0,I.normalizeNFC)(u)),u}h(u){return u.map(m=>this.g(m))}async showOpenDialog(u,m){u.defaultPath&&(await p.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const C=this.i(u,m);if(!C)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(m).queue(async()=>{let E;return m?E=await S.dialog.showOpenDialog(m,u):E=await S.dialog.showOpenDialog(u),E.filePaths=this.h(E.filePaths),E})}finally{(0,A.dispose)(C)}}i(u,m){if(!m)return A.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let C=this.a.get(m.id);C||(C=new Set,this.a.set(m.id,C));const E=(0,k.hash)(u);if(!C.has(E))return this.d.trace("[DialogMainService]: new file dialog lock created",u),C.add(E),(0,A.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),C?.delete(E),C?.size===0&&this.a.delete(m.id)})}};b=pe([x(0,h.ILogService)],b),e.DialogMainService=b}),define(te[258],ne([0,1,3,2,69,28]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class A extends t.Disposable{constructor(w,g){super(),this.f=w,this.g=g,this.b=this.B(new S.Emitter),this.c=new Map,this.h(g.applicationStorage,this.b)}h(w,g){this.B(S.Event.debounce(w.onDidChangeStorage,(p,y)=>(p?p.push(y):p=[y],p),A.a)(p=>{p.length&&g.fire(this.i(p,w))}))}i(w,g){const p=new Map,y=new Set;return w.forEach(v=>{const h=g.get(v.key);typeof h=="string"?p.set(v.key,h):y.add(v.key)}),{changed:Array.from(p.entries()),deleted:Array.from(y.values())}}listen(w,g,p){switch(g){case"onDidChangeStorage":{const y=p.profile?(0,k.revive)(p.profile):void 0;if(!y)return this.b.event;let v=this.c.get(y.id);return v||(v=this.B(new S.Emitter),this.h(this.g.profileStorage(y),v),this.c.set(y.id,v)),v.event}}throw new Error(`Event not found: ${g}`)}async call(w,g,p){const y=p.profile?(0,k.revive)(p.profile):void 0,v=(0,M.reviveIdentifier)(p.workspace),h=await this.j(y,v);switch(g){case"getItems":return Array.from(h.items.entries());case"updateItems":{const d=p;if(d.insert)for(const[b,l]of d.insert)h.set(b,l);d.delete?.forEach(b=>h.delete(b));break}case"isUsed":{const d=p.payload;if(typeof d=="string")return this.g.isUsed(d)}default:throw new Error(`Call not found: ${g}`)}}async j(w,g){let p;g?p=this.g.workspaceStorage(g):w?p=this.g.profileStorage(w):p=this.g.applicationStorage;try{await p.init()}catch(y){this.f.error(`StorageIPC#init: Unable to init ${g?"workspace":w?"profile":"application"} storage due to ${y}`)}return p}}e.StorageDatabaseChannel=A,A.a=100}),define(te[37],ne([0,1,68,3,2,20,7,171,33,16,5,6,28,40,39,8,30,26,11]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function C(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&A.URI.isUri(o.location)&&A.URI.isUri(o.globalStorageHome)&&A.URI.isUri(o.settingsResource)&&A.URI.isUri(o.keybindingsResource)&&A.URI.isUri(o.tasksResource)&&A.URI.isUri(o.snippetsHome)&&A.URI.isUri(o.extensionsResource))}e.isUserDataProfile=C,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,p.createDecorator)("IUserDataProfilesService");function E(n,o){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:A.URI.revive(n.location).with({scheme:o}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:o}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:o}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:o}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:o}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:o}),extensionsResource:A.URI.revive(n.extensionsResource)?.with({scheme:o}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=E;function R(n,o,a,c){return{id:n,name:o,location:a,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,M.joinPath)(a,"globalStorage"),settingsResource:(0,M.joinPath)(a,"settings.json"),keybindingsResource:(0,M.joinPath)(a,"keybindings.json"),tasksResource:(0,M.joinPath)(a,"tasks.json"),snippetsHome:(0,M.joinPath)(a,"snippets"),extensionsResource:(0,M.joinPath)(a,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=R;let i=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(o,a,c,s){super(),this.m=o,this.n=a,this.r=c,this.s=s,this.f=!1,this.g=this.B(new t.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new t.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new t.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new t.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new h.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,M.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(o){this.f!==o&&(this.t=void 0,this.f=o)}isEnabled(){return this.f}get u(){if(!this.t){const o=[];if(this.f)for(const f of this.G()){if(!f.name||!(0,m.isString)(f.name)||!f.location){this.s.warn("Skipping the invalid stored profile",f.location||f.name);continue}o.push(R((0,M.basename)(f.location),f.name,f.location,{shortName:f.shortName,useDefaultFlags:f.useDefaultFlags}))}const a=new h.ResourceMap,c=new Map,s=R((0,S.hash)(this.m.userRoamingDataHome.path).toString(16),(0,I.localize)(0,null),this.m.userRoamingDataHome);if(o.unshift({...s,extensionsResource:this.L()??s.extensionsResource,isDefault:!0}),o.length){const f=this.I();if(f.workspaces)for(const[P,L]of Object.entries(f.workspaces)){const T=A.URI.parse(P),U=A.URI.parse(L),G=o.find(H=>this.r.extUri.isEqual(H.location,U));G&&a.set(T,G)}if(f.emptyWindows)for(const[P,L]of Object.entries(f.emptyWindows)){const T=A.URI.parse(L),U=o.find(G=>this.r.extUri.isEqual(G.location,T));U&&c.set(P,U)}}this.t={profiles:o,workspaces:a,emptyWindows:c}}return this.t}async createTransientProfile(o){const a="Temp",c=new RegExp(`${(0,u.escapeRegExpCharacters)(a)}\\s(\\d+)`);let s=0;for(const P of this.profiles){const L=c.exec(P.name),T=L?parseInt(L[1]):0;s=T>s?T:s}const f=`${a} ${s+1}`;return this.createProfile((0,S.hash)((0,l.generateUuid)()).toString(16),f,{transient:!0},o)}async createNamedProfile(o,a,c){return this.createProfile((0,S.hash)((0,l.generateUuid)()).toString(16),o,a,c)}async createProfile(o,a,c,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const f=await this.v(o,a,c);return s&&await this.setProfileForWorkspace(s,f),f}async v(o,a,c){if(!(0,m.isString)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.k.get(a);return s||(s=(async()=>{try{const f=this.profiles.find(T=>T.name===a||T.id===o);if(f)return f;const P=R(o,a,(0,M.joinPath)(this.profilesHome,o),c);await this.n.createFolder(P.location);const L=[];return this.h.fire({profile:P,join(T){L.push(T)}}),await b.Promises.settled(L),this.z([P],[],[]),P}finally{this.k.delete(a)}})(),this.k.set(a,s)),s}async updateProfile(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(s=>s.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);return c=R(c.id,a.name??c.name,c.location,{shortName:a.shortName??c.shortName,transient:a.transient??c.isTransient,useDefaultFlags:a.useDefaultFlags??c.useDefaultFlags}),this.z([],[],[c]),c}async removeProfile(o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(o.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(s=>s.id===o.id);if(!a)throw new Error(`Profile '${o.name}' does not exist`);const c=[];this.i.fire({profile:a,join(s){c.push(s)}});try{await Promise.allSettled(c)}catch(s){this.s.error(s)}for(const s of[...this.u.emptyWindows.keys()])a.id===this.u.emptyWindows.get(s)?.id&&this.u.emptyWindows.delete(s);for(const s of[...this.u.workspaces.keys()])a.id===this.u.workspaces.get(s)?.id&&this.u.workspaces.delete(s);this.F(),this.z([],[a],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(a.location,{recursive:!0})}catch(s){this.s.error(s)}}async setProfileForWorkspace(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(s=>s.id===a.id);if(!c)throw new Error(`Profile '${a.name}' does not exist`);this.D(o,c)}unsetWorkspace(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(o,void 0,a)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const o=await this.n.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(a=>a.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,a.resource))).map(a=>this.n.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.l.profiles.filter(a=>!this.y(a));await Promise.allSettled(o.map(a=>this.removeProfile(a)))}getProfileForWorkspace(o){const a=this.w(o);return A.URI.isUri(a)?this.l.workspaces.get(a)??this.u.workspaces.get(a):this.l.emptyWindows.get(a)??this.u.emptyWindows.get(a)}w(o){return(0,v.isSingleFolderWorkspaceIdentifier)(o)?o.uri:(0,v.isWorkspaceIdentifier)(o)?o.configPath:o.id}y(o){return!!([...this.l.emptyWindows.values()].some(a=>this.r.extUri.isEqual(a.location,o.location))||[...this.l.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,o.location))||[...this.u.emptyWindows.values()].some(a=>this.r.extUri.isEqual(a.location,o.location))||[...this.u.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,o.location)))}z(o,a,c){const s=[...this.profiles,...o],f=[];this.l.profiles=[];for(let P of s)P.isDefault||a.some(L=>P.id===L.id)||(P=c.find(L=>P.id===L.id)??P,P.isTransient?this.l.profiles.push(P):f.push({location:P.location,name:P.name,shortName:P.shortName,useDefaultFlags:P.useDefaultFlags}));this.H(f),this.t=void 0,this.C(o,a,c)}C(o,a,c){this.g.fire({added:o,removed:a,updated:c,all:this.profiles})}D(o,a,c){c=a?.isTransient?!0:c,c||this.D(o,void 0,!0);const s=this.w(o),f=c?this.l:this.u;A.URI.isUri(s)?(f.workspaces.delete(s),a&&f.workspaces.set(s,a)):(f.emptyWindows.delete(s),a&&f.emptyWindows.set(s,a)),c||this.F()}F(){const o={};for(const[c,s]of this.u.workspaces.entries())o[c.toString()]=s.location.toString();const a={};for(const[c,s]of this.u.emptyWindows.entries())a[c.toString()]=s.location.toString();this.J({workspaces:o,emptyWindows:a}),this.t=void 0}G(){return[]}H(o){throw new Error("not implemented")}I(){return{}}J(o){throw new Error("not implemented")}L(){}};i.b="userDataProfiles",i.c="profileAssociations",i=pe([x(0,w.IEnvironmentService),x(1,g.IFileService),x(2,d.IUriIdentityService),x(3,y.ILogService)],i),e.UserDataProfilesService=i;class r extends i{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(o){this.a=o}I(){return this.O}J(o){this.O=o}}e.InMemoryUserDataProfilesService=r}),define(te[75],ne([0,1,8,17,2,3,40,7,111,88,16,5,6,37,39,11,13,29]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class C extends Error{constructor(n,o){super(n),this.code=o}}e.ExtensionsProfileScanningError=C,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let E=class extends k.Disposable{constructor(n,o,a,c,s,f){super(),this.h=n,this.i=o,this.j=a,this.k=c,this.l=s,this.m=f,this.a=this.B(new M.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new M.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new M.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new M.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new A.ResourceMap}scanProfileExtensions(n,o){return this.n(n,void 0,o)}async addExtensionsToProfile(n,o){const a=[],c=[];try{return await this.n(o,s=>{const f=[];for(const P of s)n.some(([L])=>(0,w.areSameExtensions)(L.identifier,P.identifier)&&L.manifest.version!==P.version)?a.push(P):f.push(P);for(const[P,L]of n)if(!f.some(T=>(0,w.areSameExtensions)(T.identifier,P.identifier)&&T.version===P.manifest.version)){const T={identifier:P.identifier,version:P.manifest.version,location:P.location,metadata:L};c.push(T),f.push(T)}return c.length&&this.a.fire({extensions:c,profileLocation:o}),a.length&&this.c.fire({extensions:a,profileLocation:o}),f}),c.length&&this.b.fire({extensions:c,profileLocation:o}),a.length&&this.f.fire({extensions:a,profileLocation:o}),c}catch(s){throw c.length&&this.b.fire({extensions:c,error:s,profileLocation:o}),a.length&&this.f.fire({extensions:a,error:s,profileLocation:o}),s}}async removeExtensionFromProfile(n,o){const a=[];this.c.fire({extensions:a,profileLocation:o});try{await this.n(o,c=>{const s=[];for(const f of c)(0,w.areSameExtensions)(f.identifier,n.identifier)?a.push(f):s.push(f);return a.length&&this.c.fire({extensions:a,profileLocation:o}),s}),a.length&&this.f.fire({extensions:a,profileLocation:o})}catch(c){throw a.length&&this.f.fire({extensions:a,error:c,profileLocation:o}),c}}async n(n,o,a){return this.v(n).queue(async()=>{let c=[],s;try{const f=await this.i.readFile(n);s=JSON.parse(f.value.toString())}catch(f){if((0,p.toFileOperationResult)(f)!==1)throw f;if(this.k.extUri.isEqual(n,this.j.defaultProfile.extensionsResource)&&(s=await this.u()),!s&&a?.bailOutWhenFileNotFound)throw new C((0,l.getErrorMessage)(f),"ERROR_PROFILE_NOT_FOUND")}if(s){Array.isArray(s)||this.p(n);let f=!1;for(const P of s){R(P)||this.p(n);let L;if((0,b.isString)(P.location))L=this.s(P.location);else{L=I.URI.revive(P.location);const T=this.r(L);T&&(f=!0,P.location=T)}c.push({identifier:P.identifier,location:L,version:P.version,metadata:P.metadata})}f&&await this.i.writeFile(n,t.VSBuffer.fromString(JSON.stringify(s)))}if(o){c=o(c);const f=c.map(P=>({identifier:P.identifier,version:P.version,location:this.r(P.location)??P.location.toJSON(),metadata:P.metadata}));await this.i.writeFile(n,t.VSBuffer.fromString(JSON.stringify(f)))}return c})}p(n){const o=new C(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:o.code}),o}r(n){return this.k.extUri.isEqualOrParent(n,this.h)?this.k.extUri.relativePath(this.h,n):void 0}s(n){return this.k.extUri.joinPath(this.h,n)}async u(){return this.t||(this.t=(async()=>{const n=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let o;try{o=(await this.i.readFile(n)).value.toString()}catch(c){if((0,p.toFileOperationResult)(c)===1)return;throw c}this.m.info("Migrating extensions from old default profile location",n.toString());let a;try{const c=JSON.parse(o);Array.isArray(c)&&c.every(s=>R(s))?a=c:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.m.error(c)}if(a)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,t.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",n.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(c){if((0,p.toFileOperationResult)(c)===3)this.m.info("Migration from old default profile location to new location is done by another window",n.toString(),this.j.defaultProfile.extensionsResource.toString());else throw c}try{await this.i.del(n)}catch(c){(0,p.toFileOperationResult)(c)!==1&&this.m.error(c)}return a})()),this.t}v(n){let o=this.g.get(n);return o||(o=new S.Queue,this.g.set(n,o)),o}};E=pe([x(1,p.IFileService),x(2,h.IUserDataProfilesService),x(3,d.IUriIdentityService),x(4,u.ITelemetryService),x(5,v.ILogService)],E),e.AbstractExtensionsProfileScannerService=E;function R(r){return(0,b.isObject)(r)&&(0,g.isIExtensionIdentifier)(r.identifier)&&(i(r.location)||(0,b.isString)(r.location))&&r.version&&(0,b.isString)(r.version)}function i(r){return r?(0,b.isString)(r.path)&&(0,b.isString)(r.scheme):!1}}),define(te[117],ne([0,1,24,8,44,17,13,43,137,2,15,9,4,20,189,98,11,7,156,33,111,88,188,16,5,6,19,3,69,75,37,39,186,187]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m,C,E,R,i,r,n,o,a,c,s,f,P,L,T,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var G;(function(_){function $(N,W){if(N===W)return!0;const z=Object.keys(N),Y=new Set;for(const oe of Object.keys(W))Y.add(oe);if(z.length!==Y.size)return!1;for(const oe of z){if(N[oe]!==W[oe])return!1;Y.delete(oe)}return Y.size===0}_.equals=$})(G=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let H=class extends g.Disposable{constructor($,N,W,z,Y,oe,ee,D,O,F,j,q){super(),this.systemExtensionsLocation=$,this.userExtensionsLocation=N,this.l=W,this.m=z,this.n=Y,this.p=oe,this.r=ee,this.s=D,this.t=O,this.u=F,this.v=j,this.w=q,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(Z,(0,h.joinPath)(this.m,R.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(Z,(0,h.joinPath)(this.m,R.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(se,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,E.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions($,N,W){const[z,Y]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(N)]),oe=W?await this.scanExtensionsUnderDevelopment($,[...z,...Y]):[];return this.F(z,Y,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const N=[];N.push(this.G(!!$.useCache,$.language)),N.push(this.H($.language,!!$.checkControlFile));const[W,z]=await Promise.all(N);return this.D([...W,...z],0,$,!1)}async scanUserExtensions($){const N=$.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",N);const W=this.v.extUri.isEqual($.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.J(N,!!$.profileLocation,1,!$.includeUninstalled,$.language,!0,W),Y=$.useCache&&!z.devMode&&z.excludeObsolete?this.j:this.k;let oe;try{oe=await Y.scanExtensions(z)}catch(ee){if(ee instanceof f.ExtensionsProfileScanningError&&ee.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),oe=await Y.scanExtensions(z);else throw ee}return oe=await this.D(oe,1,$,!0),this.s.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment($,N){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const W=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(z=>z.scheme===p.Schemas.file).map(async z=>{const Y=await this.J(z,!1,1,!0,$.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Y)).map(ee=>(ee.type=N.find(D=>(0,E.areSameExtensions)(D.identifier,ee.identifier))?.type??ee.type,this.k.validate(ee,Y)))}))).flat();return this.D(W,"development",$,!0)}return[]}async scanExistingExtension($,N,W){const z=await this.J($,!1,N,!0,W.language,!0,void 0),Y=await this.k.scanExtension(z);return!Y||!W.includeInvalid&&!Y.isValid?null:Y}async scanOneOrMultipleExtensions($,N,W){const z=await this.J($,!1,N,!0,W.language,!0,void 0),Y=await this.k.scanOneOrMultipleExtensions(z);return this.D(Y,N,W,!0)}async scanMetadata($){const N=(0,h.joinPath)($,"package.json"),W=(await this.r.readFile(N)).value.toString();return JSON.parse(W).__metadata}async updateMetadata($,N){const W=(0,h.joinPath)($,"package.json"),z=(await this.r.readFile(W)).value.toString(),Y=JSON.parse(z);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,Y.__metadata={...Y.__metadata,...N},await this.r.writeFile((0,h.joinPath)($,"package.json"),M.VSBuffer.fromString(JSON.stringify(Y,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch($){if($ instanceof f.ExtensionsProfileScanningError&&$.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw $}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const $=await this.scanUserExtensions({includeInvalid:!0});if($.length)await this.p.addExtensionsToProfile($.map(N=>[N,N.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,M.VSBuffer.fromString(JSON.stringify([])))}catch(N){(0,r.toFileOperationResult)(N)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.getErrorMessage)(N))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch($){this.s.error($)}finally{this.z=void 0}})()),this.z}async D($,N,W,z){return W.includeAllVersions||($=this.F(N===0?$:void 0,N===1?$:void 0,N==="development"?$:void 0,await this.getTargetPlatform(),z)),W.includeInvalid||($=$.filter(Y=>Y.isValid)),$.sort((Y,oe)=>{const ee=y.basename(Y.location.fsPath),D=y.basename(oe.location.fsPath);return ee<D?-1:ee>D?1:0})}F($,N,W,z,Y){const oe=(D,O,F)=>{if(D.isValid&&!O.isValid)return!1;if(D.isValid===O.isValid){if(Y&&d.gt(D.manifest.version,O.manifest.version))return this.s.debug(`Skipping extension ${O.location.path} with lower version ${O.manifest.version} in favour of ${D.location.path} with version ${D.manifest.version}`),!1;if(d.eq(D.manifest.version,O.manifest.version)){if(D.type===0)return this.s.debug(`Skipping extension ${O.location.path} in favour of system extension ${D.location.path} with same version`),!1;if(D.targetPlatform===z)return this.s.debug(`Skipping extension ${O.location.path} from different target platform ${O.targetPlatform}`),!1}}return F?this.s.warn(`Overwriting user extension ${D.location.path} with ${O.location.path}.`):this.s.debug(`Overwriting user extension ${D.location.path} with ${O.location.path}.`),!0},ee=new Map;return $?.forEach(D=>{const O=R.ExtensionIdentifier.toKey(D.identifier.id),F=ee.get(O);(!F||oe(F,D,!1))&&ee.set(O,D)}),N?.forEach(D=>{const O=R.ExtensionIdentifier.toKey(D.identifier.id),F=ee.get(O);if(!F&&$&&D.type===0){this.s.debug(`Skipping obsolete system extension ${D.location.path}.`);return}(!F||oe(F,D,!1))&&ee.set(O,D)}),W?.forEach(D=>{const O=R.ExtensionIdentifier.toKey(D.identifier.id),F=ee.get(O);(!F||oe(F,D,!0))&&ee.set(O,D),ee.set(O,D)}),[...ee.values()]}async G($,N){this.s.trace("Started scanning system extensions");const W=await this.J(this.systemExtensionsLocation,!1,0,!0,N,!0,void 0),Y=await($&&!W.devMode?this.i:this.k).scanExtensions(W);return this.s.trace("Scanned system extensions:",Y.length),Y}async H($,N){const W=this.t.isBuilt?[]:this.u.builtInExtensions;if(!W?.length)return[];this.s.trace("Started scanning dev system extensions");const z=N?await this.I():{},Y=[],oe=u.URI.file(y.normalize(y.join(p.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const D of W){const O=z[D.name]||"marketplace";switch(O){case"disabled":break;case"marketplace":Y.push((0,h.joinPath)(oe,D.name));break;default:Y.push(u.URI.file(O));break}}const ee=await Promise.all(Y.map(async D=>this.k.scanExtension(await this.J(D,!1,0,!0,$,!0,void 0))));return this.s.trace("Scanned dev system extensions:",ee.length),(0,S.coalesce)(ee)}async I(){try{const $=await this.r.readFile(this.l);return JSON.parse($.value.toString())}catch{return{}}}async J($,N,W,z,Y,oe,ee){const D=await this.f(Y??v.language),O=await this.L($),F=N&&!this.v.extUri.isEqual($,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,j=F?await this.L(F):void 0;return new K($,O,F,j,N,ee,W,z,oe,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Y,D)}async L($){try{const N=await this.r.stat($);if(typeof N.mtime=="number")return N.mtime}catch{}}};H=pe([x(4,P.IUserDataProfilesService),x(5,f.IExtensionsProfileScannerService),x(6,r.IFileService),x(7,o.ILogService),x(8,C.IEnvironmentService),x(9,a.IProductService),x(10,L.IUriIdentityService),x(11,n.IInstantiationService)],H),e.AbstractExtensionsScannerService=H;class K{constructor($,N,W,z,Y,oe,ee,D,O,F,j,q,X,B,Q){this.location=$,this.mtime=N,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=z,this.profile=Y,this.profileScanOptions=oe,this.type=ee,this.excludeObsolete=D,this.validate=O,this.productVersion=F,this.productDate=j,this.productCommit=q,this.devMode=X,this.language=B,this.translations=Q}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,N){return(0,h.isEqual)($.location,N.location)&&$.mtime===N.mtime&&(0,h.isEqual)($.applicationExtensionslocation,N.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&$.profile===N.profile&&k.equals($.profileScanOptions,N.profileScanOptions)&&$.type===N.type&&$.excludeObsolete===N.excludeObsolete&&$.validate===N.validate&&$.productVersion===N.productVersion&&$.productDate===N.productDate&&$.productCommit===N.productCommit&&$.devMode===N.devMode&&$.language===N.language&&G.equals($.translations,N.translations)}}e.ExtensionScannerInput=K;let se=class extends g.Disposable{constructor($,N,W,z,Y){super(),this.f=$,this.g=N,this.h=W,this.i=z,this.j=Y}async scanExtensions($){const N=$.profile?await this.l($):await this.k($);let W={};if($.excludeObsolete&&$.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();W=JSON.parse(z)}catch{}return(0,l.isEmptyObject)(W)?N:N.filter(z=>!W[E.ExtensionKey.create(z).toString()])}async k($){const N=await this.i.resolve($.location);if(!N.children?.length)return[];const W=await Promise.all(N.children.map(async z=>{if(!z.isDirectory||$.type===1&&(0,h.basename)(z.resource).indexOf(".")===0)return null;const Y=new K(z.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.profileScanOptions,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(Y)}));return(0,S.coalesce)(W).sort((z,Y)=>z.location.path<Y.location.path?-1:1)}async l($){let N=await this.m($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.h.extUri.isEqual($.location,$.applicationExtensionslocation)){N=N.filter(z=>!z.metadata?.isApplicationScoped);const W=await this.m($.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,$);N.push(...W)}return N}async m($,N,W){const z=await this.g.scanProfileExtensions($,W.profileScanOptions);if(!z.length)return[];const Y=await Promise.all(z.map(async oe=>{if(N(oe)){const ee=new K(oe.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(ee,oe.metadata)}return null}));return(0,S.coalesce)(Y)}async scanOneOrMultipleExtensions($){try{if(await this.i.exists((0,h.joinPath)($.location,"package.json"))){const N=await this.scanExtension($);return N?[N]:[]}else return await this.scanExtensions($)}catch(N){return this.j.error(`Error scanning extensions at ${$.location.path}:`,(0,A.getErrorMessage)(N)),[]}}async scanExtension($,N){try{let W=await this.scanExtensionManifest($.location);if(W){W.publisher||(W.publisher=R.UNDEFINED_PUBLISHER),N=N??W.__metadata,delete W.__metadata;const z=(0,E.getGalleryExtensionId)(W.publisher,W.name),Y=N?.id?{id:z,uuid:N.id}:{id:z},oe=N?.isSystem?0:$.type,ee=oe===0||!!N?.isBuiltin;U.ImplicitActivationEvents.updateManifest(W),W=await this.n($.location,W,K.createNlsConfiguration($));const D={type:oe,identifier:Y,manifest:W,location:$.location,isBuiltin:ee,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return $.validate?this.validate(D,$):D}}catch(W){$.type!==0&&this.j.error(W)}return null}validate($,N){let W=!0;const z=(0,i.validateExtensionManifest)(N.productVersion,N.productDate,N.location,$.manifest,$.isBuiltin);for(const[Y,oe]of z)Y===b.default.Error&&(W=!1,this.j.error(this.t(N.location,oe)));return $.isValid=W,$.validations=z,$}async scanExtensionManifest($){const N=(0,h.joinPath)($,"package.json");let W;try{W=(await this.i.readFile(N)).value.toString()}catch(Y){return(0,r.toFileOperationResult)(Y)!==1&&this.j.error(this.t($,(0,m.localize)(0,null,N.path,Y.message))),null}let z;try{z=JSON.parse(W)}catch{const oe=[];(0,I.parse)(W,oe);for(const ee of oe)this.j.error(this.t($,(0,m.localize)(1,null,N.path,ee.offset,ee.length,(0,w.getParseErrorMessage)(ee.error))));return null}return(0,I.getNodeType)(z)!=="object"?(this.j.error(this.t($,(0,m.localize)(2,null,N.path))),null):z}async n($,N,W){const z=await this.p($,N,W);if(z)try{const Y=[],oe=await this.r(z.default,Y);if(Y.length>0)return Y.forEach(D=>{this.j.error(this.t($,(0,m.localize)(3,null,z.default?.path,(0,w.getParseErrorMessage)(D.error))))}),N;if((0,I.getNodeType)(z)!=="object")return this.j.error(this.t($,(0,m.localize)(4,null,z.default?.path))),N;const ee=z.values||Object.create(null);return(0,T.localizeManifest)(N,ee,oe)}catch{}return N}async p($,N,W){const z=(0,h.joinPath)($,"package.nls.json"),Y=(O,F)=>{F.forEach(j=>{this.j.error(this.t($,(0,m.localize)(5,null,O?.path,(0,w.getParseErrorMessage)(j.error))))})},oe=O=>{this.j.error(this.t($,(0,m.localize)(6,null,O?.path)))},ee=`${N.publisher}.${N.name}`,D=W.translations[ee];if(D)try{const O=u.URI.file(D),F=(await this.i.readFile(O)).value.toString(),j=[],q=(0,I.parse)(F,j);return j.length>0?(Y(O,j),{values:void 0,default:z}):(0,I.getNodeType)(q)!=="object"?(oe(O),{values:void 0,default:z}):{values:q.contents?q.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let F;try{F=await this.s($,W)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const j=(await this.i.readFile(F.localized)).value.toString(),q=[],X=(0,I.parse)(j,q);return q.length>0?(Y(F.localized,q),{values:void 0,default:F.original}):(0,I.getNodeType)(X)!=="object"?(oe(F.localized),{values:void 0,default:F.original}):{values:X,default:F.original}}catch{return{values:void 0,default:F.original}}}}async r($,N){if($)try{const W=(await this.i.readFile($)).value.toString();return(0,I.parse)(W,N)}catch{}}s($,N){return new Promise((W,z)=>{const Y=oe=>{const ee=(0,h.joinPath)($,`package.nls.${oe}.json`);this.i.exists(ee).then(D=>{D&&W({localized:ee,original:(0,h.joinPath)($,"package.nls.json")});const O=oe.lastIndexOf("-");O===-1?W({localized:(0,h.joinPath)($,"package.nls.json"),original:null}):(oe=oe.substring(0,O),Y(oe))})};if(N.devMode||N.pseudo||!N.language)return W({localized:(0,h.joinPath)($,"package.nls.json"),original:null});Y(N.language)})}t($,N){return`[${$.path}]: ${N}`}};se=pe([x(1,f.IExtensionsProfileScannerService),x(2,L.IUriIdentityService),x(3,r.IFileService),x(4,o.ILogService)],se);let Z=class extends se{constructor($,N,W,z,Y,oe){super(N,W,z,Y,oe),this.y=$,this.v=this.B(new t.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions($){const N=await this.z();if(this.u=$,N&&N.input&&K.equals(N.input,this.u))return this.j.debug("Using cached extensions scan result",$.location.toString()),this.v.trigger(()=>this.D()),N.result.map(z=>(z.location=u.URI.revive(z.location),z));const W=await super.scanExtensions($);return await this.C({input:$,result:W}),W}async z(){try{const $=await this.i.readFile(this.y),N=JSON.parse($.value.toString());return{result:N.result,input:(0,s.revive)(N.input)}}catch($){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,A.getErrorMessage)($))}return null}async C($){try{await this.i.writeFile(this.y,M.VSBuffer.fromString(JSON.stringify($)))}catch(N){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,A.getErrorMessage)(N))}}async D(){if(!this.u)return;const $=await this.z();if(!$)return;const N=$.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(W,N))try{await this.i.del(this.y),this.w.fire()}catch(z){this.j.error(z)}}};Z=pe([x(2,f.IExtensionsProfileScannerService),x(3,L.IUriIdentityService),x(4,r.IFileService),x(5,o.ILogService)],Z);function ce(_,$){const N=(0,E.getExtensionId)(_.manifest.publisher,_.manifest.name);return{id:N,identifier:new R.ExtensionIdentifier(N),isBuiltin:_.type===0,isUserBuiltin:_.type===1&&_.isBuiltin,isUnderDevelopment:$,extensionLocation:_.location,uuid:_.identifier.uuid,targetPlatform:_.targetPlatform,..._.manifest}}e.toExtensionDescription=ce;class ge extends H{constructor($,N,W,z,Y,oe,ee,D,O,F,j,q){super($,N,(0,h.joinPath)(W,".vscode-oss-dev","extensions","control.json"),(0,h.joinPath)(z,R.MANIFEST_CACHE_FOLDER),Y,oe,ee,D,O,F,j,q),this.M=(async()=>{if(v.translationsConfigFile)try{const X=await this.r.readFile(u.URI.file(v.translationsConfigFile));return JSON.parse(X.value.toString())}catch{}return Object.create(null)})()}f($){return this.M}}e.NativeExtensionsScannerService=ge}),define(te[259],ne([0,1,6,37,39,29,75,16,33,7]),function(V,e,S,t,k,M,A,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let p=class extends A.AbstractExtensionsProfileScannerService{constructor(v,h,d,b,l,u){super(g.URI.file(v.extensionsPath),h,d,b,l,u)}};p=pe([x(0,w.INativeEnvironmentService),x(1,I.IFileService),x(2,t.IUserDataProfilesService),x(3,k.IUriIdentityService),x(4,M.ITelemetryService),x(5,S.ILogService)],p),e.ExtensionsProfileScannerService=p}),define(te[260],ne([0,1,7,33,75,117,16,5,6,19,39,37]),function(V,e,S,t,k,M,A,I,w,g,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let v=class extends M.NativeExtensionsScannerService{constructor(d,b,l,u,m,C,E,R){super(S.URI.file(m.builtinExtensionsPath),S.URI.file(m.extensionsPath),m.userHome,S.URI.file(m.userDataPath),d,b,l,u,m,C,E,R)}};v=pe([x(0,y.IUserDataProfilesService),x(1,k.IExtensionsProfileScannerService),x(2,A.IFileService),x(3,w.ILogService),x(4,t.INativeEnvironmentService),x(5,g.IProductService),x(6,p.IUriIdentityService),x(7,I.IInstantiationService)],v),e.ExtensionsScannerService=v}),define(te[261],ne([0,1,14,2,15,9,4,60,7,30,42,33,6,37]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends t.Disposable{constructor(l,u,m){super(),this.c=l,this.f=m,this.a=I.TernarySearchTree.forPaths(!A.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(l.appRoot),this.addValidFileRoot(l.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(l.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:l}=S.session;l.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(u,m)=>this.i(u,m)),l.protocol.interceptFileProtocol(k.Schemas.file,(u,m)=>this.h(u,m)),this.B((0,t.toDisposable)(()=>{l.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),l.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(l){const u=(0,M.normalize)(l);return this.a.get(u)?t.Disposable.None:(this.a.set(u,!0),(0,t.toDisposable)(()=>this.a.delete(u)))}h(l,u){const m=w.URI.parse(l.url);return this.f.error(`Refused to load resource ${m.fsPath} from ${k.Schemas.file}: protocol (original URL: ${l.url})`),u({error:-3})}i(l,u){const m=this.j(l);let C;return this.c.crossOriginIsolated&&((0,M.basename)(m)==="workbench.html"||(0,M.basename)(m)==="workbench-dev.html"?C=k.COI.CoopAndCoep:C=k.COI.getHeadersFromQuery(l.url)),this.a.findSubstr(m)?u({path:m,headers:C}):this.b.has((0,M.extname)(m).toLowerCase())?u({path:m}):(this.f.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${m} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${l.url})`),u({error:-3}))}j(l){const u=w.URI.parse(l.url),m=k.FileAccess.uriToFileUri(u);return(0,M.normalize)(m.fsPath)}createIPCObjectUrl(){let l;const u=w.URI.from({scheme:"vscode",path:(0,g.generateUuid)()}),m=u.toString(),C=async()=>l;return p.validatedIpcMain.handle(m,C),this.f.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:u,update:E=>l=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${m}.`),p.validatedIpcMain.removeHandler(m)}}}};d=pe([x(0,y.INativeEnvironmentService),x(1,h.IUserDataProfilesService),x(2,v.ILogService)],d),e.ProtocolMainService=d}),define(te[262],ne([0,1,14,42,8,3,2,15,11,103,27,21,6,63,64,66,45,37,38]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let C=class extends A.Disposable{constructor(R,i,r,n,o,a,c,s,f){super(),this.g=R,this.h=i,this.i=r,this.j=n,this.k=o,this.l=a,this.m=c,this.n=s,this.p=f,this.a=new k.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new M.Emitter),this.onDidError=M.Event.buffer(this.f.event),this.w=void 0,this.y=void 0,this.r()}r(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(R,i)=>this.s(R,i)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(R,i)=>this.t(R,i)),this.B(this.k.onWillShutdown(()=>this.u()))}async s(R,i){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const r=await this.connect();if(R.sender.isDestroyed())return r.close();R.sender.postMessage("vscode:createSharedProcessMessageChannelResult",i,[r])}t(R,i){this.l.trace("SharedProcess: onWorkerConnection",i);const r=new A.DisposableStore,n=a=>{!this.F()||(this.l.trace(`SharedProcess: disposing worker (reason: '${a}')`,i),r.dispose(),this.v("vscode:electron-main->shared-process=disposeWorker",i))},o=S.BrowserWindow.fromId(i.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!i.reply.channel){n("unavailable");return}r.add(M.Event.filter(this.k.onWillLoadWindow,a=>a.window.win===o)(()=>n("load"))),r.add(M.Event.fromNodeEventEmitter(o,"closed")(()=>n("closed"))),o.webContents.postMessage(i.reply.channel,i.reply.nonce,R.ports)}u(){const R=this.b;!R||(this.v("vscode:electron-main->shared-process=exit"),this.c&&(R.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{R.close()}catch{}this.b=void 0},0))}v(R,...i){if(!this.F()){this.l.warn(`Sending IPC message to channel '${R}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(R,...i)}catch(r){this.l.warn(`Error sending IPC message to channel '${R}' of shared process: ${(0,l.toErrorMessage)(r)}`)}}whenReady(){return this.w||(this.w=new Promise(R=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),R()}))),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C(),this.D(),await new Promise(R=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),R()}))})()),this.y}C(){const R=this.B(this.p.createIPCObjectUrl());this.b=new S.BrowserWindow({show:!1,backgroundColor:this.n.getBackgroundColor(),webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${R.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),R.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),product:h.default,policiesData:this.m.serialize()}),this.b.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}D(){!this.b||(this.c=R=>{this.l.trace("SharedProcess#close prevented"),R.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(R,i)=>this.f.fire({type:2,details:i})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(R,i,r)=>this.f.fire({type:3,details:{reason:r,exitCode:i}})))}async connect(){await this.z;const R=(0,w.assertIsDefined)(this.b);return(0,g.connect)(R)}async toggle(){await this.z,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}F(){const R=this.b;return R?!R.isDestroyed()&&!R.webContents.isDestroyed():!1}};C=pe([x(2,p.IEnvironmentMainService),x(3,u.IUserDataProfilesService),x(4,y.ILifecycleMainService),x(5,v.ILogService),x(6,m.IPolicyService),x(7,b.IThemeMainService),x(8,d.IProtocolMainService)],C),e.SharedProcess=C}),define(te[92],ne([0,1,8,3,2,73,11,104,5,37]),function(V,e,S,t,k,M,A,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,w.createDecorator)("storageService");var p;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(p=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var v;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(v=e.StorageTarget||(e.StorageTarget={}));function h(m){const C=m.get(e.TARGET_KEY);if(C)try{return JSON.parse(C)}catch{}return Object.create(null)}e.loadKeyTargets=h;class d extends k.Disposable{constructor(C={flushInterval:d.a}){super(),this.j=C,this.b=this.B(new t.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new t.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new t.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new S.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,S.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.J()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(C,E){if(E===e.TARGET_KEY){switch(C){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:C})}else this.b.fire({scope:C,key:E,target:this.F(C)[E]})}r(C){this.f.fire({reason:C})}get(C,E,R){return this.L(E)?.get(C,R)}getBoolean(C,E,R){return this.L(E)?.getBoolean(C,R)}getNumber(C,E,R){return this.L(E)?.getNumber(C,R)}store(C,E,R,i){if((0,A.isUndefinedOrNull)(E)){this.remove(C,R);return}this.t(()=>{this.u(C,R,i),this.L(R)?.set(C,E)})}remove(C,E){this.t(()=>{this.u(C,E,void 0),this.L(E)?.delete(C)})}t(C){this.b.pause(),this.c.pause();try{C()}finally{this.b.resume(),this.c.resume()}}keys(C,E){const R=[],i=this.F(C);for(const r of Object.keys(i))i[r]===E&&R.push(r);return R}u(C,E,R){const i=this.F(E);typeof R=="number"?i[C]!==R&&(i[C]=R,this.L(E)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[C]=="number"&&(delete i[C],this.L(E)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(C){switch(C){case-1:return this.D;case 0:return this.z;default:return this.w}}G(C){const E=this.L(C);return E?h(E):Object.create(null)}isNew(C){return this.getBoolean(e.IS_NEW_KEY,C)===!0}async flush(C=p.NONE){this.f.fire({reason:C});const E=this.L(-1),R=this.L(0),i=this.L(1);switch(C){case p.NONE:await S.Promises.settled([E?.whenFlushed()??Promise.resolve(),R?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await S.Promises.settled([E?.flush(0)??Promise.resolve(),R?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const C=this.L(-1)?.items??new Map,E=this.L(0)?.items??new Map,R=this.L(1)?.items??new Map;return u(C,E,R,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(C,E){return this.r(p.NONE),(0,g.isUserDataProfile)(C)?this.N(C,E):this.O(C,E)}H(C,E){return!(C.id===E.id||b(E)&&b(C))}I(C,E,R,i){this.t(()=>{if(i)for(const[r,n]of C)E.set(r,n);else{const r=new Set;for(const[n,o]of C)r.add(n),E.get(n)!==o&&this.n(R,n);for(const[n]of E.items)r.has(n)||this.n(R,n)}})}}e.AbstractStorageService=d,d.a=60*1e3;function b(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=b;class l extends d{constructor(){super(),this.p=this.B(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(C=>this.n(1,C))),this.B(this.P.onDidChangeStorage(C=>this.n(0,C))),this.B(this.p.onDidChangeStorage(C=>this.n(-1,C)))}L(C){switch(C){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(C){switch(C){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(C){return!1}}e.InMemoryStorageService=l;async function u(m,C,E,R,i,r){const n=U=>{try{return JSON.parse(U)}catch{return U}},o=new Map,a=new Map;m.forEach((U,G)=>{o.set(G,U),a.set(G,n(U))});const c=new Map,s=new Map;C.forEach((U,G)=>{c.set(G,U),s.set(G,n(U))});const f=new Map,P=new Map;E.forEach((U,G)=>{f.set(G,U),P.set(G,n(U))}),console.group(R!==i?`Storage: Application (path: ${R})`:`Storage: Application & Profile (path: ${R}, default profile)`);const L=[];if(o.forEach((U,G)=>{L.push({key:G,value:U})}),console.table(L),console.groupEnd(),console.log(a),R!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const U=[];c.forEach((G,H)=>{U.push({key:H,value:G})}),console.table(U),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${r})`);const T=[];f.forEach((U,G)=>{T.push({key:G,value:U})}),console.table(T),console.groupEnd(),console.log(P)}e.logStorage=u}),define(te[263],ne([0,1,24,8,3,2,9,81,7,23,104,148,6,92,29,28]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class l extends M.Disposable{get storage(){return this.f}constructor(r,n){super(),this.j=r,this.k=n,this.b=this.B(new k.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new k.Emitter),this.onDidCloseStorage=this.c.event,this.f=new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new t.DeferredPromise,this.whenInit=this.h.p,this.i=p.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===p.StorageState.None)try{const r=await this.n();this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(o=>this.b.fire({key:o}))),await this.m(r);const n=r.getBoolean(h.IS_NEW_KEY);n===void 0?r.set(h.IS_NEW_KEY,!0):n&&r.set(h.IS_NEW_KEY,!1)}catch(r){this.j.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.i=p.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===v.LogLevel.Trace?r=>this.j.trace(r):void 0,logError:r=>this.j.error(r)}}m(r){return r.init()}get items(){return this.f.items}get(r,n){return this.f.get(r,n)}set(r,n){return this.f.set(r,n)}delete(r){return this.f.delete(r)}async close(){const r=new I.StopWatch(!1);await this.s(),r.stop(),r.elapsed()>l.a&&await this.r(r),this.c.fire()}async r(r){if(!!this.path)try{const n=(0,S.top)(Array.from(this.f.items.entries()).map(([a,c])=>({key:a,length:c.length})),(a,c)=>c.length-a.length,5).map(a=>`${a.key}:${a.length}`).join(", "),o=(await this.k.stat(w.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${o}b, Large Keys: ${n}`)}catch(n){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async s(){this.g&&await this.g,this.i=p.StorageState.Closed,await this.f.close()}}l.a=2e3;class u extends l{get path(){if(!this.v.useInMemoryStorage)return(0,A.join)(this.u.globalStorageHome.fsPath,u.t)}constructor(r,n,o,a){super(o,a),this.u=r,this.v=n}async n(){return new p.Storage(new y.SQLiteStorageDatabase(this.path??y.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:p.StorageHint.STORAGE_IN_MEMORY})}}u.t="state.vscdb";class m extends u{constructor(r,n,o,a){super(r,n,o,a)}}e.ProfileStorageMain=m;class C extends u{constructor(r,n,o,a){super(n.defaultProfile,r,o,a)}async m(r){await super.m(r),this.z(r)}z(r){r.get(d.firstSessionDateStorageKey,void 0)===void 0&&r.set(d.firstSessionDateStorageKey,new Date().toUTCString());const o=r.get(d.currentSessionDateStorageKey,void 0),a=new Date().toUTCString();r.set(d.lastSessionDateStorageKey,typeof o>"u"?null:o),r.set(d.currentSessionDateStorageKey,a)}}e.ApplicationStorageMain=C;class E extends l{get path(){if(!this.w.useInMemoryStorage)return(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id,E.t)}constructor(r,n,o,a,c){super(o,c),this.v=r,this.w=n,this.y=a}async n(){const{storageFilePath:r,wasCreated:n}=await this.C();return new p.Storage(new y.SQLiteStorageDatabase(r,{logging:this.l()}),{hint:this.w.useInMemoryStorage?p.StorageHint.STORAGE_IN_MEMORY:n?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:y.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id),n=(0,A.join)(r,E.t);return await g.Promises.exists(r)?{storageFilePath:n,wasCreated:!1}:(await g.Promises.mkdir(r,{recursive:!0}),this.D(r),{storageFilePath:n,wasCreated:!0})}async D(r){let n;if((0,b.isSingleFolderWorkspaceIdentifier)(this.v)?n={folder:this.v.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.v)&&(n={workspace:this.v.configPath.toString()}),n)try{const o=(0,A.join)(r,E.u);await g.Promises.exists(o)||await g.Promises.writeFile(o,JSON.stringify(n,void 0,2))}catch(o){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.WorkspaceStorageMain=E,E.t="state.vscdb",E.u="workspace.json";class R extends l{get path(){}async n(){return new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=R}),define(te[264],ne([0,1,3,2,92]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class M extends t.Disposable{constructor(I,w,g){super(),this.b=I,this.c=w,this.f=g;const p=this.B(new t.MutableDisposable);this.a=this.B(new S.Emitter({onWillAddFirstListener:()=>p.value=this.g(),onDidRemoveLastListener:()=>p.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new t.DisposableStore;return I.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(w,g)=>(w?w.push(g.key):w=[g.key],w),100)(w=>this.h(w))),I.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(w,g)=>{w||(w=new Map);let p=w.get(g.profile.id);return p||w.set(g.profile.id,p={profile:g.profile,keys:[],storage:g.storage}),p.keys.push(g.key),w},100)(w=>this.i(w))),I}h(I){const w=I.includes(k.TARGET_KEY)?[this.c.defaultProfile]:[],g=[];if(I=I.filter(p=>p!==k.TARGET_KEY),I.length){const p=(0,k.loadKeyTargets)(this.b.applicationStorage.storage);g.push({profile:this.c.defaultProfile,changes:I.map(y=>({key:y,scope:0,target:p[y]}))})}this.j(w,g)}i(I){const w=[],g=new Map;for(const[p,y]of I.entries()){y.keys.includes(k.TARGET_KEY)&&w.push(y.profile);const v=y.keys.filter(h=>h!==k.TARGET_KEY);if(v.length){const h=(0,k.loadKeyTargets)(y.storage.storage);g.set(p,{profile:y.profile,changes:v.map(d=>({key:d,scope:0,target:h[d]}))})}}this.j(w,[...g.values()])}j(I,w){(I.length||w.length)&&this.a.fire({valueChanges:w,targetChanges:I})}listen(I,w,g){switch(w){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${w}`)}async call(I,w){throw new Error(`Call not found: ${w}`)}}e.ProfileStorageChangesListenerChannel=M}),define(te[265],ne([0,1,69,7,33,16,6,230,39,37]),function(V,e,S,t,k,M,A,I,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let p=class extends g.UserDataProfilesService{constructor(h,d,b,l){super(d,b,h,l),this.a=d}L(){return this.r.extUri.joinPath(t.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};p=pe([x(0,w.IUriIdentityService),x(1,k.INativeEnvironmentService),x(2,M.IFileService),x(3,A.ILogService)],p),e.ServerUserDataProfilesService=p;let y=class Lt extends p{constructor(h,d,b,l,u){super(d,b,l,u),this.N=h}G(){return(0,S.revive)(this.N.getItem(Lt.b,[]))}I(){return(0,S.revive)(this.N.getItem(Lt.c,{}))}L(){return this.r.extUri.joinPath(t.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y=pe([x(0,I.IStateService),x(1,w.IUriIdentityService),x(2,k.INativeEnvironmentService),x(3,M.IFileService),x(4,A.ILogService)],y),e.UserDataProfilesService=y}),define(te[52],ne([0,1,7,33,16,5,6,34,39,37,265]),function(V,e,S,t,k,M,A,I,w,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,M.refineServiceDecorator)(g.IUserDataProfilesService);let y=class dt extends p.UserDataProfilesService{constructor(h,d,b,l,u){super(h,d,b,l,u),this.R=h}setEnablement(h){super.setEnablement(h),this.f||(this.H([]),this.J({}))}getAssociatedEmptyWindows(){const h=[];for(const d of this.u.emptyWindows.keys())h.push({id:d});return h}H(h){h.length?this.R.setItem(dt.b,h):this.R.removeItem(dt.b)}J(h){h.emptyWindows||h.workspaces?this.R.setItem(dt.c,h):this.R.removeItem(dt.c)}I(){const h="workspaceAndProfileInfo",d=this.R.getItem(h,void 0);if(d){this.R.removeItem(h);const b=d.reduce((l,{workspace:u,profile:m})=>(l[S.URI.revive(u).toString()]=S.URI.revive(m).toString(),l),{});this.R.setItem(dt.c,{workspaces:b})}return super.I()}};y=pe([x(0,I.IStateMainService),x(1,w.IUriIdentityService),x(2,t.INativeEnvironmentService),x(3,k.IFileService),x(4,A.ILogService)],y),e.UserDataProfilesMainService=y}),define(te[93],ne([0,1,7,50,3,2,33,16,5,21,6,92,263,37,52,39]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,w.createDecorator)("storageMainService");let l=class extends M.Disposable{constructor(C,E,R,i,r,n){super(),this.c=C,this.f=E,this.g=R,this.h=i,this.i=r,this.j=n,this.a=void 0,this.b=this.B(new k.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(C=>{C.window.profile&&this.profileStorage(C.window.profile).init(),C.workspace&&this.workspaceStorage(C.workspace).init()})),this.B(this.h.onWillShutdown(C=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=C.reason,C.join(this.applicationStorage.close());for(const[,E]of this.n)C.join(E.close());for(const[,E]of this.r)C.join(E.close())})),this.B(this.g.onWillCreateProfile(C=>{C.join((async()=>{await this.i.exists(C.profile.globalStorageHome)||await this.i.createFolder(C.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(C=>{const E=this.n.get(C.profile.id);E&&C.join(E.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const C=new v.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,t.once)(C.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),C}profileStorage(C){if((0,y.isProfileUsingDefaultStorage)(C))return this.applicationStorage;let E=this.n.get(C.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${C.name})`),E=this.p(C),this.n.set(C.id,E);const R=this.B(E.onDidChangeStorage(i=>this.b.fire({...i,storage:E,profile:C})));(0,t.once)(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${C.name})`),this.n.delete(C.id),R.dispose()})}return E}p(C){return this.a===2?new v.InMemoryStorageMain(this.c,this.i):new v.ProfileStorageMain(C,this.k(),this.c,this.i)}workspaceStorage(C){let E=this.r.get(C.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${C.id})`),E=this.s(C),this.r.set(C.id,E),(0,t.once)(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${C.id})`),this.r.delete(C.id)})),E}s(C){return this.a===2?new v.InMemoryStorageMain(this.c,this.i):new v.WorkspaceStorageMain(C,this.k(),this.c,this.f,this.i)}isUsed(C){const E=S.URI.file(C);for(const R of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!R.path&&this.j.extUri.isEqualOrParent(S.URI.file(R.path),E))return!0;return!1}};l=pe([x(0,p.ILogService),x(1,A.IEnvironmentService),x(2,d.IUserDataProfilesMainService),x(3,g.ILifecycleMainService),x(4,I.IFileService),x(5,b.IUriIdentityService)],l),e.StorageMainService=l,e.IApplicationStorageMainService=(0,w.createDecorator)("applicationStorageMainService");let u=class extends y.AbstractStorageService{constructor(C,E){super(),this.p=C,this.s=E,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(C){if(C===-1)return this.s.applicationStorage.storage}M(C){if(C===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};u=pe([x(0,h.IUserDataProfilesService),x(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(te[266],ne([0,1,2,21,52,28,8,32]),function(V,e,S,t,k,M,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let w=class extends S.Disposable{constructor(p,y,v){super(),this.a=y,this.b=v,this.B(p.onWillLoadWindow(h=>{h.reason===2&&this.c(h.window)})),this.B(p.onBeforeCloseWindow(h=>this.c(h))),this.B(new A.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(p){const y=this.f(p),v=this.a.getProfileForWorkspace(y);v&&((0,M.isEmptyWorkspaceIdentifier)(y)||v.isTransient)&&(this.a.unsetWorkspace(y,v.isTransient),v.isTransient&&await this.a.cleanUpTransientProfiles())}f(p){return p.openedWorkspace??(0,M.toWorkspaceIdentifier)(p.backupPath,p.isExtensionDevelopmentHost)}g(){const p=this.a.getAssociatedEmptyWindows();if(p.length===0)return;const y=this.b.getWindows().map(v=>this.f(v));for(const v of p)y.some(h=>h.id===v.id)||this.a.unsetWorkspace(v,!1)}};w=pe([x(0,t.ILifecycleMainService),x(1,k.IUserDataProfilesMainService),x(2,I.IWindowsMainService)],w),e.UserDataProfilesHandler=w}),define(te[118],ne([0,1,20,7,28]),function(V,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function M(w,g,p){for(const v of w){const h=v.openedWorkspace;if((0,k.isWorkspaceIdentifier)(h)){const d=await p(h);if(d){if(d.folders.some(b=>S.extUriBiasedIgnorePathCase.isEqualOrParent(g,b.uri)))return v}else if(S.extUriBiasedIgnorePathCase.isEqualOrParent(g,h.configPath))return v}}const y=w.filter(v=>(0,k.isSingleFolderWorkspaceIdentifier)(v.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqualOrParent(g,v.openedWorkspace.uri));if(y.length)return y.sort((v,h)=>-(v.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function A(w,g){for(const p of w)if((0,k.isWorkspaceIdentifier)(p.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.configPath,g)||(0,k.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.uri,g))return p}e.findWindowOnWorkspaceOrFolder=A;function I(w,g){const p=y=>g.some(v=>S.extUriBiasedIgnorePathCase.isEqual(t.URI.file(v),t.URI.file(y)));for(const y of w)if(y.config?.extensionDevelopmentPath?.some(v=>p(v)))return y}e.findWindowOnExtensionDevelopmentPath=I}),define(te[267],ne([0,1,14,2,4,20,7,18,21,6,34,32,116,28]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class Ot extends t.Disposable{get state(){return this.b}constructor(E,R,i,r,n){super(),this.g=E,this.h=R,this.i=i,this.j=r,this.k=n,this.b=b(this.h.getItem(Ot.a)),this.c=void 0,this.f=!1,this.l()}l(){S.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(E=>this.p(E)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(E=>{E.newCount-E.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(E=>this.p(E))}m(){this.f=!0,this.n()}n(){const E=new Set,R={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!R.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(o=>!o.isExtensionDevelopmentHost)),n&&(R.lastActiveWindow=this.r(n),R.lastActiveWindow.uiState.mode===3&&E.add(R.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);i&&(R.lastPluginDevelopmentHostWindow=this.r(i),R.lastPluginDevelopmentHostWindow.uiState.mode===3&&(E.has(R.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!i.win?.isSimpleFullScreen()&&(R.lastPluginDevelopmentHostWindow.uiState.mode=1):E.add(R.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(R.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const o=this.r(n);return o.uiState.mode===3&&(E.has(o.uiState.display)?k.isMacintosh&&o.windowId!==R.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(o.uiState.mode=1):E.add(o.uiState.display)),o}));const r=u(R);this.h.setItem(Ot.a,r),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",r)}p(E){if(this.i.quitRequested)return;const R=this.r(E);E.isExtensionDevelopmentHost&&!E.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=R:!E.isExtensionDevelopmentHost&&E.openedWorkspace&&this.b.openedWindows.forEach(i=>{const r=(0,h.isWorkspaceIdentifier)(E.openedWorkspace)&&i.workspace?.id===E.openedWorkspace.id,n=(0,h.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&i.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(i.folderUri,E.openedWorkspace.uri);(r||n)&&(i.uiState=R.uiState)}),this.g.getWindowCount()===1&&(this.c=R)}r(E){return{windowId:E.id,workspace:(0,h.isWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace:void 0,folderUri:(0,h.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace.uri:void 0,backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.serializeWindowState()}}getNewWindowState(E){const R=this.s(E),i=this.k.getValue("window");if(R.mode===3){let r;R.hasDefaultState?r=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):r=!!(this.i.wasRestarted||i?.restoreFullscreen),r||(R.mode=1)}return R}s(E){const R=this.g.getLastActiveWindow();if(!E.extensionTestsPath){if(!!E.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=E.workspace;if((0,h.isWorkspaceIdentifier)(c)){const f=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===c.id).map(P=>P.uiState);if(f.length)return f[0]}if((0,h.isSingleFolderWorkspaceIdentifier)(c)){const f=this.state.openedWindows.filter(P=>P.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(P.folderUri,c.uri)).map(P=>P.uiState);if(f.length)return f[0]}else if(E.backupPath){const f=this.state.openedWindows.filter(P=>P.backupPath===E.backupPath).map(P=>P.uiState);if(f.length)return f[0]}const s=this.c||this.state.lastActiveWindow;if(!R&&s)return s.uiState}let i;const r=S.screen.getAllDisplays();if(r.length===1)i=r[0];else{if(k.isMacintosh){const c=S.screen.getCursorScreenPoint();i=S.screen.getDisplayNearestPoint(c)}!i&&R&&(i=S.screen.getDisplayMatching(R.getBounds())),i||(i=S.screen.getPrimaryDisplay()||r[0])}let n=(0,v.defaultWindowState)();n.x=Math.round(i.bounds.x+i.bounds.width/2-n.width/2),n.y=Math.round(i.bounds.y+i.bounds.height/2-n.height/2);const o=this.k.getValue("window");let a=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")n.mode=0,a=!1;else if(o.newWindowDimensions==="fullscreen")n.mode=3,a=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&R){const c=R.serializeWindowState();c.mode===3?n.mode=3:n=c,a=n.mode!==3&&o.newWindowDimensions==="offset"}}return a&&(n=this.t(n)),n.hasDefaultState=!0,n}t(E){if(this.g.getWindows().length===0)return E;E.x=typeof E.x=="number"?E.x:0,E.y=typeof E.y=="number"?E.y:0;const R=this.g.getWindows().map(i=>i.getBounds());for(;R.some(i=>i.x===E.x||i.y===E.y);)E.x+=30,E.y+=30;return E}};d.a="windowsState",d=pe([x(0,y.IWindowsMainService),x(1,p.IStateMainService),x(2,w.ILifecycleMainService),x(3,g.ILogService),x(4,I.IConfigurationService)],d),e.WindowsStateHandler=d;function b(C){const E={openedWindows:[]},R=C||{openedWindows:[]};return R.lastActiveWindow&&(E.lastActiveWindow=l(R.lastActiveWindow)),R.lastPluginDevelopmentHostWindow&&(E.lastPluginDevelopmentHostWindow=l(R.lastPluginDevelopmentHostWindow)),Array.isArray(R.openedWindows)&&(E.openedWindows=R.openedWindows.map(i=>l(i))),E}e.restoreWindowsState=b;function l(C){const E={uiState:C.uiState};return C.backupPath&&(E.backupPath=C.backupPath),C.remoteAuthority&&(E.remoteAuthority=C.remoteAuthority),C.folder&&(E.folderUri=A.URI.parse(C.folder)),C.workspaceIdentifier&&(E.workspace={id:C.workspaceIdentifier.id,configPath:A.URI.parse(C.workspaceIdentifier.configURIPath)}),E}function u(C){return{lastActiveWindow:C.lastActiveWindow&&m(C.lastActiveWindow),lastPluginDevelopmentHostWindow:C.lastPluginDevelopmentHostWindow&&m(C.lastPluginDevelopmentHostWindow),openedWindows:C.openedWindows.map(E=>m(E))}}e.getWindowsStateStoreData=u;function m(C){return{workspaceIdentifier:C.workspace&&{id:C.workspace.id,configURIPath:C.workspace.configPath.toString()},folder:C.folderUri&&C.folderUri.toString(),backupPath:C.backupPath,remoteAuthority:C.remoteAuthority,uiState:C.uiState}}}),define(te[94],ne([0,1,31,43,124,36,15,9,4,20,7,5,55,28]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,y.createDecorator)("workspacesService");function d(P){return P.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function b(P){return P.hasOwnProperty("folderUri")}e.isRecentFolder=b;function l(P){return P.hasOwnProperty("fileUri")}e.isRecentFile=l;function u(P){return m(P)||C(P)}e.isStoredWorkspaceFolder=u;function m(P){const L=P;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function C(P){const L=P;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function E(P,L,T,U,G){if(P.scheme!==U.scheme)return{name:T,uri:P.toString(!0)};let H=L?void 0:G.relativePath(U,P);if(H!==void 0)H.length===0?H=".":w.isWindows&&(H=R(H));else if(P.scheme===A.Schemas.file)H=P.fsPath,w.isWindows&&(H=R(H));else if(G.isEqualAuthority(P.authority,U.authority))H=P.path;else return{name:T,uri:P.toString(!0)};return{name:T,path:H}}e.getStoredWorkspaceFolder=E;function R(P){return P=(0,M.normalizeDriveLetter)(P),(0,S.isUNC)(P)||(P=(0,S.toSlashes)(P)),P}function i(P,L,T){const U=[],G=new Set,H=T.dirname(L);for(const K of P){let se;if(m(K))K.path&&(se=T.resolvePath(H,K.path));else if(C(K))try{se=p.URI.parse(K.uri),se.path[0]!==I.posix.sep&&(se=se.with({path:I.posix.sep+se.path}))}catch(Z){console.warn(Z)}if(se){const Z=T.getComparisonKey(se);if(!G.has(Z)){G.add(Z);const ce=K.name||T.basenameOrAuthority(se);U.push(new h.WorkspaceFolder({uri:se,name:ce,index:U.length},K))}}}return U}e.toWorkspaceFolders=i;function r(P,L,T,U,G){const H=n(L,P),K=G.dirname(L),se=G.dirname(U),Z=[];for(const $ of H.folders){const N=m($)?G.resolvePath(K,$.path):p.URI.parse($.uri);let W;T?W=!1:W=!m($)||(0,I.isAbsolute)($.path),Z.push(E(N,W,$.name,se,G))}const ce={insertSpaces:!1,tabSize:4,eol:w.isLinux||w.isMacintosh?`
`:`\r
`},ge=k.setProperty(P,["folders"],Z,ce);let _=k.applyEdits(P,ge);return(0,g.isEqualAuthority)(H.remoteAuthority,(0,v.getRemoteAuthority)(U))&&(_=k.applyEdits(_,k.removeProperty(_,["remoteAuthority"],ce))),_}e.rewriteWorkspaceFileForNewLocation=r;function n(P,L){const T=t.parse(L);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(U=>u(U));else throw new Error(`${P} looks like an invalid workspace file.`);return T}function o(P){return P.workspace&&typeof P.workspace=="object"&&typeof P.workspace.id=="string"&&typeof P.workspace.configPath=="string"}function a(P){return typeof P.folderUri=="string"}function c(P){return typeof P.fileUri=="string"}function s(P,L){const T={workspaces:[],files:[]};if(P){const U=function(H,K){for(let se=0;se<H.length;se++)try{K(H[se],se)}catch(Z){L.warn(`Error restoring recent entry ${JSON.stringify(H[se])}: ${Z.toString()}. Skip entry.`)}},G=P;Array.isArray(G.entries)&&U(G.entries,H=>{const K=H.label,se=H.remoteAuthority;o(H)?T.workspaces.push({label:K,remoteAuthority:se,workspace:{id:H.workspace.id,configPath:p.URI.parse(H.workspace.configPath)}}):a(H)?T.workspaces.push({label:K,remoteAuthority:se,folderUri:p.URI.parse(H.folderUri)}):c(H)&&T.files.push({label:K,remoteAuthority:se,fileUri:p.URI.parse(H.fileUri)})})}return T}e.restoreRecentlyOpened=s;function f(P){const L={entries:[]};for(const T of P.workspaces)b(T)?L.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):L.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of P.files)L.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return L}e.toStoreData=f}),define(te[95],ne([0,1,78,15,4,20]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function A(g){function p(){let y=g.scheme===t.Schemas.file?(0,M.originalFSPath)(g):g.toString();return k.isLinux||(y=y.toLowerCase()),(0,S.createHash)("md5").update(y).digest("hex")}return{id:p(),configPath:g}}e.getWorkspaceIdentifier=A;function I(g,p){function y(){if(g.scheme!==t.Schemas.file)return(0,S.createHash)("md5").update(g.toString()).digest("hex");if(!p)return;let h;return k.isLinux?h=p.ino:k.isMacintosh?h=p.birthtime.getTime():k.isWindows&&(typeof p.birthtimeMs=="number"?h=Math.floor(p.birthtimeMs):h=p.birthtime.getTime()),(0,S.createHash)("md5").update(g.fsPath).update(h?String(h):"").digest("hex")}const v=y();if(typeof v=="string")return{id:v,uri:g}}e.getSingleFolderWorkspaceIdentifier=I;function w(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=w}),define(te[268],ne([0,1,78,31,15,9,4,20,23,178,18,27,34,16,6,177,28,95]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let m=class Tt{constructor(E,R,i,r){this.j=E,this.k=R,this.l=i,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.extUriBiasedIgnorePathCase,this.i={isEqual:(n,o)=>(0,t.isEqual)(n,o,!A.isLinux)}}async initialize(){const E=this.m.getItem(Tt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(E.emptyWindows),this.d=await this.u((0,g.deserializeWorkspaceInfos)(E)),this.e=await this.v((0,g.deserializeFolderInfos)(E)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==h.HotExitConfiguration.OFF}q(){return this.s()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(E,R){this.d.some(r=>E.workspace.id===r.workspace.id)||(this.d.push(E),this.C());const i=(0,M.join)(this.c,E.workspace.id);return R?this.t(i,R).then(()=>i):i}async t(E,R){if(await w.Promises.exists(E)&&await this.z(E),await w.Promises.exists(R))try{await w.Promises.rename(R,E)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(E){return this.e.some(R=>this.h.isEqual(E.folderUri,R.folderUri))||(this.e.push(E),this.C()),(0,M.join)(this.c,this.D(E))}registerEmptyWindowBackup(E){return this.g.some(R=>!!R.backupFolder&&this.i.isEqual(R.backupFolder,E.backupFolder))||(this.g.push(E),this.C()),(0,M.join)(this.c,E.backupFolder)}async u(E){if(!Array.isArray(E))return[];const R=new Set,i=[];for(const r of E){const n=r.workspace;if(!(0,l.isWorkspaceIdentifier)(n))return[];if(!R.has(n.id)){R.add(n.id);const o=(0,M.join)(this.c,n.id);await this.B(o)?n.configPath.scheme!==k.Schemas.file||await w.Promises.exists(n.configPath.fsPath)?i.push(r):await this.z(o):await this.x(o)}}return i}async v(E){if(!Array.isArray(E))return[];const R=[],i=new Set;for(const r of E){const n=r.folderUri,o=this.h.getComparisonKey(n);if(!i.has(o)){i.add(o);const a=(0,M.join)(this.c,this.D(r));await this.B(a)?n.scheme!==k.Schemas.file||await w.Promises.exists(n.fsPath)?R.push(r):await this.z(a):await this.x(a)}}return R}async w(E){if(!Array.isArray(E))return[];const R=[],i=new Set;for(const r of E){const n=r.backupFolder;if(typeof n!="string")return[];if(!i.has(n)){i.add(n);const o=(0,M.join)(this.c,n);await this.B(o)?R.push(r):await this.x(o)}}return R}async x(E){try{await w.Promises.rm(E,w.RimRafMode.MOVE)}catch(R){this.l.error(`Backup: Could not delete stale backup: ${R.toString()}`)}}y(){let E=(0,u.createEmptyWorkspaceIdentifier)();for(;this.g.some(R=>!!R.backupFolder&&this.i.isEqual(R.backupFolder,E.id));)E=(0,u.createEmptyWorkspaceIdentifier)();return{backupFolder:E.id}}async z(E){const R=this.y(),i=(0,M.join)(this.c,R.backupFolder);try{await w.Promises.rename(E,i)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(R),!0}async getDirtyWorkspaces(){const E=[];for(const R of this.d)await this.A(R)&&E.push(R);for(const R of this.e)await this.A(R)&&E.push(R);return E}A(E){let R;return(0,g.isEmptyWindowBackupInfo)(E)?R=(0,M.join)(this.c,E.backupFolder):(0,b.isFolderBackupInfo)(E)?R=(0,M.join)(this.c,this.D(E)):R=(0,M.join)(this.c,E.workspace.id),this.B(R)}async B(E){try{const R=await w.Promises.readdir(E);for(const i of R)try{if((await w.Promises.readdir((0,M.join)(E,i))).length>0)return!0}catch{}}catch{}return!1}C(){const E={workspaces:this.d.map(({workspace:R,remoteAuthority:i})=>{const r={id:R.id,configURIPath:R.configPath.toString()};return i&&(r.remoteAuthority=i),r}),folders:this.e.map(({folderUri:R,remoteAuthority:i})=>{const r={folderUri:R.toString()};return i&&(r.remoteAuthority=i),r}),emptyWindows:this.g.map(({backupFolder:R,remoteAuthority:i})=>{const r={backupFolder:R};return i&&(r.remoteAuthority=i),r})};this.m.setItem(Tt.a,E)}D(E){const R=E.folderUri;let i;return R.scheme===k.Schemas.file?i=A.isLinux?R.fsPath:R.fsPath.toLowerCase():i=R.toString().toLowerCase(),(0,S.createHash)("md5").update(i).digest("hex")}};m.a="backupWorkspaces",m=pe([x(0,y.IEnvironmentMainService),x(1,p.IConfigurationService),x(2,d.ILogService),x(3,v.IStateMainService)],m),e.BackupMainService=m}),define(te[53],ne([0,1,14,3,43,36,2,15,9,20,11,23,176,62,57,27,5,6,19,52,118,28,94,95]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m,C,E,R,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,l.createDecorator)("workspacesManagementMainService");let n=class extends A.Disposable{constructor(a,c,s,f,P,L){super(),this.g=a,this.h=c,this.i=s,this.j=f,this.k=P,this.l=L,this.a=this.B(new t.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new t.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const a=(await y.Promises.readdir(this.c.fsPath)).map(c=>(0,g.joinPath)(this.c,c,R.UNTITLED_WORKSPACE_NAME));for(const c of a){const s=(0,r.getWorkspaceIdentifier)(c),f=await this.resolveLocalWorkspace(c);f?this.f.push({workspace:s,remoteAuthority:f.remoteAuthority}):await this.deleteUntitledWorkspace(s)}}catch(a){a.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${a}).`)}}resolveLocalWorkspace(a){return this.m(a,c=>y.Promises.readFile(c,"utf8"))}m(a,c){if(!!this.n(a)&&a.scheme===I.Schemas.file)try{const s=c(a.fsPath);return s instanceof Promise?s.then(f=>this.p(a,f),f=>{}):this.p(a,s)}catch{return}}n(a){return(0,R.isUntitledWorkspace)(a,this.g)||(0,R.hasWorkspaceFileExtension)(a)}p(a,c){try{const s=this.r(a,c),f=(0,r.getWorkspaceIdentifier)(a);return{id:f.id,configPath:f.configPath,folders:(0,i.toWorkspaceFolders)(s.folders,f.configPath,g.extUriBiasedIgnorePathCase),remoteAuthority:s.remoteAuthority,transient:s.transient}}catch(s){this.h.warn(s.toString())}}r(a,c){const s=(0,k.parse)(c);if(s&&Array.isArray(s.folders))s.folders=s.folders.filter(f=>(0,i.isStoredWorkspaceFolder)(f));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return s}async createUntitledWorkspace(a,c){const{workspace:s,storedWorkspace:f}=this.s(a,c),P=s.configPath.fsPath;return await y.Promises.mkdir((0,w.dirname)(P),{recursive:!0}),await y.Promises.writeFile(P,JSON.stringify(f,null,"	")),this.f.push({workspace:s,remoteAuthority:c}),s}s(a=[],c){const s=(Date.now()+Math.round(Math.random()*1e3)).toString(),f=(0,g.joinPath)(this.c,s),P=(0,g.joinPath)(f,R.UNTITLED_WORKSPACE_NAME),L=[];for(const T of a)L.push((0,i.getStoredWorkspaceFolder)(T.uri,!0,T.name,f,g.extUriBiasedIgnorePathCase));return{workspace:(0,r.getWorkspaceIdentifier)(P),storedWorkspace:{folders:L,remoteAuthority:c}}}async getWorkspaceIdentifier(a){return(0,r.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,R.isUntitledWorkspace)(a.configPath,this.g)}async deleteUntitledWorkspace(a){!this.isUntitledWorkspace(a)||(await this.t(a),this.i.isEnabled()&&this.i.unsetWorkspace(a),this.a.fire(a))}async t(a){const c=(0,g.originalFSPath)(a.configPath);try{await y.Promises.rm((0,w.dirname)(c));const s=(0,w.join)(this.g.workspaceStorageHome.fsPath,a.id);await y.Promises.exists(s)&&await y.Promises.writeFile((0,w.join)(s,"obsolete"),""),this.f=this.f.filter(f=>f.workspace.id!==a.id)}catch(s){this.h.warn(`Unable to delete untitled workspace ${c} (${s}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(a,c,s){if(!a||!a.win||!a.isReady||!await this.u(a,c,s))return;const P=await this.v(a,(0,r.getWorkspaceIdentifier)(s));if(!!P)return this.b.fire({window:a,workspace:P.workspace}),P}async u(a,c,s){if(!s)return!0;if((0,R.isWorkspaceIdentifier)(a.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,s))return!1;if((0,E.findWindowOnWorkspaceOrFolder)(c,s)){const f={title:this.l.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,v.localize)(0,null))],message:(0,v.localize)(1,null,(0,g.basename)(s)),detail:(0,v.localize)(2,null),noLink:!0,defaultId:0};return await this.k.showMessageBox(f,(0,p.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow())),!1}return!0}async v(a,c){if(!a.config)return;a.focus();let s;return a.config.extensionDevelopmentPath||(a.config.backupPath?s=await this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:a.remoteAuthority},a.config.backupPath):s=this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:a.remoteAuthority})),(0,R.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&await this.deleteUntitledWorkspace(a.openedWorkspace),a.config.workspace=c,a.config.backupPath=s,{workspace:c,backupPath:s}}};n=pe([x(0,b.IEnvironmentMainService),x(1,u.ILogService),x(2,C.IUserDataProfilesMainService),x(3,h.IBackupMainService),x(4,d.IDialogMainService),x(5,m.IProductService)],n),e.WorkspacesManagementMainService=n}),define(te[119],ne([0,1,14,42,22,5,32,28,53,11,6]),function(V,e,S,t,k,M,A,I,w,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,M.createDecorator)(e.ID);let y=class{constructor(h,d,b){this.a=h,this.b=d,this.c=b}async getRemoteDiagnostics(h){const d=this.a.getWindows();return(await Promise.all(d.map(async l=>{const u=l.remoteAuthority;if(!u)return;const m=`vscode:getDiagnosticInfoResponse${l.id}`,C={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?await this.f(l):void 0};return new Promise(E=>{l.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:m,args:C}),t.validatedIpcMain.once(m,(R,i)=>{i||E({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),E(i)}),setTimeout(()=>{E({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(l=>!!l)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const h=[];for(const d of S.BrowserWindow.getAllWindows()){const b=this.a.getWindowById(d.id);b?h.push(await this.d(b)):h.push(this.e(d))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(h){const d=await this.f(h),b=(0,g.assertIsDefined)(h.win);return this.e(b,d,h.remoteAuthority)}e(h,d=[],b){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:d,remoteAuthority:b}}async f(h){const d=[],b=h.openedWorkspace;if((0,I.isSingleFolderWorkspaceIdentifier)(b))d.push(b.uri);else if((0,I.isWorkspaceIdentifier)(b)){const l=await this.b.resolveLocalWorkspace(b.configPath);l&&l.folders.forEach(m=>{d.push(m.uri)})}return d}};y=pe([x(0,A.IWindowsMainService),x(1,w.IWorkspacesManagementMainService),x(2,p.ILogService)],y),e.DiagnosticsMainService=y}),define(te[58],ne([0,1,46,14,25,142,54,3,36,2,15,9,4,7,100,82,23,97,166,57,27,5,21,6,19,66,32,28,53,17,224,217,34]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m,C,E,R,i,r,n,o,a,c,s,f,P,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,R.createDecorator)("nativeHostMainService");let U=class extends g.Disposable{constructor(H,K,se,Z,ce,ge,_,$,N,W){super(),this.a=H,this.b=K,this.c=se,this.f=Z,this.g=ce,this.h=ge,this.i=_,this.j=$,this.k=N,this.l=W,this.onDidOpenWindow=I.Event.map(this.b.onDidOpenWindow,z=>z.id),this.onDidTriggerSystemContextMenu=I.Event.filter(I.Event.map(this.b.onDidTriggerSystemContextMenu,({window:z,x:Y,y:oe})=>({windowId:z.id,x:Y,y:oe})),({windowId:z})=>!!this.b.getWindowById(z)),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(z,Y)=>Y.id),z=>!!this.b.getWindowById(z)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(z,Y)=>Y.id),z=>!!this.b.getWindowById(z)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(z,Y)=>Y.id),z=>!!this.b.getWindowById(z)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),z=>!!z),z=>z.id),I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(z,Y)=>Y.id),z=>!!this.b.getWindowById(z))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new I.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(z,Y,oe)=>oe),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),I.Event.fromNodeEventEmitter(t.screen,"display-added"),I.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(K=>({id:K.id,workspace:K.openedWorkspace??(0,c.toWorkspaceIdentifier)(K.backupPath,K.isExtensionDevelopmentHost),title:K.win?.getTitle()??"",filename:K.getRepresentedFilename(),dirty:K.isDocumentEdited()}))}async getWindowCount(H){return this.b.getWindowCount()}async getActiveWindowId(H){const K=t.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(K)return K.id}openWindow(H,K,se){return Array.isArray(K)?this.n(H,K,se):this.p(H,K)}async n(H,K,se=Object.create(null)){K.length>0&&await this.b.open({context:5,contextWindowId:H,urisToOpen:K,cli:this.g.args,forceNewWindow:se.forceNewWindow,forceReuseWindow:se.forceReuseWindow,preferNewWindow:se.preferNewWindow,diffMode:se.diffMode,mergeMode:se.mergeMode,addMode:se.addMode,gotoLineMode:se.gotoLineMode,noRecentEntry:se.noRecentEntry,waitMarkerFileURI:se.waitMarkerFileURI,remoteAuthority:se.remoteAuthority||void 0,forceProfile:se.forceProfile,forceTempProfile:se.forceTempProfile})}async p(H,K){await this.b.openEmptyWindow({context:5,contextWindowId:H},K)}async toggleFullScreen(H){this.w(H)?.toggleFullScreen()}async handleTitleDoubleClick(H){this.w(H)?.handleTitleDoubleClick()}async isMaximized(H){const K=this.w(H);return K?.win?K.win.isMaximized():!1}async maximizeWindow(H){const K=this.w(H);K?.win&&K.win.maximize()}async unmaximizeWindow(H){const K=this.w(H);K?.win&&K.win.unmaximize()}async minimizeWindow(H){const K=this.w(H);K?.win&&K.win.minimize()}async updateWindowControls(H,K){const se=this.w(H);se&&se.updateWindowControls(K)}async focusWindow(H,K){K&&typeof K.windowId=="number"&&(H=K.windowId),this.w(H)?.focus({force:K?.force??!1})}async setMinimumSize(H,K,se){const Z=this.w(H);if(Z?.win){const[ce,ge]=Z.win.getSize(),[_,$]=Z.win.getMinimumSize(),[N,W]=[K??_,se??$],[z,Y]=[Math.max(ce,N),Math.max(ge,W)];(_!==N||$!==W)&&Z.win.setMinimumSize(N,W),(ce!==z||ge!==Y)&&Z.win.setSize(z,Y)}}async saveWindowSplash(H,K){this.j.saveWindowSplash(H,K)}async installShellCommand(H){const{source:K,target:se}=await this.r();try{const{symbolicLink:Z}=await l.SymlinkSupport.stat(K);if(Z&&!Z.dangling){const ce=await(0,d.realpath)(K);if(se===ce)return}await l.Promises.unlink(K)}catch(Z){if(Z.code!=="ENOENT")throw Z}try{await l.Promises.symlink(se,K)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="ENOENT")throw Z;const{response:ce}=await this.showMessageBox(H,{title:this.i.nameLong,type:"info",message:(0,m.localize)(0,null,this.i.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,m.localize)(1,null)),(0,w.mnemonicButtonLabel)((0,m.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ce===0)try{const ge=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${se}' '${K}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(ge)}catch{throw new Error((0,m.localize)(3,null,K))}}}async uninstallShellCommand(H){const{source:K}=await this.r();try{await l.Promises.unlink(K)}catch(se){switch(se.code){case"EACCES":{const{response:Z}=await this.showMessageBox(H,{title:this.i.nameLong,type:"info",message:(0,m.localize)(4,null,this.i.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,m.localize)(5,null)),(0,w.mnemonicButtonLabel)((0,m.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(Z===0)try{const ce=`osascript -e "do shell script \\"rm '${K}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(ce)}catch{throw new Error((0,m.localize)(7,null,K))}break}case"ENOENT":break;default:throw se}}}async r(){const H=(0,y.resolve)(this.g.appRoot,"bin","code"),K=`/usr/local/bin/${this.i.applicationName}`;if(!await l.Promises.exists(H))throw new Error((0,m.localize)(8,null,H));return{source:K,target:H}}async showMessageBox(H,K){return this.c.showMessageBox(K,this.s(H))}async showSaveDialog(H,K){return this.c.showSaveDialog(K,this.s(H))}async showOpenDialog(H,K){return this.c.showOpenDialog(K,this.s(H))}s(H){const K=this.w(H);if(K?.win)return K.win}async pickFileFolderAndOpen(H,K){const se=await this.c.pickFileFolder(K);se&&await this.t(await Promise.all(se.map(async Z=>await l.SymlinkSupport.existsDirectory(Z)?{folderUri:h.URI.file(Z)}:{fileUri:h.URI.file(Z)})),K,H)}async pickFolderAndOpen(H,K){const se=await this.c.pickFolder(K);se&&await this.t(se.map(Z=>({folderUri:h.URI.file(Z)})),K,H)}async pickFileAndOpen(H,K){const se=await this.c.pickFile(K);se&&await this.t(se.map(Z=>({fileUri:h.URI.file(Z)})),K,H)}async pickWorkspaceAndOpen(H,K){const se=await this.c.pickWorkspace(K);se&&await this.t(se.map(Z=>({workspaceUri:h.URI.file(Z)})),K,H)}async t(H,K,se){await this.b.open({context:3,contextWindowId:se,cli:this.g.args,urisToOpen:H,forceNewWindow:K.forceNewWindow})}async showItemInFolder(H,K){t.shell.showItemInFolder(K)}async setRepresentedFilename(H,K){this.w(H)?.setRepresentedFilename(K)}async setDocumentEdited(H,K){this.w(H)?.setDocumentEdited(K)}async openExternal(H,K){return v.isLinuxSnap?this.u(K):t.shell.openExternal(K),!0}u(H){const K=process.env.GDK_PIXBUF_MODULE_FILE,se=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(H),process.env.GDK_PIXBUF_MODULE_FILE=K,process.env.GDK_PIXBUF_MODULEDIR=se}moveItemToTrash(H,K){return t.shell.trashItem(K)}async isAdmin(){let H;return v.isWindows?H=(await new Promise((K,se)=>{V(["native-is-elevated"],K,se)}))():H=process.getuid()===0,H}async writeElevated(H,K,se,Z){const ce=await new Promise((ge,_)=>{V(["@vscode/sudo-prompt"],ge,_)});return new Promise((ge,_)=>{const $=[`"${this.v}"`];Z?.unlock&&$.push("--file-chmod"),$.push("--file-write",`"${K.fsPath}"`,`"${se.fsPath}"`);const N={name:this.i.nameLong.replace("-",""),icns:v.isMacintosh&&this.g.isBuilt?(0,y.join)((0,y.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};ce.exec($.join(" "),N,(W,z,Y)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),Y&&this.h.trace(`[sudo-prompt] received stderr: ${Y}`),W?_(W):ge(void 0)})})}get v(){return v.isWindows?this.g.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,y.join)(this.g.appRoot,"scripts","code-cli.bat"):v.isLinux?this.g.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,y.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,y.join)(this.g.appRoot,"bin","code"):(0,y.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return b.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return v.isWindows&&(0,P.hasWSLFeatureInstalled)()}async killProcess(H,K,se){process.kill(K,se)}async readClipboardText(H,K){return t.clipboard.readText(K)}async writeClipboardText(H,K,se){return t.clipboard.writeText(K,se)}async readClipboardFindText(H){return t.clipboard.readFindText()}async writeClipboardFindText(H,K){return t.clipboard.writeFindText(K)}async writeClipboardBuffer(H,K,se,Z){return t.clipboard.writeBuffer(K,Buffer.from(se.buffer),Z)}async readClipboardBuffer(H,K){return f.VSBuffer.wrap(t.clipboard.readBuffer(K))}async hasClipboard(H,K,se){return t.clipboard.has(K,se)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(H,K){this.w(H)?.updateTouchBar(K)}async notifyReady(H){this.w(H)?.setReady()}async relaunch(H,K){return this.f.relaunch(K)}async reload(H,K){const se=this.w(H);if(se){if((0,c.isWorkspaceIdentifier)(se.openedWorkspace)){const Z=se.openedWorkspace.configPath;if(Z.scheme===p.Schemas.file&&(await this.l.resolveLocalWorkspace(Z))?.transient)return this.openWindow(se.id,{forceReuseWindow:!0})}return this.f.reload(se,K?.disableExtensions!==void 0?{_:[],"disable-extensions":K.disableExtensions}:void 0)}}async closeWindow(H){this.closeWindowById(H,H)}async closeWindowById(H,K){const se=this.w(K);if(se?.win)return se.win.close()}async quit(H){const K=this.b.getLastActiveWindow();K?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&K.win?K.win.close():this.f.quit()}async exit(H,K){await this.f.kill(K)}async resolveProxy(H,K){const Z=this.w(H)?.win?.webContents?.session;if(Z)return Z.resolveProxy(K)}findFreePort(H,K,se,Z,ce=1){return(0,u.findFreePort)(K,se,Z,ce)}async openDevTools(H,K){const se=this.w(H);se?.win&&se.win.webContents.openDevTools(K)}async toggleDevTools(H){const K=this.w(H);K?.win&&K.win.webContents.toggleDevTools()}async sendInputEvent(H,K){const se=this.w(H);se?.win&&(K.type==="mouseDown"||K.type==="mouseUp")&&se.win.webContents.sendInputEvent(K)}async enableSandbox(H,K){K?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(H,K,se){const Z=this.w(H);if(!Z||!Z.win)throw new Error;return await new L.WindowProfiler(Z.win,K,this.h).inspect(se)}async windowsGetStringRegKey(H,K,se,Z){if(!v.isWindows)return;const ce=await new Promise((ge,_)=>{V(["@vscode/windows-registry"],ge,_)});try{return ce.GetStringRegKey(K,se,Z)}catch{return}}w(H){if(typeof H=="number")return this.b.getWindowById(H)}};pe([A.memoize],U.prototype,"v",null),U=pe([x(1,a.IWindowsMainService),x(2,C.IDialogMainService),x(3,i.ILifecycleMainService),x(4,E.IEnvironmentMainService),x(5,r.ILogService),x(6,n.IProductService),x(7,o.IThemeMainService),x(8,T.IStateMainService),x(9,s.IWorkspacesManagementMainService)],U),e.NativeHostMainService=U}),define(te[269],ne([0,1,14,42,25,36,2,15,4,101,164,85,119,57,27,5,6,58,63,19,64,74,31,11,34]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m,C,E,R,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,b.createDecorator)("issueMainService");const o="issue.processExplorerWindowState";let a=class Nt{constructor(f,P,L,T,U,G,H,K,se,Z){this.g=f,this.h=P,this.i=L,this.j=T,this.k=U,this.l=G,this.m=H,this.n=K,this.o=se,this.p=Z,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async f=>{const[P,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),T=await this.j.getSystemInfo(P,L);this.r(f,"vscode:issueSystemInfoResponse",T)}),t.validatedIpcMain.on("vscode:listProcesses",async f=>{const P=[];try{P.push({name:(0,p.localize)(0,null),rootProcess:await(0,g.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(T=>{(0,y.isRemoteDiagnosticError)(T)?P.push({name:T.hostName,rootProcess:T}):T.processes&&P.push({name:T.hostName,rootProcess:T.processes})})}catch(L){this.i.error(`Listing processes failed: ${L}`)}this.r(f,"vscode:listProcessesResponse",P)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async f=>{const P={title:this.o.nameLong,message:(0,p.localize)(1,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,p.localize)(2,null)),(0,M.mnemonicButtonLabel)((0,p.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.b){const L=await this.l.showMessageBox(P,this.b);this.r(f,"vscode:issueReporterClipboardResponse",L.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async f=>{const P=await this.v();this.r(f,"vscode:issuePerformanceInfoResponse",P)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const f={title:this.o.nameLong,message:(0,p.localize)(4,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,p.localize)(5,null)),(0,M.mnemonicButtonLabel)((0,p.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.b&&(await this.l.showMessageBox(f,this.b)).response===0&&this.b&&(this.b.destroy(),this.b=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(f,P)=>{const{id:L,from:T,args:U}=P;let G;switch(T){case"issueReporter":G=this.c;break;case"processExplorer":G=this.f;break;default:throw new Error(`Unexpected command source: ${T}`)}G?.webContents.send("vscode:runAction",{id:L,from:T,args:U})}),t.validatedIpcMain.on("vscode:openExternal",(f,P)=>{this.m.openExternal(void 0,P)}),t.validatedIpcMain.on("vscode:closeIssueReporter",f=>{this.b?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",f=>{this.d?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async f=>{const P=await this.k.getMainDiagnostics();this.r(f,"vscode:windowsInfoResponse",P.windows)})}r(f,P,...L){f.sender.isDestroyed()||f.sender.send(P,...L)}async openReporter(f){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const P=new A.DisposableStore,L=P.add(this.n.createIPCObjectUrl()),T=this.u(this.c,700,800);this.b=this.t(T,L,{backgroundColor:f.styles.backgroundColor,title:(0,p.localize)(7,null),zoomLevel:f.zoomLevel,alwaysOnTop:!1},"issue-reporter"),L.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:f,disableExtensions:!!this.h.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:m.default}),this.b.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,P.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,P.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(f){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const P=new A.DisposableStore,L=P.add(this.n.createIPCObjectUrl()),T=this.p.getItem(o,void 0),U=c(T)?T:this.u(this.f,800,500),G=S.screen.getDisplayNearestPoint({x:U.x,y:U.y});U.width/=G.scaleFactor,U.height/=G.scaleFactor,this.d=this.t(U,L,{backgroundColor:f.styles.backgroundColor,title:(0,p.localize)(8,null),zoomLevel:f.zoomLevel,alwaysOnTop:!0},"process-explorer"),L.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:f,product:m.default}),this.d.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,P.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,P.dispose())});const H=()=>{if(!this.d)return;const K=this.d.getSize(),se=this.d.getPosition();if(!K||!se)return;const Z={width:K[0],height:K[1],x:se[0],y:se[1]};this.p.setItem(o,Z)};this.d.on("moved",H),this.d.on("resized",H)}this.d&&this.s(this.d)}s(f){f.isMinimized()&&f.restore(),f.focus()}t(f,P,L,T){const U=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:f.width,height:f.height,minWidth:300,minHeight:200,x:f.x,y:f.y,title:L.title,backgroundColor:L.backgroundColor||Nt.a,webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`,`--vscode-window-kind=${T}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,R.zoomLevelToZoomFactor)(L.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:L.alwaysOnTop,experimentalDarkMode:!0});return U.setMenuBarVisibility(!1),U}async getSystemStatus(){const[f,P]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(f,P)}u(f,P,L){let T;const U=S.screen.getAllDisplays();if(U.length===1)T=U[0];else{if(w.isMacintosh){const K=S.screen.getCursorScreenPoint();T=S.screen.getDisplayNearestPoint(K)}!T&&f&&(T=S.screen.getDisplayMatching(f.getBounds())),T||(T=S.screen.getPrimaryDisplay()||U[0])}const G=T.bounds,H={width:P,height:L,x:G.x+G.width/2-P/2,y:G.y+G.height/2-L/2};return G.width>0&&G.height>0&&(H.x<G.x&&(H.x=G.x),H.y<G.y&&(H.y=G.y),H.x>G.x+G.width&&(H.x=G.x),H.y>G.y+G.height&&(H.y=G.y),H.width>G.width&&(H.width=G.width),H.height>G.height&&(H.height=G.height)),H}async v(){try{const[f,P]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(f,P)}catch(f){throw this.i.warn("issueService#getPerformanceInfo ",f.message),f}}async stopTracing(){if(!this.h.args.trace)return;const f=await S.contentTracing.stopRecording(`${(0,i.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({title:this.o.nameLong,type:"info",message:(0,p.localize)(9,null),detail:(0,p.localize)(10,null,f),buttons:[(0,M.mnemonicButtonLabel)((0,p.localize)(11,null))],defaultId:0,noLink:!0},(0,r.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,f)}};a.a="#1E1E1E",a=pe([x(1,d.IEnvironmentMainService),x(2,l.ILogService),x(3,y.IDiagnosticsService),x(4,v.IDiagnosticsMainService),x(5,h.IDialogMainService),x(6,u.INativeHostMainService),x(7,E.IProtocolMainService),x(8,C.IProductService),x(9,n.IStateMainService)],a),e.IssueMainService=a;function c(s){return typeof s!="object"||s===null?!1:"x"in s&&"y"in s&&"width"in s&&"height"in s}}),define(te[270],ne([0,1,22,18,27,21,6,58,19,56,29,49,91]),function(V,e,S,t,k,M,A,I,w,g,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let h=class extends v.AbstractUpdateService{constructor(b,l,u,m,C,E,R,i){super(b,l,m,C,E,i),this.e=u,this.u=R}s(b){return(0,v.createUpdateURL)(`linux-${process.arch}`,b,this.k)}t(b){!this.a||(this.d(y.State.CheckingForUpdates(b)),this.i.request({url:this.a},S.CancellationToken.None).then(g.asJson).then(l=>{!l||!l.url||!l.version||!l.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!b}),this.d(y.State.Idle(1))):this.d(y.State.AvailableForDownload(l))}).then(void 0,l=>{this.j.error(l),this.e.publicLog2("update:notAvailable",{explicit:!!b});const u=b?l.message||l:void 0;this.d(y.State.Idle(1,u))}))}async o(b){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):b.update.url&&this.u.openExternal(void 0,b.update.url),this.d(y.State.Idle(1))}};h=pe([x(0,M.ILifecycleMainService),x(1,t.IConfigurationService),x(2,p.ITelemetryService),x(3,k.IEnvironmentMainService),x(4,g.IRequestService),x(5,A.ILogService),x(6,I.INativeHostMainService),x(7,w.IProductService)],h),e.LinuxUpdateService=h}),define(te[271],ne([0,1,46,41,25,8,22,54,9,7,128,23,18,27,16,21,6,58,19,56,29,49,91]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m,C,E,R,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(c,s=1e3){for(;!c();)await(0,M.timeout)(s)}let n;function o(){return typeof n>"u"&&(n=t.existsSync(w.join(w.dirname(process.execPath),"unins000.exe"))?0:1),n}let a=class extends i.AbstractUpdateService{get cachePath(){const s=w.join((0,k.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return y.Promises.mkdir(s,{recursive:!0}).then(()=>s)}constructor(s,f,P,L,T,U,G,H,K){super(s,f,L,T,U,K),this.u=P,this.v=G,this.w=H}async initialize(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}s(s){let f="win32";return process.arch!=="ia32"&&(f+=`-${process.arch}`),o()===1?f+="-archive":this.k.target==="user"&&(f+="-user"),(0,i.createUpdateURL)(f,s,this.k)}t(s){!this.a||(this.d(R.State.CheckingForUpdates(s)),this.i.request({url:this.a},A.CancellationToken.None).then(C.asJson).then(f=>{const P=o();return!f||!f.url||!f.version||!f.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!s}),this.d(R.State.Idle(P)),Promise.resolve(null)):P===1?(this.d(R.State.AvailableForDownload(f)),Promise.resolve(null)):(this.d(R.State.Downloading(f)),this.B(f.version).then(()=>this.A(f.version).then(L=>y.Promises.exists(L).then(T=>{if(T)return Promise.resolve(L);const U=f.url,G=f.hash,H=`${L}.tmp`;return this.i.request({url:U},A.CancellationToken.None).then(K=>this.v.writeFile(g.URI.file(H),K.stream)).then(G?()=>(0,p.checksum)(H,f.hash):()=>{}).then(()=>y.Promises.rename(H,L)).then(()=>L)})).then(L=>{const T=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:L},T&&f.supportsFastUpdate?this.k.target==="user"?this.p():this.d(R.State.Downloaded(f)):this.d(R.State.Ready(f))})))}).then(void 0,f=>{this.j.error(f),this.u.publicLog2("update:notAvailable",{explicit:!!s});const P=s?f.message||f:void 0;this.d(R.State.Idle(o(),P))}))}async o(s){s.update.url&&this.w.openExternal(void 0,s.update.url),this.d(R.State.Idle(o()))}async A(s){const f=await this.cachePath;return w.join(f,`CodeSetup-${this.k.quality}-${s}.exe`)}async B(s=null){const f=s?U=>!new RegExp(`${this.k.quality}-${s}\\.exe$`).test(U):()=>!0,P=await this.cachePath,T=(await y.Promises.readdir(P)).filter(f).map(async U=>{try{await y.Promises.unlink(w.join(P,U))}catch{}});await Promise.all(T)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const s=this.state.update;this.d(R.State.Updating(s));const f=await this.cachePath;this.e.updateFilePath=w.join(f,`CodeSetup-${this.k.quality}-${s.version}.flag`),await y.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(R.State.Idle(o()))});const L=`${this.k.win32MutexName}-ready`,T=await new Promise((U,G)=>{V(["windows-mutex"],U,G)});r(()=>T.isActive(L)).then(()=>this.d(R.State.Ready(s)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?t.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return o()}async _applySpecificUpdate(s){if(this.state.type!=="idle")return;const f=this.g.getValue("update.enableWindowsBackgroundUpdates"),P={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!f};this.d(R.State.Downloading(P)),this.e={packagePath:s},f?this.k.target==="user"?this.p():this.d(R.State.Downloaded(P)):this.d(R.State.Ready(P))}};pe([I.memoize],a.prototype,"cachePath",null),a=pe([x(0,b.ILifecycleMainService),x(1,v.IConfigurationService),x(2,E.ITelemetryService),x(3,h.IEnvironmentMainService),x(4,C.IRequestService),x(5,l.ILogService),x(6,d.IFileService),x(7,u.INativeHostMainService),x(8,m.IProductService)],a),e.Win32UpdateService=a}),define(te[272],ne([0,1,14,8,22,45,3,36,2,15,9,73,4,7,172,62,18,57,27,61,16,21,6,19,64,235,93,29,240,66,74,32,28,53,116,121,38,34,52,58,237,112,51,90,25,113]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m,C,E,R,i,r,n,o,a,c,s,f,P,L,T,U,G,H,K,se,Z,ce,ge,_,$,N,W,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Y;(function(ee){ee[ee.NONE=0]="NONE",ee[ee.NAVIGATING=1]="NAVIGATING",ee[ee.READY=2]="READY"})(Y||(Y={}));let oe=class gt extends w.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){if(!this.config)return;const D=this.O.profiles.find(O=>O.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&D?D:this.O.getProfileForWorkspace(this.config.workspace??(0,T.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.O.defaultProfile}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(D,O,F,j,q,X,B,Q,ie,ae,de,ke,Oe,De,Me,ve,we,ye,Re,re){super(),this.L=O,this.M=F,this.N=j,this.O=q,this.P=X,this.Q=B,this.R=Q,this.S=ie,this.U=ae,this.W=de,this.X=ke,this.Y=Oe,this.Z=De,this.ab=Me,this.bb=ve,this.db=we,this.eb=ye,this.fb=Re,this.gb=re,this.c=this.B(new A.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new A.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new A.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new A.Emitter),this.onDidClose=this.h.event,this.j=this.B(new A.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.db.createIPCObjectUrl()),this.J=!1,this.hb=0;{const[he,fe]=this.sb(D.state);this.r=he,this.L.trace("window#ctor: using window state",he);const be=this.r.mode===0||this.r.mode===3;typeof gt.b>"u"&&(gt.b=this.fb.getItem("window.experimental.useSandbox",!1));const Pe=this.S.getValue("window");let We=!1;typeof Pe?.experimental?.useSandbox=="boolean"?We=Pe.experimental.useSandbox:this.bb.quality==="stable"&&gt.b?We=!0:We=typeof this.bb.quality=="string"&&this.bb.quality!=="stable";const Te={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.U.getBackgroundColor(),minWidth:P.WindowMinimumSize.WIDTH,minHeight:P.WindowMinimumSize.HEIGHT,show:!be,title:this.bb.nameLong,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,P.zoomLevelToZoomFactor)(Pe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...We?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};v.isLinux?Te.icon=(0,p.join)(this.M.appRoot,"resources/linux/code.png"):v.isWindows&&!this.M.isBuilt&&(Te.icon=(0,p.join)(this.M.appRoot,"resources/win32/code_150x150.png")),v.isMacintosh&&!this.zb()&&(Te.fullscreenable=!1),v.isMacintosh&&(Te.acceptFirstMouse=!0,Pe?.clickThroughInactive===!1&&(Te.acceptFirstMouse=!1));const qe=v.isMacintosh&&Pe?.nativeTabs===!0;qe&&(Te.tabbingIdentifier=this.bb.nameShort);const Ue=(0,P.getTitleBarStyle)(this.S)==="custom";if(Ue&&(Te.titleBarStyle="hidden",v.isMacintosh||(Te.frame=!1),(0,P.useWindowControlsOverlay)(this.S))){const je=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),Xe=H.Color.fromHex(je).isDarker()?"#FFFFFF":"#000000";Te.titleBarOverlay={height:29,color:je,symbolColor:Xe},this.z=!0}if((0,y.mark)("code/willCreateCodeBrowserWindow"),this.l=new S.BrowserWindow(Te),(0,y.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,v.isMacintosh&&Ue&&this.l.setSheetOffset(22),Ue&&(v.isWindows&&(0,P.useWindowControlsOverlay)(this.S)||v.isMacintosh)){const je=this.fb.getItem(gt.a);je&&this.updateWindowControls({height:je})}v.isWindows&&Ue&&this.l.hookWindowMessage(278,()=>{const[Xe,$e]=this.l.getPosition(),Ke=S.screen.getCursorScreenPoint(),J=Ke.x-Xe,le=Ke.y-$e;return(()=>!(J>30&&le>=0&&le<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:J,y:le})),0}),(v.isMacintosh||v.isWindows)&&fe&&(!qe||S.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(je=>typeof je=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),be&&((0,y.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.vb(!0),this.l.show(),(0,y.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.M.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.pb(),this.Db(),this.ib()}setRepresentedFilename(D){v.isMacintosh?this.l.setRepresentedFilename(D):this.v=D}getRepresentedFilename(){return v.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(D){v.isMacintosh&&this.l.setDocumentEdited(D),this.w=D}isDocumentEdited(){return v.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(D){v.isMacintosh&&D?.force&&S.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.hb=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(D=>{if(this.isReady)return D(this);this.C.push(D)})}get isReady(){return this.hb===2}get whenClosedOrLoaded(){return new Promise(D=>{function O(){F.dispose(),j.dispose(),D()}const F=this.onDidClose(()=>O()),j=this.onWillLoad(()=>O())})}ib(){this.l.on("unresponsive",()=>this.lb(1)),this.l.webContents.on("render-process-gone",(O,F)=>this.lb(2,F)),this.l.webContents.on("did-fail-load",(O,F,j)=>this.lb(3,{reason:j,exitCode:F})),this.l.webContents.on("will-prevent-unload",O=>{O.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",O=>{this.n&&(this.n.maximized=!0),S.app.emit("browser-window-maximize",O,this.l)}),this.l.on("unmaximize",O=>{this.n&&(this.n.maximized=!1),S.app.emit("browser-window-unmaximize",O,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.S.onDidChangeConfiguration(O=>this.pb(O))),this.B(this.W.onDidDeleteUntitledWorkspace(O=>this.ob(O)));const D=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:D},async(O,F)=>{const j=await this.kb();F({cancel:!1,requestHeaders:Object.assign(O.requestHeaders,j)})})}kb(){return this.jb||(this.jb=(0,o.resolveMarketplaceHeaders)(this.bb.version,this.bb,this.M,this.S,this.P,this.Q,this.Y)),this.jb}async lb(D,O){switch(D){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:D,reason:O?.reason,code:O?.exitCode}),D){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.ab.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.ab.quit();return}if(D===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const F=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this.n?.workspace?(0,d.localize)(5,null):void 0},this.l);if(F.response!==1){const j=F.response===0;await this.nb(j,F.checkboxChecked)}}else if(D===2)if(v.isWindows&&O?.reason==="launch-failed"&&O.exitCode===18&&await this.gb.isAdmin(void 0))await this.mb(O);else{let F;O?F=(0,d.localize)(7,null,O.reason,O.exitCode??"<unknown>"):F=(0,d.localize)(6,null);const j=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[this.n?.workspace?(0,I.mnemonicButtonLabel)((0,d.localize)(8,null)):(0,I.mnemonicButtonLabel)((0,d.localize)(9,null)),(0,I.mnemonicButtonLabel)((0,d.localize)(10,null))],message:F,detail:this.n?.workspace?(0,d.localize)(11,null):(0,d.localize)(12,null),noLink:!0,defaultId:0,checkboxLabel:this.n?.workspace?(0,d.localize)(13,null):void 0},this.l),q=j.response===0;await this.nb(q,j.checkboxChecked)}break}}async mb(D){const O=[],F=(0,$.isInternalTelemetry)(this.bb,this.S);if((0,$.supportsTelemetry)(this.bb,this.M)){this.bb.aiConfig&&this.bb.aiConfig.ariaKey&&O.push(new ge.OneDataSystemAppender(F,"monacoworkbench",null,this.bb.aiConfig.ariaKey));const{installSourcePath:q}=this.M,X=await(0,z.resolveMachineId)(this.fb),B={appenders:O,sendErrorTelemetry:!1,commonProperties:(0,N.resolveCommonProperties)(this.P,(0,W.release)(),(0,W.hostname)(),process.arch,this.bb.commit,this.bb.version,X,F,q),piiPaths:(0,$.getPiiPathsFromEnvironment)(this.M)};await new _.TelemetryService(B,this.S,this.bb).publicLog2("windowadminerror",{reason:D.reason,code:D.exitCode})}(await this.Z.showMessageBox({title:this.bb.nameLong,type:"error",buttons:[(0,I.mnemonicButtonLabel)((0,d.localize)(14,null)),(0,I.mnemonicButtonLabel)((0,d.localize)(15,null))],message:(0,d.localize)(16,null),detail:(0,d.localize)(17,null,this.bb.nameLong),noLink:!0,defaultId:0},this.l)).response===0&&await this.gb.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(O.map(q=>q.flush())),await this.nb(!1,!1)}async nb(D,O){const F=this.n?.workspace;if(O&&F)try{const j=this.R.workspaceStorage(F);await j.init(),j.delete("memento/workbench.parts.editor"),await j.close()}catch(j){this.L.error(j)}if(this.j.fire(),this.l?.destroy(),D&&this.n){let j,q;(0,T.isSingleFolderWorkspaceIdentifier)(F)?j={folderUri:F.uri}:(0,T.isWorkspaceIdentifier)(F)?j={workspaceUri:F.configPath}:q=!0;const[X]=await this.eb.open({context:5,userEnv:this.n.userEnv,cli:{...this.M.args,_:[]},urisToOpen:j?[j]:void 0,forceEmpty:q,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});X.focus()}}ob(D){this.n?.workspace?.id===D.id&&(this.n.workspace=void 0)}pb(D){const O=this.Ab();O!==this.s&&(this.s=O,this.Bb(O));let F=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;F?.endsWith("/")&&(F=F.substr(0,F.length-1));const j=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((F||"").indexOf("@")===-1&&(F!==this.F||j!==this.G)){this.F=F,this.G=j;const q=F||"",X=j?`${j},<local>`:"<local>";this.L.trace(`Setting proxy to '${q}', bypassing '${X}'`),this.l.webContents.session.setProxy({proxyRules:q,proxyBypassRules:X,pacScript:""})}}addTabbedWindow(D){v.isMacintosh&&D.win&&this.l.addTabbedWindow(D.win)}load(D,O=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!O.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),O.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.bb.nameLong)),this.qb(D,O),this.hb===0?this.n=D:this.I=D,this.hb=1,this.l.loadURL(g.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const F=this.J;this.J=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new t.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:D.workspace,reason:O.isReload?3:F?2:1})}qb(D,O){const F=(this.n??this.I)?.userEnv;if(F){const j=(0,C.isLaunchedFromCli)(F)&&!(0,C.isLaunchedFromCli)(D.userEnv),q=this.isExtensionDevelopmentHost;(j||q)&&(D.userEnv={...F,...D.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(D.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),O.disableExtensions!==void 0&&(D["disable-extensions"]=O.disableExtensions),D.fullscreen=this.isFullScreen,D.maximized=this.l.isMaximized(),D.partsSplash=this.U.getWindowSplash(),(0,y.mark)("code/willOpenNewWindow"),D.perfMarks=(0,y.getMarks)(),this.H.update(D)}async reload(D){const O=Object.assign({},this.n);O.workspace=await this.rb(O),delete O.filesToOpenOrCreate,delete O.filesToDiff,delete O.filesToMerge,delete O.filesToWait,this.isExtensionDevelopmentHost&&D&&(O.verbose=D.verbose,O.debugId=D.debugId,O.extensionEnvironment=D.extensionEnvironment,O["inspect-extensions"]=D["inspect-extensions"],O["inspect-brk-extensions"]=D["inspect-brk-extensions"],O["extensions-dir"]=D["extensions-dir"]),O.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),O.isInitialStartup=!1,O.policiesData=this.N.serialize(),O.continueOn=this.M.continueOn,O.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile},O.logLevel=this.L.getLevel(),this.load(O,{isReload:!0,disableExtensions:D?.["disable-extensions"]})}async rb(D){if((0,T.isWorkspaceIdentifier)(D.workspace)){const O=D.workspace.configPath;if(O.scheme===g.Schemas.file&&!await this.P.exists(O))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(D.workspace)){const O=D.workspace.uri;if(O.scheme===g.Schemas.file&&!await this.P.exists(O))return}return D.workspace}serializeWindowState(){if(!this.l)return(0,G.defaultWindowState)();if(this.isFullScreen){let F;try{F=S.screen.getDisplayMatching(this.getBounds())}catch{}const j=(0,G.defaultWindowState)();return{mode:3,display:F?F.id:void 0,width:this.r.width||j.width,height:this.r.height||j.height,x:this.r.x||0,y:this.r.y||0}}const D=Object.create(null);let O;if(!v.isMacintosh&&this.l.isMaximized()?O=0:O=1,O===0?D.mode=0:D.mode=1,O===1||O===0){let F;O===1?F=this.getBounds():F=this.l.getNormalBounds(),D.x=F.x,D.y=F.y,D.width=F.width,D.height=F.height}return D}updateWindowControls(D){if(D.height&&this.fb.setItem(gt.a,D.height),v.isWindows&&this.z)this.l.setTitleBarOverlay({color:D.backgroundColor?.trim()===""?void 0:D.backgroundColor,symbolColor:D.foregroundColor?.trim()===""?void 0:D.foregroundColor,height:D.height?D.height-1:void 0});else if(v.isMacintosh&&D.height!==void 0){const O=(D.height-15)/2;this.l.setTrafficLightPosition({x:O,y:O})}}sb(D){(0,y.mark)("code/willRestoreCodeWindowState");let O=!1;if(D)try{const F=S.screen.getAllDisplays();O=F.length>1,D=this.tb(D,F)}catch(F){this.L.warn(`Unexpected error validating window state: ${F}
${F.stack}`)}return(0,y.mark)("code/didRestoreCodeWindowState"),[D||(0,G.defaultWindowState)(),O]}tb(D,O){if(this.L.trace(`window#validateWindowState: validating window state on ${O.length} display(s)`,D),typeof D.x!="number"||typeof D.y!="number"||typeof D.width!="number"||typeof D.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(D.width<=0||D.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(O.length===1){const q=this.ub(O[0]);if(q){let X=function(){!D||typeof D.x!="number"||typeof D.y!="number"||!q||(D.x<q.x&&(D.x=q.x),D.y<q.y&&(D.y=q.y))};this.L.trace("window#validateWindowState: 1 monitor working area",q),X(),D.width>q.width&&(D.width=q.width),D.height>q.height&&(D.height=q.height),D.x>q.x+q.width-128&&(D.x=q.x+q.width-D.width),D.y>q.y+q.height-128&&(D.y=q.y+q.height-D.height),X()}return D}if(D.display&&D.mode===3){const q=O.find(X=>X.id===D.display);if(q&&typeof q.bounds?.x=="number"&&typeof q.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const X=(0,G.defaultWindowState)(3);return X.x=q.bounds.x,X.y=q.bounds.y,X}}let F,j;try{F=S.screen.getDisplayMatching({x:D.x,y:D.y,width:D.width,height:D.height}),j=this.ub(F)}catch{}if(F&&j&&D.x+D.width>j.x&&D.y+D.height>j.y&&D.x<j.x+j.width&&D.y<j.y+j.height)return this.L.trace("window#validateWindowState: multi-monitor working area",j),D}ub(D){if(D.workArea.width>0&&D.workArea.height>0)return D.workArea;if(D.bounds.width>0&&D.bounds.height>0)return D.bounds}getBounds(){const[D,O]=this.l.getPosition(),[F,j]=this.l.getSize();return{x:D,y:O,width:F,height:j}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(D){this.zb()?this.wb(D):this.yb(D),this.sendWhenReady(D?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.s&&this.Bb(this.s,!1)}get isFullScreen(){return v.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}wb(D){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.xb(D)}xb(D){v.isMacintosh&&(this.t=D,this.u=new t.DeferredPromise,Promise.race([this.u.p,(0,t.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(D)}yb(D){this.l.isFullScreen()&&this.xb(!1),this.l.setSimpleFullScreen(D),this.l.webContents.focus()}zb(){const D=this.S.getValue("window");return!D||typeof D.nativeFullScreen!="boolean"||D.nativeTabs?!0:D.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Ab(){let D=(0,P.getMenuBarVisibility)(this.S);return["visible","toggle","hidden"].indexOf(D)<0&&(D="classic"),D}Bb(D,O=!0){v.isMacintosh||(D==="toggle"&&O&&this.send("vscode:showInfoMessage",(0,d.localize)(18,null)),D==="hidden"?setTimeout(()=>{this.Cb(D)}):this.Cb(D))}Cb(D){const O=this.isFullScreen;switch(D){case"classic":this.l.setMenuBarVisibility(!O),this.l.autoHideMenuBar=O;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(v.isMacintosh)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(D,O,...F){this.isReady?this.send(D,...F):this.ready().then(()=>{O.isCancellationRequested||this.send(D,...F)})}send(D,...O){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${D}' for window that is destroyed`);return}try{this.l.webContents.send(D,...O)}catch(F){this.L.warn(`Error sending IPC message to channel '${D}' of window ${this.k}: ${(0,M.toErrorMessage)(F)}`)}}}updateTouchBar(D){!v.isMacintosh||this.D.forEach((O,F)=>{const j=D[F];O.segments=this.Fb(j)})}Db(){if(!!v.isMacintosh){for(let D=0;D<10;D++){const O=this.Eb();this.D.push(O)}this.l.setTouchBar(new S.TouchBar({items:this.D}))}}Eb(D=[]){const O=this.Fb(D),F=new S.TouchBar.TouchBarSegmentedControl({segments:O,mode:"buttons",segmentStyle:"automatic",change:j=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:F.segments[j].id,from:"touchbar"})}});return F}Fb(D=[]){return D.map(F=>{let j;F.icon&&!s.ThemeIcon.isThemeIcon(F.icon)&&F.icon?.dark?.scheme===g.Schemas.file&&(j=S.nativeImage.createFromPath(h.URI.revive(F.icon.dark).fsPath),j.isEmpty()&&(j=void 0));let q;return typeof F.title=="string"?q=F.title:q=F.title.value,{id:F.id,label:j?void 0:q,icon:j}})}dispose(){super.dispose(),this.l=null}};oe.a="windowControlHeight",oe.b=void 0,oe=pe([x(1,i.ILogService),x(2,m.IEnvironmentMainService),x(3,K.IPolicyService),x(4,Z.IUserDataProfilesMainService),x(5,E.IFileService),x(6,a.IApplicationStorageMainService),x(7,a.IStorageMainService),x(8,l.IConfigurationService),x(9,f.IThemeMainService),x(10,U.IWorkspacesManagementMainService),x(11,b.IBackupMainService),x(12,c.ITelemetryService),x(13,u.IDialogMainService),x(14,R.ILifecycleMainService),x(15,r.IProductService),x(16,n.IProtocolMainService),x(17,L.IWindowsMainService),x(18,se.IStateMainService),x(19,ce.INativeHostMainService)],oe),e.CodeWindow=oe}),define(te[76],ne([0,1,14,24,8,3,36,2,15,4,20,7,23,175,5,21,6,93,94,28,53,40]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let i=class rt extends I.Disposable{constructor(n,o,a,c){super(),this.f=n,this.g=o,this.h=a,this.j=c,this.c=this.B(new M.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new k.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let o=[],a=[];for(const s of n)if((0,m.isRecentWorkspace)(s))!this.g.isUntitledWorkspace(s.workspace)&&!this.r(o,s.workspace)&&o.push(s);else if((0,m.isRecentFolder)(s))this.s(o,s.folderUri)||o.push(s);else{const f=this.t(a,s.fileUri),P=s.fileUri.scheme===w.Schemas.file&&rt.y.indexOf((0,p.basename)(s.fileUri))>=0;!f&&!P&&(a.push(s),g.isWindows&&s.fileUri.scheme===w.Schemas.file&&S.app.addRecentDocument(s.fileUri.fsPath))}const c=await this.l({workspaces:o,files:a});o=c.workspaces,a=c.files,o.length>rt.a&&(o.length=rt.a),a.length>rt.a&&(a.length=rt.a),await this.n({workspaces:o,files:a}),this.c.fire(),g.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(n){const o=f=>{const P=this.p(f);for(const L of n)if(p.extUriBiasedIgnorePathCase.isEqual(L,P))return!1;return!0},a=await this.getRecentlyOpened(),c=a.workspaces.filter(o),s=a.files.filter(o);(c.length!==a.workspaces.length||s.length!==a.files.length)&&(await this.n({files:s,workspaces:c}),this.c.fire(),g.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(n){const o=new R.ResourceMap(s=>p.extUriBiasedIgnorePathCase.getComparisonKey(s));if(n?.workspaces)for(const s of n.workspaces)o.set(this.p(s),s);const a=new R.ResourceMap(s=>p.extUriBiasedIgnorePathCase.getComparisonKey(s));if(n?.files)for(const s of n.files)a.set(this.p(s),s);const c=await this.m();for(const s of c.workspaces){const f=o.get(this.p(s));f?f.label=f.label??s.label:o.set(this.p(s),s)}for(const s of c.files){const f=a.get(this.p(s));f?f.label=f.label??s.label:a.set(this.p(s),s)}return{workspaces:[...o.values()],files:[...a.values()]}}async m(){await this.j.whenReady;let n;const o=this.j.get(rt.b,-1);if(typeof o=="string")try{n=JSON.parse(o)}catch(a){this.f.error("Unexpected error parsing opened paths list",a)}return(0,m.restoreRecentlyOpened)(n,this.f)}async n(n){await this.j.whenReady,this.j.store(rt.b,JSON.stringify((0,m.toStoreData)(n)),-1,1)}p(n){return(0,m.isRecentFolder)(n)?n.folderUri:(0,m.isRecentFile)(n)?n.fileUri:n.workspace.configPath}r(n,o){return!!n.find(a=>(0,m.isRecentWorkspace)(a)&&a.workspace.id===o.id)}s(n,o){return!!n.find(a=>(0,m.isRecentFolder)(a)&&p.extUriBiasedIgnorePathCase.isEqual(a.folderUri,o))}t(n,o){return!!n.find(a=>p.extUriBiasedIgnorePathCase.isEqual(a.fileUri,o))}async C(){!g.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!g.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const o=[];for(const s of S.app.getJumpListSettings().removedItems){const f=s.args;if(f){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(f);P&&o.push(y.URI.parse(P[2]))}}await this.removeRecentlyOpened(o);let a=!1;const c=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.w).map(s=>{const f=(0,m.isRecentWorkspace)(s)?s.workspace:s.folderUri,{title:P,description:L}=this.F(f,s.label);let T;return y.URI.isUri(f)?T=`--folder-uri "${f.toString()}"`:(a=!0,T=`--file-uri "${f.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:L.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&n.push({type:"custom",name:a?(0,h.localize)(2,null):(0,h.localize)(3,null),items:c})}n.push({type:"recent"});try{const o=S.app.setJumpList(n);o&&o!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${o}`)}catch(o){this.f.warn("updateWindowsJumpList#setJumpList",o)}}F(n,o){if(o)return{title:(0,A.splitName)(o).name,description:o};if(y.URI.isUri(n))return{title:(0,p.basename)(n),description:this.G(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,h.localize)(4,null),description:""};let a=(0,p.basename)(n.configPath);return a.endsWith(C.WORKSPACE_EXTENSION)&&(a=a.substr(0,a.length-C.WORKSPACE_EXTENSION.length-1)),{title:(0,h.localize)(5,null,a),description:this.G(n.configPath)}}G(n){return n.scheme==="file"?(0,A.normalizeDriveLetter)(n.fsPath):n.toString()}async H(){if(!g.isMacintosh)return;S.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),o=[];let a=0;for(let s=0;s<n.workspaces.length&&a<rt.u;s++){const f=this.p(n.workspaces[s]);if(f.scheme===w.Schemas.file){const P=(0,p.originalFSPath)(f);await v.Promises.exists(P)&&(o.push(P),a++)}}const c=[];for(let s=0;s<n.files.length&&a<rt.v;s++){const f=this.p(n.files[s]);if(f.scheme===w.Schemas.file){const P=(0,p.originalFSPath)(f);if(rt.y.includes((0,p.basename)(f))||o.includes(P))continue;await v.Promises.exists(P)&&(c.push(P),a++)}}c.reverse().forEach(s=>S.app.addRecentDocument(s)),o.reverse().forEach(s=>S.app.addRecentDocument(s))}};i.a=500,i.b="history.recentlyOpenedPathsList",i.u=7,i.v=10,i.w=7,i.y=["COMMIT_EDITMSG","MERGE_MSG"],i=pe([x(0,l.ILogService),x(1,E.IWorkspacesManagementMainService),x(2,b.ILifecycleMainService),x(3,u.IApplicationStorageMainService)],i),e.WorkspacesHistoryMainService=i}),define(te[273],ne([0,1,14,8,22,36,4,7,165,18,27,21,6,213,58,19,34,29,49,74,32,76]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let r=class Ft{constructor(a,c,s,f,P,L,T,U,G,H,K){this.n=a,this.o=c,this.p=s,this.q=f,this.r=P,this.s=L,this.t=T,this.u=U,this.v=G,this.w=H,this.x=K,this.m=Object.create(null),this.g=new t.RunOnceScheduler(()=>this.E(),0),this.h=new t.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(A.isMacintosh||(0,C.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const a=this.t.getItem(Ft.a);a&&(a.menus&&(this.k=a.menus),a.keybindings&&(this.l=a.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(L,T,U)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.newWindow"]=(L,T,U)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(L,T,U)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:i}}),this.m["workbench.action.files.openFolder"]=(L,T,U)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:i}}),this.m["workbench.action.openWorkspace"]=(L,T,U)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:i}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const a=this.x.twitterUrl;a&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(a,"openTwitterUrl"));const c=this.x.requestFeatureUrl;c&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(c,"openUserVoiceUrl"));const s=this.x.reportIssueUrl;s&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(s,"openReportIssues"));const f=this.x.licenseUrl;f&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(A.language){const L=f.indexOf("?")>0?"&":"?";this.Z(`${f}${L}lang=${A.language}`,"openLicenseUrl")}else this.Z(f,"openLicenseUrl")});const P=this.x.privacyStatementUrl;P&&f&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(P,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(a=>this.F(a)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const a=this.o.getValue("window.enableMenuBarMnemonics");return typeof a!="boolean"?!0:a}get C(){if(!A.isMacintosh)return!1;const a=this.o.getValue("window.nativeTabs");return typeof a!="boolean"?!1:a}updateMenu(a,c){this.k=a.menus,this.l=a.keybindings,this.t.setItem(Ft.a,a),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(a){!A.isMacintosh||(a.oldCount===0&&a.newCount>0||a.oldCount>0&&a.newCount===0)&&(this.d=a.newCount===0,this.D())}G(){!A.isMacintosh||(this.f=!S.BrowserWindow.getFocusedWindow(),this.D())}H(){const a=S.Menu.getApplicationMenu();if(a&&this.j.push(a),Object.keys(this.k).length===0){S.Menu.setApplicationMenu(A.isMacintosh?new S.Menu:null);return}const c=new S.Menu;let s;if(A.isMacintosh){const P=new S.Menu;s=new S.MenuItem({label:this.x.nameShort,submenu:P}),this.I(P),c.append(s)}if(A.isMacintosh&&!this.c){this.c=!0;const P=new S.Menu;P.append(new S.MenuItem({label:this.bb(w.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(P)}if(this.K("File")){const P=new S.Menu,L=new S.MenuItem({label:this.bb(w.localize(1,null)),submenu:P});this.M(P,"File"),c.append(L)}if(this.K("Edit")){const P=new S.Menu,L=new S.MenuItem({label:this.bb(w.localize(2,null)),submenu:P});this.M(P,"Edit"),c.append(L)}if(this.K("Selection")){const P=new S.Menu,L=new S.MenuItem({label:this.bb(w.localize(3,null)),submenu:P});this.M(P,"Selection"),c.append(L)}if(this.K("View")){const P=new S.Menu,L=new S.MenuItem({label:this.bb(w.localize(4,null)),submenu:P});this.M(P,"View"),c.append(L)}if(this.K("Go")){const P=new S.Menu,L=new S.MenuItem({label:this.bb(w.localize(5,null)),submenu:P});this.M(P,"Go"),c.append(L)}if(this.K("Run")){const P=new S.Menu,L=new S.MenuItem({label:this.bb(w.localize(6,null)),submenu:P});this.M(P,"Run"),c.append(L)}if(this.K("Terminal")){const P=new S.Menu,L=new S.MenuItem({label:this.bb(w.localize(7,null)),submenu:P});this.M(P,"Terminal"),c.append(L)}let f;if(this.K("Window")){const P=new S.Menu;f=new S.MenuItem({label:this.bb(w.localize(8,null)),submenu:P,role:"window"}),this.S(P)}if(f&&c.append(f),this.K("Help")){const P=new S.Menu,L=new S.MenuItem({label:this.bb(w.localize(9,null)),submenu:P,role:"help"});this.M(P,"Help"),c.append(L)}c.items&&c.items.length>0?S.Menu.setApplicationMenu(c):S.Menu.setApplicationMenu(null),this.h.schedule()}I(a){const c=this.U(w.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),s=this.T();let f;if(this.K("Preferences")){const se=new S.Menu;this.M(se,"Preferences"),f=new S.MenuItem({label:this.bb(w.localize(11,null)),submenu:se})}const P=new S.Menu,L=new S.MenuItem({label:w.localize(12,null),role:"services",submenu:P}),T=new S.MenuItem({label:w.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),U=new S.MenuItem({label:w.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),G=new S.MenuItem({label:w.localize(15,null),role:"unhide"}),H=new S.MenuItem(this.Y("workbench.action.quit",{label:w.localize(16,null,this.x.nameLong),click:async(se,Z,ce)=>{const ge=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||ge?.isMinimized())&&await this.J(ce)&&this.w.quit(void 0)}})),K=[c];K.push(...s),f&&K.push(n(),f),K.push(n(),L,n(),T,U,G,n(),H),K.forEach(se=>a.append(se))}async J(a){if(this.p.getWindowCount()===0)return!0;const c=this.o.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.Q(a)){const s={title:this.x.nameLong,type:"question",buttons:[(0,M.mnemonicButtonLabel)(w.localize(17,null)),(0,M.mnemonicButtonLabel)(w.localize(18,null))],message:w.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:f}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,s);return f===0}return!0}K(a){if(!A.isMacintosh&&(0,C.getTitleBarStyle)(this.o)==="custom")return!1;switch(a){case"File":case"Help":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[a];case"Window":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[a]}}L(a,c){c.forEach(s=>{if((0,h.isMenubarMenuItemSeparator)(s))a.append(n());else if((0,h.isMenubarMenuItemSubmenu)(s)){const f=new S.Menu,P=new S.MenuItem({label:this.bb(s.label),submenu:f});this.L(f,s.submenu.items),a.append(P)}else(0,h.isMenubarMenuItemRecentAction)(s)?a.append(this.O(s)):(0,h.isMenubarMenuItemAction)(s)&&(s.id==="workbench.action.showAboutDialog"&&this.N(a),A.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[s.id]?a.append(new S.MenuItem(this.Y(s.id,{label:this.bb(s.label),click:this.m[s.id]}))):a.append(this.U(s.label,s.id,!1,s.checked)):a.append(this.U(s.label,s.id,s.enabled!==!1,!!s.checked)):a.append(this.U(s.label,s.id,s.enabled!==!1,!!s.checked)))})}M(a,c){this.k&&this.k[c]&&this.L(a,this.k[c].items)}N(a){const c=this.T();c.length&&(c.forEach(s=>a.append(s)),a.append(n()))}O(a){const c=I.URI.revive(a.uri),s=a.id,f=s==="openRecentFile"?{fileUri:c}:s==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new S.MenuItem(this.Y(s,{label:a.label,click:async(P,L,T)=>{const U=this.P(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[f],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:a.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([c])}},!1))}P(a){return!!(a&&(!A.isMacintosh&&(a.ctrlKey||a.shiftKey)||A.isMacintosh&&(a.metaKey||a.altKey)))}Q(a){return!!(a.triggeredByAccelerator||a.altKey||a.ctrlKey||a.metaKey||a.shiftKey)}R(a,c,s){const f={label:this.bb(a),role:s,enabled:!0};return new S.MenuItem(this.X(c,f))}S(a){const c=new S.MenuItem({label:w.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),s=new S.MenuItem({label:w.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),f=new S.MenuItem({label:w.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),P=this.U(w.localize(23,null),"workbench.action.switchWindow"),L=[];this.C&&(L.push(n()),L.push(this.U(w.localize(24,null),"workbench.action.newWindowTab")),L.push(this.R(w.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.R(w.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.R(w.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.R(w.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,s,n(),P,...L,n(),f].forEach(T=>a.append(T))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.bb(w.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:w.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.bb(w.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:w.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.bb(w.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:w.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.bb(w.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(a,c,s,f){const P=this.bb(a),L=typeof c=="function"?c:(K,se,Z)=>{const ce=K?K.userSettingsLabel:null;let ge=c;Array.isArray(c)&&(ge=this.P(Z)?c[1]:c[0]),ce&&Z.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ce}):this.W({type:"commandId",commandId:ge})},T=typeof s=="boolean"?s:this.p.getWindowCount()>0,U=typeof f=="boolean"?f:!1,G={label:P,click:L,enabled:T};U&&(G.type="checkbox",G.checked=U);let H;return typeof c=="string"?H=c:Array.isArray(c)&&(H=c[0]),A.isMacintosh&&(H==="editor.action.clipboardCutAction"?G.role="cut":H==="editor.action.clipboardCopyAction"?G.role="copy":H==="editor.action.clipboardPasteAction"&&(G.role="paste"),H==="undo"?G.click=this.V(L,{inDevTools:K=>K.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):H==="redo"?G.click=this.V(L,{inDevTools:K=>K.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):H==="editor.action.selectAll"&&(G.click=this.V(L,{inDevTools:K=>K.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.X(H,G))}V(a,c){return(s,f,P)=>{const L=S.BrowserWindow.getFocusedWindow();if(!L)return c.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return c.inDevTools(L.webContents.devToolsWebContents);a(s,f||L,P)}}W(a){let c=S.BrowserWindow.getFocusedWindow();if(!c){const f=this.p.getLastActiveWindow();f?.isMinimized()&&(c=f.win)}const s=c?this.p.getWindowById(c.id):void 0;if(s){if(this.v.trace("menubar#runActionInRenderer",a),A.isMacintosh&&!this.q.isBuilt&&!s.isReady&&(a.type==="commandId"&&a.commandId==="workbench.action.toggleDevTools"||a.type!=="commandId"&&a.userSettingsLabel==="alt+cmd+i"))return;if(a.type==="commandId"){const f={id:a.commandId,from:"menu"};s.sendWhenReady("vscode:runAction",k.CancellationToken.None,f)}else{const f={userSettingsLabel:a.userSettingsLabel};s.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,f)}}else this.v.trace("menubar#runActionInRenderer: no active window found",a)}X(a,c){const s=typeof a=="string"?this.l[a]:void 0;if(s?.label){if(s.isNative!==!1)c.accelerator=s.label,c.userSettingsLabel=s.userSettingsLabel;else if(typeof c.label=="string"){const f=c.label.indexOf("[");f>=0?c.label=`${c.label.substr(0,f)} [${s.label}]`:c.label=`${c.label} [${s.label}]`}}else c.accelerator=void 0;return c}Y(a,c,s=!c.accelerator){s&&(c=this.X(a,c));const f=c.click;return c.click=(P,L,T)=>{this.ab(a),f?.(P,L,T)},c}Z(a,c){this.w.openExternal(void 0,a),this.ab(c)}ab(a){this.r.publicLog2("workbenchActionExecuted",{id:a,from:i})}bb(a){return(0,M.mnemonicMenuLabel)(a,!this.B)}};r.a="lastKnownMenubarData",r=pe([x(0,m.IUpdateService),x(1,g.IConfigurationService),x(2,E.IWindowsMainService),x(3,p.IEnvironmentMainService),x(4,u.ITelemetryService),x(5,R.IWorkspacesHistoryMainService),x(6,l.IStateMainService),x(7,y.ILifecycleMainService),x(8,v.ILogService),x(9,d.INativeHostMainService),x(10,b.IProductService)],r),e.Menubar=r;function n(){return new S.MenuItem({type:"separator"})}}),define(te[274],ne([0,1,5,21,6,273]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,S.createDecorator)("menubarMainService");let A=class{constructor(w,g,p){this.b=w,this.c=g,this.d=p,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.Menubar)}async updateMenubar(w,g){this.d.trace("menubarService#updateMenubar",w),(await this.a).updateMenu(g,w)}};A=pe([x(0,S.IInstantiationService),x(1,t.ILifecycleMainService),x(2,k.ILogService)],A),e.MenubarMainService=A}),define(te[275],ne([0,1,14,23,25,24,22,3,31,50,36,2,15,9,73,4,35,20,11,7,173,62,18,57,27,16,5,21,6,63,19,64,55,34,74,272,118,267,28,95,76,53,66,38,52]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m,C,E,R,i,r,n,o,a,c,s,f,P,L,T,U,G,H,K,se,Z,ce,ge,_,$,N,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(ee){return(0,Z.isWorkspaceIdentifier)(ee?.workspace)}function Y(ee){return(0,Z.isSingleFolderWorkspaceIdentifier)(ee?.workspace)}let oe=class mt extends y.Disposable{constructor(D,O,F,j,q,X,B,Q,ie,ae,de,ke,Oe,De,Me,ve,we,ye){super(),this.k=D,this.l=O,this.m=F,this.n=j,this.r=q,this.s=X,this.t=B,this.u=Q,this.v=ie,this.w=ae,this.z=de,this.C=ke,this.D=Oe,this.F=De,this.G=Me,this.H=ve,this.I=we,this.J=ye,this.b=this.B(new I.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new I.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new I.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new I.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new I.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new se.WindowsStateHandler(this,this.n,this.u,this.m,this.w)),this.L()}L(){this.B(this.C.onDidEnterWorkspace(D=>this.c.fire(D.window))),this.B(this.onDidSignalReadyWindow(D=>{if(D.config?.extensionDevelopmentPath||D.config?.extensionTestsPath){const O=new y.DisposableStore;if(O.add(I.Event.any(D.onDidClose,D.onDidDestroy)(()=>O.dispose())),D.config.extensionDevelopmentPath)for(const F of D.config.extensionDevelopmentPath)O.add(this.I.addValidFileRoot(F));D.config.extensionTestsPath&&O.add(this.I.addValidFileRoot(D.config.extensionTestsPath))}}))}openEmptyWindow(D,O){const F=this.s.args,j=O?.remoteAuthority||void 0,q=!0,X=O?.forceReuseWindow,B=!X;return this.open({...D,cli:F,forceEmpty:q,forceNewWindow:B,forceReuseWindow:X,remoteAuthority:j})}openExistingWindow(D,O){D.focus(),this.M(O,[D])}async open(D){this.m.trace("windowsManager#open"),D.addMode&&(D.initialStartup||!this.getLastActiveWindow())&&(D.addMode=!1);const O=[],F=[],j=[],q=[],X=[];let B,Q=0;const ie=await this.S(D);this.m.trace("windowsManager#open pathsToOpen",ie);for(const De of ie)Y(De)?D.addMode?O.push(De):F.push(De):z(De)?j.push(De):De.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),B.filesToOpenOrCreate.push(De)):De.backupPath?X.push({backupFolder:(0,h.basename)(De.backupPath),remoteAuthority:De.remoteAuthority}):Q++;D.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),D.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&D.waitMarkerFileURI&&(B.filesToWait={paths:(0,M.coalesce)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:D.waitMarkerFileURI}),D.initialStartup?(q.push(...this.C.getUntitledWorkspaces()),j.push(...q),X.push(...this.v.getEmptyWindowBackups())):X.length=0;const{windows:ae,filesOpenedInWindow:de}=await this.N(D,j,F,X,Q,B,O);if(this.m.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${j.length}, foldersToOpen: ${F.length}, emptyToRestore: ${X.length}, emptyToOpen: ${Q})`),ae.length>1)if(de)de.focus();else{const De=this.j.state.lastActiveWindow&&!D.forceEmpty&&!D.cli._.length&&!D.cli["file-uri"]&&!D.cli["folder-uri"]&&!(D.urisToOpen&&D.urisToOpen.length);let Me=!0,ve=!0;if(De){const we=ae.filter(ye=>this.j.state.lastActiveWindow&&ye.backupPath===this.j.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Me=!1,ve=!1)}if(Me)for(let we=ae.length-1;we>=0;we--){const ye=ae[we];if(!(ye.openedWorkspace&&q.some(Re=>ye.openedWorkspace&&Re.workspace.id===ye.openedWorkspace.id)||ye.backupPath&&X.some(Re=>ye.backupPath&&Re.backupFolder===(0,h.basename)(ye.backupPath)))){ye.focus(),ve=!1;break}}ve&&ae[ae.length-1].focus()}const ke=B&&B.filesToDiff.length>0,Oe=B&&B.filesToMerge.length>0;if(!ae.some(De=>De.isExtensionDevelopmentHost)&&!ke&&!Oe&&!D.noRecentEntry){const De=[];for(const Me of ie)z(Me)&&!Me.transient?De.push({label:Me.label,workspace:Me.workspace,remoteAuthority:Me.remoteAuthority}):Y(Me)?De.push({label:Me.label,folderUri:Me.workspace.uri,remoteAuthority:Me.remoteAuthority}):Me.fileUri&&De.push({label:Me.label,fileUri:Me.fileUri,remoteAuthority:Me.remoteAuthority});this.z.addRecentlyOpened(De)}return this.M(D,ae),ae}M(D,O){const F=D.waitMarkerFileURI;D.context===0&&F&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.G.del(F)}catch{}})()}async N(D,O,F,j,q,X,B){const Q=[];let ie;function ae(we,ye){Q.push(we),ye&&(ie=we,X=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:ke}=this.fb(D);if(!D.initialStartup&&B.length>0){const we=B[0].remoteAuthority,ye=this.kb(we);ye&&ae(this.P(ye,B.map(Re=>Re.workspace.uri)))}const Oe=F.length+O.length+j.length;if(X&&Oe===0){const we=X.filesToOpenOrCreate[0]||X.filesToDiff[0]||X.filesToMerge[3],ye=this.getWindows().filter(re=>X&&(0,u.isEqualAuthority)(re.remoteAuthority,X.remoteAuthority));let Re;we?.fileUri&&!ke&&((D.context===4||D.context===0||D.context===1)&&(Re=await(0,K.findWindowOnFile)(ye,we.fileUri,async re=>re.configPath.scheme===v.Schemas.file?this.C.resolveLocalWorkspace(re.configPath):void 0)),Re||(Re=this.lb(ye))),Re?(0,Z.isWorkspaceIdentifier)(Re.openedWorkspace)?O.push({workspace:Re.openedWorkspace,remoteAuthority:Re.remoteAuthority}):(0,Z.isSingleFolderWorkspaceIdentifier)(Re.openedWorkspace)?F.push({workspace:Re.openedWorkspace,remoteAuthority:Re.remoteAuthority}):ae(this.O(D,Re,X),!0):ae(await this.gb({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,filesToOpen:X,forceNewWindow:!0,remoteAuthority:X.remoteAuthority,forceNewTabbedWindow:D.forceNewTabbedWindow,forceProfile:D.forceProfile,forceTempProfile:D.forceTempProfile}),!0)}const De=(0,M.distinct)(O,we=>we.workspace.id);if(De.length>0){const we=(0,M.coalesce)(De.map(ye=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.configPath)));if(we.length>0){const ye=we[0],Re=(0,u.isEqualAuthority)(X?.remoteAuthority,ye.remoteAuthority)?X:void 0;ae(this.O(D,ye,Re),!!Re),de=!0}for(const ye of De){if(we.some(he=>he.openedWorkspace&&he.openedWorkspace.id===ye.workspace.id))continue;const Re=ye.remoteAuthority,re=(0,u.isEqualAuthority)(X?.remoteAuthority,Re)?X:void 0;ae(await this.R(D,ye,de,re),!!re),de=!0}}const Me=(0,M.distinct)(F,we=>u.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Me.length>0){const we=(0,M.coalesce)(Me.map(ye=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.uri)));if(we.length>0){const ye=we[0],Re=(0,u.isEqualAuthority)(X?.remoteAuthority,ye.remoteAuthority)?X:void 0;ae(this.O(D,ye,Re),!!Re),de=!0}for(const ye of Me){if(we.some(he=>(0,Z.isSingleFolderWorkspaceIdentifier)(he.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(he.openedWorkspace.uri,ye.workspace.uri)))continue;const Re=ye.remoteAuthority,re=(0,u.isEqualAuthority)(X?.remoteAuthority,Re)?X:void 0;ae(await this.R(D,ye,de,re),!!re),de=!0}}const ve=(0,M.distinct)(j,we=>we.backupFolder);if(ve.length>0)for(const we of ve){const ye=we.remoteAuthority,Re=(0,u.isEqualAuthority)(X?.remoteAuthority,ye)?X:void 0;ae(await this.Q(D,!0,ye,Re,we),!!Re),de=!0}if(Q.length===0||X){X&&!q&&q++;const we=X?X.remoteAuthority:D.remoteAuthority;for(let ye=0;ye<q;ye++)ae(await this.Q(D,de,we,X),!!X),de=!0}return{windows:(0,M.distinct)(Q),filesOpenedInWindow:ie}}O(D,O,F){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),O.focus();const j={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToMerge:F?.filesToMerge,filesToWait:F?.filesToWait,termProgram:D?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",A.CancellationToken.None,j),O}P(D,O){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),D.focus();const F={foldersToAdd:O};return D.sendWhenReady("vscode:addFolders",A.CancellationToken.None,F),D}Q(D,O,F,j,q){this.m.trace("windowsManager#doOpenEmpty",{restore:!!q,remoteAuthority:F,filesToOpen:j,forceNewWindow:O});let X;return!O&&typeof D.contextWindowId=="number"&&(X=this.getWindowById(D.contextWindowId)),this.gb({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,remoteAuthority:F,forceNewWindow:O,forceNewTabbedWindow:D.forceNewTabbedWindow,filesToOpen:j,windowToUse:X,emptyWindowBackupInfo:q,forceProfile:D.forceProfile,forceTempProfile:D.forceTempProfile})}R(D,O,F,j,q){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:j}),!F&&!q&&typeof D.contextWindowId=="number"&&(q=this.getWindowById(D.contextWindowId)),this.gb({workspace:O.workspace,userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:D.forceNewTabbedWindow,filesToOpen:j,windowToUse:q,forceProfile:D.forceProfile,forceTempProfile:D.forceTempProfile})}async S(D){let O,F=!1,j=!1;if(D.urisToOpen&&D.urisToOpen.length>0?(O=await this.U(D),F=!0):D.forceEmpty?O=[Object.create(null)]:D.cli._.length||D.cli["folder-uri"]||D.cli["file-uri"]?(O=await this.W(D.cli),O.length===0&&O.push(Object.create(null)),F=!0):(O=await this.Y(),O.length===0&&O.push(Object.create(null)),j=!0),!D.addMode&&F){const q=O.filter(X=>Y(X));if(q.length>1){const X=q[0].remoteAuthority;if(q.every(B=>(0,u.isEqualAuthority)(B.remoteAuthority,X))){const B=await this.C.createUntitledWorkspace(q.map(Q=>({uri:Q.workspace.uri})));O.push({workspace:B,remoteAuthority:X}),O=O.filter(Q=>!Y(Q))}}}if(D.initialStartup&&!j&&this.w.getValue("window")?.restoreWindows==="preserve"){const q=await this.Y();O.unshift(...q.filter(X=>z(X)||Y(X)||X.backupPath))}return O}async U(D){const O={gotoLineMode:D.gotoLineMode,remoteAuthority:D.remoteAuthority},F=await Promise.all((0,M.coalesce)(D.urisToOpen||[]).map(async j=>{const q=await this.ab(j,O);if(q)return q.label=j.label,q;const X=this.cb(j),B={title:this.H.nameLong,type:"info",buttons:[(0,p.mnemonicButtonLabel)((0,E.localize)(0,null))],defaultId:0,message:X.scheme===v.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:X.scheme===v.Schemas.file?(0,E.localize)(3,null,(0,p.getPathLabel)(X,{os:b.OS,tildify:this.s})):(0,E.localize)(4,null,X.toString(!0)),noLink:!0};this.F.showMessageBox(B,(0,m.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow()))}));return(0,M.coalesce)(F)}async W(D){const O=[],F={ignoreFileNotFound:!0,gotoLineMode:D.goto,remoteAuthority:D.remote||void 0,forceOpenWorkspaceAsFile:D.diff&&D._.length===2||D.merge&&D._.length===4},j=D["folder-uri"];if(j){const B=await Promise.all(j.map(Q=>{const ie=this.X(Q);if(!!ie)return this.ab({folderUri:ie},F)}));O.push(...(0,M.coalesce)(B))}const q=D["file-uri"];if(q){const B=await Promise.all(q.map(Q=>{const ie=this.X(Q);if(!!ie)return this.ab((0,Z.hasWorkspaceFileExtension)(Q)?{workspaceUri:ie}:{fileUri:ie},F)}));O.push(...(0,M.coalesce)(B))}const X=await Promise.all(D._.map(B=>F.remoteAuthority?this.eb(B,F):this.db(B,F)));return O.push(...(0,M.coalesce)(X)),O}X(D){try{const O=C.URI.parse(D);if(!O.scheme){this.m.error(`Invalid URI input string, scheme missing: ${D}`);return}return O}catch(O){this.m.error(`Invalid URI input string: ${D}, ${O.message}`)}}async Y(){const D=this.Z();switch(D){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];D!=="one"&&O.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&O.push(this.j.state.lastActiveWindow);const F=await Promise.all(O.map(async j=>{if(j.workspace){const q=await this.ab({workspaceUri:j.workspace.configPath},{remoteAuthority:j.remoteAuthority,rejectTransientWorkspaces:!0});if(z(q))return q}else if(j.folderUri){const q=await this.ab({folderUri:j.folderUri},{remoteAuthority:j.remoteAuthority});if(Y(q))return q}else if(D!=="folders"&&j.backupPath)return{backupPath:j.backupPath,remoteAuthority:j.remoteAuthority}}));return(0,M.coalesce)(F)}}}Z(){let D;return this.u.wasRestarted?D="all":(D=this.w.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(D)||(D="all")),D}async ab(D,O=Object.create(null)){const F=this.cb(D);return F.scheme===v.Schemas.file?((0,G.isFileToOpen)(D)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.db(F.fsPath,O)):this.bb(D,O)}bb(D,O){let F=this.cb(D);const j=(0,T.getRemoteAuthority)(F)||O.remoteAuthority;if(F=(0,u.removeTrailingPathSeparator)((0,u.normalizePath)(F)),(0,G.isFileToOpen)(D)){if(O.gotoLineMode){const{path:q,line:X,column:B}=(0,w.parseLineAndColumnAware)(F.path);return{fileUri:F.with({path:q}),options:{selection:X?{startLineNumber:X,startColumn:B||1}:void 0},remoteAuthority:j}}return{fileUri:F,remoteAuthority:j}}else if((0,G.isWorkspaceToOpen)(D))return{workspace:(0,ce.getWorkspaceIdentifier)(F),remoteAuthority:j};return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(F),remoteAuthority:j}}cb(D){return(0,G.isWorkspaceToOpen)(D)?D.workspaceUri:(0,G.isFolderToOpen)(D)?D.folderUri:D.fileUri}async db(D,O){let F,j;O.gotoLineMode&&({path:D,line:F,column:j}=(0,w.parseLineAndColumnAware)(D)),D=(0,w.sanitizeFilePath)((0,h.normalize)(D),(0,l.cwd)());try{const q=await t.Promises.stat(D);if(q.isFile()){if(!O.forceOpenWorkspaceAsFile){const X=await this.C.resolveLocalWorkspace(C.URI.file(D));if(X)return X.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:X.id,configPath:X.configPath},type:o.FileType.File,exists:!0,remoteAuthority:X.remoteAuthority,transient:X.transient}}return{fileUri:C.URI.file(D),type:o.FileType.File,exists:!0,options:{selection:F?{startLineNumber:F,startColumn:j||1}:void 0}}}else{if(q.isDirectory())return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(C.URI.file(D),q),type:o.FileType.Directory,exists:!0};if(!b.isWindows&&D==="/dev/null")return{fileUri:C.URI.file(D),type:o.FileType.File,exists:!0}}}catch{const X=C.URI.file(D);if(this.z.removeRecentlyOpened([X]),O.ignoreFileNotFound)return{fileUri:X,type:o.FileType.File,exists:!1}}}eb(D,O){const F=D.charCodeAt(0),j=O.remoteAuthority;let q,X;O.gotoLineMode&&({path:D,line:q,column:X}=(0,w.parseLineAndColumnAware)(D)),F!==47&&((0,w.isWindowsDriveLetter)(F)&&D.charCodeAt(D.charCodeAt(1))===58&&(D=(0,w.toSlashes)(D)),D=`/${D}`);const B=C.URI.from({scheme:v.Schemas.vscodeRemote,authority:j,path:D});if(D.charCodeAt(D.length-1)!==47){if((0,Z.hasWorkspaceFileExtension)(D))return O.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:q?{startLineNumber:q,startColumn:X||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,ce.getWorkspaceIdentifier)(B),remoteAuthority:j};if(O.gotoLineMode||h.posix.basename(D).indexOf(".")!==-1)return{fileUri:B,options:{selection:q?{startLineNumber:q,startColumn:X||1}:void 0},remoteAuthority:j}}return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:j}}fb(D){const O=this.w.getValue("window"),F=O?.openFoldersInNewWindow||"default",j=O?.openFilesInNewWindow||"off";let q=(D.preferNewWindow||D.forceNewWindow)&&!D.forceReuseWindow;!D.forceNewWindow&&!D.forceReuseWindow&&(F==="on"||F==="off")&&(q=F==="on");let X=!1;return D.forceNewWindow||D.forceReuseWindow?X=!!D.forceNewWindow&&!D.forceReuseWindow:(b.isMacintosh?D.context===1&&(X=!0):D.context!==3&&D.context!==2&&!(D.userEnv&&D.userEnv.TERM_PROGRAM==="vscode")&&(X=!0),!D.cli.extensionDevelopmentPath&&(j==="on"||j==="off")&&(X=j==="on")),{openFolderInNewWindow:!!q,openFilesInNewWindow:X}}async openExtensionDevelopmentHostWindow(D,O){const F=(0,K.findWindowOnExtensionDevelopmentPath)(this.getWindows(),D);if(F)return this.u.reload(F,O.cli),F.focus(),[F];let j=O.cli["folder-uri"]||[],q=O.cli["file-uri"]||[],X=O.cli._;if(!X.length&&!j.length&&!q.length&&!O.cli.extensionTestsPath){const ie=this.j.state.lastPluginDevelopmentHostWindow,ae=ie?.workspace??ie?.folderUri;ae&&(C.URI.isUri(ae)?ae.scheme===v.Schemas.file?X=[ae.fsPath]:j=[ae.toString()]:ae.configPath.scheme===v.Schemas.file?X=[(0,u.originalFSPath)(ae.configPath)]:q=[ae.configPath.toString()])}let B=O.remoteAuthority;for(const ie of D)if(ie.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ae=C.URI.parse(ie),de=(0,T.getRemoteAuthority)(ae);de&&(B?(0,u.isEqualAuthority)(de,B)||this.m.error("more than one extension development path authority"):B=de)}X=X.filter(ie=>{const ae=C.URI.file(ie);return(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:(0,u.isEqualAuthority)((0,T.getRemoteAuthority)(ae),B)}),j=j.filter(ie=>{const ae=this.X(ie);return ae&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,u.isEqualAuthority)((0,T.getRemoteAuthority)(ae),B):!1}),q=q.filter(ie=>{const ae=this.X(ie);return ae&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,u.isEqualAuthority)((0,T.getRemoteAuthority)(ae),B):!1}),O.cli._=X,O.cli["folder-uri"]=j,O.cli["file-uri"]=q;const Q={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!X.length&&!j.length&&!q.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:B,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(Q)}async gb(D){const O=this.w.getValue("window");let F;!D.forceNewWindow&&!D.forceNewTabbedWindow&&(F=D.windowToUse||this.getLastActiveWindow(),F&&F.focus());const j={...this.s.args,...D.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.s.appRoot,execPath:process.execPath,codeCachePath:this.s.codeCachePath,backupPath:D.emptyWindowBackupInfo?(0,h.join)(this.s.backupHome,D.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.t.profiles,profile:this.t.defaultProfile},homeDir:this.s.userHome.fsPath,tmpDir:this.s.tmpDir.fsPath,userDataDir:this.s.userDataPath,remoteAuthority:D.remoteAuthority,workspace:D.workspace,userEnv:{...this.l,...D.userEnv},filesToOpenOrCreate:D.filesToOpen?.filesToOpenOrCreate,filesToDiff:D.filesToOpen?.filesToDiff,filesToMerge:D.filesToOpen?.filesToMerge,filesToWait:D.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),logsPath:this.s.logsPath,product:f.default,isInitialStartup:D.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.r.serialize(),continueOn:this.s.continueOn};if(F){const q=F.config;!j.extensionDevelopmentPath&&q?.extensionDevelopmentPath&&(j.extensionDevelopmentPath=q.extensionDevelopmentPath,j.extensionDevelopmentKind=q.extensionDevelopmentKind,j["enable-proposed-api"]=q["enable-proposed-api"],j.verbose=q.verbose,j["inspect-extensions"]=q["inspect-extensions"],j["inspect-brk-extensions"]=q["inspect-brk-extensions"],j.debugId=q.debugId,j.extensionEnvironment=q.extensionEnvironment,j["extensions-dir"]=q["extensions-dir"],j["disable-extensions"]=q["disable-extensions"])}else{const q=this.j.getNewWindowState(j);(0,d.mark)("code/willCreateCodeWindow");const X=F=this.D.createInstance(H.CodeWindow,{state:q,extensionDevelopmentPath:j.extensionDevelopmentPath,isExtensionTestHost:!!j.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),D.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(X),mt.a.push(X),this.b.fire(X),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,g.once)(X.onDidSignalReady)(()=>this.c.fire(X)),(0,g.once)(X.onDidClose)(()=>this.jb(X)),(0,g.once)(X.onDidDestroy)(()=>this.f.fire(X)),X.onDidTriggerSystemContextMenu(({x:Q,y:ie})=>this.h.fire({window:X,x:Q,y:ie}));const B=(0,m.assertIsDefined)(X.win?.webContents);B.removeAllListeners("devtools-reload-page"),B.on("devtools-reload-page",()=>this.u.reload(X)),this.u.registerWindow(X)}return j.windowId=F.id,F.isReady?this.u.unload(F,4).then(async q=>{q||await this.hb(F,j,D)}):await this.hb(F,j,D),F}async hb(D,O,F){if(O.extensionDevelopmentPath||((0,Z.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,Z.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.v.registerEmptyWindowBackup({backupFolder:F.emptyWindowBackupInfo?.backupFolder??(0,ce.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),this.t.isEnabled()){const j=O.workspace??(0,Z.toWorkspaceIdentifier)(O.backupPath,!1),q=this.ib(F,j),X=q instanceof Promise?await q:q;O.profiles.profile=X,O.extensionDevelopmentPath||await this.t.setProfileForWorkspace(j,X)}D.load(O)}ib(D,O){return D.forceProfile?this.t.profiles.find(F=>F.name===D.forceProfile)??this.t.createNamedProfile(D.forceProfile):D.forceTempProfile?this.t.createTransientProfile():this.t.getProfileForWorkspace(O)??this.t.defaultProfile}jb(D){const O=mt.a.indexOf(D);mt.a.splice(O,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const D=S.BrowserWindow.getFocusedWindow();if(D)return this.getWindowById(D.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(D){return this.lb(this.getWindows().filter(O=>(0,u.isEqualAuthority)(O.remoteAuthority,D)))}lb(D){const O=Math.max.apply(Math,D.map(F=>F.lastFocusTime));return D.find(F=>F.lastFocusTime===O)}sendToFocused(D,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(D,A.CancellationToken.None,...O)}sendToAll(D,O,F){for(const j of this.getWindows())F&&F.indexOf(j.id)>=0||j.sendWhenReady(D,A.CancellationToken.None,O)}getWindows(){return mt.a}getWindowCount(){return mt.a.length}getWindowById(D){const O=this.getWindows().filter(F=>F.id===D);return(0,M.firstOrDefault)(O)}getWindowByWebContents(D){const O=S.BrowserWindow.fromWebContents(D);if(!!O)return this.getWindowById(O.id)}};oe.a=[],oe=pe([x(2,s.ILogService),x(3,U.IStateMainService),x(4,N.IPolicyService),x(5,n.IEnvironmentMainService),x(6,W.IUserDataProfilesMainService),x(7,c.ILifecycleMainService),x(8,R.IBackupMainService),x(9,i.IConfigurationService),x(10,ge.IWorkspacesHistoryMainService),x(11,_.IWorkspacesManagementMainService),x(12,a.IInstantiationService),x(13,r.IDialogMainService),x(14,o.IFileService),x(15,P.IProductService),x(16,L.IProtocolMainService),x(17,$.IThemeMainService)],oe),e.WindowsMainService=oe}),define(te[276],ne([0,1,62,32,76,53]),function(V,e,S,t,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let A=class{constructor(w,g,p,y){this.a=w,this.b=g,this.c=p,this.d=y,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(w,g){const p=this.b.getWindowById(w);if(p)return this.a.enterWorkspace(p,this.b.getWindows(),g)}createUntitledWorkspace(w,g,p){return this.a.createUntitledWorkspace(g,p)}deleteUntitledWorkspace(w,g){return this.a.deleteUntitledWorkspace(g)}getWorkspaceIdentifier(w,g){return this.a.getWorkspaceIdentifier(g)}getRecentlyOpened(w){return this.c.getRecentlyOpened()}addRecentlyOpened(w,g){return this.c.addRecentlyOpened(g)}removeRecentlyOpened(w,g){return this.c.removeRecentlyOpened(g)}clearRecentlyOpened(w){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};A=pe([x(0,M.IWorkspacesManagementMainService),x(1,t.IWindowsMainService),x(2,k.IWorkspacesHistoryMainService),x(3,S.IBackupMainService)],A),e.WorkspacesMainService=A}),define(te[277],ne([0,1,14,42,25,17,45,13,31,50,43,36,2,15,9,4,11,7,30,132,47,146,103,252,149,62,268,18,71,181,85,119,57,106,204,27,61,110,194,216,195,254,107,196,197,16,208,87,70,5,86,269,229,255,21,6,210,274,58,19,55,262,89,34,258,93,90,29,234,112,51,49,243,244,270,245,271,115,247,248,249,250,256,32,275,257,28,94,76,276,53,253,38,215,52,225,56,75,117,260,266,264,8,113,259]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m,C,E,R,i,r,n,o,a,c,s,f,P,L,T,U,G,H,K,se,Z,ce,ge,_,$,N,W,z,Y,oe,ee,D,O,F,j,q,X,B,Q,ie,ae,de,ke,Oe,De,Me,ve,we,ye,Re,re,he,fe,be,Pe,We,Te,qe,Ue,je,Xe,$e,Ke,J,le,ue,me,Se,Le,Be,it,xe,He,tt,nt,lt,at,jt,Bt,$t,zt,qt,Ht,Vt,Pt,Gt,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ct=class extends v.Disposable{constructor(Ee,Ce,Ae,Ie,Fe,ze,_e,et,Ne,Ge,Je){super(),this.c=Ee,this.f=Ce,this.g=Ae,this.h=Ie,this.i=Fe,this.j=ze,this.k=_e,this.l=et,this.m=Ne,this.n=Ge,this.p=Je,this.r(),this.s()}r(){const Ee=Ne=>Ne?.startsWith(`${h.Schemas.vscodeWebview}://`),Ce=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((Ne,Ge,Je,Ze)=>Ee(Ze.requestingUrl)?Je(Ce.has(Ge)):Je(!1)),S.session.defaultSession.setPermissionCheckHandler((Ne,Ge,Je,Ze)=>Ee(Ze.requestingUrl)?Ce.has(Ge):!1);const Ae=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),Ie=Ne=>{for(let Ge=Ne;Ge;Ge=Ge.parent)if(Ge.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},Fe=Ne=>Ne.resourceType==="xhr"||Ie(Ne.frame),ze=Ne=>{const Ge=Ne.frame;if(!Ge||!this.a)return!1;const Je=S.BrowserWindow.getAllWindows();for(const Ze of Je)if(Ge.processId===Ze.webContents.mainFrame.processId)return!0;return!1},_e=(Ne,Ge)=>{if(Ne.path!=="/index.html")return!0;const Je=Ge.frame;if(!Je||!this.a)return!1;for(const Ze of this.a.getWindows())if(Ze.win&&Je.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((Ne,Ge)=>{const Je=u.URI.parse(Ne.url);return Je.scheme===h.Schemas.vscodeWebview&&!_e(Je,Ne)?(this.h.error("Blocked vscode-webview request",Ne.url),Ge({cancel:!0})):Je.scheme===h.Schemas.vscodeFileResource&&!ze(Ne)?(this.h.error("Blocked vscode-file request",Ne.url),Ge({cancel:!0})):Je.path.endsWith(".svg")&&!Ae.has(Je.scheme)?Ge({cancel:!Fe(Ne)}):Ge({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((Ne,Ge)=>{const Je=Ne.responseHeaders,Ze=Je["content-type"]||Je["Content-Type"];if(Ze&&Array.isArray(Ze)){const st=u.URI.parse(Ne.url);if(st.path.endsWith(".svg")&&Ae.has(st.scheme))return Je["Content-Type"]=["image/svg+xml"],Ge({cancel:!1,responseHeaders:Je});if(!st.path.endsWith(h.Schemas.vscodeRemoteResource)&&Ze.some(ct=>ct.toLowerCase().includes("image/svg")))return Ge({cancel:!Fe(Ne)})}return Ge({cancel:!1})});const et=S.session.defaultSession;typeof et.setCodeCachePath=="function"&&this.i.codeCachePath&&et.setCodeCachePath((0,d.join)(this.i.codeCachePath,"chrome"))}s(){(0,I.setUnexpectedErrorHandler)(Ae=>this.u(Ae)),process.on("uncaughtException",Ae=>(0,I.onUnexpectedError)(Ae)),process.on("unhandledRejection",Ae=>(0,I.onUnexpectedError)(Ae)),this.j.onWillShutdown(()=>this.dispose()),(0,C.registerContextMenuListener)(),S.app.on("accessibility-support-changed",(Ae,Ie)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),S.app.on("activate",async(Ae,Ie)=>{this.h.trace("app#activate"),Ie||await this.a?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Ae,Ie)=>{Ie.on("will-navigate",Fe=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),Ie.setWindowOpenHandler(({url:Fe})=>(this.b?.openExternal(void 0,Fe),{action:"deny"}))});let Ee=[],Ce;S.app.on("open-file",(Ae,Ie)=>{this.h.trace("app#open-file: ",Ie),Ae.preventDefault(),Ee.push((0,Le.hasWorkspaceFileExtension)(Ie)?{workspaceUri:u.URI.file(Ie)}:{fileUri:u.URI.file(Ie)}),Ce!==void 0&&(clearTimeout(Ce),Ce=void 0),Ce=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],Ce=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Ae=>{const Ie=this.a?.getWindowByWebContents(Ae.sender);let Fe,ze;return Ie?.config?(Fe=Ie.config,ze={...process.env,...Ie.config.userEnv}):(Fe=this.i.args,ze=process.env),this.J(Fe,ze,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Ae,Ie,Fe)=>{const ze=this.t([Ie]);if(!ze||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(ze,M.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Ae,...Ie)=>{const Fe=this.t(Ie);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Ae=>Ae.sender.reload())}t(Ee){let Ce;for(const Ae of Ee)typeof Ae=="string"&&(typeof Ce!="string"?Ce=Ae:Ce=(0,d.join)(Ce,Ae));if(!(typeof Ce!="string"||!(0,d.isAbsolute)(Ce)||!(0,w.isEqualOrParent)(Ce,this.i.cachedLanguagesPath,!b.isLinux)))return u.URI.file(Ce)}u(Ee){if(Ee){const Ce={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ce))}this.h.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.h.error(Ee.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Ee=this.n.win32AppUserModelId;b.isWindows&&Ee&&S.app.setAppUserModelId(Ee);try{b.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const Ce=new R.Server;this.j.onWillShutdown(Ne=>{Ne.reason===2&&Ce.dispose()}),this.h.trace("Resolving machine identifier...");const Ae=await(0,Gt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcess:Ie,sharedProcessReady:Fe,sharedProcessClient:ze}=this.w(Ae),_e=await this.y(Ae,Ie,Fe);this.v(_e),_e.invokeFunction(Ne=>this.z(Ne,Ce,ze)),await _e.invokeFunction(Ne=>this.C(Ne,Ce)),_e.invokeFunction(Ne=>this.G(Ne,Ie)),this.B(new Pt.RunOnceScheduler(()=>{this.B((0,Pt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Ee){this.B(Ee.createInstance(r.ProxyAuthHandler)),this.B(Ee.createInstance(Ht.UserDataProfilesHandler))}w(Ee){const Ce=this.B(this.g.createInstance(Oe.SharedProcess,Ee,this.f)),Ae=(async()=>{this.h.trace("Main->SharedProcess#connect");const Fe=await Ce.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new i.Client(Fe,"main")})(),Ie=(async()=>(await Ce.whenReady(),Ae))();return{sharedProcess:Ce,sharedProcessReady:Ie,sharedProcessClient:Ae}}async y(Ee,Ce,Ae){const Ie=new O.ServiceCollection;switch(process.platform){case"win32":Ie.set(be.IUpdateService,new ee.SyncDescriptor(Ue.Win32UpdateService));break;case"linux":b.isLinuxSnap?Ie.set(be.IUpdateService,new ee.SyncDescriptor(qe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(be.IUpdateService,new ee.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Ie.set(be.IUpdateService,new ee.SyncDescriptor(We.DarwinUpdateService));break}Ie.set(ue.IWindowsMainService,new ee.SyncDescriptor(me.WindowsMainService,[Ee,this.f],!1));const Fe=new T.DialogMainService(this.h);Ie.set(T.IDialogMainService,Fe),Ie.set(q.ILaunchMainService,new ee.SyncDescriptor(q.LaunchMainService,void 0,!1)),Ie.set(L.IDiagnosticsMainService,new ee.SyncDescriptor(L.DiagnosticsMainService,void 0,!1)),Ie.set(P.IDiagnosticsService,E.ProxyChannel.toService((0,E.getDelayedChannel)(Ae.then(et=>et.getChannel("diagnostics"))))),Ie.set(F.IIssueMainService,new ee.SyncDescriptor(F.IssueMainService,[this.f])),Ie.set(U.IEncryptionMainService,new ee.SyncDescriptor(G.EncryptionMainService,[Ee])),Ie.set(j.IKeyboardLayoutMainService,new ee.SyncDescriptor(j.KeyboardLayoutMainService)),Ie.set(ae.INativeHostMainService,new ee.SyncDescriptor(ae.NativeHostMainService,[Ce],!1)),Ie.set(s.ICredentialsMainService,new ee.SyncDescriptor(tt.CredentialsNativeMainService)),Ie.set(J.IWebviewManagerService,new ee.SyncDescriptor(le.WebviewMainService)),Ie.set(ie.IMenubarMainService,new ee.SyncDescriptor(ie.MenubarMainService)),Ie.set(Z.IExtensionUrlTrustService,new ee.SyncDescriptor(ce.ExtensionUrlTrustService)),Ie.set(ge.IExtensionHostStarter,new ee.SyncDescriptor(_.ExtensionHostStarter)),Ie.set(we.IStorageMainService,new ee.SyncDescriptor(we.StorageMainService)),Ie.set(we.IApplicationStorageMainService,new ee.SyncDescriptor(we.ApplicationStorageMainService)),b.isWindows?Ie.set($.IExternalTerminalMainService,new ee.SyncDescriptor(N.WindowsExternalTerminalService)):b.isMacintosh?Ie.set($.IExternalTerminalMainService,new ee.SyncDescriptor(N.MacExternalTerminalService)):b.isLinux&&Ie.set($.IExternalTerminalMainService,new ee.SyncDescriptor(N.LinuxExternalTerminalService));const ze=new a.BackupMainService(this.i,this.k,this.h,this.l);Ie.set(o.IBackupMainService,ze);const _e=new He.WorkspacesManagementMainService(this.i,this.h,this.p,ze,Fe,this.n);if(Ie.set(He.IWorkspacesManagementMainService,_e),Ie.set(Be.IWorkspacesService,new ee.SyncDescriptor(xe.WorkspacesMainService,void 0,!1)),Ie.set(it.IWorkspacesHistoryMainService,new ee.SyncDescriptor(it.WorkspacesHistoryMainService,void 0,!1)),Ie.set(je.IURLService,new ee.SyncDescriptor($e.NativeURLService,void 0,!1)),(0,fe.supportsTelemetry)(this.n,this.i)){const et=(0,fe.isInternalTelemetry)(this.n,this.k),Ne=(0,E.getDelayedChannel)(Ae.then(ct=>ct.getChannel("telemetryAppender"))),Ge=new re.TelemetryAppenderClient(Ne),Je=(0,ye.resolveCommonProperties)(this.m,(0,k.release)(),(0,k.hostname)(),process.arch,this.n.commit,this.n.version,Ee,et,this.i.installSourcePath),Ze=(0,fe.getPiiPathsFromEnvironment)(this.i),st={appenders:[Ge],commonProperties:Je,piiPaths:Ze,sendErrorTelemetry:!0};Ie.set(Re.ITelemetryService,new ee.SyncDescriptor(he.TelemetryService,[st],!1))}else Ie.set(Re.ITelemetryService,fe.NullTelemetryService);return Ie.set($t.IExtensionsProfileScannerService,new ee.SyncDescriptor(Kt.ExtensionsProfileScannerService,void 0,!0)),Ie.set(zt.IExtensionsScannerService,new ee.SyncDescriptor(qt.ExtensionsScannerService,void 0,!0)),await Pt.Promises.settled([ze.initialize(),_e.initialize()]),this.g.createChild(Ie)}z(Ee,Ce,Ae){const Ie=E.ProxyChannel.fromService(Ee.get(q.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Ie);const Fe=E.ProxyChannel.fromService(Ee.get(L.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Fe);const ze=new lt.PolicyChannel(Ee.get(nt.IPolicyService));Ce.registerChannel("policy",ze),Ae.then(Ye=>Ye.registerChannel("policy",ze));const _e=this.m.getProvider(h.Schemas.file);(0,l.assertType)(_e instanceof oe.DiskFileSystemProvider);const et=new Y.DiskFileSystemProviderChannel(_e,this.h,this.i);Ce.registerChannel(W.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et),Ae.then(Ye=>Ye.registerChannel(W.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et));const Ne=E.ProxyChannel.fromService(Ee.get(at.IUserDataProfilesMainService));Ce.registerChannel("userDataProfiles",Ne),Ae.then(Ye=>Ye.registerChannel("userDataProfiles",Ne));const Ge=new jt.RequestChannel(Ee.get(Bt.IRequestService));Ae.then(Ye=>Ye.registerChannel("request",Ge));const Je=new Pe.UpdateChannel(Ee.get(be.IUpdateService));Ce.registerChannel("update",Je);const Ze=E.ProxyChannel.fromService(Ee.get(F.IIssueMainService));Ce.registerChannel("issue",Ze);const st=E.ProxyChannel.fromService(Ee.get(U.IEncryptionMainService));Ce.registerChannel("encryption",st);const ct=E.ProxyChannel.fromService(Ee.get(s.ICredentialsMainService));Ce.registerChannel("credentials",ct);const kt=E.ProxyChannel.fromService(Ee.get(De.ISignService));Ce.registerChannel("sign",kt);const Qe=E.ProxyChannel.fromService(Ee.get(j.IKeyboardLayoutMainService));Ce.registerChannel("keyboardLayout",Qe),this.b=Ee.get(ae.INativeHostMainService);const wt=E.ProxyChannel.fromService(this.b);Ce.registerChannel("nativeHost",wt),Ae.then(Ye=>Ye.registerChannel("nativeHost",wt));const pt=E.ProxyChannel.fromService(Ee.get(Be.IWorkspacesService));Ce.registerChannel("workspaces",pt);const yt=E.ProxyChannel.fromService(Ee.get(ie.IMenubarMainService));Ce.registerChannel("menubar",yt);const Dt=E.ProxyChannel.fromService(Ee.get(je.IURLService));Ce.registerChannel("url",Dt);const Rt=E.ProxyChannel.fromService(Ee.get(Z.IExtensionUrlTrustService));Ce.registerChannel("extensionUrlTrust",Rt);const vt=E.ProxyChannel.fromService(Ee.get(J.IWebviewManagerService));Ce.registerChannel("webview",vt);const ut=this.B(new ve.StorageDatabaseChannel(this.h,Ee.get(we.IStorageMainService)));Ce.registerChannel("storage",ut),Ae.then(Ye=>Ye.registerChannel("storage",ut));const St=this.B(new Vt.ProfileStorageChangesListenerChannel(Ee.get(we.IStorageMainService),Ee.get(at.IUserDataProfilesMainService),this.h));Ae.then(Ye=>Ye.registerChannel("profileStorageListener",St));const bt=E.ProxyChannel.fromService(Ee.get($.IExternalTerminalMainService));Ce.registerChannel("externalTerminal",bt);const ht=new Q.LogLevelChannel(Ee.get(B.ILogService),Ee.get(B.ILoggerService));Ce.registerChannel("logLevel",ht),Ae.then(Ye=>Ye.registerChannel("logLevel",ht));const Ve=new Q.LoggerChannel(Ee.get(B.ILoggerService));Ce.registerChannel("logger",Ve),Ae.then(Ye=>Ye.registerChannel("logger",Ve));const ot=new f.ElectronExtensionHostDebugBroadcastChannel(Ee.get(ue.IWindowsMainService));Ce.registerChannel("extensionhostdebugservice",ot);const ft=E.ProxyChannel.fromService(Ee.get(ge.IExtensionHostStarter));Ce.registerChannel(ge.ipcExtensionHostStarterChannelName,ft)}async C(Ee,Ce){const Ae=this.a=Ee.get(ue.IWindowsMainService),Ie=Ee.get(je.IURLService),Fe=Ee.get(ae.INativeHostMainService);this.j.phase=2;const ze=[],_e=[...this.i.args["open-url"]?this.i.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ve=>{try{return{uri:u.URI.parse(Ve),url:Ve}}catch{return}}).filter(Ve=>{if(!Ve||this.D(Ve.uri))return!1;const ot=this.F(Ve.uri);return ot?(ze.push(ot),!1):!0}),et=this,Ne=this.i,Ge=this.n,Je=this.h;Ie.registerHandler({async handleURL(Ve,ot){if(Je.trace("app#handleURL: ",Ve.toString(!0),ot),Ve.scheme===Ge.urlProtocol&&Ve.path==="workspace"&&(Ve=Ve.with({authority:"file",path:u.URI.parse(Ve.query).path,query:""})),et.D(Ve))return!0;let ft=!1;const Ye=new URLSearchParams(Ve.query);Ye.get("windowId")==="_blank"&&(Ye.delete("windowId"),Ve=Ve.with({query:Ye.toString()}),ft=!0),ft||=b.isMacintosh&&Ae.getWindowCount()===0;const Wt=Ye.get("continueOn");Wt!==null&&(Ne.continueOn=Wt??void 0,Ye.delete("continueOn"),Ve=Ve.with({query:Ye.toString()}));const Mt=et.F(Ve);if(Je.trace("app#handleURL: windowOpenableFromProtocolLink = ",Mt),Mt){const[At]=await Ae.open({context:5,cli:{...Ne.args},urisToOpen:[Mt],forceNewWindow:ft,gotoLineMode:!0});return At.focus(),!0}if(ft){const[At]=await Ae.open({context:5,cli:{...Ne.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ke.getRemoteAuthority)(Ve)});return await At.ready(),Ie.open(Ve,ot)}return!1}});const Ze=this.B(new Se.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),st=new E.StaticRouter(Ve=>Ze.getActiveClientId().then(ot=>Ve===ot)),ct=new Xe.URLHandlerRouter(st),kt=Ce.getChannel("urlHandler",ct);Ie.registerHandler(new Xe.URLHandlerChannelClient(kt)),this.B(new Ke.ElectronURLListener(_e,Ie,Ae,this.i,this.n));const Qe=this.i.args,wt=global.macOpenFiles,pt=(0,K.isLaunchedFromCli)(process.env)?0:4,yt=Qe._.length,Dt=!!Qe["folder-uri"],Rt=!!Qe["file-uri"],vt=Qe["skip-add-to-recently-opened"]===!0,ut=Qe.wait&&Qe.waitMarkerFilePath?u.URI.file(Qe.waitMarkerFilePath):void 0,St=Qe.remote||void 0,bt=Qe.profile,ht=Qe["profile-temp"];if(ze.length>0)return Ae.open({context:pt,cli:Qe,urisToOpen:ze,gotoLineMode:!0,initialStartup:!0});if(!yt&&!Dt&&!Rt){if(Qe["new-window"]||bt||ht)return Ae.open({context:pt,cli:Qe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:vt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:St,forceProfile:bt,forceTempProfile:ht});if(wt.length)return Ae.open({context:1,cli:Qe,urisToOpen:wt.map(Ve=>(0,Le.hasWorkspaceFileExtension)(Ve)?{workspaceUri:u.URI.file(Ve)}:{fileUri:u.URI.file(Ve)}),noRecentEntry:vt,waitMarkerFileURI:ut,initialStartup:!0})}return Ae.open({context:pt,cli:Qe,forceNewWindow:Qe["new-window"]||!yt&&Qe["unity-launch"],diffMode:Qe.diff,mergeMode:Qe.merge,noRecentEntry:vt,waitMarkerFileURI:ut,gotoLineMode:Qe.goto,initialStartup:!0,remoteAuthority:St,forceProfile:bt,forceTempProfile:ht})}D(Ee){return!!(Ee.authority===h.Schemas.file&&b.isWindows&&S.dialog.showMessageBoxSync({title:this.n.nameLong,type:"question",buttons:[(0,y.mnemonicButtonLabel)((0,n.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,n.localize)(1,null))],defaultId:0,cancelId:1,message:(0,n.localize)(2,null,(0,y.getPathLabel)(Ee,{os:b.OS,tildify:this.i}),this.n.nameShort),detail:(0,n.localize)(3,null),noLink:!0})===1)}F(Ee){if(!!Ee.path){if(Ee.authority===h.Schemas.file){const Ce=u.URI.file(Ee.fsPath);return(0,Le.hasWorkspaceFileExtension)(Ce)?{workspaceUri:Ce}:{fileUri:Ce}}else if(Ee.authority===h.Schemas.vscodeRemote){const Ce=Ee.path.indexOf(d.posix.sep,1);if(Ce!==-1){const Ae=Ee.path.substring(1,Ce),Ie=Ee.path.substring(Ce),Fe=u.URI.from({scheme:h.Schemas.vscodeRemote,authority:Ae,path:Ie,query:Ee.query,fragment:Ee.fragment});return(0,Le.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Fe}:/:[\d]+$/.test(Ie)?{fileUri:Fe}:{folderUri:Fe}}}}}G(Ee,Ce){const Ae=Ee.get(Re.ITelemetryService),Ie=Ee.get(be.IUpdateService);this.j.phase=3,this.I(Ae,Ce),this.H(),S.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(Fe,ze)=>{ze({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})}),(Ie instanceof Ue.Win32UpdateService||Ie instanceof Te.LinuxUpdateService||Ie instanceof We.DarwinUpdateService)&&Ie.initialize(),this.J(this.i.args,process.env,!0),this.L()}async H(){const Ee=this.n.win32MutexName;if(b.isWindows&&Ee)try{const Ce=await new Promise((Ie,Fe)=>{V(["windows-mutex"],Ie,Fe)}),Ae=new Ce.Mutex(Ee);(0,g.once)(this.j.onWillShutdown)(()=>Ae.release())}catch(Ce){this.h.error(Ce)}}I(Ee,Ce){let Ae=!1;(0,g.once)(this.j.onWillShutdown)(()=>Ae=!0),this.B(Ce.onDidError(({type:Ie,details:Fe})=>{let ze;switch(Ie){case 1:ze="SharedProcess: detected unresponsive window";break;case 2:ze=`SharedProcess: renderer process gone (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:ze=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(ze)),Ee.publicLog2("sharedprocesserror",{type:Ie,reason:Fe?.reason,code:Fe?.exitCode,visible:Ce.isVisible(),shuttingdown:Ae})}))}async J(Ee,Ce,Ae){try{return await(0,se.getResolvedShellEnv)(this.k,this.h,Ee,Ce)}catch(Ie){const Fe=(0,A.toErrorMessage)(Ie);Ae?this.a?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.h.error(Fe)}return{}}async L(){try{const Ce=(await this.m.readFile(this.i.argvResource)).value.toString(),Ae=JSON.parse((0,p.stripComments)(Ce)),Fe=(0,fe.getTelemetryLevel)(this.k)>=1;if(Ae["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,m.generateUuid)()}"`,"}"],_e=Ce.substring(0,Ce.length-2).concat(`,
`,ze.join(`
`));await this.m.writeFile(this.i.argvResource,M.VSBuffer.fromString(_e))}else{const ze=Ce.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Fe},`);ze!==Ce&&await this.m.writeFile(this.i.argvResource,M.VSBuffer.fromString(ze))}}catch(Ee){this.h.error(Ee)}}};Ct=pe([x(2,D.IInstantiationService),x(3,B.ILogService),x(4,H.IEnvironmentMainService),x(5,X.ILifecycleMainService),x(6,c.IConfigurationService),x(7,Me.IStateMainService),x(8,z.IFileService),x(9,de.IProductService),x(10,at.IUserDataProfilesMainService)],Ct),e.CodeApplication=Ct}),define(te[278],ne([0,1,38,8,286,2,6]),function(V,e,S,t,k,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let I=class extends S.AbstractPolicyService{constructor(g,p){super(),this.j=g,this.k=p,this.a=new t.Throttler,this.b=this.B(new M.MutableDisposable)}async i(g){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(g).length} policy definitions`),await this.a.queue(()=>new Promise((p,y)=>{try{this.b.value=(0,k.createWatcher)(this.k,g,v=>{this.m(v),p()})}catch(v){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),y(v)}}))}m(g){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(g)}`);for(const p in g){const y=g[p];y===void 0?this.g.delete(p):this.g.set(p,y)}this.h.fire(Object.keys(g))}};I=pe([x(0,A.ILogService)],I),e.NativePolicyService=I}),define(te[279],ne([0,1,227,8,17,13,2,11,18,33,110,6,226,287]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends A.Disposable{constructor(l,u,m){super(),this.h=l,this.i=u,this.j=m,this.k(),this.B(l.onDidChangeConfiguration(C=>{C.affectsConfiguration("http")&&this.k()}))}k(){const l=this.h.getValue("http");this.a=l?.proxy,this.b=!!l?.proxyStrictSSL,this.f=l?.proxyAuthorization}async request(l,u){this.j.trace("RequestService#request (node) - begin",l.url);const{a:m,b:C}=this;let E;try{E=await(0,p.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(r){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",r))}const R={...process.env,...E},i=l.agent?l.agent:await(0,v.getProxyAgent)(l.url||"",R,{proxyUrl:m,strictSSL:C});l.agent=i,l.strictSSL=C,this.f&&(l.headers={...l.headers||{},"Proxy-Authorization":this.f});try{const r=await this.m(l,u);return this.j.trace("RequestService#request (node) - success",l.url),r}catch(r){throw this.j.trace("RequestService#request (node) - error",l.url,r),r}}async l(l){return((0,S.parse)(l.url).protocol==="https:"?await new Promise((C,E)=>{V(["https"],C,E)}):await new Promise((C,E)=>{V(["http"],C,E)})).request}m(l,u){return t.Promises.withAsyncBody(async(m,C)=>{const E=(0,S.parse)(l.url),R=l.getRawRequest?l.getRawRequest(l):await this.l(l),i={hostname:E.hostname,port:E.port?parseInt(E.port):E.protocol==="https:"?443:80,protocol:E.protocol,path:E.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,I.isBoolean)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(i.auth=l.user+":"+l.password);const r=R(i,n=>{const o=(0,I.isNumber)(l.followRedirects)?l.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&o>0&&n.headers.location)this.m({...l,url:n.headers.location,followRedirects:o-1},u).then(m,C);else{let a=n;!l.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(a=n.pipe((0,h.createGunzip)())),m({res:n,stream:(0,k.streamToBufferReadableStream)(a)})}});r.on("error",C),l.timeout&&r.setTimeout(l.timeout),l.isChromiumNetwork&&r.removeHeader("Content-Length"),l.data&&typeof l.data=="string"&&r.write(l.data),r.end(),u.onCancellationRequested(()=>{r.abort(),C(new M.CancellationError)})})}async resolveProxy(l){}};d=pe([x(0,w.IConfigurationService),x(1,g.INativeEnvironmentService),x(2,y.ILogService)],d),e.RequestService=d}),define(te[280],ne([0,1,14,279]),function(V,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(A){return S.net.request}class M extends t.RequestService{request(I,w){return super.request({...I||{},getRawRequest:k,isChromiumNetwork:!0},w)}}e.RequestMainService=M}),define(te[288],ne([0,1,14,41,7,24,8,45,13,31,50,36,15,9,73,4,35,26,23,47,84,277,10,18,220,233,27,61,185,16,206,87,70,202,86,21,209,6,212,63,19,64,261,114,241,56,280,89,228,34,232,51,66,52,38,278,214,2,39,246,37,242]),function(V,e,S,t,k,M,A,I,w,g,p,y,v,h,d,b,l,u,m,C,E,R,i,r,n,o,a,c,s,f,P,L,T,U,G,H,K,se,Z,ce,ge,_,$,N,W,z,Y,oe,ee,D,O,F,j,q,X,B,Q,ie,ae,de,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Oe{main(){try{this.a()}catch(ve){console.error(ve.message),S.app.exit(1)}}async a(){(0,w.setUnexpectedErrorHandler)(Pe=>console.error(Pe));const[ve,we,ye,Re,re,he,fe,be]=this.b();try{try{await this.d(ye,be,Re,re,fe)}catch(Pe){throw this.f(ye,fe.nameLong,Pe),Pe}await ve.invokeFunction(async Pe=>{const We=Pe.get(se.ILogService),Te=Pe.get(H.ILifecycleMainService),qe=Pe.get(f.IFileService),Ue=Pe.get(se.ILoggerService),je=await this.e(We,ye,Te,ve,fe,!0);return m.Promises.writeFile(ye.mainLockfile,String(process.pid)).catch(Xe=>{We.warn(`Error writing main lockfile: ${Xe.stack}`)}),he.logger=Ue.createLogger(k.URI.file((0,h.join)(ye.logsPath,"main.log")),{name:"main"}),(0,p.once)(Te.onWillShutdown)(Xe=>{qe.dispose(),Re.dispose(),Xe.join(m.Promises.unlink(ye.mainLockfile).catch(()=>{}))}),ve.createInstance(R.CodeApplication,je,we).startup()})}catch(Pe){ve.invokeFunction(this.i,Pe)}}b(){const ve=new G.ServiceCollection,we=new ie.DisposableStore;process.once("exit",()=>we.dispose());const ye={_serviceBrand:void 0,...ce.default};ve.set(ge.IProductService,ye);const Re=new a.EnvironmentMainService(this.j(),ye),re=this.c(Re);ve.set(a.IEnvironmentMainService,Re);const he=new K.BufferLogService,fe=we.add(new se.MultiplexLogService([new se.ConsoleMainLogger((0,se.getLogLevel)(Re)),he]));ve.set(se.ILogService,fe);const be=new P.FileService(fe);ve.set(f.IFileService,be);const Pe=new L.DiskFileSystemProvider(fe);be.registerProvider(v.Schemas.file,Pe);const We=new de.UriIdentityService(be);ve.set(ae.IUriIdentityService,We),ve.set(se.ILoggerService,new Z.LoggerService(fe));const Te=new O.StateMainService(Re,fe,be);ve.set(D.IStateMainService,Te);const qe=new q.UserDataProfilesMainService(Te,We,Re,be,fe);ve.set(q.IUserDataProfilesMainService,qe);const Ue=b.isWindows&&ye.win32RegValueName?we.add(new B.NativePolicyService(fe,ye.win32RegValueName)):Re.policyFile?we.add(new Q.FilePolicyService(Re.policyFile,be,fe)):new X.NullPolicyService;ve.set(X.IPolicyService,Ue);const je=new n.ConfigurationService(qe.defaultProfile.settingsResource,be,Ue,fe);return ve.set(r.IConfigurationService,je),ve.set(H.ILifecycleMainService,new T.SyncDescriptor(H.LifecycleMainService,void 0,!1)),ve.set(z.IRequestService,new T.SyncDescriptor(Y.RequestMainService,void 0,!0)),ve.set(j.IThemeMainService,new T.SyncDescriptor(j.ThemeMainService)),ve.set(oe.ISignService,new T.SyncDescriptor(ee.SignService,void 0,!1)),ve.set(N.ITunnelService,new T.SyncDescriptor(W.TunnelService)),ve.set(_.IProtocolMainService,new $.ProtocolMainService(Re,qe,fe)),[new U.InstantiationService(ve,!0),re,Re,je,Te,he,ye,qe]}c(ve){const we={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ye=>{const Re=process.env[ye];typeof Re=="string"&&(we[ye]=Re)}),Object.assign(process.env,we),we}async d(ve,we,ye,Re,re){await A.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsPath,we.defaultProfile.globalStorageHome.fsPath,ve.workspaceStorageHome.fsPath,ve.localHistoryHome.fsPath,ve.backupHome].map(he=>he?m.Promises.mkdir(he,{recursive:!0}):void 0)),Re.init(),ye.initialize()]),we.setEnablement(re.quality!=="stable"||ye.getValue(ke.PROFILES_ENABLEMENT_CONFIG))}async e(ve,we,ye,Re,re,he){let fe;try{(0,d.mark)("code/willStartMainServer"),fe=await(0,E.serve)(we.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,p.once)(ye.onWillShutdown)(()=>fe.dispose())}catch(be){if(be.code!=="EADDRINUSE")throw this.f(we,re.nameLong,be),be;let Pe;try{Pe=await(0,E.connect)(we.mainIPCHandle,"main")}catch(Ue){if(!he||b.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.g((0,i.localize)(0,null,re.nameShort),(0,i.localize)(1,null),re.nameLong),Ue;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(je){throw ve.warn("Could not delete obsolete instance handle",je),je}return this.e(ve,we,ye,Re,re,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const Ue=`Running extension tests from the command line is currently only supported if no other instance of ${re.nameShort} is running.`;throw ve.error(Ue),Pe.dispose(),new Error(Ue)}let We;!we.args.wait&&!we.args.status&&(We=setTimeout(()=>{this.g((0,i.localize)(2,null,re.nameShort),(0,i.localize)(3,null),re.nameLong)},1e4));const Te=C.ProxyChannel.toService(Pe.getChannel("launch"),{disableMarshalling:!0}),qe=C.ProxyChannel.toService(Pe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return Re.invokeFunction(async()=>{const Ue=new o.DiagnosticsService(F.NullTelemetryService,re),je=await qe.getMainDiagnostics(),Xe=await qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),$e=await Ue.getDiagnostics(je,Xe);throw console.log($e),new w.ExpectedError});throw b.isWindows&&await this.h(Te,ve),ve.trace("Sending env to running instance..."),await Te.start(we.args,process.env),Pe.dispose(),We&&clearTimeout(We),new w.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw ve.warn(`Warning: The --status argument can only be used if ${re.nameShort} is already running. Please run it again after {0} has started.`),new w.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),fe}f(ve,we,ye){if(ye.code==="EACCES"||ye.code==="EPERM"){const Re=(0,M.coalesce)([ve.userDataPath,ve.extensionsPath,E.XDG_RUNTIME_DIR]).map(re=>(0,y.getPathLabel)(k.URI.file(re),{os:b.OS,tildify:ve}));this.g((0,i.localize)(4,null),(0,i.localize)(5,null,(0,I.toErrorMessage)(ye),Re.join(`
`)),we)}}g(ve,we,ye){S.dialog.showMessageBoxSync({title:ye,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,i.localize)(6,null))],message:ve,detail:we,defaultId:0,noLink:!0})}async h(ve,we){if(b.isWindows){const ye=await ve.getMainProcessId();we.trace("Sending some foreground love to the running instance:",ye);try{(await new Promise((Re,re)=>{V(["windows-foreground-love"],Re,re)})).allowSetForegroundWindow(ye)}catch(Re){we.error(Re)}}}i(ve,we){const ye=ve.get(se.ILogService),Re=ve.get(H.ILifecycleMainService);let re=0;we&&(we.isExpected?we.message&&ye.trace(we.message):(re=1,we.stack?ye.error(we.stack):ye.error(`Startup error: ${we.toString()}`))),Re.kill(re)}j(){const ve=this.k((0,c.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const we=(0,s.createWaitMarkerFileSync)(ve.verbose);we&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",we),ve.waitMarkerFilePath=we)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const we=this.l(ve._,ve.goto);ve._=we}return ve}l(ve,we){const ye=(0,l.cwd)(),Re=ve.map(fe=>{let be=String(fe),Pe;we&&(Pe=(0,g.parseLineAndColumnAware)(be),be=Pe.path),be&&(be=this.m(ye,be));const We=(0,g.sanitizeFilePath)(be,ye),Te=(0,h.basename)(We);return Te&&!(0,g.isValidBasename)(Te)?null:we&&Pe?(Pe.path=We,this.n(Pe)):We}),re=b.isWindows||b.isMacintosh,he=(0,M.distinct)(Re,fe=>fe&&re?fe.toLowerCase():fe||"");return(0,M.coalesce)(he)}m(ve,we){return b.isWindows&&(we=(0,u.rtrim)(we,'"')),we=(0,u.trim)((0,u.trim)(we," "),"	"),b.isWindows&&(we=(0,h.resolve)(ve,we),we=(0,u.rtrim)(we,".")),we}n(ve){const we=[ve.path];return typeof ve.line=="number"&&we.push(String(ve.line)),typeof ve.column=="number"&&we.push(String(ve.column)),we.join(":")}}new Oe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4acf2d9b46b75748ae687cf3b2952a0799679873/core/vs/code/electron-main/main.js.map
